<?php
class Bootstrap extends Zend_Application_Bootstrap_Bootstrap
{
    protected function _initAutoload()
    {
        $autoloader = new Zend_Application_Module_Autoloader(array(
            'namespace' => 'Shipcode_',
            'basePath'  => dirname(__FILE__), 
        ));
        return $autoloader;  
    }
 
    protected function _initDoctype() 
    {
        $this->bootstrap('view'); 
        $view = $this->getResource('view');
        $view->doctype('XHTML1_STRICT');
    }
     
    protected function _initConstants()  
    {
        // 0 = Inactiva, 1 = Inicia en 30 minutos, 2 = Activa
        Zend_Registry::set('STATUS_UPDATE', 0); 
        Zend_Registry::set('PATH_SERVER', '/home/admin/sites/demo.naves.cl/public/');
        Zend_Registry::set('URL_SERVER', 'http://demo.naves.cl/');
        Zend_Registry::set('OTHERS_PHP_CLASSES', '/home/admin/external/');
        Zend_Registry::set('LIBRARY', '/home/admin/library/');
        Zend_Registry::set('NOMBRE_EMPRESA', 'Nav. Chiloé (Demo)');
        Zend_Registry::set('FIRMA_EMPRESA', 'Shipcode');
        Zend_Registry::set('MAIL_FROM', 'system@webcode.cl');
        Zend_Registry::set('MAIL_SUPERADMIN', 'claudiosalazarb@gmail.com');
        Zend_Registry::set('NOMBRE_SUPERADMIN', 'Claudio Salazar');

        Zend_Registry::set('BORRADOR_SOLICITUDES', TRUE);
        
        Zend_Registry::set('FORMAT_DATE', 'yyyy-MM-dd');
        
        Zend_Registry::set('MAX_SIZE_IMG_UPLOAD', 4 * 1024 * 1024);
        Zend_Registry::set('ACCEPTED_IMG_FORMAT', array('jpg', 'png', 'JPG', 'PNG'));
        
        Zend_Registry::set('MAX_SIZE_FILE_UPLOAD', 48 * 1024 * 1024);
        Zend_Registry::set('ACCEPTED_FILE_FORMAT', array('pdf', 'xls', 'xslx', 'doc', 'docx', 'dwg', 'dxf', 'jpg', 'jpeg', 'png'));
        
        // CONSTANTES IMAGESTIÓN
        Zend_Registry::set('IMA_URL', 'http://soc.tmc.cl:8080/e1/api/');
        Zend_Registry::set('IMA_TOKEN_CPT', '38d69eaea1834aee04486ea98c318291fb97506b');
        Zend_Registry::set('IMA_TOKEN_TMC', '5cfa9f446e6a84aa25ba58e2411894586032c330');
        Zend_Registry::set('IMA_TOKEN_NAS', '4f15062022fafb5f2254b2c64c135b1c2c7f4fd1');
        Zend_registry::set('IMA_TOKEN_MAR', 'a26ab0de4ad5807576aeeaf0305b3a47c5695a8f');
    }
    
    protected function _initLocale()
    {
        $locale = new Zend_Locale('es_CL');
        Zend_Locale::setDefault($locale);
        Zend_Registry::set('Zend_Locale', $locale);
        $traduccion = new Zend_Translate('array', APPLICATION_PATH . '/langs/es.php', 'es');
        Zend_Form::setDefaultTranslator($traduccion);
    }
    
    protected function _initRouter()
    {   
        $frontController = Zend_Controller_Front::getInstance();
        $router = $frontController->getRouter();
        
        $router->addRoute(
            'estandar-route-id',
            new Zend_Controller_Router_Route('/:controller/:action/:id',
                array(
                    'controller' => ':controller', 
                    'action' => ':action'
                )
            ));
        
        $router->addRoute(
            'estandar-route-from',
            new Zend_Controller_Router_Route('/:controller/:action/:id/:from_id',
                array(
                    'controller' => ':controller', 
                    'action' => ':action'
                )
            ));
        
        $router->addRoute(
            'ver-tab',
            new Zend_Controller_Router_Route('/:controller/ver/:id/:tab',
                array(
                    'controller' => ':controller', 
                    'action' => 'ver'
                )
            ));
        
        $router->addRoute(
            'ver-tab-nave',
            new Zend_Controller_Router_Route('/:controller/nave/:id/:tab',
                array(
                    'controller' => ':controller', 
                    'action' => 'nave'
                )
            ));
        
        $router->addRoute(
            'ver-tab-equipo',
            new Zend_Controller_Router_Route('/:controller/equipo/:id/:tab',
                array(
                    'controller' => ':controller', 
                    'action' => 'equipo'
                )
            ));
        
        $router->addRoute(
            'detalles-mensuales-gastos',
            new Zend_Controller_Router_Route('/nave/detallar-gastos-mensuales/:nave_id/:year/:month',
                array(
                    'controller' => 'nave', 
                    'action' => 'detallar-gastos-mensuales'
                )
            ));
        
        $router->addRoute(
            'graficas-gastos',
            new Zend_Controller_Router_Route('/empresa/grafica-gastos/:empresa_id/:year/',
                array(
                    'controller' => 'empresa', 
                    'action' => 'grafica-gastos'
                )
            ));
        
        $router->addRoute(
            'agregar-mantenimiento',
            new Zend_Controller_Router_Route('/equipo-mantenimiento/agregar/:servicio_id',
                array(
                    'controller' => 'equipo-mantenimiento', 
                    'action' => 'agregar'
                )
            ));
        /*
        $router->addRoute(
            'reporte-nave-solicitudes',
            new Zend_Controller_Router_Route('/reporte-nave/solicitudes/:id/:solicitud_id',
                array(
                    'controller'=> 'reporte-nave', 
                    'action'    => 'solicitudes'
                )
            ));
        
        $router->addRoute(
            'reporte-nave-eliminar-solicitud',
            new Zend_Controller_Router_Route('/reporte-nave/eliminar-solicitud/:id/:informe_id',
                array(
                    'controller'=> 'reporte-nave', 
                    'action'    => 'eliminar-solicitud'
                )
            ));
        
        $router->addRoute(
            'informe-nave-mantenimientos',
            new Zend_Controller_Router_Route('/reporte-nave/mantenimientos/:id/:mantenimiento_id',
                array(
                    'controller'=> 'reporte-nave', 
                    'action'    => 'mantenimientos'
                )
            ));
        
        $router->addRoute(
            'reporte-nave-eliminar-mantenimiento',
            new Zend_Controller_Router_Route('/reporte-nave/eliminar-mantenimiento/:id/:informe_id',
                array(
                    'controller'=> 'reporte-nave', 
                    'action'    => 'eliminar-mantenimiento'
                )
            ));
        */
        
        $router->addRoute(
            'imagestion-cargar-presupuesto',
            new Zend_Controller_Router_Route('/imagestion/cargar-presupuesto/:cod_centro/:year',
                array(
                    'controller'=> 'imagestion', 
                    'action'    => 'cargar-presupuesto'
                )
            ));
        
        $router->addRoute(
            'imagestion-cargar-ordenes-de-compra',
            new Zend_Controller_Router_Route('/imagestion/cargar-ordenes-de-compra/:month/:year',
                array(
                    'controller'=> 'imagestion', 
                    'action'    => 'cargar-ordenes-de-compra'
                )
            ));
        
        $router->addRoute(
            'ver-gasto-mensual-cuenta',
            new Zend_Controller_Router_Route('/imagestion/ver-gasto-mensual-cuenta/:cod_centro/:cod_cuenta/:month/:year',
                array(
                    'controller'=> 'imagestion', 
                    'action'    => 'ver-gasto-mensual-cuenta'
                )
            ));
        
        $router->addRoute(
            'ver-presupuesto-mensual',
            new Zend_Controller_Router_Route('/imagestion/ver-presupuesto-mensual/:cod_centro/:month/:year',
                array(
                    'controller'=> 'imagestion', 
                    'action'    => 'ver-presupuesto-mensual'
                )
            ));
        
        $router->addRoute(
            'descargar-informe-resumen-anual',
            new Zend_Controller_Router_Route('/informes/descargar-resumen-gastos/:empresa_id/:year',
                array(
                    'controller'=> 'informes', 
                    'action'    => 'descargar-resumen-gastos'
                )
            ));
        
        $router->addRoute(
            'cronjobs-hash',
            new Zend_Controller_Router_Route('/cronjobs/:action/:hash',
                array(
                    'controller'=> 'cronjobs', 
                    'action'    => ':action'
                )
            ));     
    }
    
    protected function _initMail()
    {
        $config = array(
            'auth'      => 'login',
            'username'  => 'system@webcode.cl',
            'password'  => 'systmwbcd13',
            'ssl'       => 'tls',
            'port'      => 587
        );
        $transport = new Zend_Mail_Transport_Smtp('smtp.gmail.com', $config);
        Zend_Mail::setDefaultTransport($transport);
    }
}
