<?php
class ImagestionController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 5;
        $this->view->pageTitle = "Imagestión";
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    public function managerAction() {
        
    }
    
    public function verGastoMensualCuentaAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
         
            $cod_centro = (int)$this->_getParam('cod_centro');
            $cod_cuenta = (int)$this->_getParam('cod_cuenta');
            $mes = (int)$this->_getParam('month');
            $year = (int)$this->_getParam('year');
            $gasto = new Shipcode_Model_ImagestionGasto();
            $this->view->gastos = $gasto->getDetalleMensualCuenta($cod_centro, $cod_cuenta, $mes, $year);
            $this->view->mes = $mes;
            $this->view->year = $year;
            $this->renderScript('imagestion/ver-gasto-mensual.phtml');
        }    
    }
    
    public function verPresupuestoMensualAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
         
            $cod_centro = (int)$this->_getParam('cod_centro');
            $mes = (int)$this->_getParam('month');
            $year = (int)$this->_getParam('year');
            $imagestion = new Shipcode_Model_Imagestion();
            $this->view->cuentas = $imagestion->getDetallePresupuestoMensual($cod_centro, $mes, $year);
            $this->view->mes = $mes;
            $this->view->year = $year;
            $this->renderScript('imagestion/ver-presupuesto-mensual.phtml');
        }    
    }
    /**************************************************************************/
    public function presupuestosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes != '') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->view->pageTitle = "Imagestión - Importación y Actualización de datos";
        
        $presupuesto = new Shipcode_Model_ImagestionPresupuesto();
        $this->view->yearsPresupuestos = $presupuesto->getAll();
    }
    
    public function importarPresupuestoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes != '') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $request = $this->getRequest();
        $form = new Shipcode_Form_ImagestionPresupuesto();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    $imagestion = new Shipcode_Model_ImagestionPresupuesto();
                    if($imagestion->checkPresupuesto($form->getValues()) == FALSE){
                        $result = $imagestion->importarPresupuesto($form->getValues());
                        if($result == TRUE){
                            $mSession->mensajes = array('El presupuesto fue importado de forma exitosa.');
                            $mSession->claseMensaje = 'confirmacion';
                            $this->_redirect('/imagestion/presupuestos');
                        } else {
                            $mSession->mensajes = array('No existe un presupuesto para el centro de costo y año solicitado.');
                            $mSession->claseMensaje = 'error';
                            $this->_redirect('/imagestion/presupuestos');
                        }
                    } else {
                        $this->view->mensajes = array('Ya existe un prespuesto para el centro de costo y año ' . $form->getValue('year'));
                        $this->view->claseMensaje = 'error';
                        $form->populate($request->getPost());
                    }
                } catch (Exception $e) {
                    $mSession->mensajes[] = 'Ocurrió un error al intentar importar el presupuesto.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/imagestion/presupuestos/');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $form->setAction('/imagestion/importar-presupuesto');
        $form->cancel->setAttrib('onclick', "javascript:goTo('/imagestion/presupuestos');");
        $this->view->form = $form;
        $this->view->title = "Importar Presupuesto";
        $this->view->pageTitle = "Imagestion > Importar Presupuesto";
    }
    
    public function eliminarPresupuestoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes != '') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $id = (int)$this->_getParam('id');
        try {
            
            $presupuesto = new Shipcode_Model_ImagestionPresupuesto();
            $presupuesto->setId($id);
            $presupuesto->eliminar();
            $this->_redirect('/imagestion/presupuestos');
            
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un error al intentar eliminar el presupuesto";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/imagestion/presupuestos');
        }
    }
    
    /**************************************************************************/

    public function configAccesoAction() {
        $mSession = new Zend_Session_Namespace('shipcode');
        if ($mSession->mensajes != '') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_ImagestionAccesoApi();
        $form->cancel->setAttrib('onclick', 'javascript:goTo("' . $_SERVER['HTTP_REFERER'] . '");');

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $empresa = new Shipcode_Model_Empresa();
                    $id = $empresa->crear($form->getValues(), $this->usuario->id);

                    $mSession->mensajes = array('La empresa fue creada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/empresa/ver/' . $id);
                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la empresa.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/empresa');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        $this->view->form = $form;
        $this->view->title = "Configurar Acceso API Imagestión";
        $this->renderScript('imagestion/config-acceso.phtml');
    }

    /**************************************************************************/

    public function centrosDeCostoAction() {
        $mSession = new Zend_Session_Namespace('shipcode');
        if ($mSession->mensajes != '') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $this->view->pageTitle = "Centros de Costo";

        try {
            $imagestion = new Shipcode_Model_Imagestion();
            $this->view->centros = $imagestion->getCentrosCosto();
        } catch (Exception $e) {
            echo $e->getMessage();
        }
    }

    public function crearCentroDeCostoAction() {
        $mSession = new Zend_Session_Namespace('shipcode');
        if ($mSession->mensajes != '') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_ImagestionCentroCosto();
        $form->cancel->setAttrib('onclick', 'javascript:goTo("/imagestion/centros-de-costo");');

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $imagestion = new Shipcode_Model_Imagestion();
                    $imagestion->crearCentroCosto($form->getValues(), $this->usuario->id);

                    $mSession->mensajes = array('El centro de costo fue creado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/imagestion/centros-de-costo');
                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear el centro de costo.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/imagestion/centros-de-costo');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        $this->view->form = $form;
        $this->view->title = "Agregar centro de costo";
        $this->renderScript('imagestion/form-centro-de-costo.phtml');
    }

    public function editarCentroDeCostoAction() {
        $mSession = new Zend_Session_Namespace('shipcode');
        if ($mSession->mensajes != '') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_ImagestionCentroCosto();
        $form->id->setRequired(true);
        $imagestion = new Shipcode_Model_Imagestion();

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $imagestion->editarCentroCosto($form->getValues(), $this->usuario->id);

                    $mSession->mensajes = array('El centro de costo fue editado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/imagestion/centros-de-costo');
                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar el centro de costo.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/imagestion/centros-de-costo');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        $id = (int) $this->_getParam('id');
        $form->id->setValue($id);
        $form->populate($imagestion->getCentroCosto($id)->toArray());
        $form->setAction('/imagestion/editar-centro-de-costo/editar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/centro-costo');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->pageTitle = "Editar centro de costo";
        $this->view->title = "Editar centro de costo";
        $this->renderScript('imagestion/form-centro-de-costo.phtml');
    }

    public function eliminarCentroDeCostoAction() {
        $mSession = new Zend_Session_Namespace('shipcode');
        $id = (int) $this->_getParam('id');

        try {

            $imagestion = new Shipcode_Model_Imagestion();
            $imagestion->eliminarCentroCosto($id);

            $mSession->mensajes[] = 'El centro de costo fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/imagestion/centros-de-costo');
        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el centro de costo.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/imagestion/centros-de-costo');
        }
    }

    /**************************************************************************/

    public function cuentasDeGastoAction() {
        $mSession = new Zend_Session_Namespace('shipcode');
        if ($mSession->mensajes != '') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Cuentas de Gastos";

        try {
            $imagestion = new Shipcode_Model_Imagestion();
            $this->view->cuentas = $imagestion->getCuentasGasto();
        } catch (Exception $e) {
            echo $e->getMessage();
        }
    }

    public function crearCuentaDeGastoAction() {
        $mSession = new Zend_Session_Namespace('shipcode');
        if ($mSession->mensajes != '') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Shipcode_Form_ImagestionCuentaGasto();

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $imagestion = new Shipcode_Model_Imagestion();
                    $imagestion->crearCuentaGasto($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('La cuenta de gastos fue creada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/imagestion/cuentas-de-gasto');
                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la cuenta de gastos.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/imagestion/cuentas-de-gasto');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        $form->cancel->setAttrib('onclick', "javascript:goTo('/imagestion/cuentas-de-gasto');");
        $this->view->form = $form;
        $this->view->pageTitle = "Crear cuenta de gastos";
        $this->view->title = "Crear cuenta de gastos";
        $this->renderScript('imagestion/form-cuenta-de-gasto.phtml');
    }

    public function editarCuentaDeGastoAction() {
        $mSession = new Zend_Session_Namespace('shipcode');
        if ($mSession->mensajes != '') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_ImagestionCuentaGasto();
        $form->id->setRequired(true);
        $imagestion = new Shipcode_Model_Imagestion();

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $imagestion->editarCuentaGasto($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('La cuenta de gastos fue editada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/imagestion/cuentas-de-gasto');
                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar la cuenta de gastos.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/imagestion/cuentas-de-gasto');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        $id = (int) $this->_getParam('id');
        $form->id->setValue($id);
        $form->populate($imagestion->getCuentaGasto($id)->toArray());
        $form->setAction('/imagestion/editar-cuenta-de-gasto/editar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/imagestion/cuentas-de-gasto');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->pageTitle = "Editar cuenta de gastos";
        $this->view->title = "Editar cuenta de gastos";
        $this->renderScript('imagestion/form-cuenta-de-gasto.phtml');
    }

    public function eliminarCuentaDeGastoAction() {
        $mSession = new Zend_Session_Namespace('shipcode');
        if ($mSession->mensajes != '') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int) $this->_getParam('id');

        try {

            $imagestion = new Shipcode_Model_Imagestion();
            $imagestion->eliminarCuentaGasto($id);

            $mSession->mensajes[] = 'La cuenta de gastos fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/imagestion/cuentas-de-gasto');
        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar la cuenta de gastos.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/imagestion/cuentas-de-gasto');
        }
    }

    /*     * *********************************************************************** */
    
    
    /*
    public function cargarPresupuestoAction()
    {
        $cod_centro = $this->_getParam('cod_centro');
        $year = $this->_getParam('year');
        $imagestion = new Shipcode_Model_Imagestion();
        $imagestion->cargarPresupuesto($cod_centro, $year);
        $this->_redirect('/imagestion');
    }
    
    public function cargarOrdenesDeCompraAction()
    {
        $year = $this->_getParam('year');
        $month = $this->_getParam('month');
        $imagestion = new Shipcode_Model_Imagestion();
        $imagestion->cargarOrdenesDeCompra($year, $month);
        $this->_redirect('/imagestion');
    }
    
    public function cargarProductosAction()
    {
        $imagestion = new Shipcode_Model_Imagestion();
        $imagestion->cargarProductos();
        $this->_redirect('/imagestion');
    }
    */
    /*
    public function verPresupuestoMensualAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
            //$this->_helper->viewRenderer->setNoRender();
            $cod_centro = (int)$this->_getParam('id');
            $mes = date("m");
            $year = date("Y");
            $imagestion = new Shipcode_Model_Imagestion();
            $this->view->presupuesto = $imagestion->getPresupuestoMensual($cod_centro, $mes, $year);
            $this->view->mes = $mes;
            $this->view->year = $year;
        }    
    }
    
    public function verPresupuestoAcumuladoAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
         
            $cod_centro = (int)$this->_getParam('id');
            $mes = date("m");
            $year = date("Y");
            $imagestion = new Shipcode_Model_Imagestion();
            $this->view->presupuesto = $imagestion->getDetallePresupuestoAcumulado($cod_centro, $mes, $year);
            $this->view->mes = $mes;
            $this->view->year = $year;
        }    
    }
    
    public function verPresupuestoAnualAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
         
            $cod_centro = (int)$this->_getParam('id');
            $mes = 12;
            $year = date("Y");
            $imagestion = new Shipcode_Model_Imagestion();
            $this->view->presupuesto = $imagestion->getDetallePresupuestoAcumulado($cod_centro, $mes, $year);
            $this->view->mes = $mes;
            $this->view->year = $year;
            $this->renderScript('imagestion/ver-presupuesto-acumulado.phtml');
        }    
    }
    
    public function verGastoMensualAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
         
            $cod_centro = (int)$this->_getParam('id');
            $mes = date("m");
            $year = date("Y");
            $imagestion = new Shipcode_Model_Imagestion();
            $this->view->gastos = $imagestion->getGastoMensual($cod_centro, $mes, $year);
            $this->view->mes = $mes;
            $this->view->year = $year;
        }    
    }
    
    public function verGastoAcumuladoAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
         
            $cod_centro = (int)$this->_getParam('id');
            $mes = date("m");
            $year = date("Y");
            $imagestion = new Shipcode_Model_Imagestion();
            $this->view->gastos = $imagestion->getGastoAcumulado($cod_centro, $mes, $year);
            $this->view->mes = $mes;
            $this->view->year = $year;
        }    
    }
    */
    /**************************************************************************/
}