<?php
class AdministradorHorometrosController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 3;
        $this->view->pageTitle = "Gestión de Horómetros";
        
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }

    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->view->pageTitle = "Gestión de Horómetros";
        $empresa = new Shipcode_Model_Empresa();
        $this->view->hEmpresas = $empresa->getHorometrosActivos();
    }
    
    public function getAction()
    {
        $this->_helper->layout->disableLayout();
        if($this->getRequest()->isXmlHttpRequest()){
            $id = (int)$this->_getParam('id');
            try {
                $equipo = new Shipcode_Model_NaveEquipo();
                $equipo->setId($id);
                $this->view->equipo = $equipo->getRowFull();
                $this->view->lecturas = $equipo->getLecturasHorometro();
                $this->view->sumarioHorometro = $equipo->getSumarioHorometro();
                $this->view->horasOperacion = $equipo->getHorasOperacionMensuales();
                $this->renderScript('administrador-horometros/horometro.phtml');
            } catch(Exception $e){
                echo $e->getMessage();
            }
        }
    }
    
    public function analizarLecturaAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            try {
                
                $idUno = (int)$this->_getParam('idUno');
                $idDos = (int)$this->getParam('idDos');
                $lectura = new Shipcode_Model_NaveHorometroLectura();
                $lectura->setId($idUno);
                $result = $lectura->validarSiguiente($idDos);
                echo Zend_Json::encode($result);
                
            } catch(Exception $e){
                
                $data['error'] = true;
                $data['mensaje'] = $e->getMessage();
                echo Zend_Json::encode($data);
            }
        }
    }

    /*
    public function getInfoEquipoAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        $id = (int)$this->_getParam('id');
        $equipo = new Shipcode_Model_NaveEquipo();
        $equipo->setId($id);
        echo $equipo->calcularPromedioMensualOperacion();
        echo '<br>';
        Zend_Debug::dump($equipo->getDetalleCalculoPromedioMensualOperacion());
    }
    */
}