<?php
class AjaxController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
    }
    /**************************************************************************/
   
    /****************************  OPERACIONES AJAX ***************************/
    public function getEquiposAgrupadosPorSistemaAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $id = (int)$this->_getParam('id');
            $nave = new Shipcode_Model_Nave();
            $nave->setId($id);
            $equipos = $nave->getEquiposAgrupadosPorSistemaToSelect();
            $data['grupos'] = $equipos;
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getNavesAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $empresa_id = (int)$this->_getParam('id');
            $nave = new Shipcode_Model_Nave();
            $naves = $nave->getRowsToSelectByEmpresaId($empresa_id, $this->autorizaciones);
            $data['filas'] = $naves;
            $data['grupos'] = array();
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getCentrosDeCostoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $empresa_id = (int)$this->_getParam('id');
            $nave = new Shipcode_Model_Nave();
            $naves = $nave->getCentrosDeCostoToSelectByEmpresaId($empresa_id);
            $data['filas'] = $naves;
            $data['grupos'] = array();
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getSistemasAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $nave_id = (int)$this->_getParam('id');
            $sistema = new Shipcode_Model_NaveSistema();
            $sistemas = $sistema->getPairsToSelectByNaveId($nave_id, 'JSON');
            $data['filas'] = array();
            $data['grupos'] = $sistemas;
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getSistemasPrincipalesAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $nave_id = (int)$this->_getParam('id');
            $sistema = new Shipcode_Model_NaveSistema();
            $sistemas = $sistema->getSistemasToClone($nave_id);
            $data['filas'] = $sistemas;
            $data['grupos'] = array();
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getSubsistemasAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $sistema_id = (int)$this->_getParam('id');
            $sistema = new Shipcode_Model_NaveSistema();
            $sistemas = $sistema->getSubSistemasToClone($sistema_id);
            $data['filas'] = $sistemas;
            $data['grupos'] = array();
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getSistemasConHorometroAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $nave_id = (int)$this->_getParam('id');
            $sistema = new Shipcode_Model_NaveSistema();
            $sistemas = $sistema->getRowsConHorometroToSelectByNaveId($nave_id);
            $data['filas'] = $sistemas;
            $data['grupos'] = array();
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getEquiposAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $sistema_id = (int)$this->_getParam('id');
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipos = $equipo->getEquiposToSelectBySistemaId($sistema_id);
            $data['filas'] = $equipos;
            $data['grupos'] = array();
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getEquiposUvirtualAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $ubicacionv_id = (int)$this->_getParam('id');
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipos = $equipo->getEquiposToSelectByUbicacionVirtualId($ubicacionv_id);
            $data['filas'] = $equipos;
            $data['grupos'] = array();
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getEquiposConHorometroAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $sistema_id = (int)$this->_getParam('id');
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipos = $equipo->getRowsConHorometroToSelectBySistemaId($sistema_id);
            $data['filas'] = $equipos;
            $data['grupos'] = array();
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getMarcasAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $tipo_id = (int)$this->_getParam('id');
            $marca = new Shipcode_Model_EquipoMarca();
            $marcas = $marca->getRowsByTipoEquipoId($tipo_id);
            $data['filas'] = $marcas;
            $data['grupos'] = array();
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getServiciosPlanAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $equipo_id = (int)$this->_getParam('id', 0);
            $plan = new Shipcode_Model_BasePlanMant();
            $items = $plan->getServiciosByEquipoIdToSelect($equipo_id);
            $data['filas'] = $items;
            $data['grupos'] = array();
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    
    public function getServiciosRealizadosAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            $equipo_id = $this->_getParam('id', 0);
            $mantenimiento = new Shipcode_Model_NaveEquipoMantenimiento();
            $items = $mantenimiento->getServiciosByPlanIdToSelect($equipo_id);
            $data['filas'] = $items;
            $data['grupos'] = array();
            $data['error'] = false;
            echo Zend_Json::encode($data);
        }
    }
    /**************************************************************************/
}