<?php
class BibliotecaTecnicaController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 3;
        $this->view->pageTitle = "Gestión de Equipos";
        
        if(!$this->getRequest()->isXmlHttpRequest() 
                && $this->getRequest()->getActionName() != 'exportar-seleccion'){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    /************************ OPERACIONES BIBLIOTECA **************************/
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $mSession->equiposSeleccionados = array();
        $mSession->tiposSeleccionados = array();
        
        $this->view->pageTitle = "Gestión de Equipos";
        $this->view->empresas = Shipcode_Model_Empresa::getPairsToSelect();
        $this->view->ubicacionesVirtuales = Shipcode_Model_UbicacionVirtual::getPairsToSelect();
        $this->view->tiposEquipos = Shipcode_Model_TipoEquipo::getPairsToSelect();
        $this->view->marcasEquipos = Shipcode_Model_EquipoMarca::getPairsToSelect();
        $this->view->planesMantenimiento = Shipcode_Model_BasePlanMant::getPairsToSelect();
    }
    
    public function findAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if($this->getRequest()->isXmlHttpRequest()){
            
            $data = array(
                'empresa_id' => (int)$this->_getParam('empresa_id', 0),
                'nave_id' => (int)$this->_getParam('nave_id', 0),
                'sistema_id' => (int)$this->_getParam('sistema_id', 0),
                'ubicacionv_id' => (int)$this->_getParam('ubicacionv_id', 0),
                'tipo_id' => (int)$this->_getParam('tipo_id', 0),
                'marca_id' => (int)$this->_getParam('marca_id', 0),
                'modelo' => $this->_getParam('modelo', NULL),
                'nombre' => $this->_getParam('nombre', NULL),
                'plan' => $this->_getParam('plan', NULL),
                'info_tecnica' => $this->_getParam('info_tecnica', NULL)
            );
            
            try {
                
                $equipo = new Shipcode_Model_NaveEquipo();
                $equipos = $equipo->buscar($data);
                echo Zend_Json::encode($equipos);
                
            } catch (Exception $exc) {
                echo $exc->getTraceAsString();
            }
        }
    }
    
    public function equipoAction()
    {
        $this->_helper->layout->disableLayout();
        if($this->getRequest()->isXmlHttpRequest()){
            $id = (int)$this->_getParam('id');
            try {
                $equipo = new Shipcode_Model_NaveEquipo();
                $equipo->setId($id);
                $this->view->equipo = $equipo->getRowFull();
                $this->view->horometro = $equipo->getUltimaLecturaHorometro();
                $this->view->partes = $equipo->getPartes();
                $this->view->plan = $equipo->getPlanMantenimientoBasico($this->view->equipo['planmant_id']);
            } catch(Exception $e){
                echo $e->getMessage();
            }
        }
    }

    /************************ OPERACIONES SELECCIÖN ***************************/
    public function seleccionarEquipoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            if($this->_getParam('equipo_id')){
                
                $data = array();
                
                $id = (int)$this->_getParam('equipo_id');
                $tipo_id = (int)$this->_getParam('tipo_id');
                
                $resultEquipo = array_key_exists($id, $mSession->equiposSeleccionados);
                if($resultEquipo == FALSE){
                    $mSession->equiposSeleccionados[$id] = $id;
                    $mSession->tiposSeleccionados[$id] = $tipo_id;
                }

                $data['error'] = false;
                echo Zend_Json::encode($data);
                
            } else {
                $data['error'] = true;
                $data['mensaje'] = "No se envió el ID para agregar a los equipos seleccionados";
                echo Zend_Json::encode($data);
            }
        }
    }
    
    public function deseleccionarEquipoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if($this->getRequest()->isXmlHttpRequest()){
            if($this->_getParam('equipo_id')){
                
                $data = array();
                $id = (int)$this->_getParam('equipo_id');
                
                $resultEquipo = array_key_exists($id, $mSession->equiposSeleccionados);
                if($resultEquipo == TRUE){
                    unset($mSession->equiposSeleccionados[$id]);
                    unset($mSession->tiposSeleccionados[$id]);
                }
               
                $data['error'] = false;
                echo Zend_Json::encode($data);
            } else {
                $data['error'] = true;
                $data['mensaje'] = "No se envió el ID para eliminar de los equipos seleccionados";
                echo Zend_Json::encode($data);
            }
        }
    }
    
    public function seleccionarTodosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            
            if($this->_getParam('ids')){
                
                $data = array();
                $count = 0;
                $ids = $this->_getParam('ids');
                $tipos = $this->_getParam('tipoIds');
                
                $equiposIds = explode(",", $ids);
                $tiposIds = explode(",", $tipos);
                
                for($i = 0; $i < count($equiposIds); $i++){
                    $result = array_key_exists($equiposIds[$i], $mSession->equiposSeleccionados);
                    if($result == FALSE){
                        $mSession->equiposSeleccionados[$equiposIds[$i]] = $equiposIds[$i];
                        $mSession->tiposSeleccionados[$equiposIds[$i]] = $tiposIds[$i];
                        $count++;
                    }
                }
                
                $data['error'] = false;
                $data['cantidad'] = $count;
                echo Zend_Json::encode($data);
                
            } else {
                $data['error'] = true;
                $data['mensaje'] = "No se envió el ID para agregar a los equipos seleccionados";
                echo Zend_Json::encode($data);
            }
            
        }
    }
    
    public function deseleccionarTodosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if($this->getRequest()->isXmlHttpRequest()){
            
            if($this->_getParam('ids')){
                
                $data = array();
                $count = 0;
                $ids = $this->_getParam('ids');
                $equiposIds = explode(",", $ids);
                
                for($i = 0; $i < count($equiposIds); $i++){
                    $result = array_key_exists($equiposIds[$i], $mSession->equiposSeleccionados);
                    if($result == TRUE){
                        unset($mSession->equiposSeleccionados[$equiposIds[$i]]);
                        unset($mSession->tiposSeleccionados[$equiposIds[$i]]);
                        $count++;
                    }
                }
                $data['error'] = false;
                $data['cantidad'] = $count;
                echo Zend_Json::encode($data);
                
            } else {
                $data['error'] = true;
                $data['mensaje'] = "No se envió el ID para eliminar de los equipos seleccionados";
                echo Zend_Json::encode($data);
            }
        }
    }
    
    public function resetearEquiposSeleccionadosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $this->_helper->layout->disableLayout();
        if($this->getRequest()->isXmlHttpRequest()){
            $mSession->equiposSeleccionados = array();
            $mSession->tiposSeleccionados = array();
            $this->forward('equipos-seleccionados');
        }
    }
    
    public function equiposSeleccionadosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $this->_helper->layout->disableLayout();
        
        if($this->getRequest()->isXmlHttpRequest()){
            
            $modelEquipo = new Shipcode_Model_NaveEquipo();
            $this->view->equipos = $modelEquipo->getRowsByEquiposId($mSession->equiposSeleccionados);
            $this->view->planes = Shipcode_Model_BasePlanMant::getPairsToSelect();
        }
    }
    
    public function exportarSeleccionAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();

        define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
        require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
        PHPExcel_Settings::setLocale('es');
        
        $objPHPExcel = new PHPExcel();
        $objPHPExcel->getProperties()->setCreator(" Sistema de Gestión de Mantenimiento")
                                     ->setTitle("Informe")
                                     ->setSubject("Informe");
        $objPHPExcel->setActiveSheetIndex(0)
                    ->setCellValue('A1', 'Nave')
                    ->setCellValue('B1', 'Marca')
                    ->setCellValue('C1', 'Modelo')
                    ->setCellValue('D1', 'Nombre')
                    ->setCellValue('E1', 'Serie');
        
        $styleArray = array(
            'font' => array('bold' => true, 'size' => 14, 'color' => array('argb' => 'ffffffff'),),
            'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,),
            'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
            'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '00000000',),),
        );
        
        $objPHPExcel->getActiveSheet()->getStyle('A1:E1')->applyFromArray($styleArray);
        $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(12);
        $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
        
        $modelEquipo = new Shipcode_Model_NaveEquipo();
        $equipos = $modelEquipo->getRowsByEquiposId($mSession->equiposSeleccionados);
        
        if(count($equipos) > 0 ) { 
            $fila = 2;
            foreach($equipos as $equipo) { 
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $equipo['nave']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $fila, $equipo['marca']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $fila, $equipo['modelo']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $fila, $equipo['nombre']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $fila, $equipo['serie']);
                $fila++;
            }
        } else {
             $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, 1, "No se seleccionaron equipos para exportar.");
        }

        // redirect output to client browser
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="Equipos_Seleccionados.xls"');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');

        $objPHPExcel->disconnectWorksheets();
        
        unset($objPHPExcel);  
        unset($objPHPExcel);
    }
    /**************************************************************************/
    
    /******************  OPERACIONES PLANES DE MANTENIMIENTO ******************/
    public function seleccionarPlanDeMantenimientoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $this->_helper->layout->disableLayout();
        
        if($this->getRequest()->isXmlHttpRequest()){
            
            $tipos = array_unique($mSession->tiposSeleccionados);
            if(count($tipos) > 1){
                $this->view->error = TRUE;
            } elseif(count($tipos) == 1) {
                $plan = new Shipcode_Model_BasePlanMant();
                $this->view->planes = $plan->getPlanesSugeridos(array_shift(array_values($tipos)));
            }
        }
    }
    
    public function asignarPlanDeMantenimientoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        try {
            $plan_id = $this->_getparam('id');
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->asignarPlanesDeMantenimientoMasivamente($plan_id, $mSession->equiposSeleccionados, $this->usuario->id);
            $mSession->mensajes[] = "El plan de mantenimiento fue asignado masivamente de forma exitosa.";
            $mSession->claseMensaje = "confirmacion";
            $this->_redirect('/biblioteca-tecnica');
            
        } catch (Exception $e){
            
            $mSession->mensajes[] = "Ocurrió un error al intentar asignar masivamente el plan de mantenimiento";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/biblioteca-tecnica');
        }
    }
    
    public function eliminarPlanesDeMantenimientoAsignadosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        
        try {
            
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->eliminarPlanesMantenimientoMasivamente($mSession->equiposSeleccionados);
            $mSession->mensajes[] = "Los planes de mantenimiento fueron eliminados de los equipos de forma exitosa.";
            $mSession->claseMensaje = "confirmacion";
            $this->_redirect('/biblioteca-tecnica');
            
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un error al intentar eliminar masivamente la asignación de los planes de mantenimiento";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/biblioteca-tecnica');
        }
    }
    /**************************************************************************/
    
    /********************  OPERACIONES DE PARTES Y PIEZAS *********************/
    public function sincronizarPartesYPiezasAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        try {
            
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->sincronizarInformacionTecnica(1, $mSession->equiposSeleccionados, $this->usuario->id);
            $mSession->mensajes[] = "La información de partes y piezas fue sincronizada de forma exitosa.";
            $mSession->claseMensaje = "confirmacion";
            $this->_redirect('/biblioteca-tecnica');
            
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un error al intentar sincronizar la información de partes y piezas";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/biblioteca-tecnica');
        }
    }
    
    public function sincronizarInformacionTecnicaAdicionalAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        try {
            
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->sincronizarInformacionTecnica(2, $mSession->equiposSeleccionados, $this->usuario->id);
            $mSession->mensajes[] = "La información técnica adicional fue sincronizada de forma exitosa.";
            $mSession->claseMensaje = "confirmacion";
            $this->_redirect('/biblioteca-tecnica');
            
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un error al intentar sincronizar la información técnica adicional";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/biblioteca-tecnica');
        }
    }
    
    public function sincronizarTodaLaInformacionTecnicaAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        try {
            
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->sincronizarInformacionTecnica(3, $mSession->equiposSeleccionados, $this->usuario->id);
            $mSession->mensajes[] = "Toda la información técnica fue sincronizada de forma exitosa.";
            $mSession->claseMensaje = "confirmacion";
            $this->_redirect('/biblioteca-tecnica');
            
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un error al intentar sincronizar toda la información técnica";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/biblioteca-tecnica');
        }
    }
    /**************************************************************************/
    
    /*****************  OPERACIONES ASIGNACION PROMEDIO HORAS *****************/
    public function getFormPromedioHorasAction()
    {
        $this->_helper->layout->disableLayout();
        if($this->getRequest()->isXmlHttpRequest()){
            $mSession = new Zend_Session_Namespace('shipcode');
            $this->view->numEquipos = count($mSession->equiposSeleccionados);
            $this->renderScript('biblioteca-tecnica/form-promedio-horas.phtml');
        }
    }
    
    public function asignarPromedioMasivamenteAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if($this->getRequest()->isXmlHttpRequest()){
            
            $promedio = (int)$this->_getParam('promedio_asignado');
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->setPromedioAsignadoMasivamente($mSession->equiposSeleccionados, $promedio, $this->usuario->id);
            
            $data['error'] = false;
            echo Zend_Json::encode($data);
            
        }
    }
    
    public function calcularPromediosDeHorasMasivamenteAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        try {
            
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->setPromedioCalculadoMasivamente($mSession->equiposSeleccionados, $this->usuario->id);
            $mSession->mensajes[] = "Los promedios mensuales de operación fueron recalculados de forma exitosa.";
            $mSession->claseMensaje = "confirmacion";
            $this->_redirect('/biblioteca-tecnica');
            
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un error al intentar recalcular los promedios mensuales de operación.";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/biblioteca-tecnica');
        }
    }
    
    public function usarPromediosAsignadosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        try {
            
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->setPromedioAsignadoMasivamente($mSession->equiposSeleccionados, $this->usuario->id);
            $mSession->mensajes[] = "Los equipos fueron configurados de forma exitosa para utilizar los promedios asignados.";
            $mSession->claseMensaje = "confirmacion";
            $this->_redirect('/biblioteca-tecnica');
            
        } catch (Exception $e){
            
            $mSession->mensajes[] = "Ocurrió un error al intentar configurar los equipos para el uso de los promedios asignados";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/biblioteca-tecnica');
        }
    }
    
    public function usarPromediosCalculadosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        try {
            
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->setPromedioCalculadoMasivamente($mSession->equiposSeleccionados, $this->usuario->id);
            $mSession->mensajes[] = "Los equipos fueron configurados de forma exitosa para utilizar los promedios calculados.";
            $mSession->claseMensaje = "confirmacion";
            $this->_redirect('/biblioteca-tecnica');
            
        } catch (Exception $e){
            
            $mSession->mensajes[] = "Ocurrió un error al intentar configurar los equipos para el uso de los promedios calculados";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/biblioteca-tecnica');
        }
    }
    /**************************************************************************/
}