<?php
class ConfigMantenimientoController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 5;
        
        $this->_helper->layout->setLayout('config');
        $this->view->action = $this->getRequest()->getActionName();
        $this->view->controller = $this->getRequest()->getControllerName();
        
        $this->view->pageTitle = "Configuración de mantenimiento";
       
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
            $response->insert('menuConfig' , $this->view->render('menu-base.phtml'));
        }
    }
    
    /***************** OPERACIONES TIPOS DE MANTENIMIENTOS ********************/
    public function tiposAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        try {
            $tipo = new Shipcode_Model_TipoMantenimiento();
            $this->view->tipos = $tipo->getAll();
            $this->view->title = "Tipos de Servicio";
            
        } catch(Exception $e){
            echo $e->getMessage();
        }
    }
    /**************************************************************************/
    
    /************************ OPERACIONES SERVICIOS ***************************/
    public function serviciosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        try {
            $servicio = new Shipcode_Model_BaseServicio();
            $this->view->servicios = $servicio->getAll();
            $this->view->title = "Servicios";
            
        } catch(Exception $e){
            echo $e->getMessage();
        }
    }
    
    public function agregarServicioAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Shipcode_Form_BaseServicio();
        $form->cancel->setAttrib('onclick', "javascript:goTo('/config-mantenimiento/servicios');");
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $servicio = new Shipcode_Model_BaseServicio();
                    $servicio->crear($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('El servicio fue creado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/config-mantenimiento/servicios');

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar agregar el servicio.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/config-mantenimiento/servicios');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $this->view->form = $form;
        $this->view->title = "Servicios : Crear";
        $this->renderScript('config-mantenimiento/form-servicio.phtml');
    }
    
    public function editarServicioAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_BaseServicio();
        $form->cancel->setAttrib('onclick', "javascript:goTo('/config-mantenimiento/servicios');");
        $servicio = new Shipcode_Model_BaseServicio();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $servicio->editar($form->getValues(), (int)$this->_getParam('id'));
                    
                    $mSession->mensajes = array('El trabajo fue editado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/config-mantenimiento/servicios');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar el trabajo.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/config-mantenimiento/servicios');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $servicio->setId($id);
        $form->populate($servicio->getRow()->toArray());
        $form->setAction('/config-mantenimiento/editar-servicio/' . $id);
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->title = "Servicios : Editar";
        $this->renderScript('config-mantenimiento/form-servicio.phtml');
    }
    
    public function eliminarServicioAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        
        try {

            $servicio = new Shipcode_Model_BaseServicio();
            $servicio->setId($id);
            $servicio->eliminar();
            
            $mSession->mensajes[] = 'El servicio fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/config-mantenimiento/servicios');

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el servicio.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/config-mantenimiento/servicios');
        }
    }
    /**************************************************************************/
    
    /************************** OPERACIONES PLANES ****************************/
    public function planesAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        try {
            $plan = new Shipcode_Model_BasePlanMant();
            $this->view->planes = $plan->getAll();
            $this->view->title = "Planes de Mantenimiento";
            
        } catch(Exception $e){
            echo $e->getMessage();
        }
    }
    
    public function agregarPlanAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Shipcode_Form_BasePlanMant();
        $form->cancel->setAttrib('onclick', "javascript:goTo('/config-mantenimiento/planes');");

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $plan = new Shipcode_Model_BasePlanMant();
                    $id = $plan->crear($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('El plan de mantenimiento fue creado de forma exitosa. Ahora puede agregar servicios.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/config-mantenimiento/plan/' . $id);

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear el plan de mantenimiento.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/config-mantenimiento/planes');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $this->view->form = $form;
        $this->view->title = "Planes de Mantenimiento : Crear";
        $this->renderScript('config-mantenimiento/form-plan.phtml');
    }
    
    public function editarPlanAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_BasePlanMant();
        $plan = new Shipcode_Model_BasePlanMant();
        $id = (int)$this->_getParam('id');
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $plan->editar($form->getValues(), (int)$this->_getParam('id'));
                    $mSession->mensajes = array('El plan fue editado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/config-mantenimiento/plan/' . $form->getValue('id'));

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar el plan de mantenimiento.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/config-mantenimiento/plan/' . $id);
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        
        $plan->setId($id);
        $form->populate($plan->getRow()->toArray());
        $form->setAction('/config-mantenimiento/editar-plan/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/config-mantenimiento/plan/$id');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->plan = $plan->getRowFull();
        $this->view->title = "Planes de Mantenimiento : Editar";
        $this->renderScript('config-mantenimiento/form-plan.phtml');
    }
    
    public function habilitarPlanAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $id = (int)$this->_getParam('id');
        
        try {

            $plan = new Shipcode_Model_BasePlanMant();
            $plan->setId($id);
            $plan->habilitar();
            $mSession->mensajes = array('El plan fue habilitado de forma exitosa.');
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/config-mantenimiento/plan/' . $id);

        } catch (Exception $e) {

            $mSession->mensajes = array('Ocurrió un error al intentar habilitar el plan de mantenimiento.');
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/config-mantenimiento/plan/' . $id);
        }
    }
    
    public function deshabilitarPlanAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $id = (int)$this->_getParam('id');
        
        try {

            $plan = new Shipcode_Model_BasePlanMant();
            $plan->setId($id);
            $plan->deshabilitar();
            $mSession->mensajes = array('El plan fue deshabilitado de forma exitosa.');
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/config-mantenimiento/plan/' . $id);

        } catch (Exception $e) {

            $mSession->mensajes = array('Ocurrió un error al intentar deshabilitar el plan de mantenimiento.');
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/config-mantenimiento/plan/' . $id);
        }
    }
    
    public function planAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $id = (int)$this->_getParam('id');
        
        try {
            
            $plan = new Shipcode_Model_BasePlanMant();
            $plan->setId($id);
            $this->view->title = "Planes de Mantenimiento : Detalle";
            $this->view->plan = $plan->getRowFull();
            $this->view->items = $plan->getItems();
            $this->view->equipos = $plan->getEquiposAsociados();
            
        } catch(Exception $e){
            $mSession->mensajes[] = 'Ocurrió un error al intentar visualizar el plan de mantenimiento.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/config-mantenimiento/planes');
        }
    }
    
    public function clonarPlanAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $id = (int)$this->_getParam('id');
        
        try {
            
            $plan = new Shipcode_Model_BasePlanMant();
            $plan->setId($id);
            $nuevo_id = $plan->clonar($this->usuario->id);
            $mSession->mensajes = array('El plan de mantenimiento fue clonado de forma exitosa.');
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/config-mantenimiento/plan/' . $nuevo_id);
            
        } catch (Exception $e){
            
            $mSession->mensajes[] = 'Ocurrió un error al intentar clonar el plan de mantenimiento.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/config-mantenimiento/plan/' . $id);
        }
    }
    
    public function eliminarPlanAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        
        try {

            $plan = new Shipcode_Model_BasePlanMant();
            $plan->setId($id);
            $plan->eliminar();
            
            $mSession->mensajes[] = 'El plan de mantenimiento fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/config-mantenimiento/planes');

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el plan de mantenimiento.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/config-mantenimiento/planes');
        }
    }
    /**************************************************************************/
    
    /*********************** OPERACIONES ITEMS PLANES *************************/
    public function agregarItemAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Shipcode_Form_BasePlanMantItem();
        $id = (int)$this->_getParam('id');
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $item = new Shipcode_Model_BasePlanMantItem();
                    $item->crear($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('El ítem fue agregado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/config-mantenimiento/plan/' . $form->getValue('plan_id'));

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar agregar el servicio.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/config-mantenimiento/plan/' . $id);
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        $plan = new Shipcode_Model_BasePlanMant();
        $plan->setId($id);
        $dataPlan = $plan->getRow();
        $form->cancel->setAttrib('onclick', "javascript:goTo('/config-mantenimiento/plan/$id');");
        $form->plan_id->setValue($id);
        $this->view->plan = $dataPlan;
        $this->view->form = $form;
        $this->view->title = "Planes de Mantenimiento : Agregar ítem";
        $this->renderScript('config-mantenimiento/form-item.phtml');
    }
    
    public function editarItemAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_BasePlanMantItem();
        $item = new Shipcode_Model_BasePlanMantItem();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $item->editar($form->getValues(), (int)$this->_getParam('id'), $this->usuario->id);
                    $mSession->mensajes = array('El ítem fue editado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/config-mantenimiento/plan/' . $form->getValue('plan_id'));

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar el trabajo.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/config-mantenimiento/plan/' . $form->getValue('plan_id'));
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $item->setId($id);
        $plan_id = $item->getPlanId();
        $form->populate($item->getRow()->toArray());
        $form->setAction('/config-mantenimiento/editar-item/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/config-mantenimiento/plan/$plan_id');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->plan = $item->getPlan();
        $this->view->form = $form;
        $this->view->title = "Planes de Mantenimiento : Editar ítem";
        $this->renderScript('config-mantenimiento/form-item.phtml');
    }
    
    public function eliminarItemAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        
        try {
            
            $plan = new Shipcode_Model_BasePlanMant();
            $plan_id = $plan->eliminarItem($id);
            
            $mSession->mensajes[] = 'El ítem fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/config-mantenimiento/plan/' . $plan_id);

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el ítem.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/config-mantenimiento/planes');
        }
    }
    
    public function responsableItemAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $id = (int)$this->_getParam('id');
        $asignado_a = $this->_getParam('from_id');
        
        try {
            
            if(!in_array($asignado_a, array('NAVE', 'EXTERNO'))){
                $asignado_a = 'NAVE';
            }

            $item = new Shipcode_Model_BasePlanMantItem();
            $item->setId($id);
            $item->configResponsable($asignado_a);
            $plan_id = $item->getPlanId();
            $mSession->mensajes = array('El ítem fue asignado de forma exitosa.');
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/config-mantenimiento/plan/' . $plan_id);

        } catch (Exception $e) {

            $mSession->mensajes = array('Ocurrió un error al intentar asignar el ítem del plan de mantenimiento.');
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/config-mantenimiento');
        }
    }
    /**************************************************************************/
}