<?php
class ConfigParametrosController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 5;
        
        $this->_helper->layout->setLayout('config');
        $this->view->action = $this->getRequest()->getActionName();
        $this->view->controller = $this->getRequest()->getControllerName();
        
        if(!$this->getRequest()->isXmlHttpRequest() && $this->usuario){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
            $response->insert('menuConfig' , $this->view->render('menu-base.phtml'));
        }
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $nave = new Shipcode_Model_Nave();
        $this->view->pageTitle = "Configuración de Reportes";
        $this->view->title = "Configuración de Reportes";
        $this->view->empresas = $nave->getAgrupadasPorEmpresaToSelect();
        
        if($this->_getParam('id')){
            
            $id = (int)$this->_getParam('id');
            
            $nave->setId($id);
            
            $parametro = new Shipcode_Model_EquipoParametro();
            
            $this->view->parametros = $parametro->getAll();
            $this->view->colspan = count($this->view->parametros) + 2;
            $this->view->nave = $nave->getRowFull();
            $this->view->sistemas = $nave->getSistemas();
        }
    }
    
    public function setParametroEquipoAction()
    {   
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if($this->getRequest()->isXmlHttpRequest()){
            try {
                $equipo_id = (int)$this->_getParam('equipo_id');
                $parametro_id = (int)$this->_getParam('parametro_id');
                
                $equipo = new Shipcode_Model_NaveEquipo();
                $equipo->setId($equipo_id);
                $equipo->setParametroInforme($parametro_id);
                
                $data['error'] = false;
                echo Zend_Json::encode($data);
                
            } catch(Exception $e){
                echo $e->getMessage();
            }
        }
    }
    
    public function vistaPreviaAction()
    {   
        $this->_helper->layout->disableLayout();
        if($this->getRequest()->isXmlHttpRequest()){
            try {
                $id = (int)$this->_getParam('id');
                $nave = new Shipcode_Model_Nave();
                $nave->setId($id);
                $this->view->equipos = $nave->getEquiposInforme();
                $parametro = new Shipcode_Model_EquipoParametro();
                $this->view->parametros = $parametro->getAll();
                $this->view->colspan = count($this->view->parametros) + 2;
            } catch(Exception $e){
                echo $e->getMessage();
            }
        }
    }
}