<?php
class ConfigPersonalController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pageTitle = 'Configuraciones personales';
        $this->view->pagina = 7;
        
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    /**************************************************************************/
    public function cambiarClaveAccesoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_CambiarClaveAcceso();
        $usuario = new Shipcode_Model_SistemaUsuario();
        $id = $this->usuario->id;
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $usuario->cambiarClave($form->getValues(), $this->usuario->id);
                    $mSession->mensajes[]   = 'La clave fue cambiada de forma exitosa. Comenzará a '
                                            . 'utilizarla desde próxima la vez que ingrese al sistema';
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/sistema-usuario/cambiar-clave-acceso');

                } catch (Exception $e) {

                    $mSession->mensajes[]   = 'Ocurrió un error al intentar cambiar la clave.';
                    $mSession->mensajes[]   = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/sistema-usuario/cambiar-clave-acceso');
                }
            }
        }
        $usuario->setId($id);
        $this->view->user = $usuario->getRow();
        $this->view->title = 'Usuario';
        $this->view->form = $form;
        $this->renderScript('config-personal/form-cambio-clave-acceso.phtml');
    }
    /**************************************************************************/
}
     