<?php
class ControlGastosController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);

        $this->view->pagina = 3;
        
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->view->pageTitle = "Control de Gastos de Mantenimiento";
        
        try {
            
            $empresa = new Shipcode_Model_Empresa();
            $this->view->empresas = $empresa->getAll();    
            //$empresa->setId(8);
            //$this->view->empresa = $empresa->getRowFull();
            //$this->view->naves = $empresa->getNaves();
            //$nave = new Shipcode_Model_Nave();
            //$this->view->dataEstadoActual = $nave->getEstadoActual($id, 2013);
            //$this->view->dataEstadoGasto = $nave->getEstadoGasto($id, 2013);
            //$this->view->navesSaldosNegativos = $nave->getNavesSaldosNegativos($id, 2013);
            $this->view->year = date("Y");
            
        } catch(Exception $e){
            echo $e->getMessage();
        }
    }
    
    public function importarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->view->pageTitle = "Control de Gastos de Mantenimiento :: Importar Datos";
        
        try {
            
           
            
        } catch(Exception $e){
            echo $e->getMessage();
        }
    }
    
    public function configAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->view->pageTitle = "Control de Gastos de Mantenimiento :: Configurar importación de datos";
        
        try {
            
           
            
        } catch(Exception $e){
            echo $e->getMessage();
        }
    }
    
    
    
    public function graficaGastosAction()
    {
        $this->_helper->layout->disableLayout();
        if($this->getRequest()->isXmlHttpRequest()){
            $empresa_id = (int)$this->_getParam('empresa_id');
            $year = (int)$this->_getParam('year');
            $empresa = new Shipcode_Model_Empresa();
            $empresa->setId($empresa_id);
            $this->view->naves  = $empresa->getGastosByNaveToGraph($year);
            $this->view->year   = $year;
        }
    }
}