<?php
class CronjobsController extends Zend_Controller_Action
{
    public function init()
    {
        $localHash = md5("EnvíoAutomáticoDeInformes" . date("Ymd")); 
        $remoteHash = $this->_getParam('hash');
        if($localHash !== $remoteHash){
            $this->_redirect('/acceso/logout');
        }
    }
    
    public function enviarMailInformesAutomaticosAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        $informe = new Shipcode_Model_SistemaInformeAutomatico();
        $informesParaEnviar = $informe->getAll();
        
        if(count($informesParaEnviar) > 0) { 
            foreach($informesParaEnviar as $informeParaEnviar){
                if(date("j") == $informeParaEnviar['dia']){
                    
                    $modelName = 'Shipcode_Model_' . $informeParaEnviar['modelo'];
                    $model = new $modelName();
                    $rows = $model->buscar(Zend_Json::decode($informeParaEnviar['parametros']));
                    if(count($rows) > 0) { 
                        $mail = new App_HtmlMailerDocument('UTF-8');
                        $mail->setFrom(Zend_Registry::get('MAIL_FROM'), Zend_Registry::get('FIRMA_EMPRESA'));
                        $mail->setSubject($informeParaEnviar['nombre'] . ' - ' . date("YmdHis"));
                        $mail->addTo($informeParaEnviar['mail'], $informeParaEnviar['usuario']);
                        if($informeParaEnviar['con_copia'] != NULL) {
                            $copias = explode(",", $informeParaEnviar['con_copia']);
                            foreach($copias as $copia){
                                $mail->addCc($copia);
                            }
                        }
                        if($informeParaEnviar['con_copia_oculta'] != NULL) {
                            $copiasOcultas = explode(",", $informeParaEnviar['con_copia_oculta']);
                            foreach($copiasOcultas as $copiaOculta){
                                $mail->addBcc($copiaOculta);
                            }
                        }
                        $mail->setViewParam('nombreInforme', $informeParaEnviar['nombre']);
                        $mail->setViewParam('rows', $rows);
                        $mail->setViewParam('mensaje', $informeParaEnviar['mensaje']);
                        $mail->setViewParam('firma', Zend_Registry::get('FIRMA_EMPRESA'));
                        $mail->sendHtmlTemplate('informe-' . $informeParaEnviar['base'] . '.phtml');
                    }
                }
            }
        } 
    }
    
    public function enviarMailNotificacionesAuditoriasAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        $auditoria = new Shipcode_Model_AuditoriaInterna();
        $auditoriasAviso = $auditoria->getRowsAvisoHoy();
        $auditoriasVencimiento = $auditoria->getRowsVencimientoHoy();
        
        if(count($auditoriasAviso) > 0) { 
            foreach($auditoriasAviso as $dataAuditoria){
                    
                $mail = new App_HtmlMailerDocument('UTF-8');
                $mail->setFrom(Zend_Registry::get('MAIL_FROM'), Zend_Registry::get('FIRMA_EMPRESA'));
                $mail->setSubject('Auditoría - Aviso - ' . $dataAuditoria['titulo']);
                $mail->addTo($dataAuditoria['mail_responsable'], $dataAuditoria['responsable']);
                if($dataAuditoria['notificaciones_aviso'] != NULL) {
                    $copias = explode(",", $dataAuditoria['notificaciones_aviso']);
                    foreach($copias as $copia){
                        $mail->addTo($copia);
                    }
                }
                $mail->setViewParam('auditoria', $dataAuditoria);
                $mail->setViewParam('firma', Zend_Registry::get('FIRMA_EMPRESA'));
                $mail->sendHtmlTemplate('auditoria-aviso.phtml');
            }
        } 
        
        if(count($auditoriasVencimiento) > 0) { 
            foreach($auditoriasVencimiento as $dataAuditoria){
                    
                $mail = new App_HtmlMailerDocument('UTF-8');
                $mail->setFrom(Zend_Registry::get('MAIL_FROM'), Zend_Registry::get('FIRMA_EMPRESA'));
                $mail->setSubject('Auditoría - Plazo vencido - ' . $dataAuditoria['titulo']);
                $mail->addTo($dataAuditoria['mail_responsable'], $dataAuditoria['responsable']);
                if($dataAuditoria['notificaciones_vencimiento'] != NULL) {
                    $copias = explode(",", $dataAuditoria['notificaciones_vencimiento']);
                    foreach($copias as $copia){
                        $mail->addTo($copia);
                    }
                }
                $mail->setViewParam('auditoria', $dataAuditoria);
                $mail->setViewParam('firma', Zend_Registry::get('FIRMA_EMPRESA'));
                $mail->sendHtmlTemplate('auditoria-vencimiento.phtml');
            }
        } 
    }
    
    public function enviarMailStatusMantenimientoNavesAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        $nave = new Shipcode_Model_Nave();
        $usuario = new Shipcode_Model_SistemaUsuario();
        $programacion = new Shipcode_Model_ProgramacionMensual();
        $mantenimiento = new Shipcode_Model_MantenimientoInformado();
        $solicitud = new Shipcode_Model_Solicitud();
        $naves = $nave->getAll();
        if(count($naves) > 0 ){
            foreach($naves as $dataNave){
                $id = $programacion->getIdProgramacionAbiertaByNaveId($dataNave->id);
                if($id){
                    $programacion->setId($id);
                    $dataProgramacion = $programacion->getRowFull();
                    $dataTrabajosInformados = $programacion->getTrabajosRealizadosUltimaSemana();
                } else {
                    $dataProgramacion = NULL;
                    $dataTrabajosInformados = NULL;
                }
                $dataMantenimientos = $mantenimiento->getUltimaSemana($dataNave->id);
                $dataSolicitudes = $solicitud->getUltimaSemana($dataNave->id);
                $dataEquipos = $nave->getEquiposInformeToMail($dataNave->id);
                
                $mail = new App_HtmlMailerDocument('UTF-8');
                $mail->setFrom(Zend_Registry::get('MAIL_FROM'), Zend_Registry::get('FIRMA_EMPRESA'));
                $mail->setSubject("Estado mant. mensual" . ' - Nave : ' . $dataNave->nombre . ' - ' . date("YmdHis"));
                $mail->setViewParam('nave', $dataNave);
                $mail->setViewParam('programacion', $dataProgramacion);
                $mail->setViewParam('mantenimientos', $dataMantenimientos);
                $mail->setViewParam('solicitudes', $dataSolicitudes);
                $mail->setViewParam('trabajosInformados', $dataTrabajosInformados);
                $mail->setViewParam('equipos', $dataEquipos);
                $mail->setViewParam('firma', Zend_Registry::get('FIRMA_EMPRESA'));
                //$motoristas = $usuario->getMotoristasByNaveId($dataNave->id);
                //$supervisores = $usuario->getSupervisoresByEmpresaId($dataNave->empresa_id);
                /*
                if(count($motoristas) > 0){
                    foreach($motoristas as $motorista){
                        $mail->addTo($motorista['mail'], $motorista['nombre']);
                    }
                }
                if(count($supervisores) > 0){
                    foreach($supervisores as $supervisor){
                        $mail->addTo($supervisor['mail'], $supervisor['nombre']);
                    }
                }*/
                $mail->addTo(Zend_Registry::get('MAIL_SUPERADMIN'), Zend_Registry::get('NOMBRE_SUPERADMIN'));
                //$mail->addBcc('claudiosalazarb@gmail.com', 'Claudio Salazar');
                
                //$mail->addTo('claudiosalazarb@gmail.com', 'Claudio Salazar');
                $mail->sendHtmlTemplate('informe-status-mantenimiento-nave.phtml');
            }
        }
    }
    
    public function enviarMailStatusMantenimientoSupervisoresAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        $usuario = new Shipcode_Model_SistemaUsuario();
        $supervisores = $usuario->getAll(10, 10);
        
        foreach($supervisores as $sup){
            $usuario->setId($sup['id']);
            $dataUsuario = $usuario->getRow()->toArray();
            $autorizaciones = Zend_Json::decode($dataUsuario['autorizaciones']);
           
            $nave = new Shipcode_Model_Nave();
            $programacion = new Shipcode_Model_ProgramacionMensual();
            $mantenimiento = new Shipcode_Model_MantenimientoInformado();
            $naves = $nave->getAll($autorizaciones);
            if(count($naves) > 0 ){
                foreach($naves as $dataNave){
                    $id = $programacion->getIdProgramacionAbiertaByNaveId($dataNave->id);
                    if($id){
                        $programacion->setId($id);
                        $dataProgramacion = $programacion->getRowFull();
                        $dataTrabajosInformados = $programacion->getTrabajosRealizadosUltimaSemana();
                    } else {
                        $dataProgramacion = NULL;
                        $dataTrabajosInformados = NULL;
                    }
                    $dataMantenimientos = $mantenimiento->getUltimaSemana($dataNave->id);
                    $dataEquipos = $nave->getEquiposInformeToMail($dataNave->id);

                    $mail = new App_HtmlMailerDocument('UTF-8');
                    $mail->setFrom(Zend_Registry::get('MAIL_FROM'), Zend_Registry::get('FIRMA_EMPRESA'));
                    $mail->setSubject("Estado mant. mensual" . ' - Nave : ' . $dataNave->nombre . ' - ' . date("YmdHis"));
                    $mail->setViewParam('nave', $dataNave);
                    $mail->setViewParam('programacion', $dataProgramacion);
                    $mail->setViewParam('mantenimientos', $dataMantenimientos);
                    $mail->setViewParam('trabajosInformados', $dataTrabajosInformados);
                    $mail->setViewParam('equipos', $dataEquipos);
                    $mail->setViewParam('firma', Zend_Registry::get('FIRMA_EMPRESA'));

                    $mail->addTo($sup['mail'], $sup['nombre']);
                    $mail->sendHtmlTemplate('informe-status-mantenimiento.phtml');
                }
            }
        }
    }
    
    public function enviarMailStatusMantenimientoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        $nave = new Shipcode_Model_Nave();
        $programacion = new Shipcode_Model_ProgramacionMensual();
        $mantenimiento = new Shipcode_Model_MantenimientoInformado();
        $naves = $nave->getAll();
        if(count($naves) > 0 ){
            foreach($naves as $dataNave){
                $id = $programacion->getIdProgramacionAbiertaByNaveId($dataNave->id);
                if($id){
                    $programacion->setId($id);
                    $dataProgramacion = $programacion->getRowFull();
                    $dataTrabajosInformados = $programacion->getTrabajosRealizadosUltimaSemana();
                } else {
                    $dataProgramacion = NULL;
                    $dataTrabajosInformados = NULL;
                }
                $dataMantenimientos = $mantenimiento->getUltimaSemana($dataNave->id);
                $dataEquipos = $nave->getEquiposInformeToMail($dataNave->id);
                
                $mail = new App_HtmlMailerDocument('UTF-8');
                $mail->setFrom(Zend_Registry::get('MAIL_FROM'), Zend_Registry::get('FIRMA_EMPRESA'));
                $mail->setSubject("Estado mant. mensual" . ' - Nave : ' . $dataNave->nombre . ' - ' . date("YmdHis"));
                $mail->setViewParam('nave', $dataNave);
                $mail->setViewParam('programacion', $dataProgramacion);
                $mail->setViewParam('mantenimientos', $dataMantenimientos);
                $mail->setViewParam('trabajosInformados', $dataTrabajosInformados);
                $mail->setViewParam('equipos', $dataEquipos);
                $mail->setViewParam('firma', Zend_Registry::get('FIRMA_EMPRESA'));
                
                $mail->addTo(Zend_Registry::get('MAIL_SUPERADMIN'), Zend_Registry::get('NOMBRE_SUPERADMIN'));
                $mail->addBcc('claudiosalazarb@gmail.com', 'Claudio Salazar');
                //$mail->addTo('claudiosalazarb@gmail.com', 'Claudio Salazar');
                $mail->sendHtmlTemplate('informe-status-mantenimiento.phtml');
            }
        }
    }

    public function cerrarProyectosProrrateadosAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        $proyecto = new Shipcode_Model_Proyecto();
        $proyectosTerminadosAbiertos = $proyecto->getTerminadosParaCierre();
        if(count($proyectosTerminadosAbiertos) > 0) { 
            
            foreach($proyectosTerminadosAbiertos as $proyectoTerminadoAbierto){

                $proyecto->liquidarAutomatico($proyectoTerminadoAbierto['id']);

                $mail = new App_HtmlMailerDocument('UTF-8');
                $mail->setFrom(Zend_Registry::get('MAIL_FROM'), Zend_Registry::get('FIRMA_EMPRESA'))
                     ->addTo(Zend_Registry::get('MAIL_SUPERADMIN'))
                     ->setSubject('Termino de prorrateo de proyecto')
                     ->setViewParam('proyecto', $proyectoTerminadoAbierto)
                     ->sendHtmlTemplate('cierre-proyecto.phtml');
            }
        }
    }    
    
    // Falta uno para el supervisor con el resumen de todas sus naves
    // Falta uno para los admin con el resumen de toda la flota
    /*
    public function enviarMailReportesNoEnviadosAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        $informe = new Shipcode_Model_NaveInforme();
        $navesSinReporte = $informe->getNoEnviados();
        if(count($navesSinReporte) > 0) { 
            $mail = new App_HtmlMailerDocument('UTF-8');
            $mail->setFrom(Zend_Registry::get('MAIL_FROM'), Zend_Registry::get('FIRMA_EMPRESA'));
            $mail->setSubject('Aviso reportes no enviados')
                 ->setViewParam('navesSinReporte', $navesSinReporte);
            $nave = new Shipcode_Model_Nave();
            $nave->setId($informe->getNaveId());
            $supervisores = $nave->getSupervisores();
            if(count($supervisores) > 0){
                foreach($supervisores as $supervisor){
                    $mail->addTo($supervisor['mail'], $supervisor['nombre']);
                }
            }
            $mail->addBcc('claudiosalazarb@gmail.com', 'Claudio Salazar Beltrán');
            $mail->sendHtmlTemplate('informes-no-enviados.phtml');
            echo 'El mail fue enviado de forma satisfactoria.';
        } 
    }
    */
}