<?php

require_once Zend_Registry::get('OTHERS_PHP_CLASSES'). '/abeautifulsite/SimpleImage.php';

class EquipoController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->controller = $this->getRequest()->getControllerName();
        $this->view->action = $this->getRequest()->getActionName();
        
        if($this->usuario->perfil_id >= 20 && $this->usuario->perfil <= 29){
            $this->nave_id = $this->view->nave_id = Shipcode_Model_SistemaUsuario::getNaveAsignada($this->view->autorizaciones['naves']);
            $nave = new Shipcode_Model_Nave();
            $nave->setId($this->nave_id);
            $this->view->naveToMenu = $nave->getRow()->nombre;
            $this->ultimaVisita = Shipcode_Model_SistemaLogIngreso::getVisitaAnteriorByUsuarioId($this->usuario->id);
        }
        
        /*
        if($this->usuario->tipo == 2){
            $this->empresa_id = $this->view->empresa_id = Shipcode_Model_SistemaUsuario::getEmpresaAsignada($this->view->privilegios['autorizaciones']['empresas']);
        }
        */
        
        $this->view->pagina = 1;
        
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    public function verAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $id = (int)$this->_getParam('id');
        
        if($this->_getParam('tab')){
            $this->view->tab = $this->_getParam('tab');
        }
        try {
            $modelEquipo = new Shipcode_Model_NaveEquipo();
            $modelEquipo->setId($id);
            $this->view->equipo = $modelEquipo->getRowFull();
            $this->view->gastos = array(); //$modelEquipo->getGastos();
            $this->view->partes = $modelEquipo->getPartes();
            $this->view->horometro = $modelEquipo->getUltimaLecturaHorometro();  
            $this->view->tiposServiciosRealizados = $modelEquipo->getTiposServiciosRealizados();
            $this->view->yearsMantenimientos = $modelEquipo->getHistorialMantenimiento();
            $this->view->plan = $modelEquipo->getPlanMantenimiento($this->view->equipo['planmant_id']);
            $this->view->pageTitle = "Detalle equipo";
            $this->view->horasOperacion = $modelEquipo->getHorasOperacionMensuales();
            $this->view->etiquetasArchivos = $modelEquipo->getArchivos();
            $this->view->ubicaciones = $modelEquipo->getUbicaciones(5);
            
        } catch(Exception $e){
            
            $mSession->mensajes[] = "Ocurrió un problema al intentar visualizar el equipo.";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect($_SERVER['HTTP_REFERER']);
            
        }
    }

    public function agregarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $sistema = new Shipcode_Model_NaveSistema();
        
        $id = (int)$this->getParam('id');
        $request = $this->getRequest();
        $form = new Shipcode_Form_Equipo();
        $form->sistema_id->addMultiOptions($sistema->getPairsToSelectByNaveId($id));
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $modelEquipo = new Shipcode_Model_NaveEquipo();
                    $id = $modelEquipo->crear($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('El equipo fue creado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/equipo/ver/' . $id);
                    
                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear el equipo.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $id .'#equipos');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        $form->setAction('/equipo/agregar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$id#equipos');");
        $modelNave = new Shipcode_Model_Nave();
        $modelNave->setId($id);
        $this->view->nave = $modelNave->getRowFull();
        $this->view->form = $form;
        $this->view->title = "Agregar equipo";
        $this->view->pageTitle = $this->view->nave->nombre . " > Agregar equipo";
        $this->renderScript('equipo/form.phtml');
    }
    
    public function editarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $sistema = new Shipcode_Model_NaveSistema();

        $request = $this->getRequest();
        $form = new Shipcode_Form_Equipo();
        $form->id->setRequired(true);
        $equipo = new Shipcode_Model_NaveEquipo();
        $id = (int)$this->_getParam('id');
        $equipo->setId($id);
        $this->view->equipo = $equipo->getRowFull();
        
        if($this->view->equipo['sistema_id'] == NULL) {
            $form->sistema_id->setRequired(false);
        } else {
            $form->sistema_id->addMultiOptions($sistema->getPairsToSelectByNaveId($this->view->equipo['nave_id']));
        }
                
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    
                    $equipo->editar($form->getValues(), $this->usuario->id, $form->getValue('id'));
                    $mSession->mensajes[] = 'La información del equipo fue editada de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/equipo/ver/' . $form->getValue('id'));

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar la información del equipo.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/equipo/ver/' . $form->getValue('id'));
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        
        $form->populate($equipo->getRowToForm());
        $form->setAction('/equipo/editar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/equipo/ver/$id');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->title = "Editar equipo";
        $this->view->pageTitle = "Editar equipo";
        $this->view->form = $form;
        $this->renderScript('equipo/form.phtml');
    }
    
    public function eliminarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $this->_helper->viewRenderer->setNoRender();
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $id = (int)$this->_getParam('id');
        
        try {
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->setId($id);
            $ubicacion = $equipo->getUbicacionToBack();
            $equipo->eliminar();
            $mSession->mensajes[] = 'El equipo y toda su información relacionada fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect("/" . $ubicacion['tipo'] . "/ver/" . $ubicacion['id']);

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el equipo y su información relacionada.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/equipo/ver/' .  $id);
        }
    }
    
    public function ordenarAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
       
        $data = $this->_getParam('data');
        
        if (isset($data)) {
            try {
                
                $equipo = new Shipcode_Model_NaveEquipo();
                $equipo->setOrden($data);
                $result = array(
                    'error'     => false
                );
                
                echo Zend_Json_Encoder::encode($result);
                
            } catch(Exception $e){
                echo $e->getMessage();
            }
        }
    }
    
    public function subirFotografiaAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
            
        if($this->getRequest()->isXmlHttpRequest()){
            
            $path = 'files/fotografias/';
            $id = (int)$this->_getParam('id');
            $allowedExtensions = array('jpeg', 'jpg', 'JPG', 'png');
            $sizeLimit = 3 * 1024 * 1024;
            $uploader = new App_Upload_QqFileUploader($allowedExtensions, $sizeLimit);
            $result = $uploader->handleUpload($path, TRUE);
            $name = $uploader->getName();
            
            if($result == TRUE){
                
                $newName = date("Ymdhis") . '.jpg';
                $image = new abeautifulsite\SimpleImage($path . $name);
                $image->fit_to_width(960);
                $image->save($path. $newName);
                $image->fit_to_width(360);
                $image->save($path . 'thumbs/' . $newName);
                
                try{
                    $equipo = new Shipcode_Model_NaveEquipo();
                    $equipo->setId($id);
                    $equipo->actualizarFotografia($newName);
                    echo Zend_Json_Encoder::encode(array('success' => true, 'name' => $newName));
                    
                } catch(Exception $e){
                    echo $e->getTraceAsString();
                }
            } else {
                echo Zend_Json_Encoder::encode($result);
            }
         
        }    
    }
    /**************************************************************************/
    
    /************************ OPERACIONES HOROMETROS **************************/
    public function crearRegistroDeHorometroAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $id = (int)$this->getParam('id');
        $request = $this->getRequest();
        $form = new Shipcode_Form_EquipoHorometro();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $equipo = new Shipcode_Model_NaveEquipo();
                    $equipo->crearRegistroHorometro($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('El registro de horómetro fue creado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/equipo/ver/' . $form->getValue('equipo_id'));

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar el registro de horómetro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/equipo/ver/' . $form->getValue('equipo_id') .'/partes');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $form->setAction('/equipo/crear-registro-de-horometro/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/equipo/ver/$id');");
        
        $modelEquipo = new Shipcode_Model_NaveEquipo();
        $modelEquipo->setId($id);
        $this->view->equipo = $modelEquipo->getRowFull();
        $form->equipo_id->setValue($id);
        $this->view->form = $form;
        $this->view->title = "Crear registro de horómetro";
        $this->view->pageTitle = $this->view->equipo['nombre'] . " > Crear registro de horómetro";
        $this->renderScript('equipo/form-registro-de-horometro.phtml');
    }
    
    public function asignarPromedioOperacionAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if($this->getRequest()->isPost()) {
            if ($this->_getParam('id') && $this->_getParam('promedio')) {
                try {

                    $id = (int)$this->_getParam('id');
                    $promedio = (int)$this->_getParam('promedio');
                    $equipo = new Shipcode_Model_NaveEquipo();
                    $equipo->setId($id);
                    $equipo->setPromedioAsignado($promedio, $this->usuario->id);
                    
                    $mSession->mensajes = array('El promedio de operación mensual fue asignado de forma satisfactoria.');
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar asignar el promedio de operación.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                }
            } else {
                $mSession->mensajes = array('Ocurrió un error al intentar asignar el promedio de operación.');
                $mSession->claseMensaje = 'error';
            }
        } 
        
        $this->_redirect($_SERVER['HTTP_REFERER']);
    }
    
    public function calcularPromedioOperacionAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();

        try {

            $id = (int)$this->_getParam('id');
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->setId($id);
            $promedio = $equipo->calcularPromedioMensualOperacion();
            $equipo->setPromedioCalculado($promedio, $this->usuario->id);

            $mSession->mensajes = array('El promedio de operación fue recalculado de forma satisfactoria.');
            $mSession->claseMensaje = 'confirmacion';

        } catch (Exception $e) {

            $mSession->mensajes = array('Ocurrió un error al intentar calcular el promedio de operación.');
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
        }
            
        $this->_redirect($_SERVER['HTTP_REFERER']);
    }
    
    public function usarPromedioAsignadoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        try {
            
            $id = (int)$this->_getParam('id');
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->setId($id);
            $equipo->setPromedioUsado("A", $this->usuario->id);
            $mSession->mensajes[] = "El equipo fue configurado para utilizar el promedio de horas asignado para los cálculos de fecha.";
            $mSession->claseMensaje = "confirmacion";
            
        } catch(Exception $e){
            $mSession->mensajes[] = 'Ocurrió un error al intentar configurar el promedio de horas del equipo';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
        }
        
        $this->_redirect($_SERVER['HTTP_REFERER']);
    }
    
    public function usarPromedioCalculadoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        try {
            
            $id = (int)$this->_getParam('id');
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->setId($id);
            $equipo->setPromedioUsado("C", $this->usuario->id);
            $mSession->mensajes[] = "El equipo fue configurado para utilizar el promedio de horas calculado por el sistema para los cálculos de fecha.";
            $mSession->claseMensaje = "confirmacion";
            
        } catch(Exception $e){
            $mSession->mensajes[] = 'Ocurrió un error al intentar configurar el promedio de horas del equipo';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
        }
        
        $this->_redirect($_SERVER['HTTP_REFERER']);
    }
   
    public function eliminarRegistroHorometroAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $id = (int)$this->_getParam('id');
        $equipo = new Shipcode_Model_NaveEquipo();
        $equipo->setId($id);
        
        try {
            $equipo->eliminarRegistroHorometro();
            $mSession->mensajes[] = 'El registro de horómetro fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/equipo/ver/' . $id);

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el registro de horómetro .';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/equipo/ver/' .  $id);
        }
    }
    
    /*********** anclaje de horometros *************/
    public function selectAncladoAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
            
            $id = (int)$this->_getParam('id');
            $equipo = new Shipcode_Model_NaveEquipo();
            $sistema = new Shipcode_Model_NaveSistema();
            $equipo->setId($id);
            $this->view->equipo = $equipo->getRowFull();
            
            if($this->view->equipo['sistema_id']) {
                $this->view->equipos = $sistema->getOtrosEquiposConHorometro($this->view->equipo['sistema_id'], $id);
            }
        }
    }
    
    public function anclarHorometrosAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
        
            try {
                
                $dataErrores = NULL;
                
                $fecha_lectura = $this->_getParam('fecha_lectura');
                $lectura_maestro = $this->_getParam('lectura_maestro');
                $lectura_esclavo = $this->_getParam('lectura_esclavo');
                $id_maestro = $this->_getParam('id_maestro');
                $id_esclavo = $this->_getParam('id_esclavo');
                
                $equipoMaestro = new Shipcode_Model_NaveEquipo();
                $equipoMaestro->setId($id_maestro);
                $checkEquipoMaestro = $equipoMaestro->verificarSiEsUltimaLectura($fecha_lectura, $lectura_maestro);
                if($checkEquipoMaestro !== TRUE){
                    $error['nombre'] =  "Equipo Maestro";
                    $error['mensajes'] = $checkEquipoMaestro;
                    $dataErrores[] = $error;
                }
                
                $equipoEsclavo = new Shipcode_Model_NaveEquipo();
                $equipoEsclavo->setId($id_esclavo);
                $checkEquipoEsclavo = $equipoEsclavo->verificarSiEsUltimaLectura($fecha_lectura, $lectura_esclavo);
                if($checkEquipoEsclavo !== TRUE){
                    $error['nombre'] = "Equipo Esclavo";
                    $error['mensajes'] = $checkEquipoEsclavo;
                    $dataErrores[] = $error;
                }
                
                if($dataErrores === NULL){
                    
                    $equipoEsclavo->anclarHorometro($id_maestro);
                    $id = $equipoMaestro->registrarLecturaHorometro($lectura_maestro, $fecha_lectura, $this->usuario->id);
                    $equipoEsclavo->registrarLecturaHorometro($lectura_esclavo, $fecha_lectura, $this->usuario->id, $id);
                    
                    $data['error'] = false;
                    $data['ubicacion'] = false;
                    $data['fila'] = $equipoMaestro->getLecturaHorometroByIdToJson($id);
                    $data['sumario'] = $equipoMaestro->getSumarioHorometroToJson();
                    $data['horasOperacion'] = $equipoMaestro->getHorasOperacionMensuales();
                    echo Zend_Json::encode($data);
                    
                } else {
                    $data['error'] = true;
                    $data['dataErrores'] = $dataErrores;
                    echo Zend_Json::encode($data);
                }
                
            } catch (Exception $ex) {
                $data['error'] = true;
                $data['mensaje'] = "Ocurrió un error al intentar anclar los horómetros." . $ex->getMessage();
                echo Zend_Json::encode($data);
            }
        }
    }
    
    public function eliminarAnclajeHorometroAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            try {
                
                $id = (int)$this->_getParam('id');
                $equipo = new Shipcode_Model_NaveEquipo();
                $equipo->setId($id);
                $equipo->eliminarAnclajeHorometro();
                $data['error'] = false;
                echo Zend_Json::encode($data);
                
            } catch (Exception $ex) {
                $data['error'] = true;
                $data['mensaje'] = "Ocurrió un error al intentar eliminar el anclaje de los horómetros." . $ex->getMessage();
                echo Zend_Json::encode($data);
            }
        }
    }
    /**************************************************************************/
    
    /******************* OPERACIONES PLAN DE MANTENIMIENTO ********************/
    public function seleccionarPlanDeMantenimientoAction()
    {
        $this->_helper->layout->disableLayout();
        
        $id = (int)$this->_getParam('id');
        
        $equipo = new Shipcode_Model_NaveEquipo();
        $equipo->setId($id);
        $this->view->planes = $equipo->getPlanesSugeridos();
        $this->view->id = $id;
    }
    
    public function asignarPlanDeMantenimientoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $id = (int)$this->_getParam('id');
        $plan_id = (int)$this->_getParam('from_id');
        
        try {
            
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->setId($id);
            $equipo->asignarPlanMantenimiento($plan_id, $this->usuario->id);
            $mSession->mensajes[] = 'El plan de mantenimiento fue asignado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/equipo/ver/' . $id .'/plan-de-mantenimiento');

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar asociar el plan de mantenimiento.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/equipo/ver/' .  $id .'/plan-de-mantenimiento');
        }
    }
    
    public function eliminarPlanDeMantenimientoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        
        try {
            
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->setId($id);
            $equipo->eliminarPlanMantenimiento();
            $mSession->mensajes[] = 'El equipo ya no se encuentra asociado a un plan de mantenimiento';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/equipo/ver/' . $id .'/plan-de-mantenimiento');

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar la asociación del plan de mantenimiento.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/equipo/ver/' .  $id .'/plan-de-mantenimiento');
        }
    }
    /**************************************************************************/
    
    /*********************** OPERACIONES UBICACIONES **************************/
    public function registroHistoricoUbicacionesAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){
            $this->_helper->layout->disableLayout();
            $id = (int)$this->_getParam('id');
            $equipo = new Shipcode_Model_NaveEquipo();
            $equipo->setId($id);
            $this->view->ubicaciones = $equipo->getUbicaciones();
        }
    }
    /**************************************************************************/
    
    /*
    public function crearThumbnailsAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        
        $i = 0;
        $dir = '/home/admin/sites/riodulce.naves.cl/public/files/equipos/fotografias/';
        
        $modelEquipo = new Shipcode_Model_NaveEquipo();
        $equipos = $modelEquipo->fetchAll("fotografia IS NOT NULL");
        
        foreach($equipos as $equipo){
            if(file_exists($dir . $equipo->fotografia)){
                
                $newName = date("Ymdhis") . '.jpg';
                $image = new abeautifulsite\SimpleImage($dir . $equipo->fotografia);
                $image->fit_to_width(960);
                $image->save($dir . $newName);
                
                if(file_exists($dir . $newName)){
                    
                    $rowEquipo = new Shipcode_Model_NaveEquipo();
                    $rowEquipo->setId($equipo->id);
                    $rowEquipo->actualizarFotografia($newName);
                    
                    $image->fit_to_width(360);
                    $image->save($dir . 'thumbs/' . $newName);
                    $i++;
                    
                    unlink($dir . $equipo->fotografia);
                    if(file_exists($dir . 'thumbs/' . $equipo->fotografia)){
                        unlink($dir . 'thumbs/' . $equipo->fotografia);
                    }
                        
                    
                    sleep(1);
                    
                }
               
            }
        }
        echo "Se crearon $i thumbnails";
    }
    public function testPromedioHorasAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        
        $equipo = new Shipcode_Model_NaveEquipo();
        $equipo->setId(4442);
        Zend_Debug::dump($equipo->calcularPromedioMensualOperacion());
        
    }
    public function checkFotosAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        $equipo = new Shipcode_Model_NaveEquipo();
        $whereConFoto = "fotografia IS NOT NULL";
        $equiposConFoto = $equipo->fetchAll($whereConFoto);
        if(count($equiposConFoto) > 0){
            foreach($equiposConFoto as $equipoConFoto){
                $foto = Zend_Registry::get('PATH_SERVER') . 'files/equipos/fotografias/' . $equipoConFoto->fotografia;
                if(!file_exists($foto)){
                    echo $equipoConFoto->id . ' :: ' . $equipoConFoto->nombre .'<br>';
                }
            }
        }
    }
    */
}