<?php

class EquipoParteController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 1;
        
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    public function agregarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $id = (int)$this->getParam('id');
        $request = $this->getRequest();
        $form = new Shipcode_Form_EquipoParte();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $equipo = new Shipcode_Model_NaveEquipo();
                    $equipo->agregarParte($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('La información de partes y piezas fue ingresada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/equipo/ver/' . $form->getValue('equipo_id') .'#partes-y-piezas');

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar ingresar la información de partes y piezas.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/equipo/ver/' . $form->getValue('equipo_id') .'#partes-y-piezas');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $form->setAction('/equipo-parte/agregar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/equipo/ver/$id#partes-y-piezas');");
        $modelEquipo = new Shipcode_Model_NaveEquipo();
        $modelEquipo->setId($id);
        $this->view->equipo = $modelEquipo->getRowFull();
        $form->equipo_id->setValue($id);
        $this->view->form = $form;
        $this->view->title = "Agregar partes y piezas";
        $this->view->pageTitle = $this->view->equipo['nombre'] . " > Agregar partes y piezas";
        $this->renderScript('equipo-parte/form.phtml');
    }

    public function editarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_EquipoParte();
        $parte = new Shipcode_Model_NaveEquipoParte();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $parte->editar($form->getValues(), $this->usuario->id, (int)$this->_getParam('id'));
                    
                    $mSession->mensajes = array('Las partes y piezas fueron editadas de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/equipo/ver/' . $form->getValue('equipo_id') .'#partes-y-piezas');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar la información de partes y piezas.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/equipo/ver/' . $form->getValue('equipo_id') .'#partes-y-piezas');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $parte->setId($id);
        $equipo_id = $parte->getEquipoId();
        $form->populate($parte->getRow()->toArray());
        $form->setAction('/equipo-parte/editar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/equipo/ver/$equipo_id#partes-y-piezas');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->equipo = $parte->getEquipo();
        $this->view->title = "Editar partes y piezas";
        $this->view->pageTitle = $this->view->equipo['nombre'] . " > Editar partes y piezas";
        $this->renderScript('equipo-parte/form.phtml');
    }
    
    public function eliminarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        $parte = new Shipcode_Model_NaveEquipoParte();
        $parte->setId($id);
        $equipo_id = $parte->getEquipoId();
        
        try {

            $parte->eliminar();
            $mSession->mensajes[] = 'La información de partes y piezas fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/equipo/ver/' . $equipo_id .'#partes-y-piezas');

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar la información de partes y piezas.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/equipo/ver/' .  $equipo_id .'#partes-y-piezas');
        }
    }
}