<?php
class ErrorController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pageTitle = 'Gestión de Errores';
        $this->view->pagina = 5;
        
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    public function errorAction()
    {
        // Ensure the default view suffix is used so we always return good
        // content
        $this->_helper->viewRenderer->setViewSuffix('phtml');

        // Grab the error object from the request
        $errors = $this->_getParam('error_handler');

        // $errors will be an object set as a parameter of the request object,
        // type is a property
        switch ($errors->type) {
            case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_CONTROLLER:
            case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_ACTION:

                // 404 error -- controller or action not found
                $this->getResponse()->setHttpResponseCode(404);
                $this->view->message = 'Page not found';
                break;
            default:
                // application error
                $this->getResponse()->setHttpResponseCode(500);
                $this->view->message = 'Application error';
                break;
        }

        // pass the environment to the view script so we can conditionally
        // display more/less information
        $this->view->env       = $this->getInvokeArg('env');

        // pass the actual exception object to the view
        $this->view->exception = $errors->exception;

        // pass the request to the view
        $this->view->request   = $errors->request;
        $this->view->pageTitle = "Gestión de Errores";
    }

    public function errorDeleteRegistroAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('session');

            $this->view->errores        = $mSession->errores;
            $this->view->tipo_error     = $mSession->tipo_error;
            $mSession->errores          = null;
            $mSession->tipo_error       = null;

            $this->view->title = 'Error al intenter eliminar un registro';
            $this->renderScript('error/error-delete-registro.phtml');
        }
    }

    public function errorNewRegistroAction()
    {
        if($this->getRequest()->isXmlHttpRequest()){

            $mSession = new Zend_Session_Namespace('session');

            $this->view->errores        = $mSession->errores;
            $this->view->tipo_error     = $mSession->tipo_error;
            $mSession->errores          = null;
            $mSession->tipo_error       = null;

            $this->view->title = 'Error al intenter crear un registro';
            $this->renderScript('error/error-new-registro.phtml');
        }
    }
}
