<?php
class InformesController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 2;

        if($this->usuario->perfil_id >= 20 && $this->usuario->perfil <= 29){
            $this->nave_id = $this->view->nave_id = Shipcode_Model_SistemaUsuario::getNaveAsignada($this->view->autorizaciones['naves']);
            $nave = new Shipcode_Model_Nave();
            $nave->setId($this->nave_id);
            $this->view->naveToMenu = $nave->getRow()->nombre;
            
        }
        
        $this->ultimaVisita = Shipcode_Model_SistemaLogIngreso::getVisitaAnteriorByUsuarioId($this->usuario->id);
        $this->fecha = "Realizado el " . $this->view->formatFechaCorta(date("Y-m-d")) . ", a las " . date("H:i");
        $action = $this->getRequest()->getActionName();
        
        if(!$this->getRequest()->isXmlHttpRequest() 
                && !$this->_getParam('export') 
                && $action != 'crear-pdf'){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    /**************************************************************************/
    
    /********************** OPERACIONES CERTIFICADOS **************************/
    public function certificadosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        unset($mSession->informe);
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de certificados";
        $empresa = new Shipcode_Model_Empresa();
        $tipo = new Shipcode_Model_TipoCertificado();
        $this->view->tipos = $tipo->getPairsToSelect();
        $this->view->empresas = $empresa->getAll();
        $this->renderScript('informes/form-certificados.phtml');
    }
    
    public function buscarCertificadosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de certificados";
        $certificado = new Shipcode_Model_NaveCertificado();
        
        $parametros = array(
            'empresa' => $this->_getParam('empresa'),
            'nave' => $this->_getParam('nave'),
            'tipo' => $this->_getParam('tipo'),
            'numero' => $this->_getParam('numero'),
            'estado' => $this->_getParam('estado')
        );
        
        if($parametros['estado'] == 0 ) { $titulo = 'Informe certificados'; }
        if($parametros['estado'] == 1 ) { $titulo = 'Informe certificados por vencer'; }
        if($parametros['estado'] == 2 ) { $titulo = 'Informe certificados vencidos'; }
        if($parametros['estado'] == 3 ) { $titulo = 'Informe certificados con vencimiento desconocido'; }
        if($parametros['estado'] == 4 ) { $titulo = 'Informe certificados indefinidos'; }
        
        $rowsCertificados = $certificado->buscar($parametros, $this->view->autorizaciones['naves']);
        
        $this->view->certificados = $rowsCertificados;
        $mSession->informe['filas'] = $rowsCertificados;
        $mSession->informe['fileName'] = 'Informe_Certificados.pdf';
        $mSession->informe['contents'] = $certificado->getHtmlToPdf($rowsCertificados, $titulo);
        $mSession->informe['tipo'] = 'Certificados';
        $mSession->informe['base'] = 'certificados';
        $mSession->informe['modelo'] = "NaveCertificado";
        $mSession->informe['parametros'] = $parametros;
        
        if($this->_getParam('export') == 'xls') {
            
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
            require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
            PHPExcel_Settings::setLocale('es');

            $objPHPExcel = new PHPExcel();
            $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(12);
            $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', $titulo);
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', Shipcode_Model_Fecha::format($this->fecha));
            $objPHPExcel->setActiveSheetIndex(0)
                        ->setCellValue('A3', 'Empresa')
                        ->setCellValue('B3', 'Nave')
                        ->setCellValue('D3', 'Nombre')
                        ->setCellValue('C3', 'Nº')
                        ->setCellValue('E3', 'Emisión')
                        ->setCellValue('F3', 'Vencimiento');

            $objPHPExcel->getActiveSheet()->mergeCells('A1:F1');
            $objPHPExcel->getActiveSheet()->mergeCells('A2:F2');
            
            $styleArrayTitulo = array(
                'font' => array('bold' => true, 'size' => 24, 'color' => array('argb' => '00000000'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayFecha = array(
                'font' => array('bold' => false, 'size' => 12, 'color' => array('argb' => '66666666'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayCabeceras = array(
                'font' => array('bold' => true, 'size' => 12, 'color' => array('argb' => 'ffffffff'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,),
                'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
                'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '33333300',),),
            );
            
            $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArrayTitulo);
            $objPHPExcel->getActiveSheet()->getStyle('A2')->applyFromArray($styleArrayFecha);
            $objPHPExcel->getActiveSheet()->getStyle('A3:F3')->applyFromArray($styleArrayCabeceras);
            
            if(count($rowsCertificados) > 0) {
                $fila = 4;
                foreach($rowsCertificados as $certificado) { 
                    
                    if($certificado['fecha_emision']==NULL){ 
                        $fechaEmisionTexto = 'Desconocida'; 
                    } else { 
                        $fechaEmisionTexto = Shipcode_Model_Fecha::format($certificado['fecha_emision']); 
                    }
                
                    if($certificado['fecha_vencimiento'] == NULL && $certificado['indefinido'] == 0){ 
                        $fechaVencimientoTexto = 'Desconocida';
                    } elseif($certificado['fecha_vencimiento'] == NULL && $certificado['indefinido'] == 1) {
                        $fechaVencimientoTexto = 'Indefinido';
                    } else {   
                        $fechaVencimientoTexto = Shipcode_Model_Fecha::format($certificado['fecha_vencimiento']);
                    }
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $certificado['empresa']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $fila, $certificado['nave']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $fila, $certificado['tipo'] . ' ' . $certificado['descripcion']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $fila, $certificado['numero']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $fila, $fechaEmisionTexto);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5, $fila, $fechaVencimientoTexto);
                    $fila++;
                }
            }    
            
            // redirect output to client browser
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="Informe_Certificados_'. date("Y-m-d") .'.xls"');
            header('Cache-Control: max-age=0');
            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
            $objWriter->save('php://output');

            $objPHPExcel->disconnectWorksheets();
            unset($objPHPExcel);     
            
        } else {
            $this->view->parametros = $parametros;
            $this->renderScript('informes/resultados-certificados.phtml');
        }
    }
    /**************************************************************************/
    
    /************************ OPERACIONES OBSERVACIONES ***********************/
    public function observacionesAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        unset($mSession->informe);
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de observaciones de revista";
        $empresa = new Shipcode_Model_Empresa();
        $codigo = new Shipcode_Model_CodigoObservacion();
        $this->view->codigos = $codigo->getPairsToSelect();
        $this->view->empresas = $empresa->getAll();
        $this->renderScript('informes/form-observaciones.phtml');
    }
    
    public function buscarObservacionesAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de observaciones de revista";
        $observacion = new Shipcode_Model_NaveObservacion();
        
        $parametros = array(
            'empresa' => $this->_getParam('empresa'),
            'nave' => $this->_getParam('nave'),
            'codigo' => $this->_getParam('codigo'),
            'area' => $this->_getParam('area'),
            'estado' => $this->_getParam('estado'),
            'desde' => $this->_getParam('desde'),
            'hasta' => $this->_getParam('hasta')
        );
        
        $rowsObservaciones = $observacion->buscar($parametros, $this->view->autorizaciones['naves']);
        
        $this->view->observaciones = $rowsObservaciones;
        $mSession->informe['filas'] = $rowsObservaciones;
        $mSession->informe['fileName'] = 'Informe_Observaciones.pdf';
        $mSession->informe['contents'] = $observacion->getHtmlToPdf($rowsObservaciones);
        $mSession->informe['tipo'] = 'Observaciones';
        $mSession->informe['base'] = 'observaciones';
        $mSession->informe['modelo'] = "NaveObservacion";
        $mSession->informe['parametros'] = $parametros;
        
        if($this->_getParam('export') == 'xls') {
            
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            if($parametros['estado'] == 4 ) { $titulo = 'Informe observaciones'; }
            if($parametros['estado'] == 1 ) { $titulo = 'Informe observaciones levantadas'; }
            if($parametros['estado'] == 2 ) { $titulo = 'Informe observaciones corregidas sin inspección'; }
            if($parametros['estado'] == 3 ) { $titulo = 'Informe observaciones con solicitud enviada'; }
            if($parametros['estado'] == 0 ) { $titulo = 'Informe observaciones pendientes'; }
            
            define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
            require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
            PHPExcel_Settings::setLocale('es');

            $objPHPExcel = new PHPExcel();
            $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(12);
            $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('H')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('I')->setAutoSize(true);

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', $titulo);
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', Shipcode_Model_Fecha::format($this->fecha));
            $objPHPExcel->setActiveSheetIndex(0)
                        ->setCellValue('A3', 'Empresa')
                        ->setCellValue('B3', 'Nave')
                        ->setCellValue('C3', 'Nº Boleta / Ítem')
                        ->setCellValue('D3', 'Código')
                        ->setCellValue('E3', 'Área')
                        ->setCellValue('F3', 'Detalles Observación')
                        ->setCellValue('G3', 'Emisión')
                        ->setCellValue('H3', 'Estado')
                        ->setCellValue('I3', 'Boleta Levantamiento');

            $objPHPExcel->getActiveSheet()->mergeCells('A1:I1');
            $objPHPExcel->getActiveSheet()->mergeCells('A2:I2');
            
            $styleArrayTitulo = array(
                'font' => array('bold' => true, 'size' => 24, 'color' => array('argb' => '00000000'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayFecha = array(
                'font' => array('bold' => false, 'size' => 12, 'color' => array('argb' => '66666666'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayCabeceras = array(
                'font' => array('bold' => true, 'size' => 12, 'color' => array('argb' => 'ffffffff'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,),
                'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
                'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '33333300',),),
            );
            
            $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArrayTitulo);
            $objPHPExcel->getActiveSheet()->getStyle('A2')->applyFromArray($styleArrayFecha);
            $objPHPExcel->getActiveSheet()->getStyle('A3:I3')->applyFromArray($styleArrayCabeceras);
            
            if(count($rowsObservaciones) > 0) {
                $fila = 4;
                foreach($rowsObservaciones as $observacion) { 
                    
                    if($observacion['estado'] == 0 ) { 
                        $textoEstado = 'PENDIENTE';    
                    } elseif($observacion['estado'] == 2) { 
                        $textoEstado= 'CORREGIDA SIN INSPECCIÓN';
                    }else {
                        $textoEstado = 'LEVANTADA';
                    }
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $observacion['empresa']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $fila, $observacion['nave']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $fila, $observacion['boleta'] . ' / ' . $observacion['item']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $fila, $observacion['codigo']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $fila, $observacion['area']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5, $fila, $observacion['detalle']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6, $fila, Shipcode_Model_Fecha::format($observacion['fecha_emision']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7, $fila, $textoEstado);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8, $fila, $observacion['boleta_aprob']);
                    $fila++;
                }
            }
            
            // redirect output to client browser
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="Informe_Observaciones_'. date("Y-m-d") .'.xls"');
            header('Cache-Control: max-age=0');
            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
            $objWriter->save('php://output');

            $objPHPExcel->disconnectWorksheets();
            unset($objPHPExcel); 
            
        } else {
            $this->view->parametros = $parametros;
            $this->renderScript('informes/resultados-observaciones.phtml');
        }
    }
    /**************************************************************************/
    
    /******************* OPERACIONES AUDITORIAS INTERNAS *******************/
    public function auditoriasInternasAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        unset($mSession->informe);
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de auditorías internas";
        $empresa = new Shipcode_Model_Empresa();
        $this->view->prioridades = Shipcode_Model_AuditoriaInternaPrioridad::getPairsToSelect();
        $this->view->empresas = $empresa->getAll();
        $this->renderScript('informes/form-auditorias-internas.phtml');
    }
    
    public function buscarAuditoriasInternasAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de auditorías internas";
        $auditoria = new Shipcode_Model_AuditoriaInterna();
        
        $parametros = array(
            'empresa' => $this->_getParam('empresa'),
            'nave' => $this->_getParam('nave'),
            'area' => $this->_getParam('sistema'),    
            'prioridad' => (int)$this->_getParam('prioridad'),
            'estado_cierre' => $this->_getParam('estado_cierre'),
            'estado_vencimiento' => $this->_getParam('estado_vencimiento'),
            'ingreso_desde' => $this->_getParam('ingreso_desde'),
            'ingreso_hasta' => $this->_getParam('ingreso_hasta'),
            'vencimiento_desde' => $this->_getParam('vencimiento_desde'),
            'vencimiento_hasta' => $this->_getParam('vencimiento_hasta')
        );
        
        $rowsAuditorias = $auditoria->buscar($parametros, $this->view->autorizaciones['naves']);
        
        $this->view->auditoriasInternas = $rowsAuditorias;
        $mSession->informe['filas'] = $rowsAuditorias;
        $mSession->informe['fileName'] = 'Informe_Auditorías_Internas.pdf';
        $mSession->informe['contents'] = $auditoria->getHtmlToPdf($rowsAuditorias);
        $mSession->informe['tipo'] = 'Auditorías internas';
        $mSession->informe['base'] = 'auditorias-internas';
        $mSession->informe['modelo'] = "AuditoriaInterna";
        $mSession->informe['parametros'] = $parametros;
        
        if($this->_getParam('export') == 'xls') {
            
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            if($parametros['estado'] == 2 ) { $titulo = 'Informe auditorías internas'; }
            if($parametros['estado'] == 1 ) { $titulo = 'Informe auditorías internas terminadas'; }
            if($parametros['estado'] == 0 ) { $titulo = 'Informe auditorías internas pendientes'; }
            
            define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
            require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
            PHPExcel_Settings::setLocale('es');

            $objPHPExcel = new PHPExcel();
            $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(12);
            $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('H')->setAutoSize(true);

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', $titulo);
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', Shipcode_Model_Fecha::format($this->fecha));
            $objPHPExcel->setActiveSheetIndex(0)
                        ->setCellValue('A3', 'Empresa')
                        ->setCellValue('B3', 'Nave')
                        ->setCellValue('C3', 'Título')
                        ->setCellValue('D3', 'Prioridad')
                        ->setCellValue('E3', 'Ingreso')
                        ->setCellValue('F3', 'Vencimiento')
                        ->setCellValue('G3', 'Responsable')
                        ->setCellValue('H3', 'Cierre')
                        ->setCellValue('I3', 'Estado');

            $objPHPExcel->getActiveSheet()->mergeCells('A1:I1');
            $objPHPExcel->getActiveSheet()->mergeCells('A2:I2');
            
            $styleArrayTitulo = array(
                'font' => array('bold' => true, 'size' => 24, 'color' => array('argb' => '00000000'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayFecha = array(
                'font' => array('bold' => false, 'size' => 12, 'color' => array('argb' => '66666666'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayCabeceras = array(
                'font' => array('bold' => true, 'size' => 12, 'color' => array('argb' => 'ffffffff'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,),
                'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
                'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '33333300',),),
            );
            
            $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArrayTitulo);
            $objPHPExcel->getActiveSheet()->getStyle('A2')->applyFromArray($styleArrayFecha);
            $objPHPExcel->getActiveSheet()->getStyle('A3:I3')->applyFromArray($styleArrayCabeceras);
            
            if(count($rowsAuditorias) > 0) {
                $fila = 4;
                foreach($rowsAuditorias as $auditoria) { 
                    
                    $cierre = '----';
                    if($auditoria['estado'] === 'TERMINADA'){
                        $cierre = Shipcode_Model_Fecha::format($auditoria['cierre_fecha']);
                    }
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $auditoria['empresa']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $fila, $auditoria['nave']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $fila, $auditoria['titulo']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $fila, $auditoria['prioridad']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $fila, Shipcode_Model_Fecha::format($auditoria['ingreso_fecha']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5, $fila, Shipcode_Model_Fecha::format($auditoria['fecha_vencimiento']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6, $fila, $auditoria['responsable']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7, $fila, $cierre);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8, $fila, $auditoria['estado']);
                    $fila++;
                }
            }
            
            // redirect output to client browser
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="Informe_Auditorías_Internas_'. date("Y-m-d") .'.xls"');
            header('Cache-Control: max-age=0');
            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
            $objWriter->save('php://output');

            $objPHPExcel->disconnectWorksheets();
            unset($objPHPExcel); 
            
        } else {
            $this->view->parametros = $parametros;
            $this->renderScript('informes/resultados-auditorias-internas.phtml');
        }
    }
    /**************************************************************************/
    
    /************************** OPERACIONES CARENAS  **************************/
    public function carenasAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        unset($mSession->informe);
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de carenas";
        $empresa = new Shipcode_Model_Empresa();
        $codigo = new Shipcode_Model_CodigoObservacion();
        $this->view->codigos = $codigo->getPairsToSelect();
        $this->view->empresas = $empresa->getAll();
        $this->renderScript('informes/form-carenas.phtml');
    }
    
    public function buscarCarenasAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de carenas";
        $carena = new Shipcode_Model_NaveCarena();
        
        $parametros = array(
            'empresa' => $this->_getParam('empresa'),
            'nave' => $this->_getParam('nave'),
            'desde' => $this->_getParam('desde'),
            'hasta' => $this->_getParam('hasta')
        );
        
        $rowsCarenas = $carena->buscar($parametros, $this->view->autorizaciones['naves']);
        
        $this->view->carenas = $rowsCarenas;
        $mSession->informe['filas'] = $rowsCarenas;
        $mSession->informe['fileName'] = 'Informe_Carenas.pdf';
        $mSession->informe['contents'] = $carena->getHtmlToPdf($rowsCarenas);
        $mSession->informe['tipo'] = 'Carenas';
        $mSession->informe['base'] = 'carenas';
        $mSession->informe['modelo'] = "NaveCarena";
        $mSession->informe['parametros'] = $parametros;
        
        if($this->_getParam('export') == 'xls') {
            
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
            require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
            PHPExcel_Settings::setLocale('es');

            $objPHPExcel = new PHPExcel();
            $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(12);
            $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', "Informe de Carenas");
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', Shipcode_Model_Fecha::format($this->fecha));
            $objPHPExcel->setActiveSheetIndex(0)
                        ->setCellValue('A3', 'Empresa')
                        ->setCellValue('B3', 'Nave')
                        ->setCellValue('C3', 'Fecha de salida')
                        ->setCellValue('D3', 'Período')
                        ->setCellValue('E3', 'Costo Total')
                        ->setCellValue('F3', 'Desglose por cuentas');

            $objPHPExcel->getActiveSheet()->mergeCells('A1:F1');
            $objPHPExcel->getActiveSheet()->mergeCells('A2:F2');
            
            $styleArrayTitulo = array(
                'font' => array('bold' => true, 'size' => 24, 'color' => array('argb' => '00000000'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayFecha = array(
                'font' => array('bold' => false, 'size' => 12, 'color' => array('argb' => '66666666'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayCabeceras = array(
                'font' => array('bold' => true, 'size' => 12, 'color' => array('argb' => 'ffffffff'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,),
                'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
                'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '33333300',),),
            );
            
            $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArrayTitulo);
            $objPHPExcel->getActiveSheet()->getStyle('A2')->applyFromArray($styleArrayFecha);
            $objPHPExcel->getActiveSheet()->getStyle('A3:F3')->applyFromArray($styleArrayCabeceras);
            
            if(count($rowsCarenas) > 0) {
                $fila = 4;
                foreach($rowsCarenas as $carena) { 
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $carena['empresa']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $fila, $carena['nave']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $fila, Shipcode_Model_Fecha::format($carena['fecha']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $fila, $carena['periodo']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $fila, $carena['total_gastos']);
                    $objPHPExcel->getActiveSheet()
                                ->getStyle("E$fila")
                                ->getNumberFormat()
                                ->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_NUMBER_COMMA_SEPARATED1);
                    $desglose = '';
                    $i = 0;
                    foreach($carena['detalle_cuentas'] as $cuenta) {
                        if($i != 0) { $desglose = $desglose . "\n"; }
                        $filaCuenta =  $cuenta['cuenta'] . ' : ' . $this->view->formatNumber($cuenta['monto']);
                        $desglose = $desglose . $filaCuenta;
                        $i++;
                    }
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5, $fila, $desglose);
                    $objPHPExcel->getActiveSheet()
                                ->getStyle("F$fila")
                                ->getAlignment()
                                ->setWrapText(true);
                    
                    $fila++;
                }
            }
            
            // redirect output to client browser
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="Informe_Carenas_'. date("Y-m-d") .'.xls"');
            header('Cache-Control: max-age=0');
            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
            $objWriter->save('php://output');

            $objPHPExcel->disconnectWorksheets();
            unset($objPHPExcel); 
            
        } else {
            $this->view->parametros = $parametros;
            $this->renderScript('informes/resultados-carenas.phtml');
        }
    }
    /**************************************************************************/
    
    /************************  OPERACIONES SINIESTROS *************************/
    public function siniestrosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        unset($mSession->informe);
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de siniestros";
        $empresa = new Shipcode_Model_Empresa();
        $this->view->empresas = $empresa->getAll();
        $this->renderScript('informes/form-siniestros.phtml');
    }
    
    public function buscarSiniestrosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de siniestros";
        $siniestro = new Shipcode_Model_NaveSiniestro();
        
        $parametros = array(
            'empresa' => $this->_getParam('empresa'),
            'nave' => $this->_getParam('nave'),
            'desde' => $this->_getParam('desde'),
            'hasta' => $this->_getParam('hasta'),
            'estado' => $this->_getParam('estado')
        );
        
        $rowsSiniestros = $siniestro->buscar($parametros, $this->view->autorizaciones['naves']);
        
        $this->view->siniestros = $rowsSiniestros;
        $mSession->informe['filas'] = $rowsSiniestros;
        $mSession->informe['fileName'] = 'Informe_Siniestros.pdf';
        $mSession->informe['contents'] = $siniestro->getHtmlToPdf($rowsSiniestros);
        $mSession->informe['tipo'] = 'Siniestros';
        $mSession->informe['base'] = 'siniestros';
        $mSession->informe['modelo'] = "NaveSiniestro";
        $mSession->informe['parametros'] = $parametros;
        
        if($this->_getParam('export') == 'xls') {
            
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            if($parametros['estado'] == 0 ) { $titulo = 'Informe siniestros'; }
            if($parametros['estado'] == 1 ) { $titulo = 'Informe siniestros en trámite'; }
            if($parametros['estado'] == 2 ) { $titulo = 'Informe siniestros despachados'; }
            if($parametros['estado'] == 3 ) { $titulo = 'Informe siniestros liquidados'; }   
            
            define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
            require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
            PHPExcel_Settings::setLocale('es');

            $objPHPExcel = new PHPExcel();
            $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(12);
            $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setAutoSize(true);

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', $titulo);
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', Shipcode_Model_Fecha::format($this->fecha));
            $objPHPExcel->setActiveSheetIndex(0)
                        ->setCellValue('A3', 'Empresa')
                        ->setCellValue('B3', 'Nave')
                        ->setCellValue('C3', 'Nº')
                        ->setCellValue('D3', 'Fecha')
                        ->setCellValue('E3', 'Detalle')
                        ->setCellValue('F3', 'Monto reclamado')
                        ->setCellValue('G3', 'Estado');

            $objPHPExcel->getActiveSheet()->mergeCells('A1:G1');
            $objPHPExcel->getActiveSheet()->mergeCells('A2:G2');
            
            $styleArrayTitulo = array(
                'font' => array('bold' => true, 'size' => 24, 'color' => array('argb' => '00000000'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayFecha = array(
                'font' => array('bold' => false, 'size' => 12, 'color' => array('argb' => '66666666'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayCabeceras = array(
                'font' => array('bold' => true, 'size' => 12, 'color' => array('argb' => 'ffffffff'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,),
                'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
                'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '33333300',),),
            );
            
            $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArrayTitulo);
            $objPHPExcel->getActiveSheet()->getStyle('A2')->applyFromArray($styleArrayFecha);
            $objPHPExcel->getActiveSheet()->getStyle('A3:G3')->applyFromArray($styleArrayCabeceras);
            
            if(count($rowsSiniestros) > 0) {
                $fila = 4;
                foreach($rowsSiniestros as $siniestro) { 
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $siniestro['empresa']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $fila, $siniestro['nave']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $fila, $siniestro['numero']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $fila, Shipcode_Model_Fecha::format($siniestro['fecha']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $fila, $siniestro['detalle']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5, $fila, $siniestro['valor']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6, $fila, $siniestro['estado']);
                    $objPHPExcel->getActiveSheet()
                                ->getStyle("F$fila")
                                ->getNumberFormat()
                                ->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_NUMBER_COMMA_SEPARATED1);
                    $objPHPExcel->getActiveSheet()
                                ->getStyle("E$fila")
                                ->getAlignment()
                                ->setWrapText(true);
                    $fila++;
                }
            }
            
            // redirect output to client browser
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="Informe_Siniestros_'. date("Y-m-d") .'.xls"');
            header('Cache-Control: max-age=0');
            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
            $objWriter->save('php://output');

            $objPHPExcel->disconnectWorksheets();
            unset($objPHPExcel);
            
        } else {
            $this->view->parametros = $parametros;
            $this->renderScript('informes/resultados-siniestros.phtml');
        }
    }
    /**************************************************************************/
    
    /************************  OPERACIONES SINIESTROS *************************/
    public function gastosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        unset($mSession->informe);
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de gastos";
        $empresa = new Shipcode_Model_Empresa();
        $cuentaGasto = new Shipcode_Model_CuentaGasto();
        $this->view->empresas = $empresa->getAll();
        $this->view->cuentas = $cuentaGasto->getAll(false, true);
        $this->renderScript('informes/form-gastos.phtml');
    }
    
    public function buscarGastosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de gastos";
        $gasto = new Shipcode_Model_ImagestionGasto();
        
        $parametros = array(
            'empresa' => $this->_getParam('empresa'),
            'cod_centro' => $this->_getParam('cod_centro'),
            'cod_cuenta' => $this->_getParam('cod_cuenta'),
            'desde' => $this->_getParam('desde'),
            'hasta' => $this->_getParam('hasta'),
            'mayor_a' => $this->_getParam('mayor_a'),
            'menor_a' => $this->_getParam('menor_a')
        );
        
        $rowsGastos = $gasto->buscar($parametros, $this->view->autorizaciones['naves']);
            
        $this->view->gastos = $rowsGastos;
        $mSession->informe['filas'] = $rowsGastos;
        $mSession->informe['fileName'] = 'Informe_Gastos.pdf';
        $mSession->informe['contents'] = $gasto->getHtmlToPdf($rowsGastos);
        $mSession->informe['tipo'] = 'Gastos';
        $mSession->informe['base'] = 'gastos';
        $mSession->informe['modelo'] = "NaveGasto";
        $mSession->informe['parametros'] = $parametros;
        
        if($this->_getParam('export') == 'xls') {
            
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
            require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
            PHPExcel_Settings::setLocale('es');

            $objPHPExcel = new PHPExcel();
            $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(12);
            $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', "Informe de Gastos");
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', Shipcode_Model_Fecha::format($this->fecha));
            $objPHPExcel->setActiveSheetIndex(0)
                        ->setCellValue('A3', 'Empresa')
                        ->setCellValue('B3', 'Centro de Costo')
                        ->setCellValue('C3', 'Cuenta de Gasto')
                        ->setCellValue('D3', 'Fecha aprobación')
                        ->setCellValue('E3', 'Detalle')
                        ->setCellValue('F3', 'Cantidad')
                        ->setCellValue('G3', 'Unitario')
                        ->setCellValue('H3', 'Total');

            $objPHPExcel->getActiveSheet()->mergeCells('A1:H1');
            $objPHPExcel->getActiveSheet()->mergeCells('A2:H2');
            
            $styleArrayTitulo = array(
                'font' => array('bold' => true, 'size' => 24, 'color' => array('argb' => '00000000'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayFecha = array(
                'font' => array('bold' => false, 'size' => 12, 'color' => array('argb' => '66666666'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayCabeceras = array(
                'font' => array('bold' => true, 'size' => 12, 'color' => array('argb' => 'ffffffff'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,),
                'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
                'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '33333300',),),
            );
            
            $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArrayTitulo);
            $objPHPExcel->getActiveSheet()->getStyle('A2')->applyFromArray($styleArrayFecha);
            $objPHPExcel->getActiveSheet()->getStyle('A3:H3')->applyFromArray($styleArrayCabeceras);
            
            if(count($rowsGastos) > 0) {
                $fila = 4;
                foreach($rowsGastos as $gasto) { 
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $gasto['empresa']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $fila, $gasto['nave']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $fila, $gasto['cuenta']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $fila, Shipcode_Model_Fecha::format($gasto['fecha_aprobacion']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $fila, $gasto['producto']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5, $fila, $gasto['cantidad']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6, $fila, $gasto['monto']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7, $fila, $this->view->calculateTotalGasto($gasto));
                    $objPHPExcel->getActiveSheet()
                                ->getStyle("F$fila")
                                ->getNumberFormat()
                                ->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_NUMBER_COMMA_SEPARATED1);
                    $fila++;
                }
            }
            
            // redirect output to client browser
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="Informe_Gastos_'. date("Y-m-d") .'.xls"');
            header('Cache-Control: max-age=0');
            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
            $objWriter->save('php://output');

            $objPHPExcel->disconnectWorksheets();
            unset($objPHPExcel);     
            
        } else {
            $this->view->parametros = $parametros;
            $this->renderScript('informes/resultados-gastos.phtml');
        }
    }
    /**************************************************************************/
    
    /*********************  OPERACIONES MANTENIMIENTOS ************************/
    public function mantenimientosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        unset($mSession->informe);
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de mantenimientos";
        $empresa = new Shipcode_Model_Empresa();
        $this->view->empresas = $empresa->getAll();
        $this->view->tipos = Shipcode_Model_TipoMantenimiento::getPairsToSelect();
        $this->view->servicios = Shipcode_Model_BaseServicio::getPairsToSelect();
        $this->renderScript('informes/form-mantenimientos.phtml');
    }
    
    public function buscarMantenimientosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de mantenimientos";
        $mantenimiento = new Shipcode_Model_NaveEquipoMantenimiento();
        
        $parametros = array(
            'empresa' => $this->_getParam('empresa'),
            'nave' => $this->_getParam('nave'),
            'sistema' => $this->_getParam('sistema'),
            'equipo' => $this->_getParam('equipo'),
            'tipo' => $this->_getParam('tipo'),
            'servicio' => $this->_getParam('servicio'),
            'requiere_proyecto' => $this->_getParam('requiere_proyecto'),
            'estado_proyecto' => $this->_getParam('estado_proyecto'),
            'desde' => $this->_getParam('desde'),
            'hasta' => $this->_getParam('hasta')
        );

        $rowsMantenimientos = $mantenimiento->buscar($parametros, $this->view->autorizaciones['naves']);
        
        $this->view->mantenimientos = $rowsMantenimientos;
        $mSession->informe['filas'] = $rowsMantenimientos;
        $mSession->informe['fileName'] = 'Informe_Mantenimientos.pdf';
        $mSession->informe['contents'] = $mantenimiento->getHtmlToPdf($rowsMantenimientos);
        $mSession->informe['tipo'] = 'Mantenimientos Realizados';
        $mSession->informe['base'] = 'mantenimientos';
        $mSession->informe['modelo'] = "NaveEquipoMantenimiento";
        $mSession->informe['parametros'] = $parametros;
        
        if($this->_getParam('export') == 'xls') {
            
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
            require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
            PHPExcel_Settings::setLocale('es');

            $objPHPExcel = new PHPExcel();
            $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(12);
            $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('H')->setAutoSize(true);

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', "Informe de Mantenimientos/Reparaciones Realizados");
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', Shipcode_Model_Fecha::format($this->fecha));
            $objPHPExcel->setActiveSheetIndex(0)
                        ->setCellValue('A3', 'Empresa')
                        ->setCellValue('B3', 'Nave')
                        ->setCellValue('C3', 'Equipo')
                        ->setCellValue('D3', 'Tipo')
                        ->setCellValue('E3', 'Fecha')
                        ->setCellValue('F3', 'Horómetro')
                        ->setCellValue('G3', 'Detalle')
                        ->setCellValue('H3', 'Observaciones');

            $objPHPExcel->getActiveSheet()->mergeCells('A1:H1');
            $objPHPExcel->getActiveSheet()->mergeCells('A2:H2');
            
            $styleArrayTitulo = array(
                'font' => array('bold' => true, 'size' => 24, 'color' => array('argb' => '00000000'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayFecha = array(
                'font' => array('bold' => false, 'size' => 12, 'color' => array('argb' => '66666666'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayCabeceras = array(
                'font' => array('bold' => true, 'size' => 12, 'color' => array('argb' => 'ffffffff'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,),
                'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
                'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '33333300',),),
            );
            
            $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArrayTitulo);
            $objPHPExcel->getActiveSheet()->getStyle('A2')->applyFromArray($styleArrayFecha);
            $objPHPExcel->getActiveSheet()->getStyle('A3:H3')->applyFromArray($styleArrayCabeceras);
            
            if(count($rowsMantenimientos) > 0) {
                $fila = 4;
                foreach($rowsMantenimientos as $mantenimiento) { 
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $mantenimiento['empresa']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $fila, $mantenimiento['nave']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $fila, $mantenimiento['equipo']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $fila, $mantenimiento['tipo']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $fila, Shipcode_Model_Fecha::format($mantenimiento['fecha']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5, $fila, $mantenimiento['horometro']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6, $fila, $mantenimiento['detalles']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7, $fila, $mantenimiento['observaciones']);
                    $objPHPExcel->getActiveSheet()
                                ->getStyle("G$fila")
                                ->getAlignment()
                                ->setWrapText(true);
                    $objPHPExcel->getActiveSheet()
                                ->getStyle("H$fila")
                                ->getAlignment()
                                ->setWrapText(true);
                    $fila++;
                }
            }
            
            // redirect output to client browser
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="Informe_Mantenimientos_y_Reparaciones_Realizados_'. date("Y-m-d") .'.xls"');
            header('Cache-Control: max-age=0');
            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
            $objWriter->save('php://output');

            $objPHPExcel->disconnectWorksheets();
            unset($objPHPExcel);   
            
        } else {
            $this->view->parametros = $parametros;
            $this->renderScript('informes/resultados-mantenimientos.phtml');
        }
    }
    /**************************************************************************/
    
    /************************ OPERACIONES SOLICITUDES *************************/
    public function solicitudesAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        unset($mSession->informe);
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de solicitudes";
        $empresa = new Shipcode_Model_Empresa();
        $this->view->empresas = $empresa->getAll();
        $this->renderScript('informes/form-solicitudes.phtml');
    }
    
    public function buscarSolicitudesAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de mantenimientos";
        $solicitud = new Shipcode_Model_Solicitud();
        
        $parametros = array(
            'empresa' => $this->_getParam('empresa'),
            'nave' => $this->_getParam('nave'),
            'desde' => $this->_getParam('desde'),
            'hasta' => $this->_getParam('hasta'),
            'estado' => $this->_getParam('estado'),
            'prioridad' => $this->_getParam('prioridad')
        );

        $rowsSolicitudes = $solicitud->buscar($parametros, $this->view->autorizaciones['naves']);

        $this->view->solicitudes = $rowsSolicitudes;
        $mSession->informe['filas'] = $rowsSolicitudes;
        $mSession->informe['fileName'] = 'Informe_Solicitudes.pdf';
        $mSession->informe['contents'] = $solicitud->getHtmlToPdf($rowsSolicitudes);
        $mSession->informe['tipo'] = 'Solicitudes Realizadas';
        $mSession->informe['base'] = 'solicitudes';
        $mSession->informe['modelo'] = "NaveInformeSolicitud";
        $mSession->informe['parametros'] = $parametros;
        
        if($this->_getParam('export') == 'xls') {
            
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            if($parametros['estado'] == 0 ) { $titulo = 'Informe solicitudes pendientes'; }
            if($parametros['estado'] == 1 ) { $titulo = 'Informe solicitudes en curso'; }
            if($parametros['estado'] == 2 ) { $titulo = 'Informe solicitudes terminadas OK'; }
            if($parametros['estado'] == 3 ) { $titulo = 'Informe solicitudes rechazadas'; }
            if($parametros['estado'] == 4 ) { $titulo = 'Informe solicitudes cerradas'; }
            if($parametros['estado'] == 5 ) { $titulo = 'Informe solicitudes no conformes'; }
            if($parametros['estado'] == 10 ) { $titulo = 'Informe solicitudes'; }
            
            define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
            require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
            PHPExcel_Settings::setLocale('es');

            $objPHPExcel = new PHPExcel();
            $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('H')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('I')->setAutoSize(true);

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', $titulo);
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', $this->fecha);
            $objPHPExcel->setActiveSheetIndex(0)
                        ->setCellvalue('A3', 'Prioridad')
                        ->setCellValue('B3', 'Empresa')
                        ->setCellValue('C3', 'Nave')
                        ->setCellValue('D3', 'Informe')
                        ->setCellValue('E3', 'Enviado por')
                        ->setCellValue('F3', 'Detalles')
                        ->setCellValue('G3', 'Estado')
                        ->setCellValue('H3', 'Días')
                        ->setCellValue('I3', 'Comentarios');

            $objPHPExcel->getActiveSheet()->mergeCells('A1:I1');
            $objPHPExcel->getActiveSheet()->mergeCells('A2:I2');
            
            $styleArrayTitulo = array(
                'font' => array('bold' => true, 'size' => 24, 'color' => array('argb' => '00000000'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayFecha = array(
                'font' => array('bold' => false, 'size' => 12, 'color' => array('argb' => '66666666'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayCabeceras = array(
                'font' => array('bold' => true, 'size' => 12, 'color' => array('argb' => 'ffffffff'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,),
                'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
                'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '33333300',),),
            );
            
            $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArrayTitulo);
            $objPHPExcel->getActiveSheet()->getStyle('A2')->applyFromArray($styleArrayFecha);
            $objPHPExcel->getActiveSheet()->getStyle('A3:I3')->applyFromArray($styleArrayCabeceras);
            
            if(count($rowsSolicitudes) > 0) {
                $fila = 4;
                foreach($rowsSolicitudes as $solicitud) { 
                    
                    if($solicitud['estado'] == 0) {
                        $estado = "PENDIENTE";
                    } elseif($solicitud['estado'] == 1){
                        $estado = "EN CURSO";
                    } elseif($solicitud['estado'] == 2){
                        $estado = "TERMINADA OK";
                    } elseif($solicitud['estado'] == 3) {
                        $estado = "RECHAZADA";
                    } elseif($solicitud['estado'] == 4) {
                        $estado = "CERRADA";
                    } elseif($solicitud['estado'] == 5) {
                        $estado = "NO CONFORME";
                    }
                    
                    if($solicitud['prioridad'] == 'NORMAL') { 
                        $dias = $solicitud['dias_aprobacion'];
                    } else { 
                        $dias = $solicitud['dias_creacion'];
                    } 
                    
                    if(count($solicitud['comentarios']) > 0) {
                        $comentarios = NULL;
                        foreach($solicitud['comentarios'] as $comentario){
                            $comentarios .= Shipcode_Model_Fecha::formatShort($comentario['creacion']);
                            if($comentario['tipo']=='supervisor') { 
                                $comentarios .= ' S : '; 
                            } else { 
                                $comentarios .= ' M : '; 
                            } 

                            $comentarios .= $comentario['comentarios'];
                            $comentarios .= "\n";
                        }
                    
                    } else {
                        $comentarios = '---';
                    }
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $solicitud['prioridad']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $fila, $solicitud['empresa']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $fila, $solicitud['nave']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $fila, Shipcode_Model_Fecha::format($solicitud['fecha_envio']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $fila, $solicitud['enviado_por_nombre']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5, $fila, $solicitud['detalles']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6, $fila, $estado);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7, $fila, $dias);
                    $objPHPExcel->getActiveSheet()
                                ->getStyle("G$fila")
                                ->getAlignment()
                                ->setWrapText(true);
                    $objPHPExcel->getActiveSheet()
                                ->getStyle("H$fila")
                                ->getAlignment()
                                ->setWrapText(true);
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8, $fila, $comentarios);
                    $objPHPExcel->getActiveSheet()
                                ->getStyle("I$fila")
                                ->getAlignment()
                                ->setWrapText(true);
                    
                    $fila++;
                }
            }
            
            // redirect output to client browser
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="Informe_Solicitudes_Realizadas_'. date("Y-m-d") .'.xls"');
            header('Cache-Control: max-age=0');
            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
            $objWriter->save('php://output');

            $objPHPExcel->disconnectWorksheets();
            unset($objPHPExcel);   
            
        } else {
            $this->view->parametros = $parametros;
            $this->renderScript('informes/resultados-solicitudes.phtml');
        }
    }
    /**************************************************************************/
    
    /*********************  OPERACIONES PROGRAMACIONES ************************/
    public function programacionesAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        unset($mSession->informe);
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de mantenimientos programados";
        $empresa = new Shipcode_Model_Empresa();
        $this->view->empresas = $empresa->getAll();
        $this->view->servicios = Shipcode_Model_BaseServicio::getPairsToSelect();
        $this->renderScript('informes/form-programaciones.phtml');
    }
    
    public function buscarProgramacionesAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de mantenimientos programados";
        $actividad = new Shipcode_Model_NaveActividad();
        
        $parametros = array(
            'empresa' => $this->_getParam('empresa'),
            'nave' => $this->_getParam('nave'),
            'sistema' => $this->_getParam('sistema'),
            'equipo' => $this->_getParam('equipo'),
            'servicio' => $this->_getParam('servicio'),
            'desde' => $this->_getParam('desde', NULL),
            'hasta' => $this->_getParam('hasta', NULL),
            'estado' => $this->_getParam('estado'),
            'programacion' => NULL
        ); 
        
        $rowsActividades = $actividad->buscar($parametros, $this->view->autorizaciones['naves']);

        $this->view->actividades = $rowsActividades;
        $mSession->informe['filas'] = $rowsActividades;
        $mSession->informe['fileName'] = 'Informe_Mantenimientos_Programados.pdf';
        $mSession->informe['contents'] = $actividad->getHtmlToPdf($rowsActividades);
        $mSession->informe['tipo'] = 'Mantenimientos Programados';
        $mSession->informe['base'] = 'programaciones';
        $mSession->informe['modelo'] = "NaveActividad";
        $mSession->informe['parametros'] = $parametros;
        
        if($this->_getParam('export') == 'xls') {
            
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
            require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
            PHPExcel_Settings::setLocale('es');

            $objPHPExcel = new PHPExcel();
            $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('H')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('I')->setAutoSize(true);
            

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', "Informe de Mantenimientos Programados");
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', Shipcode_Model_Fecha::format($this->fecha));
            $objPHPExcel->setActiveSheetIndex(0)
                        ->setCellValue('A3', 'Nave')
                        ->setCellValue('B3', 'Equipo')
                        ->setCellValue('C3', 'Servicio')
                        ->setCellValue('D3', 'Ciclo')
                        ->setCellValue('E3', 'Fecha programada')
                        ->setCellValue('F3', 'Días restantes')
                        ->setCellValue('G3', 'Horas programación')
                        ->setCellValue('H3', 'Horas actuales')
                        ->setCellValue('I3', 'Horas restantes');

            $objPHPExcel->getActiveSheet()->mergeCells('A1:I1');
            $objPHPExcel->getActiveSheet()->mergeCells('A2:I2');
            
            $styleArrayTitulo = array(
                'font' => array('bold' => true, 'size' => 24, 'color' => array('argb' => '00000000'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayFecha = array(
                'font' => array('bold' => false, 'size' => 12, 'color' => array('argb' => '66666666'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayCabeceras = array(
                'font' => array('bold' => true, 'size' => 12, 'color' => array('argb' => 'ffffffff'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,),
                'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
                'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '33333300',),),
            );
            
            $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArrayTitulo);
            $objPHPExcel->getActiveSheet()->getStyle('A2')->applyFromArray($styleArrayFecha);
            $objPHPExcel->getActiveSheet()->getStyle('A3:I3')->applyFromArray($styleArrayCabeceras);
            
            if(count($rowsActividades) > 0) {
                $fila = 4;
                foreach($rowsActividades as $actividad) { 
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $actividad['nave']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $fila, $actividad['equipo']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $fila, $actividad['servicio']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $fila, $actividad['ciclo']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $fila, Shipcode_Model_Fecha::formatShort($actividad['fecha_editada']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5, $fila, $actividad['dias_restantes']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6, $fila, $actividad['horas']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7, $fila, $actividad['horas_actuales']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8, $fila, $actividad['horas_restantes']);
                    $fila++;
                }
            }
            
            // redirect output to client browser
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="Informe_Mantenimientos_Programados_'. date("Y-m-d") .'.xls"');
            header('Cache-Control: max-age=0');
            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
            $objWriter->save('php://output');

            $objPHPExcel->disconnectWorksheets();
            unset($objPHPExcel);  
        } else {
            $this->view->parametros = $parametros;
            $this->renderScript('informes/resultados-programaciones.phtml');
        }
    }
    /**************************************************************************/
    
    /************************  OPERACIONES HOROMETROS *************************/
    public function horometrosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        unset($mSession->informe);
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de registro de horómetros";
        $empresa = new Shipcode_Model_Empresa();
        $this->view->empresas = $empresa->getAll();
        $this->renderScript('informes/form-horometros.phtml');
    }
    
    public function buscarHorometrosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Gestión de Mantenimiento :: Informes de registro de horómetros";
        $horometroLectura = new Shipcode_Model_NaveHorometroLectura();
        
        $parametros = array(
            'empresa' => $this->_getParam('empresa'),
            'nave' => $this->_getParam('nave'),
            'sistema' => $this->_getParam('sistema'),
            'equipo' => $this->_getParam('equipo'),
            'desde' => $this->_getParam('desde', NULL),
            'hasta' => $this->_getParam('hasta', NULL)
        );

        $rowsRegistros = $horometroLectura->buscar($parametros, $this->view->autorizaciones['naves']);

        $this->view->registros = $rowsRegistros;
        $mSession->informe['filas'] = $rowsRegistros;
        $mSession->informe['fileName'] = 'Informe_Registros_Horometros.pdf';
        $mSession->informe['contents'] = $horometroLectura->getHtmlToPdf($rowsRegistros);
        $mSession->informe['tipo'] = 'Horómetros';
        $mSession->informe['base'] = 'horometros';
        $mSession->informe['modelo'] = "NaveHorometroLectura";
        $mSession->informe['parametros'] = $parametros;
        
        if($this->_getParam('export') == 'xls') {
            
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            
            define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
            require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
            PHPExcel_Settings::setLocale('es');

            $objPHPExcel = new PHPExcel();
            $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(12);
            $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setAutoSize(true);
            $objPHPExcel->getActiveSheet()->getColumnDimension('H')->setAutoSize(true);

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', "Informe de registro de horómetros");
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', Shipcode_Model_Fecha::format($this->fecha));
            $objPHPExcel->setActiveSheetIndex(0)
                        ->setCellValue('A3', 'Empresa')
                        ->setCellValue('B3', 'Nave')
                        ->setCellValue('C3', 'Equipo')
                        ->setCellValue('D3', 'Fecha')
                        ->setCellValue('E3', 'Horas registradas');

            $objPHPExcel->getActiveSheet()->mergeCells('A1:E1');
            $objPHPExcel->getActiveSheet()->mergeCells('A2:E2');
            
            $styleArrayTitulo = array(
                'font' => array('bold' => true, 'size' => 24, 'color' => array('argb' => '00000000'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayFecha = array(
                'font' => array('bold' => false, 'size' => 12, 'color' => array('argb' => '66666666'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
            );
            
            $styleArrayCabeceras = array(
                'font' => array('bold' => true, 'size' => 12, 'color' => array('argb' => 'ffffffff'),),
                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,),
                'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
                'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '33333300',),),
            );
            
            $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArrayTitulo);
            $objPHPExcel->getActiveSheet()->getStyle('A2')->applyFromArray($styleArrayFecha);
            $objPHPExcel->getActiveSheet()->getStyle('A3:E3')->applyFromArray($styleArrayCabeceras);
            
            if(count($rowsRegistros) > 0) {
                $fila = 4;
                foreach($rowsRegistros as $registro) { 
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $registro['empresa']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $fila, $registro['nave']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $fila, $registro['equipo']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $fila, Shipcode_Model_Fecha::format($registro['fecha']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $fila, $registro['lectura']);
                    $fila++;
                }
            }
            
            // redirect output to client browser
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="Informe_Registro_de_Horómetros_'. date("Y-m-d") .'.xls"');
            header('Cache-Control: max-age=0');
            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
            $objWriter->save('php://output');

            $objPHPExcel->disconnectWorksheets();
            unset($objPHPExcel);        
            
        } else {
            $this->view->parametros = $parametros;
            $this->renderScript('informes/resultados-horometros.phtml');
        }
    }
    /**************************************************************************/
    
    public function descargarResumenGastosAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        $titulo = "Informe generado el " . Shipcode_Model_Fecha::format($this->fecha);

        $empresa_id = (int)$this->_getParam('empresa_id');
        $year = (int)$this->_getParam('year');
        
        $nave = new Shipcode_Model_Nave();
        $dataEstadoGasto = $nave->getEstadoGasto($empresa_id, $year);
        
        define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
        require_once Zend_Registry::get('OTHERS_PHP_CLASSES') . '/phpexcel/PHPExcel.php';
        PHPExcel_Settings::setLocale('es');

        $objPHPExcel = new PHPExcel();
        
        $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(15);
        $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true); 
        $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('H')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('I')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('J')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('K')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('L')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('M')->setAutoSize(true);
        $objPHPExcel->getActiveSheet()->getColumnDimension('N')->setAutoSize(true);
        
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', "Resumen Avance Ejecución Presupuestaria");
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', $titulo);
        $objPHPExcel->setActiveSheetIndex(0)
                    ->setCellValue('A3', 'Nave')
                    ->setCellValue('B3', 'Enero')
                    ->setCellValue('C3', 'Febrero')
                    ->setCellValue('D3', 'Marzo')
                    ->setCellValue('E3', 'Abril')
                    ->setCellValue('F3', 'Mayo')
                    ->setCellValue('G3', 'Junio')
                    ->setCellValue('H3', 'Julio')
                    ->setCellValue('I3', 'Agosto')
                    ->setCellValue('J3', 'Septiembre')
                    ->setCellValue('K3', 'Octubre')
                    ->setCellValue('L3', 'Noviembre')
                    ->setCellValue('M3', 'Diciembre')
                    ->setCellValue('N3', 'Totales');

        $objPHPExcel->getActiveSheet()->mergeCells('A1:N1');
        $objPHPExcel->getActiveSheet()->mergeCells('A2:N2');
        
        $styleArrayTitulo = array(
            'font' => array('bold' => true, 'size' => 24, 'color' => array('argb' => '00000000'),),
            'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
        );
        $styleArrayFecha = array(
            'font' => array('bold' => false, 'size' => 12, 'color' => array('argb' => '66666666'),),
            'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,),
        );
        $styleArrayCabeceras = array(
            'font' => array('bold' => true, 'size' => 12, 'color' => array('argb' => 'ffffffff'),),
            'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER),
            'borders' => array('top' => array('style' => PHPExcel_Style_Border::BORDER_THIN,), ),
            'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('argb' => '33333300',),),
        );
        
        $styleNombreNave = array(
            'alignment' => array(
                'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
            )
        );
        
        $styleTotalPositivo = array(
            'font' => array('bold' => true, 'color' => array('argb' => '00008000'),),
        );
        
        $styleTotalNegativo = array(
            'font' => array('bold' => true, 'color' => array('argb' => '00ff0000')),
        );
        
        $styleMesInactivo = array(
            'font' => array('color' => array('argb' => '00888888')),
        );

        $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArrayTitulo);
        $objPHPExcel->getActiveSheet()->getStyle('A2')->applyFromArray($styleArrayFecha);
        $objPHPExcel->getActiveSheet()->getStyle('A3:N3')->applyFromArray($styleArrayCabeceras);
        
        if(count($dataEstadoGasto['naves']) > 0) {
            
            $fila = 4;
            
            foreach($dataEstadoGasto['naves'] as $nave) {
                
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $fila, $nave['nombre']);
                $objPHPExcel->getActiveSheet()->mergeCellsByColumnAndRow(0, $fila, 0, $fila + 3);
                $objPHPExcel->getActiveSheet()->getStyle('A'.$fila)->applyFromArray($styleNombreNave);
                
                if(count($nave['presupuestosMensuales']) > 0 ) { 
                    
                    $totalPresupuesto       = 0; 
                    $totalGastoEjecutado    = 0; 
                    $totalGastoProyectado   = 0; 
                    $totalSaldo             = 0; 
                    
                    $columna = 1;
                    
                    foreach($nave['presupuestosMensuales'] as $presupuestoMensual) {
                        
                        $filaGasto = $fila + 1;
                        $filaGastoProy = $fila + 2;
                        $filaSaldo = $fila + 3;
                        
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($columna, $fila, (int)$presupuestoMensual['presupuesto']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($columna, $filaGasto, (int)$presupuestoMensual['gasto']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($columna, $filaGastoProy, (int)$presupuestoMensual['gasto_proyectado']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($columna, $filaSaldo, (int)$presupuestoMensual['saldo']);

                        $totalPresupuesto = $totalPresupuesto + $presupuestoMensual['presupuesto'];
                        $totalGastoEjecutado = $totalGastoEjecutado + $presupuestoMensual['gasto'];
                        $totalGastoProyectado = 0;
                        $totalSaldo = $totalPresupuesto - $totalGastoEjecutado - $totalGastoProyectado;
                        
                        if($presupuestoMensual['mes'] > $dataEstadoGasto['mesActual']){
                            
                            $objPHPExcel->getActiveSheet()
                                            ->getStyleByColumnAndRow($columna, $fila)
                                            ->applyFromArray($styleMesInactivo);
                            $objPHPExcel->getActiveSheet()
                                            ->getStyleByColumnAndRow($columna, $filaGasto)
                                            ->applyFromArray($styleMesInactivo);
                            $objPHPExcel->getActiveSheet()
                                            ->getStyleByColumnAndRow($columna, $filaGastoProy)
                                            ->applyFromArray($styleMesInactivo);
                            $objPHPExcel->getActiveSheet()
                                            ->getStyleByColumnAndRow($columna, $filaSaldo)
                                            ->applyFromArray($styleMesInactivo);
                            
                        } else {
                            
                            if($presupuestoMensual['saldo'] < 0){
                                $objPHPExcel->getActiveSheet()
                                            ->getStyleByColumnAndRow($columna, $filaSaldo)
                                            ->applyFromArray($styleTotalNegativo);
                            } else {
                                $objPHPExcel->getActiveSheet()
                                            ->getStyleByColumnAndRow($columna, $filaSaldo)
                                            ->applyFromArray($styleTotalPositivo);
                            }
                        }
                        $columna++;
                    }
                    
                    $filaTotalGastoEjec = $fila + 1;
                    $filaTotalGastoProy = $fila + 2;
                    $filaTotalSaldo = $fila + 3;
                    
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($columna, $fila, $totalPresupuesto);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($columna, $filaTotalGastoEjec, $totalGastoEjecutado);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($columna, $filaTotalGastoProy, $totalGastoProyectado);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($columna, $filaTotalSaldo, $totalSaldo);
                    
                    if($totalSaldo < 0){
                        $objPHPExcel->getActiveSheet()
                                    ->getStyleByColumnAndRow($columna, $filaTotalSaldo)
                                    ->applyFromArray($styleTotalNegativo);
                    } else {
                        $objPHPExcel->getActiveSheet()
                                    ->getStyleByColumnAndRow($columna, $filaTotalSaldo)
                                    ->applyFromArray($styleTotalPositivo);
                    }
                }
                $fila = $fila + 5;
            }
        }  
        
        $objPHPExcel->getActiveSheet()
                    ->getStyle('A1:N40')
                    ->getNumberFormat()
                    ->setFormatCode('#,##0');


        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="Resumen_Anual_Gastos_'. date("Y-m-d") .'.xls"');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
        $objPHPExcel->disconnectWorksheets();
        unset($objPHPExcel);        
    }
    
    /************************  OPERACIONES ADICIONALES ************************/
    public function guardarModeloAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            
            $mSession = new Zend_Session_Namespace('shipcode');
            $informe = new Shipcode_Model_SistemaInformePreconfigurado();
            $id = $informe->crear($mSession->informe['parametros'], $mSession->informe['base'], $mSession->informe['tipo'], $mSession->informe['modelo']);
            if($id == FALSE){
                $data['error'] = true;
                $data['mensaje'] = 'Ocurrió un error al intentar guardar el informe';
                echo Zend_Json::encode($data);
            } else {
                $data['error'] = false;
                $data['id'] = $id;
                echo Zend_Json::encode($data);
            }
        }
    }
    /**************************************************************************/
    
    /*************************  CREAR Y DESCARGAR PDF *************************/
    public function crearPdfAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        require_once(Zend_Registry::get('LIBRARY') . 'Shipcode/Pdf.php');
        $mSession = new Zend_Session_Namespace('shipcode');
        $pdf = new Shipcode_Pdf($mSession->informe['contents']);
        $pdf->setName($mSession->informe['fileName']);
        $pdf->download();
    }
    
    public function enviarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $request = $this->getRequest();
        $form = new Shipcode_Form_InformeEnvio();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $copiaTerceros = $form->getValue('copia_terceros');
                    $copiaParaMi = $form->getValue('copia_a_mi');
                    
                    $mail = new App_HtmlMailerDocument('UTF-8');
                    $mail->setFrom(Zend_Registry::get('MAIL_FROM'), Zend_Registry::get('FIRMA_EMPRESA'));
                    $mail->setSubject('Informe vía Email - ' . $mSession->informe['tipo'])
                         ->setViewParam('nombre', $form->getValue('nombre'))
                         ->setViewParam('remitente', $this->usuario)
                         ->setViewParam('tipo', $mSession->informe['tipo'])
                         ->setViewParam('informe', $mSession->informe['contents']);
                    
                    if($form->getValue('mensaje') != ''){
                        $mail->setViewParam('mensaje', $form->getValue('mensaje'));
                    }

                    $mail->addTo($form->getValue('mail'), $form->getValue('nombre'));
                    
                    if($copiaParaMi == 1){
                        $mail->addTo($this->usuario->mail, $this->usuario->nombre);
                    }
                    
                    if($copiaTerceros != '') {
                        $copias = explode(",", $copiaTerceros);
                        foreach($copias as $copia){
                            $mail->addTo($copia);
                        }
                    }
                    $mail->sendHtmlTemplate('enviar-informe.phtml');
                    
                    $mSession->mensajes[] = 'El informe ha sido enviado vía email de forma satisfactoria.';
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/informes/buscar-' . $mSession->informe['base']  . $this->view->construirUrlInformes($mSession->informe['parametros']));

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar enviar el informe vía email.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/informes/enviar');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $form->cancel->setAttrib('onclick', "javascript:goTo('/informes/buscar-" . $mSession->informe['base']  . $this->view->construirUrlInformes($mSession->informe['parametros']) . "');");
        $this->view->title = "Enviar resultados último informe por mail";
        $this->view->pageTitle = "Enviar informe por email";
        $this->view->form = $form;
        $this->view->informe = $mSession->informe;
    }
    /**************************************************************************/
}