<?php
class MantenimientoInformadoController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 13;
        
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    /************************ FUNCIONES MANTENIMIENTOS ************************/
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->view->pageTitle = "Mantenimientos y/o reparaciones informadas";
        
        try {
        
            $mantenimiento = new Shipcode_Model_NaveEquipoMantenimiento();
            $this->view->empresas = Shipcode_Model_Empresa::getPairsToSelect();
            $this->view->naves = Shipcode_Model_Nave::getPairsToSelect();
            
            if($this->getRequest()->isPost()) {
            
                $this->view->title = "Resultados búsqueda";
                
                $parametros = array(
                    'estado' => $this->_getParam('estado'),
                    'desde' => $this->_getParam('desde'),
                    'hasta' => $this->_getParam('hasta'),
                    'empresa' => $this->_getParam('empresa'),
                    'nave' => $this->_getParam('nave'),
                    'sistema' => $this->_getParam('sistema'),
                    'equipo' => $this->_getParam('equipo')
                );
                $this->view->parametros = $parametros;
                $this->view->mantenimientos = $mantenimiento->buscar($parametros);
                
            } else {
                
                $this->view->title = "No asignados";
                $this->view->mantenimientos = $mantenimiento->getNoAsignados(); 
            }
            
        } catch(Exception $e){
            echo $e->getMessage();
        }
    }
    
    public function seleccionarEquipoAction()
    {
        $this->_helper->layout->disableLayout();
        if($this->getRequest()->isXmlHttpRequest()){
            $id = (int)$this->_getParam('id');
            try {
                $sistema = new Shipcode_Model_NaveSistema();
                $mantenimiento = new Shipcode_Model_MantenimientoInformado();
                $mantenimiento->setId($id);
                $this->view->sistemasPrincipales = $sistema->getPairsToSelectByNaveId($mantenimiento->getNaveId());
                $this->view->mantenimiento_informe_id = $id;
            } catch(Exception $e){
                echo $e->getMessage();
            }
        }
    }
    
    public function eliminarAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        $mSession = new Zend_Session_Namespace('shipcode');
        try {
            $id = (int)$this->_getParam('id');
            $mantenimiento = new Shipcode_Model_MantenimientoInformado();
            $mantenimiento->setId($id);
            $mantenimiento->setEstado(2);
            
            $mSession->mensajes[] = "El manteniniento ha quedado oculto de forma satisfactoria";
            $mSession->claseMensaje = "confirmacion";
            $this->_redirect('/mantenimiento-informado');
            
        } catch (Exception $e) {
            $mSession->mensajes[] = "Ocurrió un problema al intentar eliminar el mantenimiento";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/mantenimiento-informado');
        }
    }
    
    public function reactivarAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        $mSession = new Zend_Session_Namespace('shipcode');
        try {
            $id = (int)$this->_getParam('id');
            $mantenimiento = new Shipcode_Model_MantenimientoInformado();
            $mantenimiento->setId($id);
            $mantenimiento->setEstado(0);
            
            $mSession->mensajes[] = "El manteniniento ha sido reactivado de forma satisfactoria";
            $mSession->claseMensaje = "confirmacion";
            $this->_redirect('/mantenimiento-informado');
            
        } catch (Exception $e) {
            $mSession->mensajes[] = "Ocurrió un problema al intentar reactivar el mantenimiento";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/mantenimiento-informado');
        }
    }
    
    public function verAsignacionesAction()
    {
        $this->_helper->layout->disableLayout();
        if($this->getRequest()->isXmlHttpRequest()){
            try {
                $id = (int)$this->_getParam('id');
                $mantenimiento = new Shipcode_Model_MantenimientoInformado();
                $mantenimiento->setId($id);
                $this->view->mantenimientoInforme = $mantenimiento->getRowFull();
                $this->view->mantenimientosAsignados = $mantenimiento->getAsignaciones();
            } catch(Exception $e){
                echo $e->getMessage(); 
            }
        }
    }
    /**************************************************************************/
}