<?php
class NaveCertificadoController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 1;
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    /*********************** OPERACIONES CERTIFICADOS *************************/
    public function agregarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $id = (int)$this->getParam('id');
        $request = $this->getRequest();
        $form = new Shipcode_Form_CertificadoFull();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $modelNave = new Shipcode_Model_Nave();
                    $modelNave->agregarCertificado($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('El certificado fue agregado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#certificados');

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar agregar el certificado.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#certificados');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $form->setAction('/nave-certificado/agregar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$id#certificados');");
        
        $modelNave = new Shipcode_Model_Nave();
        $modelNave->setId($id);
        
        $this->view->nave = $modelNave->getRowFull();
        $form->nave_id->setValue($id);
        $this->view->form = $form;
        $this->view->title = "Agregar certificado";
        $this->view->pageTitle = $this->view->nave->nombre . " > Agregar Certificado";
        $this->renderScript('nave-certificado/form.phtml');
    }

    public function editarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_Certificado();
        $certificado = new Shipcode_Model_NaveCertificado();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $certificado->editar($form->getValues(), $this->usuario->id, (int)$this->_getParam('id'));
                    
                    $mSession->mensajes = array('El certificado fue editado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#certificados');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar el certificado.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#certificados');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $certificado->setId($id);
        $nave_id = $certificado->getNaveId();
        $form->populate($certificado->getRowToForm());
        $form->setAction('/nave-certificado/editar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$nave_id#certificados');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->nave = $certificado->getNave();
        $this->view->title = "Editar certificado";
        $this->view->pageTitle = $this->view->nave->nombre . " > Editar certificado";
        $this->renderScript('nave-certificado/form.phtml');
    }
    
    public function editarEmisionAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_CertificadoFull();
        $form->tipo_id->setRequired(false);
        $certificado = new Shipcode_Model_NaveCertificado();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $certificado->editarUltimaEmision($form->getValues(), $this->usuario->id);
                    
                    $mSession->mensajes = array('Las fechas de emisión del certificado fueron editadas de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#certificados');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar las fechas de emisión del certificado.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#certificados');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $certificado->setId($id);
        $nave_id = $certificado->getNaveId();
        $form->populate($certificado->getRowToForm());
        $form->setAction('/nave-certificado/editar-emision/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$nave_id#certificados');");
        $form->submit->setLabel('Guardar cambios');
        $form->fecha_emision->setLabel('Cambiar fecha de emisión');
        $form->fecha_vencimiento->setLabel('Cambiar fecha de vencimiento');
        $this->view->form = $form;
        $this->view->nave = $certificado->getNave();
        $this->view->title = "Editar emisión de certificado";
        $this->view->pageTitle = $this->view->nave->nombre . " > Editar emisión certificado";
        $this->renderScript('nave-certificado/form-emision.phtml');
    }
    
    public function renovarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_CertificadoFull();
        $form->tipo_id->setRequired(false);
        $certificado = new Shipcode_Model_NaveCertificado();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $certificado->ingresarRenovacion($form->getValues(), $this->usuario->id);
                    
                    $mSession->mensajes = array('La renovación del certificado fue registrada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#certificados');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar ingresar la renovación del certificado.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#certificados');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $certificado->setId($id);
        $nave_id = $certificado->getNaveId();
        $form->populate($certificado->getRowToForm());
        $form->setAction('/nave-certificado/renovar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$nave_id#certificados');");
        $form->submit->setLabel('Renovar');
        $form->fecha_emision->setLabel('Nueva fecha de emisión');
        $form->fecha_emision->setValue('');
        $form->fecha_vencimiento->setLabel('Nueva fecha de vencimiento');
        $form->fecha_vencimiento->setValue('');
        $this->view->form = $form;
        $this->view->nave = $certificado->getNave();
        $this->view->title = "Renovar certificado";
        $this->view->pageTitle = $this->view->nave->nombre . " > Renovar certificado";
        $this->renderScript('nave-certificado/form-renovacion.phtml');
    }
    
    public function eliminarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        $certificado = new Shipcode_Model_NaveCertificado();
        $certificado->setId($id);
        
        try {

            $certificado->eliminar();
            $mSession->mensajes[] = 'El certificado y toda su información asociada fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect($_SERVER['HTTP_REFERER']);

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el certificado.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    public function archivosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        try {
            $id = (int)$this->_getParam('id');
            $certificado = new Shipcode_Model_NaveCertificado();
            $certificado->setId($id);
            $this->view->archivos = $certificado->getArchivos();
            $this->view->certificado = $certificado->getRowFull();
            $this->view->nave = $certificado->getNave();
            $this->view->title = "Administrar archivos del certificado";
            $this->view->pageTitle = "Administrar archivos del certificado";

        } catch (Exception $e) {
            $mSession->mensajes[] = 'Ocurrió un error al intentar ingresar al administrador de archivos del certificado.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    } 

    public function subirArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            
            $path = 'tmp/';
            $uploader = new Shipcode_Upload_QqFileUploader(
                Zend_Registry::get('ACCEPTED_FILE_FORMAT'),
                Zend_Registry::get('MAX_SIZE_FILE_UPLOAD')
            );
            $result = $uploader->handleUpload($path, TRUE);
            if($result == TRUE){
                $name = $uploader->getName();
                $newName = Shipcode_Archivo::renombrar($name);
                if($newName !== FALSE){
                    echo Zend_Json_Encoder::encode(array('success' => true, 'name' => $newName));
                } else {
                    echo Zend_Json_Encoder::encode(array('success' => false, 'name' => $name));
                }
                    
            } 
        }
    }
    
    public function guardarArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            
            $certificado = new Shipcode_Model_NaveCertificado();
            
            try {
                
                $data = array();
                $data['certificado_id'] = (int)$this->_getParam('p_id'); 
                $data['archivo'] = $this->_getParam('archivo'); 
                $data['nombre'] = $this->_getParam('nombre'); 
                
                $idContador = "#num-archivos-documentos";
                $idTabla    = "#list-acc-documentos";
                $idTrigger  = "#trigger-acc-documentos";
                
                $id = $certificado->guardarArchivo($data, $this->usuario->id);
                $num = Shipcode_Model_NaveCertificado::getNumArchivos($data['certificado_id']);
                
                echo Zend_Json::encode(array(
                    'error'     => false, 
                    'mensaje'   => 'El archivo fue guardado de forma satisfactoria.',
                    'id'        => $id,
                    'numTotal'  => $num,
                    'numCarpeta'=> $num,
                    'pid'       => $data['certificado_id'],
                    'folder'    => 'certificados',
                    'controller'=> 'nave-certificado',
                    'nombre'    => $data['nombre'],
                    'archivo'   => $data['archivo'],
                    'idTabla'   => $idTabla,
                    'idContador'=> $idContador,
                    'idTrigger' => $idTrigger,
                    'formato'   => 'pdf',
                    'carpeta'   => "0",
                ));
                
            } catch(Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'mensaje'   => 'Ocurrió un error al intentar guardar el archivo. Error: ' . $e->getMessage(),
                    'clases'    => 'alert alert-error'
                ));
            }
        }
    }
    
    public function editarArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            
            $certificado = new Shipcode_Model_NaveCertificado();
            
            try {
                
                $data = array();
                $data['id'] = (int)$this->_getParam('id'); 
                $data['nombre'] = $this->_getParam('nombre'); 
                $id = $certificado->editarArchivo($data, $this->usuario->id);
                
                echo Zend_Json::encode(array(
                    'error'     => false, 
                    'mensaje'   => 'El archivo fue editado de forma satisfactoria.',
                    'id'        => $id,
                    'nombre'    => $data['nombre']
                ));
                
            } catch(Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'mensaje'   => 'Ocurrió un error al intentar editar el archivo. Error: ' . $e->getMessage(),
                    'clases'    => 'alert alert-error'
                ));
            }
        }
    }
    
    public function eliminarArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if($this->getRequest()->isXmlHttpRequest()){
            try {
                
                $id = $this->_getParam('id');
                $certificado_id = $this->_getParam('from_id');
                $archivo = new Shipcode_Model_NaveCertificadoArchivo();
                $archivo->setId($id);
                $result = $archivo->eliminar();
                $num = Shipcode_Model_NaveCertificado::getNumArchivos($certificado_id);
                $idContador = "#num-archivos-documentos";
                
                if(TRUE == $result){
                    echo Zend_Json::encode(array(
                        'error'     => false, 
                        'id'        => $id,
                        'pid'       => $certificado_id,
                        'numTotal'  => $num,
                        'numCarpeta'=> $num,
                        'idContador'=> $idContador,
                        'clases'    => 'alert alert-success',
                        'mensaje'   => 'La imagen fue eliminada de forma exitosa'
                    ));
                } else {
                    
                    echo Zend_Json::encode(array(
                        'error'     => true, 
                        'clases'    => 'alert alert-error',
                        'mensaje'   => 'Ocurrió un error al intenar eliminar la imagen'
                    ));
                }
            } catch (Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'clases'    => 'alert alert-error',
                    'mensaje'   => $e->getMessage()
                ));
            }
        }
    }
    /**************************************************************************/
    
    public function convertirArchivosAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        
        $pathObs = Zend_Registry::get('PATH_SERVER') . "files/naves/certificados/"; 
        
        $certificado = new Shipcode_Model_NaveCertificado();
        $certificados = $certificado->fetchAll();
        foreach($certificados as $c){
            $pathFiles = $pathObs . $c->id;
            if(is_dir($pathFiles)){
                $files = glob($pathFiles . "/*.jpg");
                foreach($files as $file){
                    $newName = $pathFiles . "/" .date("YmdHis") . ".pdf";
                    exec("convert " . $file . " " . $newName);
                    sleep(3);
                }
            } 
        }
    }
    
    public function asociarArchivosAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        
        $pathObs = Zend_Registry::get('PATH_SERVER') . "files/naves/certificados/"; 
        
        $certificado = new Shipcode_Model_NaveCertificado();
        $certificados = $certificado->fetchAll();
        foreach($certificados as $c){
            $pathFiles = $pathObs . $c->id;
            if(is_dir($pathFiles)){
                $files = glob($pathFiles . "/*.pdf");
                $i = 1;
                foreach($files as $file){
                    $archivo = new Shipcode_Model_NaveCertificadoArchivo();
                    $data = array(
                        'creador'           => $this->usuario->id,
                        'certificado_id'    => $c->id,
                        'nombre'            => "Archivo " . $i,
                        'archivo'           => basename($file)
                    );
                    $row = $archivo->createRow();
                    $row->setFromArray($data);
                    $row->save();
                    $i++;
                }
            } 
        }
    }
    
    public function eliminarArchivosSobrantesAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        $pathCert = "files/naves/certificados/"; 
        $certificado = new Shipcode_Model_NaveCertificado();
        $certificados = $certificado->fetchAll();
        
        foreach($certificados as $c){
            $pathFiles = $pathCert . $c->id;
            if(is_dir($pathFiles)){
                
                if(is_dir($pathFiles . '/thumbs')){
                    $filesThumb = glob($pathFiles . '/thumbs/' . "/*.jpg");
                    foreach($filesThumb as $fileThumb){
                        unlink($fileThumb);
                        echo "Se eliminó " . $fileThumb . "<br>";
                    }
                    rmdir($pathFiles . '/thumbs');
                }
                
                $files = glob($pathFiles . "/*.jpg");
                
                foreach($files as $file){
                    unlink($file);
                    echo "Se eliminó " . $file . "<br>";
                }
            }
        }
    }
}