<?php

require_once Zend_Registry::get('OTHERS_PHP_CLASSES'). '/abeautifulsite/SimpleImage.php';

class NaveController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->controller = $this->getRequest()->getControllerName();
        $this->view->action = $this->getRequest()->getActionName();
        
        if($this->usuario->perfil_id >= 20 && $this->usuario->perfil <= 29){
            $this->nave_id = $this->view->nave_id = Shipcode_Model_SistemaUsuario::getNaveAsignada($this->view->autorizaciones['naves']);
            $nave = new Shipcode_Model_Nave();
            $nave->setId($this->nave_id);
            $this->view->naveToMenu = $nave->getRow()->nombre;
            $this->ultimaVisita = Shipcode_Model_SistemaLogIngreso::getVisitaAnteriorByUsuarioId($this->usuario->id);
        }
        /*
        if($this->usuario->tipo == 2){
            $this->empresa_id = $this->view->empresa_id = Shipcode_Model_SistemaUsuario::getEmpresaAsignada($this->view->privilegios['autorizaciones']['empresas']);
        }
        */

        $this->view->pagina = 1;
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    public function crearAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Shipcode_Form_Nave();
        
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $modelNave = new Shipcode_Model_Nave();
                    $id = $modelNave->crear($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('La nave fue creada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $id);

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la nave.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/empresa/ver/' . $form->getValue('empresa_id'));
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $id = (int)$this->getParam('id');
        $modelEmpresa = new Shipcode_Model_Empresa();
        $modelEmpresa->setId($id);
        $this->view->empresa = $modelEmpresa->getRow();
        $form->cancel->setAttrib('onclick', "javascript:goTo('/empresa/ver/$id');");
        $form->setAction('/nave/crear/' . $id);
        $form->empresa_id->setValue($id);
        $this->view->form = $form;
        $this->view->title = "Crear nave";
        $this->view->pageTitle = $this->view->empresa->nombre . " > Crear nave";
        $this->renderScript('nave/form.phtml');
    }
    
    public function editarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_Nave();
        $nave = new Shipcode_Model_Nave();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $id = $nave->editar($form->getValues(), $this->usuario->id, (int)$this->_getParam('nave_id'));
                    
                    $mSession->mensajes = array('La información de la nave fue editada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $id);

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar la nave.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('id'));
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $nave->setId($id);
        $rowNave = $nave->getRow()->toArray();
        $form->populate($rowNave);
        $form->nave_id->setValue($rowNave['id']);
        $form->setAction('/nave/editar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$id');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->empresa = $nave->getEmpresa();
        $this->view->title = "Editar nave";
        $this->view->nave = $nave->getRow();
        $this->view->pageTitle = $this->view->empresa->nombre . " > Editar nave";
        $this->renderScript('nave/form.phtml');
    }
    
    public function verAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        if($this->usuario->perfil_id >= 20){
            $id = $this->view->nave_id;
            if(!$mSession->identidadUsuario){
                $this->_redirect('/u-nave/identificacion');
            }
        } else {
            $id = (int)$this->_getParam('id');
        }
            

        if($this->_getParam('tab')){
            $this->view->tab = $this->_getParam('tab');
        }
        
        try {
            
            $modelNave = new Shipcode_Model_Nave();
            $modelNave->setId($id);
            $this->view->nave = $modelNave->getRowFull();
            $this->view->sistemas = $modelNave->getSistemas();
            $this->view->siniestros = $modelNave->getSiniestros();
            $this->view->carenas = $modelNave->getCarenas();
            $this->view->certificados = $modelNave->getCertificados();
            $this->view->observaciones = $modelNave->getObservaciones();
            $this->view->auditoriasInternas = $modelNave->getAuditoriasInternas();
            $this->view->etiquetasArchivos = $modelNave->getArchivos();
            $this->view->etiquetas = Shipcode_Model_EtiquetaArchivo::getpairsToSelect();
            $this->view->horometros = $modelNave->getHorometros();
            $this->view->pageTitle = "Detalle Nave :: " . $this->view->nave->nombre;

        } catch(Exception $e){
            
            $mSession->mensajes[] = "Ocurrió un problema al intentar visualizar la nave.";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    public function eliminarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        
        try {

            $nave = new Shipcode_Model_Nave();
            $nave->setId($id);
            $empresa_id = $nave->getEmpresa()->id;
            $nave->eliminar();
            
            $mSession->mensajes[] = 'La nave y toda su información asociada ha sido eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/empresa/ver/' . $empresa_id);

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar la nave y toda su información asociada.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/nave/ver/' .  $id);
        }
    }
    
    public function subirFotografiaAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
            
        if($this->getRequest()->isXmlHttpRequest()){
            
            $path = 'files/fotografias/';
            $id = (int)$this->_getParam('id');
            
            $uploader = new App_Upload_QqFileUploader(
                Zend_Registry::get('ACCEPTED_IMG_FORMAT'), 
                Zend_Registry::get('MAX_SIZE_IMG_UPLOAD')
            );
            $result = $uploader->handleUpload($path, TRUE);
            $name = $uploader->getName();
            
            if($result == TRUE){
                
                try{
                    $nave = new Shipcode_Model_Nave();
                    $nave->setId($id);
                    $nave->actualizarFotografia($name);

                    echo Zend_Json_Encoder::encode(array('success' => true, 'name' => $name));
                } catch(Exception $e){
                    echo $e->getTraceAsString();
                }
            } else {
                echo Zend_Json_Encoder::encode($result);
            }
        }    
    }
    /**************************************************************************/
   
    /******************** OPERACIONES PRESUPUESTO & GASTOS ********************/
    public function detallarGastosMensualesAction()
    {
        $this->_helper->layout->disableLayout();
            
        if($this->getRequest()->isXmlHttpRequest()){

            $nave_id = (int)$this->_getParam('nave_id');
            $year = (int)$this->_getParam('year');
            $month = (int)$this->_getParam('month');
            try {
                $nave = new Shipcode_Model_Nave();
                $nave->setId($nave_id);
                $this->view->gastos = $nave->getGastosMensuales($year, $month);
            } catch(Exception $e){
                echo $e->getMessage();
            }
        }
    }
    /**************************************************************************/
    /*
    public function configurarSistemasAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $id = (int)$this->_getParam('id');
        try {
            $nave = new Shipcode_Model_Nave();
            $nave->setId($id);
            $this->view->nave = $nave->getRowFull();
            $this->view->sistemas = $nave->getSistemas();
            $this->view->title = "Configuración de Sistemas";
            $this->view->pageTitle = $this->view->nave->nombre . " > Configuración de sistemas";
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un error al intentar ingresar a la configuración de sistemas de la nave.";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect("/nave/ver/" . $id . "/equipos");
        }
    }
    
    public function configurarEquiposAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $id = (int)$this->_getParam('id');
        try {
            $nave = new Shipcode_Model_Nave();
            $nave->setId($id);
            $this->view->nave = $nave->getRowFull();
            $this->view->sistemas = $nave->getSistemas();
            $this->view->title = "Configuración de Equipos";
            $this->view->pageTitle = $this->view->nave->nombre . " > Configuración de equipos";
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un error al intentar ingresar a la configuración de equipos de la nave.";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect("/nave/ver/" . $id . "/equipos");
        }
    }
    
    public function agregarSistemaAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $request = $this->getRequest();
        $form = new Shipcode_Form_Sistema();
        $id = (int)$this->getParam('id');
        $nave = new Shipcode_Model_Nave();
        $nave->setId($id);
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $nave->agregarSistema($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('El sistema fue agregado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/configurar-sistemas/' . $id);

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar agregar el sistema a la nave.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/configurar-sistemas/' . $id);
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $form->nave_id->setValue($id);
        $form->setAction("/nave/agregar-sistema/" . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/configurar-sistemas/$id');");
        $this->view->nave = $nave->getRowFull();
        $this->view->form = $form;
        $this->view->title = "Agregar sistema principal";
        $this->view->pageTitle = $this->view->nave->nombre . " > Agregar sistema principal";
        $this->renderScript('nave/form-sistema.phtml');
    }
    
    public function agregarSubsistemaAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $request = $this->getRequest();
        $form = new Shipcode_Form_Subsistema();
        $id = (int)$this->_getParam('id');
        $nave = new Shipcode_Model_Nave();
        $nave->setId($id);
        $form->padre_id->addMultiOptions(Shipcode_Model_Nave::getSistemasPrincipalesToSelect($id));
        $form->nave_id->setValue($id);
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $nave->agregarSubsistema($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('El subsistema fue agregado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/configurar-sistemas/' . $id);

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar agregar el sistema a la nave.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/configurar-sistemas/' . $id);
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        
        $form->setAction("/nave/agregar-subsistema/" . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/configurar-sistemas/$id');");
        $this->view->nave = $nave->getRowFull();
        $this->view->form = $form;
        $this->view->title = "Agregar subsistema";
        $this->view->pageTitle = $this->view->nave->nombre . " > Agregar subsistema";
        $this->renderScript('nave/form-sistema.phtml');
    }
    
    public function editarSistemaAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $request = $this->getRequest();
        $form = new Shipcode_Form_SistemaEdit();
        $id = (int)$this->getParam('id');
        $sistema = new Shipcode_Model_NaveSistema();
        $sistema->setId($id);
        $nave_id = $sistema->getNaveId();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $sistema->editar($form->getValues(), $this->usuario->id, (int)$this->_getParam('id'));
                    $mSession->mensajes = array('El sistema fue editado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/configurar-sistemas/' . $nave_id);

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar el sistema';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/configurar-sistemas/' . $nave_id);
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $form->populate($sistema->getRow()->toArray());
        $form->setAction("/nave/editar-sistema/" . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/configurar-sistemas/$nave_id');");
        $this->view->nave = $sistema->getNave();
        $this->view->form = $form;
        $this->view->title = "Editar nombre del sistema";
        $this->view->pageTitle = $this->view->nave->nombre . " > Editar nombre del sistema";
        $this->renderScript('nave/form-sistema.phtml');
    }
    
    public function eliminarSistemaAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        
        try {
            
            $sistema = new Shipcode_Model_NaveSistema();
            $sistema->setId($id);
            $nave_id = $sistema->getNaveId();
            $sistema->eliminar();
            $mSession->mensajes[] = 'El sistema fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/nave/configurar-sistemas/' . $nave_id );

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el sistema.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/nave/configurar-sistemas/' .  $nave_id );
        }
    }
    public function adjuntarArchivoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_NaveArchivo();
        $nave = new Shipcode_Model_Nave();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $nave->adjuntarArchivo($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('El archivo fue subido de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') . '/archivos');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar subir un archivo adjunto.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') . '/archivos');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $nave->setId($id);
        $form->nave_id->setValue($id);
        $form->setAction('/nave/adjuntar-archivo/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$id/archivos');");
        $this->view->form = $form;
        $this->view->empresa = $nave->getEmpresa();
        $this->view->title = "Adjuntar archivo";
        $this->view->nave = $nave->getRow();
        $this->view->pageTitle = $this->view->empresa->nombre . " > Subir archivo";
        $this->renderScript('nave/form-archivo.phtml');
    }
    
    public function editarArchivoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $request = $this->getRequest();
        $form = new Shipcode_Form_NaveArchivoEdit();
        $id = (int)$this->getParam('id');
        $nave_id = (int)$this->getParam('from_id');
        
        $archivo = new Shipcode_Model_NaveArchivo();
        $archivo->setId($id);
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $archivo->editar($form->getValues(), $this->usuario->id, (int)$this->_getParam('id'));
                    $mSession->mensajes = array('El archivo fue editado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $nave_id . '/archivos');

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar el archivo';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $nave_id . '/archivos');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $nave = new Shipcode_Model_Nave();
        $nave->setId($nave_id);
        
        $form->populate($archivo->getRow()->toArray());
        $form->setAction("/nave/editar-archivo/" . $id . "/" . $nave_id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$nave_id/archivos');");
        $this->view->nave = $nave->getRowFull();
        $this->view->form = $form;
        $this->view->title = "Editar información del archivo";
        $this->view->pageTitle = $this->view->nave->nombre . " > Editar archivo";
        $this->renderScript('nave/form-archivo-editar.phtml');
    }
    
    public function eliminarArchivoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        $archivo = new Shipcode_Model_NaveArchivo();
        $archivo->setId($id);
        
        try {

            $archivo->eliminar();
            $mSession->mensajes[] = 'El archivo adjunto fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect($_SERVER['HTTP_REFERER']);

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el archivo adjunto.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    public function subirArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
            
        if($this->getRequest()->isXmlHttpRequest()){
            
            $path = 'files/naves/adjuntos/';
            $uploader = new App_Upload_QqFileUploader(
                Zend_Registry::get('ACCEPTED_FILE_FORMAT'), 
                Zend_Registry::get('MAX_SIZE_FILE_UPLOAD'));
            $result = $uploader->handleUpload($path, TRUE);
            
            if($result == TRUE){
                
                $name = $uploader->getName();
                $file = Zend_Registry::get('PATH_SERVER') . 'files/naves/adjuntos/' . $name;
                $newName = date("YmdHis") . "-" . str_replace(" ", "_", $name);
                $newFile = Zend_Registry::get('PATH_SERVER') . 'files/naves/adjuntos/' . $newName;
                rename($file, $newFile);
                echo Zend_Json_Encoder::encode(array('success' => true, 'name' => $newName));
            } 
        }    
    }
    
    public function descargarArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        $id = (int)$this->_getParam('id');
        
        $archivo = new Shipcode_Model_NaveArchivo();
        $archivo->setId($id);
        $nombre = $archivo->getRow()->archivo;
        
        
        $fileFullPath = Zend_Registry::get('PATH_SERVER') . 'files/naves/adjuntos/' . $nombre;
        $nave_id = (int)$this->_getParam('from_id');
        
        if(file_exists($fileFullPath)){
            
            $download_path = Zend_Registry::get('PATH_SERVER') . "files/naves/adjuntos/";
            $args = array(
		'download_path'		=>	$download_path,
		'file'                  =>	$nombre,		
		'extension_check'	=>	TRUE,
		'referrer_check'	=>	FALSE,
		'referrer'		=>	NULL,
		);
            $download = new App_Download($args);
            $download_hook = $download->get_download_hook();

            if( $download_hook['download'] == TRUE ) {
        	$download->get_download();
            }
            
        } else {
            $mSession = new Zend_Session_Namespace('shipcode');
            $mSession->mensajes[] = "El archivo solicitado no existe.";
            $mSession->claseMensaje = "error";
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    public function ingresarSiniestroAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $id = (int)$this->getParam('id');
        $request = $this->getRequest();
        $form = new Shipcode_Form_Siniestro();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $modelNave = new Shipcode_Model_Nave();
                    $modelNave->registrarSiniestro($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('El siniestro fue registrado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'/siniestros');

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar registrar el siniestro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'/siniestros');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $form->setAction('/nave/ingresar-siniestro/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$id/siniestros');");
        $modelNave = new Shipcode_Model_Nave();
        $modelNave->setId($id);
        
        $this->view->nave = $modelNave->getRowFull();
        $form->nave_id->setValue($id);
        $this->view->form = $form;
        $this->view->title = "Ingresar siniestro";
        $this->view->pageTitle = $this->view->nave->nombre . " > Ingresar siniestro";
        $this->renderScript('nave/form-siniestro.phtml');
    }

    public function editarSiniestroAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_Siniestro();
        $siniestro = new Shipcode_Model_NaveSiniestro();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $siniestro->editar($form->getValues(), $this->usuario->id, (int)$this->_getParam('id'));
                    
                    $mSession->mensajes = array('El siniestro fue editado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'/siniestros');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar la información del siniestro.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'/siniestros');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $siniestro->setId($id);
        $nave_id = $siniestro->getNaveId();
        $form->populate($siniestro->getRow()->toArray());
        $form->setAction('/nave/editar-siniestro/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$nave_id/siniestros');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->nave = $siniestro->getNave();
        $this->view->title = "Editar siniestro";
        $this->view->pageTitle = $this->view->nave->nombre . " > Editar siniestro";
        $this->renderScript('nave/form-siniestro.phtml');
    }
    
    public function eliminarSiniestroAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        $siniestro = new Shipcode_Model_NaveSiniestro();
        $siniestro->setId($id);
        $nave_id = $siniestro->getNaveId();
        
        try {

            $siniestro->eliminar();
            $mSession->mensajes[] = 'El registro de siniestro fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect($_SERVER['HTTP_REFERER']);

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el registro del siniestro.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    // Igual al siguiente pero restrcit
    public function verArchivosSiniestroAction()
    {
        $this->_helper->layout->disablelayout();
        $id = (int)$this->_getParam('id');
        $siniestro = new Shipcode_Model_NaveSiniestro();
        $siniestro->setId($id);
        $this->view->archivos = $siniestro->getArchivos();
        $this->view->id= $id;
        $this->renderScript('nave/restrict-administrar-archivos-siniestro.phtml');
    }
    
    public function administrarArchivosSiniestroAction()
    {
        $this->_helper->layout->disablelayout();
        $id = (int)$this->_getParam('id');
        $siniestro = new Shipcode_Model_NaveSiniestro();
        $siniestro->setId($id);
        $this->view->archivos = $siniestro->getArchivos();
        $this->view->id= $id;
    }
    
    public function subirArchivoSiniestroAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
            
        if($this->getRequest()->isXmlHttpRequest()){
            
            $path = 'files/naves/siniestros/tmp/';
            $uploader = new App_Upload_QqFileUploader(
                Zend_Registry::get('ACCEPTED_FILE_FORMAT'),
                Zend_Registry::get('MAX_SIZE_FILE_UPLOAD')
            );
            $result = $uploader->handleUpload($path, TRUE);
            
            if($result == TRUE){
             
                $mime = new App_Mime();
                $name = $uploader->getName();
                $file = Zend_Registry::get('PATH_SERVER') . 'files/naves/siniestros/tmp/' . $name;
                $newName = date("YmdHis") . $mime->getExtension($file);
                $newFile = Zend_Registry::get('PATH_SERVER') . 'files/naves/siniestros/tmp/' . $newName;
                rename($file, $newFile);
                echo Zend_Json_Encoder::encode(array(
                    'success' => true, 
                    'name' => $newName
                ));
                
            } 
        }    
    }
    
    public function guardarArchivoSiniestroAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
            
        if($this->getRequest()->isXmlHttpRequest()){
            
            $siniestro = new Shipcode_Model_NaveSiniestro();
            
            try {
                
                $data = array();
                $data['siniestro_id'] = (int)$this->_getParam('siniestro_id'); 
                $data['archivo'] = $this->_getParam('archivo'); 
                $data['nombre'] = $this->_getParam('nombre'); 
                $id = $siniestro->guardarArchivo($data, $this->usuario->id);
                
                echo Zend_Json::encode(array(
                    'error'     => false, 
                    'mensaje'   => 'El archivo fue guardado de forma satisfactoria.',
                    'id'        => $id,
                    'num'       => Shipcode_Model_NaveSiniestro::getNumArchivos($data['siniestro_id']),
                    'sid'       => $data['siniestro_id'],
                    'clase'     => 'success',
                    'nombre'    => $data['nombre']
                ));
                
            } catch(Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'mensaje'   => 'Ocurrió un error al intentar guardar el archivo. Error: ' . $e->getMessage(),
                    'clase'     => 'error'
                ));
            }
        }
    }
    
    public function descargarArchivoSiniestroAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        $id = (int)$this->_getParam('id');
        
        $archivo = new Shipcode_Model_NaveSiniestroArchivo();
        $archivo->setId($id);
        $row = $archivo->getRow();
        $fileFullPath = Zend_Registry::get('PATH_SERVER') . 'files/naves/siniestros/' . $row->siniestro_id . '/' . $row->archivo;
        
        if(file_exists($fileFullPath)){
            
            $download_path = Zend_Registry::get('PATH_SERVER') . "files/naves/siniestros/" . $row->siniestro_id . '/';
            $args = array(
		'download_path'		=>	$download_path,
		'file'                  =>	$row->archivo,		
		'extension_check'	=>	TRUE,
		'referrer_check'	=>	FALSE,
		'referrer'		=>	NULL,
		);
            $download = new App_Download($args);
            $download_hook = $download->get_download_hook();

            if( $download_hook['download'] == TRUE ) {
        	$download->get_download();
            }
            
        } else {
            $mSession = new Zend_Session_Namespace('shipcode');
            $mSession->mensajes[] = "El archivo solicitado no existe.";
            $mSession->claseMensaje = "error";
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    public function descargarArchivosSiniestroAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        $id = (int)$this->_getParam('id');
        
        
        $siniestro = new Shipcode_Model_NaveSiniestro();
        $siniestro->setId($id);
        $row = $siniestro->getRow();
        $archivos = $siniestro->getArchivos();
        
        $path = Zend_Registry::get('PATH_SERVER') . 'files/naves/siniestros/' . $row->id . '/';
        $download = $row->numero . ".zip";
        $zip = new ZipArchive();
        
        if ($zip->open($download, ZIPARCHIVE::CREATE )!==TRUE) {
            exit("cannot open <$download>\n");
        } else {
            foreach($archivos as $archivo){
                $file = $path . $archivo->archivo;
                if(file_exists($file)){
                    $zip->addFile($file , basename($file));
                }
            }
            $zip->close();
            header("Content-type: application/zip");
            header("Content-Disposition: attachment; filename=$download");
            header("Pragma: no-cache");
            header("Expires: 0");
            readfile("$download");
            @unlink("$download");
            exit;
        }
    }
    
    public function eliminarArchivoSiniestroAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if($this->getRequest()->isXmlHttpRequest()){
            try {
                
                $id = (int)$this->_getParam('id');
                $archivo = new Shipcode_Model_NaveSiniestroArchivo();
                $archivo->setId($id);
                $siniestro_id = $archivo->eliminar();
                $numArchivos = Shipcode_Model_NaveSiniestro::getNumArchivos($siniestro_id);
                
                if(FALSE != $id){
                    
                    echo Zend_Json::encode(array(
                        'error'     => false, 
                        'id'        => $id,
                        'sid'       => $siniestro_id,
                        'num'       => $numArchivos,
                        'clase'     => 'success',
                        'mensaje'   => 'El archivo fue eliminado de forma exitosa'
                    ));
                    
                } else {
                    
                    echo Zend_Json::encode(array(
                        'error'     => true, 
                        'clase'     => 'error',
                        'mensaje'   => 'Ocurrió un error al intenar eliminar el archivo'
                    ));
                    
                }
                    
            } catch (Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'clase'     => 'error',
                    'mensaje'   => $e->getMessage()
                ));
            }
        }
    }
    public function agregarObservacionAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $id = (int)$this->getParam('id');
        $request = $this->getRequest();
        $form = new Shipcode_Form_Observacion();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $modelNave = new Shipcode_Model_Nave();
                    $modelNave->agregarObservacion($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('La observación fue ingresada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'/observaciones');

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar ingresar la observación.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'/observaciones');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $form->setAction('/nave/agregar-observacion/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$id/observaciones');");
        $modelNave = new Shipcode_Model_Nave();
        $modelNave->setId($id);
        
        $this->view->nave = $modelNave->getRowFull();
        $form->nave_id->setValue($id);
        $this->view->form = $form;
        $this->view->title = "Agregar observación de revista";
        $this->view->pageTitle = $this->view->nave->nombre . " > Agregar observación de revista";
        $this->renderScript('nave/form-observacion.phtml');
    }

    public function editarObservacionAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_Observacion();
        $observacion = new Shipcode_Model_NaveObservacion();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $observacion->editar($form->getValues(), $this->usuario->id, (int)$this->_getParam('id'));
                    
                    $mSession->mensajes = array('La observación fue editada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'/observaciones');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar la observación.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'/observaciones');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $observacion->setId($id);
        $nave_id = $observacion->getNaveId();
        $form->populate($observacion->getRow()->toArray());
        $form->setAction('/nave/editar-observacion/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$nave_id/observaciones');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->nave = $observacion->getNave();
        $this->view->title = "Editar observación de revista";
        $this->view->pageTitle = $this->view->nave->nombre . " > Editar observación de revista";
        $this->renderScript('nave/form-observacion.phtml');
    }
    
    public function eliminarObservacionAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        $observacion = new Shipcode_Model_NaveObservacion();
        $observacion->setId($id);
        
        try {

            $observacion->eliminar();
            $mSession->mensajes[] = 'La observación fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect($_SERVER['HTTP_REFERER']);

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar la observación.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    public function subirBoletaObservacionesAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_BoletaObservaciones();
        $nave = new Shipcode_Model_Nave();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $this->_renombrarBoleta($form->getValues());
                    $mSession->mensajes = array('La imagen de la boleta de observaciones fue subida de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') . '/observaciones');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar subir la imagen de la boleta de observaciones.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') . '/observaciones');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $nave_id = (int)$this->_getParam('from_id');
        $numero = $this->_getParam('id');
        $nave->setId($nave_id);
        $form->nave_id->setValue($nave_id);
        $form->numero->setValue($numero);
        $form->setAction('/nave/subir-boleta-observaciones/' . $numero . '/' . $nave_id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$nave_id/observaciones');");
        $this->view->form = $form;
        $this->view->empresa = $nave->getEmpresa();
        $this->view->title = "Subir boleta observaciones";
        $this->view->nave = $nave->getRow();
        $this->view->pageTitle = $this->view->empresa->nombre . " > Subir boleta observaciones";
        $this->renderScript('nave/form-boleta-observaciones.phtml');
    }
    
    public function subirImagenBoletaObservacionesAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
            
        if($this->getRequest()->isXmlHttpRequest()){
            
            $path = 'files/observaciones/';
            $uploader = new App_Upload_QqFileUploader(
                Zend_Registry::get('ACCEPTED_IMG_FORMAT'), 
                Zend_Registry::get('MAX_SIZE_IMG_UPLOAD')
            );
            $result = $uploader->handleUpload($path, TRUE);
            
            if($result == TRUE){
              echo Zend_Json_Encoder::encode(array('success' => true, 'name' => $uploader->getName()));
            } 
        }    
    }
    
    public function descargarImagenBoletaObservacionesAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        $nombre = $this->_getParam('id');
        $fileFullPath = Zend_Registry::get('PATH_SERVER') . 'files/observaciones/' . $nombre;
        $nave_id = (int)$this->_getParam('from_id');
        
        if(file_exists($fileFullPath)){
            
            $download_path = Zend_Registry::get('PATH_SERVER') . "files/observaciones/";
            $args = array(
		'download_path'		=>	$download_path,
		'file'                  =>	$nombre,		
		'extension_check'	=>	TRUE,
		'referrer_check'	=>	FALSE,
		'referrer'		=>	NULL,
		);
            $download = new App_Download($args);
            $download_hook = $download->get_download_hook();
            //$download->chip_print($download_hook);
            //exit;

            if( $download_hook['download'] == TRUE ) {
        	$download->get_download();
            }
            
        } else {
            $mSession = new Zend_Session_Namespace('shipcode');
            $mSession->mensajes[] = "La imagen de la boleta de observaciones solicitada no existe.";
            $mSession->claseMensaje = "error";
            $this->_redirect('/nave/ver/' . $nave_id . '/observaciones');
        }
    }
    
    public function eliminarImagenBoletaObservacionesAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $nave_id = (int)$this->_getParam('from_id');
        $archivo = $this->_getParam('id');
        
        try {
            
            unlink(Zend_Registry::get('PATH_SERVER') . 'files/observaciones/' . $archivo);
            $mSession->mensajes[] = "La imagen de la boleta de observaciones fue eliminada de forma exitosa.";
            $mSession->claseMensaje = "confirmacion";
            
        } catch(Exception $e){
            
            $mSession->mensajes[] = "Ocurrió un error al intentar eliminar la imagen de la boleta de observaciones";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            
        }
        $this->_redirect($_SERVER['HTTP_REFERER']);
        
    }
    
    private function _renombrarBoleta($data)
    {
        $file = Zend_Registry::get('PATH_SERVER') . 'files/observaciones/' . $data['archivo'];
        $mime = new App_Mime();
        $filterAlnum = new Zend_Filter_Alnum();
        $fileName = $filterAlnum->filter($data['numero']) . $mime->getExtension($file);
        $newFile = Zend_Registry::get('PATH_SERVER') . 'files/observaciones/' . $fileName;
        if(rename($file, $newFile)){
            return true;
        }
        return false;
    }
    public function crearThumbnailsAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        
        $i = 0;
        $dir = Zend_Registry::get('PATH_SERVER') . 'files/naves/fotografias/';
        
        $modelNave = new Shipcode_Model_Nave();
        $naves = $modelNave->fetchAll("fotografia IS NOT NULL");
        
        foreach($naves as $nave){
            if(file_exists($dir . $nave->fotografia)){
                
                $newName = date("Ymdhis") . '.jpg';
                $image = new abeautifulsite\SimpleImage($dir . $nave->fotografia);
                $image->fit_to_width(360);
                $image->save($dir . $newName);
                
                if(file_exists($dir . $newName)){
                    
                    $rowNave = new Shipcode_Model_Nave();
                    $rowNave->setId($nave->id);
                    $rowNave->actualizarFotografia($newName);
                    $i++;
                    unlink($dir . $nave->fotografia);
                    sleep(1);
                    
                }
               
            }
        }
        echo "Se crearon $i thumbnails";
    }
    public function crearCarenaAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $id = (int)$this->getParam('id');
        try {
            $modelNave = new Shipcode_Model_Nave();
            $modelNave->setId($id);
            $carena_id = $modelNave->crearCarena($this->usuario->id);
            $this->_redirect('/nave/editar-carena/' . $carena_id);
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un error al intentar crear la carena";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/nave/ver/' . $id . '/carenas');
        }
            
    }
    
    public function editarCarenaAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $id = (int)$this->getParam('id');
        $form = new Shipcode_Form_Carena($id);
        $modelCarena = new Shipcode_Model_NaveCarena();
        $modelCarena->setId($id);
        $nave = $modelCarena->getNave();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $modelCarena = new Shipcode_Model_NaveCarena();
                    $modelCarena->guardar($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('La carena fue guardada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $nave->id .'/carenas');

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar registrar la carena.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $nave->id .'/carenas');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $form->populate($modelCarena->getRow()->toArray());
        $form->setAction('/nave/editar-carena/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$nave->id/carenas');");
        $this->view->nave = $nave;
        $this->view->form = $form;
        $this->view->title = "Ingresar carena";
        $this->view->pageTitle = $nave->nombre . " > Ingresar carena";
        $this->renderScript('nave/form-carena.phtml');
    }
    
    public function eliminarCarenaAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        $carena = new Shipcode_Model_NaveCarena();
        $carena->setId($id);
        $nave_id = $carena->getNaveId();
        
        try {

            $carena->eliminar();
            $mSession->mensajes[] = 'El registro de carena fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/nave/ver/' . $nave_id .'/carenas');

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el registro de la carena.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/nave/ver/' .  $nave_id .'/carenas');
        }
    }

    public function configurarProximaCarenaAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        $nave = new Shipcode_Model_Nave();
        
        $this->_helper->layout->disablelayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if ($this->getRequest()->isPost()) {
            
            $actual = date("Y");
            $years = array($actual, $actual + 1, $actual + 2, $actual + 3, $actual + 4);
            $meses = array('1','2','3','4','5','6','7','8','9','10','11','12');
            
            if (in_array($this->_getParam('sig_carena_year'), $years) && 
                in_array($this->_getParam('sig_carena_mes'), $meses)){
                
                try {

                    $nave->setId($this->_getParam('nave_id'));
                    $nave->actualizarProximaCarena(array(
                        'sig_carena_mes' => (int)$this->_getParam('sig_carena_mes'),
                        'sig_carena_year' => (int)$this->_getParam('sig_carena_year')
                    ), $this->usuario->id);
                    
                    $mSession->mensajes = array('La programación de la próxima carena fue editada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $this->_getParam('nave_id'));

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar la programación de la próxima carena.', $e->getMessage());
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $this->_getParam('nave_id'));
                }
            } else {
                $mSession->mensajes = array($this->_getParam('sig_carena_mes'));
                $mSession->claseMensaje = 'error';
                $this->_redirect('/nave/ver/' . $this->_getParam('nave_id'));
            }
        } 
    }
    
    public function administrarArchivosCarenaAction()
    {
        $this->_helper->layout->disablelayout();
        $id = (int)$this->_getParam('id');
        $carena = new Shipcode_Model_NaveCarena();
        $carena->setId($id);
        $this->view->archivos = $carena->getArchivos();
        $this->view->id= $id;
    }
    
    public function verArchivosCarenaAction()
    {
        $this->_helper->layout->disablelayout();
        $id = (int)$this->_getParam('id');
        $carena = new Shipcode_Model_NaveCarena();
        $carena->setId($id);
        $this->view->archivos = $carena->getArchivos();
        $this->view->id= $id;
        $this->renderScript('nave/restrict-administrar-archivos-carena.phtml');
    }
    
    public function subirArchivoCarenaAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
            
        if($this->getRequest()->isXmlHttpRequest()){
            
            $path = 'files/naves/carenas/tmp/';
            $uploader = new App_Upload_QqFileUploader(
                Zend_Registry::get('ACCEPTED_FILE_FORMAT'),
                Zend_Registry::get('MAX_SIZE_FILE_UPLOAD')
            );
            $result = $uploader->handleUpload($path, TRUE);
            
            if($result == TRUE){
             
                $mime = new App_Mime();
                $name = $uploader->getName();
                $file = Zend_Registry::get('PATH_SERVER') . 'files/naves/carenas/tmp/' . $name;
                $newName = date("YmdHis") . $mime->getExtension($file);
                $newFile = Zend_Registry::get('PATH_SERVER') . 'files/naves/carenas/tmp/' . $newName;
                rename($file, $newFile);
                echo Zend_Json_Encoder::encode(array(
                    'success' => true, 
                    'name' => $newName
                ));
                
            } 
        }    
    }
    
    public function guardarArchivoCarenaAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
            
        if($this->getRequest()->isXmlHttpRequest()){
            
            $carena = new Shipcode_Model_NaveCarena();
            
            try {
                
                $data = array();
                $data['carena_id'] = (int)$this->_getParam('carena_id'); 
                $data['archivo'] = $this->_getParam('archivo'); 
                $data['nombre'] = $this->_getParam('nombre'); 
                $id = $carena->guardarArchivo($data, $this->usuario->id);
                
                echo Zend_Json::encode(array(
                    'error'     => false, 
                    'mensaje'   => 'El archivo fue guardado de forma satisfactoria.',
                    'id'        => $id,
                    'num'       => Shipcode_Model_NaveCarena::getNumArchivos($data['carena_id']),
                    'cid'       => $data['carena_id'],
                    'clases'    => 'alert alert-success',
                    'nombre'    => $data['nombre']
                ));
                
            } catch(Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'mensaje'   => 'Ocurrió un error al intentar guardar el archivo. Error: ' . $e->getMessage(),
                    'clases'    => 'alert alert-error'
                ));
            }
        }
    }
    
    public function descargarArchivoCarenaAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        $id = (int)$this->_getParam('id');
        
        $archivo = new Shipcode_Model_NaveCarenaArchivo();
        $archivo->setId($id);
        $row = $archivo->getRow();
        $fileFullPath = Zend_Registry::get('PATH_SERVER') . 'files/naves/carenas/' . $row->carena_id . '/' . $row->archivo;
        
        if(file_exists($fileFullPath)){
            
            $download_path = Zend_Registry::get('PATH_SERVER') . "files/naves/carenas/" . $row->carena_id . '/';
            $args = array(
		'download_path'		=>	$download_path,
		'file'                  =>	$row->archivo,		
		'extension_check'	=>	TRUE,
		'referrer_check'	=>	FALSE,
		'referrer'		=>	NULL,
		);
            $download = new App_Download($args);
            $download_hook = $download->get_download_hook();

            if( $download_hook['download'] == TRUE ) {
        	$download->get_download();
            }
            
        } else {
            $mSession = new Zend_Session_Namespace('shipcode');
            $mSession->mensajes[] = "El archivo solicitado no existe.";
            $mSession->claseMensaje = "error";
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    public function descargarArchivosCarenaAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        $id = (int)$this->_getParam('id');
        
        
        $carena = new Shipcode_Model_NaveCarena();
        $carena->setId($id);
        $row = $carena->getRow();
        $archivos = $carena->getArchivos();
        
        $path = Zend_Registry::get('PATH_SERVER') . 'files/naves/carenas/' . $row->id . '/';
        $download = 'Carena-' . $row->fecha . ".zip";
        $zip = new ZipArchive();
        
        if ($zip->open($download, ZIPARCHIVE::CREATE )!==TRUE) {
            exit("cannot open <$download>\n");
        } else {
            foreach($archivos as $archivo){
                $file = $path . $archivo->archivo;
                if(file_exists($file)){
                    $zip->addFile($file, basename($file));
                }
            }
            $zip->close();
            header("Content-type: application/zip");
            header("Content-Disposition: attachment; filename=$download");
            header("Pragma: no-cache");
            header("Expires: 0");
            readfile("$download");
            @unlink("$download");
            exit;
        }
    }
    
    public function eliminarArchivoCarenaAction()
    {
        
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if($this->getRequest()->isXmlHttpRequest()){
            try {
                
                $id = (int)$this->_getParam('id');
                $archivo = new Shipcode_Model_NaveCarenaArchivo();
                $archivo->setId($id);
                $carena_id = $archivo->eliminar();
                $numArchivos = Shipcode_Model_NaveCarena::getNumArchivos($carena_id);
                
                if(FALSE != $id){
                    
                    echo Zend_Json::encode(array(
                        'error'     => false, 
                        'id'        => $id,
                        'cid'       => $carena_id,
                        'num'       => $numArchivos,
                        'clases'    => 'alert alert-success',
                        'mensaje'   => 'El archivo fue eliminado de forma exitosa'
                    ));
                    
                } else {
                    
                    echo Zend_Json::encode(array(
                        'error'     => true, 
                        'clases'    => 'alert alert-error',
                        'mensaje'   => 'Ocurrió un error al intenar eliminar el archivo'
                    ));
                    
                }
                    
            } catch (Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'clases'    => 'alert alert-error',
                    'mensaje'   => $e->getMessage()
                ));
            }
        }
    }
    */
}
     