<?php
class NaveObservacionController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 1;
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    /***************** OPERACIONES OBSERVACIONES DE REVISTA *******************/
    public function agregarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $id = (int)$this->getParam('id');
        $request = $this->getRequest();
        $form = new Shipcode_Form_Observacion();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $modelNave = new Shipcode_Model_Nave();
                    $modelNave->agregarObservacion($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('La observación fue ingresada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#observaciones');

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar ingresar la observación.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#observaciones');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $form->setAction('/nave-observacion/agregar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$id#observaciones');");
        $modelNave = new Shipcode_Model_Nave();
        $modelNave->setId($id);
        
        $this->view->nave = $modelNave->getRowFull();
        $form->nave_id->setValue($id);
        $this->view->form = $form;
        $this->view->title = "Agregar observación de revista";
        $this->view->pageTitle = $this->view->nave->nombre . " > Agregar observación de revista";
        $this->renderScript('nave-observacion/form.phtml');
    }

    public function editarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_Observacion();
        $observacion = new Shipcode_Model_NaveObservacion();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $observacion->editar($form->getValues(), $this->usuario->id, (int)$this->_getParam('id'));
                    
                    $mSession->mensajes = array('La observación fue editada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#observaciones');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar la observación.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#observaciones');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $observacion->setId($id);
        $nave_id = $observacion->getNaveId();
        $form->populate($observacion->getRow()->toArray());
        $form->setAction('/nave-observacion/editar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$nave_id#observaciones');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->nave = $observacion->getNave();
        $this->view->title = "Editar observación de revista";
        $this->view->pageTitle = $this->view->nave->nombre . " > Editar observación de revista";
        $this->renderScript('nave-observacion/form.phtml');
    }
    
    public function eliminarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        $observacion = new Shipcode_Model_NaveObservacion();
        $observacion->setId($id);
        
        try {

            $observacion->eliminar();
            $mSession->mensajes[] = 'La observación fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect($_SERVER['HTTP_REFERER']);

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar la observación.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    /************************** OPERACIONES ITEMS *****************************/
    public function agregarItemAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $id = (int)$this->getParam('id');
        $request = $this->getRequest();
        $form = new Shipcode_Form_ObservacionItem();
        $modelObservacion = new Shipcode_Model_NaveObservacion();
        $modelObservacion->setId($id);
        $this->view->observacion = $modelObservacion->getRowFull();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $modelObservacion = new Shipcode_Model_NaveObservacion();
                    $modelObservacion->agregarItem($form->getValues());
                    $mSession->mensajes = array('El ítem fue agregado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $this->view->observacion['nave_id'] .'#observaciones');

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar ingresar el ítem.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $this->view->observacion['id'] .'#observaciones');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $form->setAction('/nave-observacion/agregar-item/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/" . $this->view->observacion['nave_id'] . "#observaciones');");
        $form->observacion_id->setValue($id);
        $this->view->form = $form;
        $this->view->title = "Agregar ítem a la boleta de observaciones";
        $this->view->pageTitle = $this->view->observacion['nave'] . " > Agregar ítem a la boleta de observaciones";
        $this->renderScript('nave-observacion/form-item.phtml');
    }
    
    public function editarItemAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_ObservacionItem();
        $item = new Shipcode_Model_NaveObservacionItem();
        $id = (int)$this->_getParam('id');
        $item->setId($id);
        $this->view->observacion = $item->getObservacion();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $item->editar($form->getValues());
                    
                    $mSession->mensajes = array('El ítem fue editado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $this->view->observacion['nave_id'] .'#observaciones');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar el ítem.'); 
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $this->view->observacion['nave_id'] .'#observaciones');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        
        $form->populate($item->getRow()->toArray());
        $form->setAction('/nave-observacion/editar-item/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/" . $this->view->observacion['nave_id'] . "#observaciones');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->title = "Editar observación de revista";
        $this->view->pageTitle = $this->view->observacion['nave'] . " > Editar observación de revista";
        $this->renderScript('nave-observacion/form-item.phtml');
    }
    
    public function eliminarItemAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        $item = new Shipcode_Model_NaveObservacionItem();
        $item->setId($id);
        
        try {

            $item->eliminar();
            $mSession->mensajes[] = 'El ítem fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect($_SERVER['HTTP_REFERER']);

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el ítem.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    public function archivosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        try {
            $id = (int)$this->_getParam('id');
            $observacion = new Shipcode_Model_NaveObservacion();
            $observacion->setId($id);
            $this->view->archivos = $observacion->getArchivos();
            $this->view->numTotalArchivos = Shipcode_Model_NaveObservacion::getNumArchivos($id, FALSE);
            $this->view->observacion = $observacion->getRowFull();
            $this->view->items = $observacion->getItemsToUpload();
            $this->view->nave = $observacion->getNave();
            $this->view->title = "Administrar archivos de la observación";
            $this->view->pageTitle = "Administrar archivos de la observación";

        } catch (Exception $e) {
            $mSession->mensajes[] = 'Ocurrió un error al intentar ingresar al administrador de archivos de la observación.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    } 
    
    public function subirArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
            
        if($this->getRequest()->isXmlHttpRequest()){
            
            $path = 'tmp/';
            $uploader = new Shipcode_Upload_QqFileUploader(
                Zend_Registry::get('ACCEPTED_FILE_FORMAT'),
                Zend_Registry::get('MAX_SIZE_FILE_UPLOAD')
            );
            $result = $uploader->handleUpload($path, TRUE);
            if($result == TRUE){
                $name = $uploader->getName();
                $newName = Shipcode_Archivo::renombrar($name);
                $info = pathinfo(Zend_Registry::get('PATH_SERVER') . $path . $name);
                if($newName !== FALSE){
                    echo Zend_Json_Encoder::encode(array('success' => true, 'name' => $newName, 'formato' => $info['extension']));
                } else {
                    echo Zend_Json_Encoder::encode(array('success' => false, 'name' => $name));
                }
                    
            } 
        }      
    }
    
    public function guardarArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            
            $observacion = new Shipcode_Model_NaveObservacion();
            
            try {
                $data = array();
                $data['observacion_id'] = (int)$this->_getParam('p_id'); 
                $data['formato'] = $this->_getParam('formato');
                $data['archivo'] = $this->_getParam('archivo'); 
                $data['carpeta'] = $this->_getParam('carpeta');
                $data['nombre'] = $this->_getParam('nombre'); 
                $id = $observacion->guardarArchivo($data, $this->usuario->id);
                
                if($data['carpeta'] === "0"){
                    $idContador = "#num-archivos-documentos";
                    $idTabla = "#list-acc-documentos";
                    $idTrigger = "#trigger-acc-documentos";
                } else {
                    $idContador = "#num-archivos-item-" . $data['carpeta'];
                    $idTabla = "#list-acc-item-" . $data['carpeta'];
                    $idTrigger = "#trigger-acc-item-" . $data['carpeta'];
                }
                
                echo Zend_Json::encode(array(
                    'error'     => false, 
                    'mensaje'   => 'El archivo fue guardado de forma satisfactoria.',
                    'id'        => $id,
                    'numTotal'  => Shipcode_Model_NaveObservacion::getNumArchivos($data['observacion_id'], FALSE),
                    'numCarpeta'=> Shipcode_Model_NaveObservacion::getNumArchivos($data['observacion_id'], $data['carpeta']),
                    'pid'       => $data['observacion_id'],
                    'folder'    => 'observaciones',
                    'controller'=> 'nave-observacion',
                    'nombre'    => $data['nombre'],
                    'formato'   => $data['formato'],
                    'archivo'   => $data['archivo'],
                    'carpeta'   => $data['carpeta'],
                    'idTabla'   => $idTabla,
                    'idContador'=> $idContador,
                    'idTrigger' => $idTrigger
                ));
                
            } catch(Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'mensaje'   => 'Ocurrió un error al intentar guardar el archivo. Error: ' . $e->getMessage(),
                    'clases'    => 'alert alert-error'
                ));
            }
        }
    }
    
    public function editarArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            
            $observacion = new Shipcode_Model_NaveObservacion();
            
            try {
                
                $data = array();
                $data['id'] = (int)$this->_getParam('id'); 
                $data['nombre'] = $this->_getParam('nombre'); 
                $id = $observacion->editarArchivo($data, $this->usuario->id);
                
                echo Zend_Json::encode(array(
                    'error'     => false, 
                    'mensaje'   => 'El archivo fue editado de forma satisfactoria.',
                    'id'        => $id,
                    'nombre'    => $data['nombre']
                ));
                
            } catch(Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'mensaje'   => 'Ocurrió un error al intentar editar el archivo. Error: ' . $e->getMessage(),
                    'clases'    => 'alert alert-error'
                ));
            }
        }
    }
    
    public function eliminarArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if($this->getRequest()->isXmlHttpRequest()){
            try {
                
                $id = $this->_getParam('id');
                $observacion_id = $this->_getParam('from_id');
                $archivo = new Shipcode_Model_NaveObservacionArchivo();
                $archivo->setId($id);
                $dataFile = $archivo->getRow();
                $result = $archivo->eliminar();
                
                if($dataFile['carpeta'] === NULL){
                    $idContador = "#num-archivos-documentos";
                } else {
                    $idContador = "#num-archivos-item-" . $dataFile->carpeta;
                }
                
                if(TRUE == $result){
                    
                    echo Zend_Json::encode(array(
                        'error'     => false, 
                        'id'        => $id,
                        'pid'       => $observacion_id,
                        'numTotal'  => Shipcode_Model_NaveObservacion::getNumArchivos($observacion_id),
                        'numCarpeta'=> Shipcode_Model_NaveObservacion::getNumArchivos($observacion_id, $dataFile->carpeta),
                        'idContador'=> $idContador,
                        'clases'    => 'alert alert-success',
                        'mensaje'   => 'El archivo fue eliminado de forma exitosa'
                    ));
                    
                } else {
                    
                    echo Zend_Json::encode(array(
                        'error'     => true, 
                        'clases'    => 'alert alert-error',
                        'mensaje'   => 'Ocurrió un error al intenar eliminar el archivo'
                    ));
                    
                }
                    
            } catch (Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'clases'    => 'alert alert-error',
                    'mensaje'   => $e->getMessage()
                ));
            }
        }
    }
    
    public function traspasarDataAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        $observacion = new Shipcode_Model_NaveObservacion();
        $observacion->transformData();
    }
    
    public function convertirArchivosAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        $path = Zend_Registry::get('PATH_SERVER') . "files/observaciones/"; 
        $newPath = Zend_Registry::get('PATH_SERVER') . "files/naves/observaciones/"; 
        $observacion = new Shipcode_Model_NaveObservacion();
        $observaciones = $observacion->fetchAll();
        
        foreach($observaciones as $o){
            $file = $path . $o->boleta . '.jpg';
            if(is_file($file)){
                $newFile = $newPath . $o->id . "/" .date("YmdHis") . ".pdf";
                if(!is_dir($newPath . $o->id)){
                    mkdir($newPath . $o->id, 0777, true);
                }
                exec("convert " . $file . " " . $newFile);
                sleep(3);
            } 
        }
    }
    
    public function asociarArchivosAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        
        $path = Zend_Registry::get('PATH_SERVER') . "files/naves/observaciones/"; 
        
        $observacion = new Shipcode_Model_NaveObservacion();
        $observaciones = $observacion->fetchAll();
        foreach($observaciones as $o){
            $pathFiles = $path . $o->id;
            if(is_dir($pathFiles)){
                $files = glob($pathFiles . "/*.pdf");
                $i = 1;
                foreach($files as $file){
                    $archivo = new Shipcode_Model_NaveObservacionArchivo();
                    $data = array(
                        'creador'           => $this->usuario->id,
                        'observacion_id'    => $o->id,
                        'nombre'            => "Archivo " . $i,
                        'archivo'           => basename($file)
                    );
                    $row = $archivo->createRow();
                    $row->setFromArray($data);
                    $row->save();
                    $i++;
                }
            } 
        }
    }
    
    public function eliminarArchivosSobrantesAction()
    {
        $this->_helper->viewRenderer->setNoRender();
        $pathObs = "files/naves/observaciones/"; 
        $observacion = new Shipcode_Model_NaveObservacion();
        $observaciones = $observacion->fetchAll();
        foreach($observaciones as $o){
            $pathFiles = $pathObs . $o->id;
            if(is_dir($pathFiles)){
                $files = glob($pathFiles . "/*.jpg");
                foreach($files as $file){
                    unlink($file);
                    echo "Se eliminó " . $file . "<br>";
                }
            }
        }
    }
    /**************************************************************************/
}
     