<?php

class NaveSiniestroController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 1;
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    /************************ OPERACIONES SINIESTROS **************************/
    public function ingresarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $id = (int)$this->getParam('id');
        $request = $this->getRequest();
        $form = new Shipcode_Form_Siniestro();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $modelNave = new Shipcode_Model_Nave();
                    $modelNave->registrarSiniestro($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('El siniestro fue registrado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#siniestros');

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar registrar el siniestro.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#siniestros');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $form->setAction('/nave-siniestro/ingresar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$id#siniestros');");
        $modelNave = new Shipcode_Model_Nave();
        $modelNave->setId($id);
        
        $this->view->nave = $modelNave->getRowFull();
        $form->nave_id->setValue($id);
        $this->view->form = $form;
        $this->view->title = "Ingresar siniestro";
        $this->view->pageTitle = $this->view->nave->nombre . " > Ingresar siniestro";
        $this->renderScript('nave-siniestro/form.phtml');
    }

    public function editarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_Siniestro();
        $siniestro = new Shipcode_Model_NaveSiniestro();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $siniestro->editar($form->getValues(), $this->usuario->id, (int)$this->_getParam('id'));
                    
                    $mSession->mensajes = array('El siniestro fue editado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#siniestros');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar la información del siniestro.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/nave/ver/' . $form->getValue('nave_id') .'#siniestros');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $siniestro->setId($id);
        $nave_id = $siniestro->getNaveId();
        $form->populate($siniestro->getRow()->toArray());
        $form->setAction('/nave-siniestro/editar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/nave/ver/$nave_id#siniestros');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->nave = $siniestro->getNave();
        $this->view->title = "Editar siniestro";
        $this->view->pageTitle = $this->view->nave->nombre . " > Editar siniestro";
        $this->renderScript('nave-siniestro/form.phtml');
    }
    
    public function eliminarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        $siniestro = new Shipcode_Model_NaveSiniestro();
        $siniestro->setId($id);
        $nave_id = $siniestro->getNaveId();
        
        try {

            $siniestro->eliminar();
            $mSession->mensajes[] = 'El registro de siniestro fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect($_SERVER['HTTP_REFERER']);

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el registro del siniestro.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    public function archivosAction()
    {
        $this->_helper->layout->disablelayout();
        $id = (int)$this->_getParam('id');
        $siniestro = new Shipcode_Model_NaveSiniestro();
        $siniestro->setId($id);
        $this->view->archivos = $siniestro->getArchivos();
        $this->view->id= $id;
    }
    
    public function subirArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
            
        if($this->getRequest()->isXmlHttpRequest()){
            
            $path = 'tmp/';
            $uploader = new Shipcode_Upload_QqFileUploader(
                Zend_Registry::get('ACCEPTED_FILE_FORMAT'),
                Zend_Registry::get('MAX_SIZE_FILE_UPLOAD')
            );
            $result = $uploader->handleUpload($path, TRUE);
            if($result == TRUE){
                $name = $uploader->getName();
                $newName = Shipcode_Archivo::renombrar($name);
                if($newName !== FALSE){
                    echo Zend_Json_Encoder::encode(array('success' => true, 'name' => $newName));
                } else {
                    echo Zend_Json_Encoder::encode(array('success' => false, 'name' => $name));
                }
            } 
        }    
    }
    
    public function guardarArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
            
        if($this->getRequest()->isXmlHttpRequest()){
            
            $siniestro = new Shipcode_Model_NaveSiniestro();
            
            try {
                
                $data = array();
                $data['siniestro_id'] = (int)$this->_getParam('siniestro_id'); 
                $data['archivo'] = $this->_getParam('archivo'); 
                $data['nombre'] = $this->_getParam('nombre'); 
                $id = $siniestro->guardarArchivo($data, $this->usuario->id);
                echo Zend_Json::encode(array(
                    'error'     => false, 
                    'mensaje'   => 'El archivo fue guardado de forma satisfactoria.',
                    'id'        => $id,
                    'num'       => Shipcode_Model_NaveSiniestro::getNumArchivos($data['siniestro_id']),
                    'sid'       => $data['siniestro_id'],
                    'clase'     => 'success',
                    'nombre'    => $data['nombre']
                ));
                
            } catch(Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'mensaje'   => 'Ocurrió un error al intentar guardar el archivo. Error: ' . $e->getMessage(),
                    'clase'     => 'error'
                ));
            }
        }
    }
    
    public function descargarArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        $id = (int)$this->_getParam('id');
        
        $archivo = new Shipcode_Model_NaveSiniestroArchivo();
        $archivo->setId($id);
        $row = $archivo->getRow();
        $fileFullPath = Zend_Registry::get('PATH_SERVER') . 'files/siniestros/' . $row->archivo;
        if(file_exists($fileFullPath)){
            $download_path = Zend_Registry::get('PATH_SERVER') . "files/siniestros/";
            $args = array(
		'download_path'		=>	$download_path,
		'file'                  =>	$row->archivo,		
		'extension_check'	=>	TRUE,
		'referrer_check'	=>	FALSE,
		'referrer'		=>	NULL,
		);
            $download = new App_Download($args);
            $download_hook = $download->get_download_hook();

            if( $download_hook['download'] == TRUE ) {
        	$download->get_download();
            }
        } else {
            $mSession = new Zend_Session_Namespace('shipcode');
            $mSession->mensajes[] = "El archivo solicitado no existe.";
            $mSession->claseMensaje = "error";
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    public function eliminarArchivoAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        
        if($this->getRequest()->isXmlHttpRequest()){
            try {
                
                $id = (int)$this->_getParam('id');
                $archivo = new Shipcode_Model_NaveSiniestroArchivo();
                $archivo->setId($id);
                $siniestro_id = $archivo->eliminar();
                $numArchivos = Shipcode_Model_NaveSiniestro::getNumArchivos($siniestro_id);
                
                if(FALSE != $id){
                    
                    echo Zend_Json::encode(array(
                        'error'     => false, 
                        'id'        => $id,
                        'sid'       => $siniestro_id,
                        'num'       => $numArchivos,
                        'clase'     => 'success',
                        'mensaje'   => 'El archivo fue eliminado de forma exitosa'
                    ));
                    
                } else {
                    
                    echo Zend_Json::encode(array(
                        'error'     => true, 
                        'clase'     => 'error',
                        'mensaje'   => 'Ocurrió un error al intenar eliminar el archivo'
                    ));
                    
                }
                    
            } catch (Exception $e){
                echo Zend_Json::encode(array(
                    'error'     => true, 
                    'clase'     => 'error',
                    'mensaje'   => $e->getMessage()
                ));
            }
        }
    }
    /**************************************************************************/
}
     