<?php
class ProyeccionMantenimientoController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pagina = 3;
        $this->view->controller = $this->getRequest()->getControllerName();
        $this->view->action = $this->getRequest()->getActionName();
        if(!$this->getRequest()->isXmlHttpRequest() && $this->view->action != 'exportar'){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        try {
            $this->view->pageTitle = "Proyecciones de Mantenimiento & Gastos";
            $proyeccion = new Shipcode_Model_ProyeccionMantenimiento();
            $this->view->title = "Configuración";
            $this->view->proyecciones = $proyeccion->getAll(0);
        } catch(Exception $e){
            echo $e->getMessage();
        }
    }
    
    public function crearAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Shipcode_Form_ProyeccionMantenimiento();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $proyeccion = new Shipcode_Model_ProyeccionMantenimiento();
                    $id = $proyeccion->crear($form->getValues(), $this->usuario->id);
                    $proyeccion->setId($id);
                    $proyeccion->setDataConfig();
                    $mSession->mensajes = array('La proyección de mantenimiento fue creada de forma exitosa. Ahora puede seleccionar los ítems a proyectar.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/proyeccion-mantenimiento/configuracion/' . $id);

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear la proyección de mantenimiento.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/proyeccion-mantenimiento');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        $form->cancel->setAttrib('onclick', "javascript:goTo('/proyeccion-mantenimiento');");
        $this->view->form = $form;
        $this->view->title = "Crear proyección de mantenimiento";
        $this->view->pageTitle = "Proyección de Mantenimiento";
        $this->renderScript('proyeccion-mantenimiento/form.phtml');
    }
    
    public function eliminarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $id = (int)$this->_getParam('id');
        try {
            $proyeccion = new Shipcode_Model_ProyeccionMantenimiento();
            $proyeccion->setId($id);
            $proyeccion->eliminar();
            $mSession->mensajes[] = 'La proyección de mantenimiento fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/proyeccion-mantenimiento');
        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar proyección de mantenimiento.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/proyeccion-mantenimiento');
        }
    }
    
    public function configuracionAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Proyección de Mantenimiento";
        try {
            $id = (int)$this->_getParam('id');
            $proyeccion = new Shipcode_Model_ProyeccionMantenimiento();
            $proyeccion->setId($id);
            $this->view->proyeccion = $proyeccion->getRowFull();
            
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un problema al intentar visualizar la proyección de mantenimiento procesada.";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/proyeccion-mantenimiento');
        }
    }
    
    public function proyeccionAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Proyección de Mantenimiento";
        try {
            $id = (int)$this->_getParam('id');
            $proyeccion = new Shipcode_Model_ProyeccionMantenimiento();
            $proyeccion->setId($id); 
            $this->view->proyeccion = $proyeccion->getRowFull();
            $this->view->data_eventos = Zend_Json::decode($this->view->proyeccion['data_eventos']);
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un problema al intentar visualizar la proyección de mantenimiento procesada.";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error"; 
            $this->_redirect('/proyeccion-mantenimiento');
        }
    }
    
    public function gastosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Proyección de Mantenimiento";
        try {
            $id = (int)$this->_getParam('id');
            $proyeccion = new Shipcode_Model_ProyeccionMantenimiento();
            $proyeccion->setId($id);
            $this->view->proyeccion = $proyeccion->getRowFull();
            $this->view->data_gastos = Zend_Json::decode($this->view->proyeccion['data_gastos']);
            
        } catch(Exception $e){
            $mSession->mensajes[] = "Ocurrió un problema al intentar visualizar la proyección de mantenimiento procesada.";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/proyeccion-mantenimiento');
        }
    }
    
    /************************ FUNCIONES PROCESAMIENTO *************************/
    public function procesarAction()
    {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        $mSession = new Zend_Session_Namespace('shipcode');
        try {
            $id = (int)$this->_getParam('id');
            $proyeccion = new Shipcode_Model_ProyeccionMantenimiento();
            $proyeccion->setId($id);
            $proyeccion->hacerProyeccion();
            $mSession->mensajes[] = "La proyección se ha procesado exitosamente.";
            $mSession->claseMensaje = "confirmacion";
            $this->_redirect('/proyeccion-mantenimiento/proyeccion/' . $id);
        } catch (Exception $ex) {
            $mSession->mensajes[] = "Ocurrió un problema al procesar la proyección de mantenimiento";
            $mSession->mensajes[] = $ex->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect('/proyeccion-mantenimiento');
        }
    }
    
    /************************** FUNCIONES SELECCIÓN ***************************/
    public function setServiciosAction()
    {   
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            try {
                $pid = (int)$this->_getParam('pid');
                $id = (int)$this->_getParam('id');
                $flag = (int)$this->_getParam('flag');
                $proyeccion = new Shipcode_Model_ProyeccionMantenimiento();
                $proyeccion->setId($pid);
                $data['result'] = $proyeccion->setServicios($id, $flag);
                $data['error'] = false;
                echo Zend_Json::encode($data);
            } catch(Exception $e){
                echo $e->getMessage();
            }
        }
    }
    
    public function setPromedioEquipoAction()
    {   
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            try {
                $pid = (int)$this->_getParam('pid');
                $eid = (int)$this->_getParam('eid');
                $prom = (int)$this->_getParam('prom');
                $proyeccion = new Shipcode_Model_ProyeccionMantenimiento();
                $proyeccion->setId($pid);
                $data['result'] = $proyeccion->setPromedioEquipo($eid, $prom);
                $data['error'] = false;
                echo Zend_Json::encode($data);
            } catch(Exception $e){
                echo $e->getMessage();
            }
        }
    }
    
    public function setValorServicioAction()
    {   
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();
        if($this->getRequest()->isXmlHttpRequest()){
            try {
                $pid = (int)$this->_getParam('pid');
                $sid = (int)$this->_getParam('sid');
                $val = (int)$this->_getParam('val');
                $proyeccion = new Shipcode_Model_ProyeccionMantenimiento();
                $proyeccion->setId($pid);
                $data['result'] = $proyeccion->setValorUnitarioServicio($sid, $val);
                $data['error'] = false;
                echo Zend_Json::encode($data);
            } catch(Exception $e){
                echo $e->getMessage();
            }
        }
    }
}