<?php
class SistemaInformePreconfiguradoController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        $this->view->pageTitle = 'Informes preconfigurados';
        $this->view->pagina = 5;
        
        $this->_helper->layout->setLayout('config');
        $this->view->action = $this->getRequest()->getActionName();
        $this->view->controller = $this->getRequest()->getControllerName();
        
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
            $response->insert('menuConfig' , $this->view->render('menu-config.phtml'));
        }
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $informe = new Shipcode_Model_SistemaInformePreconfigurado();
        $this->view->informes = $informe->getAll();
        $this->view->pageTitle = 'Informes preconfigurados';
    }
    
    public function editarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $id = (int)$this->_getParam('id');
        
        $request = $this->getRequest();
        $form = new Shipcode_Form_SistemaInformePreconfigurado();
        $form->cancel->setAttrib('onclick', "javascript:goTo('/sistema-informe-preconfigurado');");
        $informe = new Shipcode_Model_SistemaInformePreconfigurado();

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    $informe->editar($form->getValues());
                    $mSession->mensajes[] = 'El informe preconfigurado fue editado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/sistema-informe-preconfigurado');
                } catch (Exception $e) {
                    $mSession->mensajes[] = 'Ocurrió un error al intentar editar el informe preconfigurado.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/sistema-informe-preconfigurado');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $informe->setId($id);
        $form->populate($informe->getRow()->toArray());
        $form->setAction('/sistema-informe-preconfigurado/editar/' . $id);
        $this->view->form = $form;
        $this->view->title = "Editar informe preconfigurado";
        $this->renderScript('sistema-informe-preconfigurado/form.phtml');
    }
    
    public function eliminarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        
        try {
            
            $id = (int)$this->_getParam('id');
            $informe = new Shipcode_Model_SistemaInformePreconfigurado();
            $informe->setId($id);
            $informe->eliminar();
            $mSession->mensajes[]   = 'El informe preconfigurado fue eliminado de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/sistema-informe-preconfigurado');

        } catch (Exception $e) {
            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar el informe preconfigurado.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/sistema-informe-preconfigurado');
        }
    }
}
     