<?php
class SistemaMantenimientoController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        
        if(!$this->getRequest()->isXmlHttpRequest() && $this->usuario){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    } 
    
    public function indexAction() 
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Mantenimiento del sistema";
    }
    
    public function conocerArchivosPerdidosAction()
    {
        $naveArchivo = new Shipcode_Model_NaveArchivo();
        $certificadoArchivo = new Shipcode_Model_NaveCertificadoArchivo();
        $observacionArchivo = new Shipcode_Model_NaveObservacionArchivo();
        $carenaArchivo = new Shipcode_Model_NaveCarenaArchivo();
        $siniestroArchivo = new Shipcode_Model_NaveSiniestroArchivo(); 
        $equipoArchivo = new Shipcode_Model_NaveEquipoArchivo();
        $mantenimientoArchivo = new Shipcode_Model_NaveEquipoMantenimientoArchivo();
        
        $archivosNaves = $naveArchivo->getAll();
        $archivosCertificados = $certificadoArchivo->getAll();
        $archivosObservaciones = $observacionArchivo->getAll();
        $archivosCarenas = $carenaArchivo->getAll();
        $archivosSiniestros = $siniestroArchivo->getAll();
        $archivosEquipos = $equipoArchivo->getAll();
        $archivosMantenimientos = $mantenimientoArchivo->getAll();
        
        $path = Zend_Registry::get("PATH_SERVER");
        
        $this->view->pageTitle = "Archivos Perdidos";
        
        $noEncontrados = array(
            'naves' => NULL,
            'certificados' => NULL,
            'observaciones' => NULL,
            'carenas' => NULL,
            'siniestros' => NULL,
            'equipos' => NULL,
            'mantenimientos' => NULL
        );
        
        if(count($archivosNaves) > 0) {
            foreach($archivosNaves as $archivoNave){
                if(!file_exists($path . "files/naves/adjuntos/" . $archivoNave->archivo)){
                    $naveArchivo->setFileNotFound($archivoNave->id);
                    $noEncontrados['naves'][] = $archivoNave->toArray();
                }
            }
        } 
        
        if(count($archivosCertificados) > 0) {
            foreach($archivosCertificados as $archivoCertificado){
                if(!file_exists($path . "files/naves/certificados/" . $archivoCertificado->certificado_id . "/" . $archivoCertificado->archivo)){
                    $certificadoArchivo->setFileNotFound($archivoCertificado->id);
                    $noEncontrados['certificados'][] = $archivoCertificado->toArray();
                }
            }
        }
        
        if(count($archivosObservaciones) > 0) {
            foreach($archivosObservaciones as $archivoObservacion){
                if(!file_exists($path . "files/naves/observaciones/" . $archivoObservacion->observacion_id . "/" . $archivoObservacion->carpeta . "/" . $archivoObservacion->archivo)){
                    $observacionArchivo->setFileNotFound($archivoObservacion->id);
                    $noEncontrados['observaciones'][] = $archivoObservacion->toArray();
                }
            }
        } 
        
        if(count($archivosCarenas) > 0) {
            foreach($archivosCarenas as $archivoCarena){
                if(!file_exists($path . "files/naves/carenas/" . $archivoCarena->carena_id . "/" . $archivoCarena->archivo)){
                    $carenaArchivo->setFileNotFound($archivoCarena->id);
                    $noEncontrados['carenas'][] = $archivoCarena->toArray();
                }
            }
        }
        
        if(count($archivosSiniestros) > 0) {
            foreach($archivosSiniestros as $archivoSiniestro){
                if(!file_exists($path . "files/naves/siniestros/" . $archivoSiniestro->siniestro_id . "/" . $archivoSiniestro->archivo)){
                    $siniestroArchivo->setFileNotFound($archivoSiniestro->id);
                    $noEncontrados['siniestros'][] = $archivoSiniestro->toArray();
                }
            }
        }
        
        
        if(count($archivosEquipos) > 0) {
            foreach($archivosEquipos as $archivoEquipo){
                if(!file_exists($path . "files/equipos/adjuntos/" . $archivoEquipo->archivo)){
                    $equipoArchivo->setFileNotFound($archivoEquipo->id);
                    $noEncontrados['equipos'][] = $archivoEquipo->toArray();
                }
            }
        }
        
        if(count($archivosMantenimientos) > 0) {
            foreach($archivosMantenimientos as $archivoMantenimiento){
                if(!file_exists($path . "files/mantenimientos/" . $archivoMantenimiento->mantenimiento_id . "/" . $archivoMantenimiento->archivo)){
                    $mantenimientoArchivo->setFileNotFound($archivoMantenimiento->id);
                    $noEncontrados['mantenimientos'][] = $archivoMantenimiento->toArray();
                }
            }
        } 
        $this->view->noEncontrados = $noEncontrados;
    }
}