<?php
class SistemaPreferenciasController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        $this->view->pageTitle = 'Preferencias';
        $this->usuario = $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
        
        $this->view->pagina = 5;
        
        $this->_helper->layout->setLayout('config');
        $this->view->action = $this->getRequest()->getActionName();
        $this->view->controller = $this->getRequest()->getControllerName();
        
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
            $response->insert('menuConfig' , $this->view->render('menu-config.phtml'));
        }
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $preferencia = new Shipcode_Model_SistemaPreferencia();
        $this->view->preferencias = $preferencia->getAll();
        $this->view->title = 'Preferencias';
    }

    public function editAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $preferencia = new Shipcode_Model_SistemaPreferencia();
        $request = $this->getRequest();
        $form = new Shipcode_Form_SistemaPreferencia();
        $form->cancel->setAttrib('onclick', "javascript:goTo('/sistema-preferencias');");
        
        if($this->getRequest()->isPost()) {
            
            $id = (int)$this->_getParam('id');
            $preferencia->setId($id);
            $form->valor->addValidator($preferencia->getValidador());
            
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $preferencia->editar($form->getValue('valor'), $form->getValue('id'));
                    $mSession->mensajes[] = 'El parámetro fue guardado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';
                    
                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar guardar los cambios.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    
                }
                $this->_redirect('/sistema-preferencias');
            } else {
                $form->populate($request->getPost());
            }
        }
        
        $id = (int)$this->_getParam('id');
        $preferencia->setId($id);
        $row = $preferencia->getRow();
        $form->populate($row->toArray());
        
        if($row->validador == 'Int') { 
            $form->valor->setValue((int)$row->valor);
            
        } 
        
        if($row->validador == 'Int') { 
            $title = 'Sólo números enteros.';
        } elseif($row->validador == 'Float') {
            $title = 'Sólo números enteros o decimales. El separador de decimales es el punto. Por ej.: 11.7';
        }
        $form->valor->setAttrib('title', $title);
        $this->view->form = $form;
        $this->view->label = utf8_encode($row->label);
        $this->view->descripcion = utf8_encode($row->descripcion);
        $this->view->preferencia = $preferencia->getRow();
        $this->renderScript('sistema-preferencias/form.phtml');
    }
}