<?php
class ToolsUpdateController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        $this->view->pageTitle = "Tools Update";
        if(!$this->getRequest()->isXmlHttpRequest() && $this->usuario){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $this->view->pageTitle = "Tools Update";
        $this->view->resultados = $mSession->resultados;
        unset($mSession->resultados);
    }
    
    public function reubicarArchivosAction()
    {
        $path = Zend_Registry::get("PATH_SERVER") . "files/";
        
        $certificadoArchivo = new Shipcode_Model_NaveCertificadoArchivo();
        $archivosCertificados = $certificadoArchivo->getAll();
        
       
        $observacionArchivo = new Shipcode_Model_NaveObservacionArchivo();
        $archivosObservaciones = $observacionArchivo->getAll();
        
        $carenaArchivo = new Shipcode_Model_NaveCarenaArchivo();
        $archivosCarenas = $carenaArchivo->getAll();
        
        $siniestroArchivo = new Shipcode_Model_NaveSiniestroArchivo(); 
        $archivosSiniestros = $siniestroArchivo->getAll();
        
        $mantenimientoArchivo = new Shipcode_Model_NaveEquipoMantenimientoArchivo();
        $archivosMantenimientos = $mantenimientoArchivo->getAll();
        
        if(count($archivosCertificados) > 0) {
            foreach($archivosCertificados as $archivoCertificado){
                $archivoOrigen = $path 
                               . "naves/certificados/" 
                               . $archivoCertificado->certificado_id . "/" 
                               . $archivoCertificado->archivo;
                $archivoDestino = $path 
                                . "certificados/ce_" 
                                . $archivoCertificado->archivo;
                if(file_exists($archivoOrigen)){
                    rename($archivoOrigen, $archivoDestino);
                    echo "El archivo " . $archivoCertificado->archivo . " ha sido movido.<br>";
                }
            }
        } else {
            echo "No hay archivos de certificados. <br><br>";
        }

        
        if(count($archivosObservaciones) > 0) {
            foreach($archivosObservaciones as $archivoObservacion){
                $archivoOrigen = $path 
                               . "naves/observaciones/" 
                               . $archivoObservacion->observacion_id . "/" 
                               . $archivoObservacion->carpeta . "/" 
                               . $archivoObservacion->archivo;
                $archivoDestino = $path 
                                . "observaciones/ob_" 
                                . $archivoObservacion->archivo;
                if(file_exists($archivoOrigen)){
                    rename($archivoOrigen, $archivoDestino);
                    echo "El archivo " . $archivoObservacion->archivo . " ha sido movido.<br>";
                }
            }
        } else {
            echo "No hay archivos de observaciones. <br><br>";
        }
        
        if(count($archivosCarenas) > 0) {
            foreach($archivosCarenas as $archivoCarena){
                $archivoOrigen = $path 
                               . "naves/carenas/" 
                               . $archivoCarena->carena_id . "/" 
                               . $archivoCarena->archivo;
                $archivoDestino = $path 
                                . "carenas/ca_" 
                                . $archivoCarena->archivo;
                if(file_exists($archivoOrigen)){
                    rename($archivoOrigen, $archivoDestino);
                    echo "El archivo " . $archivoCarena->archivo . " ha sido movido.<br>";
                }
            }
        } else {
            echo "No hay archivos de carenas. <br><br>";
        }
        
        if(count($archivosSiniestros) > 0) {
            foreach($archivosSiniestros as $archivoSiniestro){
                $archivoOrigen = $path 
                               . "naves/siniestros/" 
                               . $archivoSiniestro->siniestro_id . "/" 
                               . $archivoSiniestro->archivo;
                $archivoDestino = $path 
                                . "siniestro/si_" 
                                . $archivoSiniestro->archivo;
                if(file_exists($archivoOrigen)){
                    rename($archivoOrigen, $archivoDestino);
                    echo "El archivo " . $archivoSiniestro->archivo . " ha sido movido.<br>";
                }
            }
        } else {
            echo "No hay archivos de siniestros. <br><br>";
        }
        
        if(count($archivosMantenimientos) > 0) {
            foreach($archivosMantenimientos as $archivoMantenimiento){
                $archivoOrigen = $path 
                               . "mantenimientos/" 
                               . $archivoMantenimiento->mantenimiento_id . "/" 
                               . $archivoMantenimiento->archivo;
                $archivoDestino = $path 
                                . "mantenimientos/ma_" 
                                . $archivoMantenimiento->archivo;
                if(file_exists($archivoOrigen)){
                    rename($archivoOrigen, $archivoDestino);
                    echo "El archivo " . $archivoMantenimiento->archivo . " ha sido movido.<br>";
                }
            }
        } else {
            echo "No hay archivos de mantenimiento. <br><br>";
        }
    }
    
    public function renombrarArchivosAction()
    {
        $path = Zend_Registry::get("PATH_SERVER") . "files/";
        
        $certificadoArchivo = new Shipcode_Model_NaveCertificadoArchivo();
        $archivosCertificados = $certificadoArchivo->getAll();
        
       
        $observacionArchivo = new Shipcode_Model_NaveObservacionArchivo();
        $archivosObservaciones = $observacionArchivo->getAll();
        
        $carenaArchivo = new Shipcode_Model_NaveCarenaArchivo();
        $archivosCarenas = $carenaArchivo->getAll();
        
        $siniestroArchivo = new Shipcode_Model_NaveSiniestroArchivo(); 
        $archivosSiniestros = $siniestroArchivo->getAll();
        
        $mantenimientoArchivo = new Shipcode_Model_NaveEquipoMantenimientoArchivo();
        $archivosMantenimientos = $mantenimientoArchivo->getAll();
        
        if(count($archivosCertificados) > 0) {
            foreach($archivosCertificados as $archivoCertificado){
                $archivo1 = $path 
                                . "certificados/ce_" 
                                . $archivoCertificado->archivo;
                $archivo2 = $path 
                                . "certificados/" 
                                . $archivoCertificado->archivo;
                if(file_exists($archivo1)){
                    rename($archivo1, $archivo2);
                    echo "El archivo " . $archivoCertificado->archivo . " ha sido movido.<br>";
                }
            }
        } else {
            echo "No hay archivos de certificados. <br><br>";
        }

        if(count($archivosObservaciones) > 0) {
            foreach($archivosObservaciones as $archivoObservacion){
                $archivo1 = $path 
                                . "observaciones/ob_" 
                                . $archivoObservacion->archivo;
                $archivo2 = $path 
                                . "observaciones/" 
                                . $archivoObservacion->archivo;
                if(file_exists($archivo1)){
                    rename($archivo1, $archivo2);
                    echo "El archivo " . $archivoObservacion->archivo . " ha sido movido.<br>";
                }
            }
        } else {
            echo "No hay archivos de observaciones. <br><br>";
        }
        
        if(count($archivosCarenas) > 0) {
            foreach($archivosCarenas as $archivoCarena){
                $archivo1 = $path 
                                . "carenas/ca_" 
                                . $archivoCarena->archivo;
                $archivo2 = $path 
                                . "carenas/" 
                                . $archivoCarena->archivo;
                if(file_exists($archivo1)){
                    rename($archivo1, $archivo2);
                    echo "El archivo " . $archivoCarena->archivo . " ha sido movido.<br>";
                }
            }
        } else {
            echo "No hay archivos de carenas. <br><br>";
        }
        
        if(count($archivosSiniestros) > 0) {
            foreach($archivosSiniestros as $archivoSiniestro){
                $archivo1 = $path 
                                . "siniestro/si_" 
                                . $archivoSiniestro->archivo;
                $archivo2 = $path 
                                . "siniestro/" 
                                . $archivoSiniestro->archivo;
                if(file_exists($archivo1)){
                    rename($archivo1, $archivo2);
                    echo "El archivo " . $archivoSiniestro->archivo . " ha sido movido.<br>";
                }
            }
        } else {
            echo "No hay archivos de siniestros. <br><br>";
        }
        
        if(count($archivosMantenimientos) > 0) {
            foreach($archivosMantenimientos as $archivoMantenimiento){
                $archivo1 = $path 
                                . "mantenimientos/ma_" 
                                . $archivoMantenimiento->archivo;
                $archivo2 = $path 
                                . "mantenimientos/" 
                                . $archivoMantenimiento->archivo;
                if(file_exists($archivo1)){
                    rename($archivo1, $archivo2);
                    echo "El archivo " . $archivoMantenimiento->archivo . " ha sido movido.<br>";
                }
            }
        } else {
            echo "No hay archivos de mantenimiento. <br><br>";
        }
    }
    
    public function migrarSolicitudesAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        
        $solicitudAntigua = new Shipcode_Model_NaveInformeSolicitud();
        $solicitudNueva = new Shipcode_Model_Solicitud();
        $solicitudesAntiguas = $solicitudAntigua->getAll(1);
        
        $adapter = $solicitudNueva->getDefaultAdapter();
        
        try {
            $i = 0;
            $adapter->beginTransaction();
            foreach($solicitudesAntiguas as $sAntigua){
                $sNueva = $solicitudNueva->createRow();
                $sNueva->id = $sAntigua['id'];
                $sNueva->creacion = $sAntigua['creacion'];
                $sNueva->creador = $sAntigua['creador'];
                if($sAntigua->fecha_envio === NULL){
                    $sNueva->fecha_envio = $sAntigua['creacion'];
                } else {
                    $sNueva->fecha_envio = $sAntigua['fecha_envio'];
                }
                if($sAntigua['estado'] == 2){
                    $sNueva->fecha_recepcion = $sAntigua['creacion'];
                }
                if($sAntigua['estado'] == 3){
                    $sNueva->fecha_termino = $sAntigua['creacion'];
                }
                if($sAntigua['estado'] == 4){
                    $sNueva->fecha_cierre = $sAntigua['creacion'];
                }
                $sNueva->nave_id = $sAntigua['nave_id'];
                $sNueva->prioridad = $sAntigua['prioridad'];
                $sNueva->detalles = $sAntigua['detalles'];
                $sNueva->estado = $sAntigua['estado'];
                if($sAntigua['estado'] > 0){
                    $sNueva->enviada = 1;
                }
                $sNueva->save();
                $i++;
            }    
                
            $adapter->commit();  
            $mSession->resultados = "Se migraron exitosamente $i registros";
            $this->_redirect('/tools-update');
            
        } catch (Exception $ex) {
            $adapter->rollBack();
            $mSession->resultados = $ex->getMessage();
            $this->_redirect('/tools-update');
        }
    }
    
    public function migrarMantenimientosEnviadosAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        
        $mantenimientoAntiguo = new Shipcode_Model_NaveInformeMantenimiento();
        $mantenimientoNuevo = new Shipcode_Model_MantenimientoInformado();
        $mantenimientosAntiguos = $mantenimientoAntiguo->getAll(1);
        
        $adapter = $mantenimientoNuevo->getDefaultAdapter();
        
        try {
            $i = 0;
            $adapter->beginTransaction();
            foreach($mantenimientosAntiguos as $mAntiguo){
                
                $mNuevo = $mantenimientoNuevo->createRow();
                $mNuevo->id = $mAntiguo['id'];
                $mNuevo->creacion = $mAntiguo['creacion'];
                $mNuevo->creador = $mAntiguo['creador'];
                if($mAntiguo->fecha_envio === NULL){
                    $mNuevo->fecha_envio = $mAntiguo['creacion'];
                } else {
                    $mNuevo->fecha_envio = $mAntiguo['fecha_envio'];
                }
                $mNuevo->nave_id = $mAntiguo['nave_id'];
                $mNuevo->equipo = $mAntiguo['equipo'];
                $mNuevo->fecha = $mAntiguo['fecha'];
                
                if($mAntiguo['horas'] !== NULL){
                    $mNuevo->horas = $mAntiguo['horas'];
                }
                $mNuevo->detalles = $mAntiguo['detalles'];
                $mNuevo->estado = $mAntiguo['estado'];
                $mNuevo->save();
                
                $i++;
            }    
                
            $adapter->commit();  
            $mSession->resultados = "Se migraron exitosamente $i registros";
            $this->_redirect('/tools-update');
            
        } catch (Exception $ex) {
            $adapter->rollBack();
            $mSession->resultados = $ex->getMessage();
            $this->_redirect('/tools-update');
        }
    }
    
    public function importarLecturasHorometrosAction()
    {
        $id = (int)$this->_getParam('id');
        if (($handle = fopen(Zend_Registry::get("PATH_SERVER") . "files/csv/horometros$id.csv", "r")) !== FALSE) {
            $lectura = new Shipcode_Model_NaveHorometroLectura();
            while (($data = fgetcsv($handle, 1000, ";")) !== FALSE) {
                $dataLectura = array(
                    'creador' => $data[2],
                    'equipo_id' => $data[6],
                    'fecha' => $data[3],
                    'lectura' => $data[4],
                    'estado' => "1"
                );
                $lectura->guardar($dataLectura);
                //Zend_Debug::dump($dataLectura);
            }
            fclose($handle);
        }
    }
    
    public function conocerArchivosPerdidosAction()
    {
        $naveArchivo = new Shipcode_Model_NaveArchivo();
        $certificadoArchivo = new Shipcode_Model_NaveCertificadoArchivo();
        $observacionArchivo = new Shipcode_Model_NaveObservacionArchivo();
        $carenaArchivo = new Shipcode_Model_NaveCarenaArchivo();
        $siniestroArchivo = new Shipcode_Model_NaveSiniestroArchivo(); 
        $equipoArchivo = new Shipcode_Model_NaveEquipoArchivo();
        $mantenimientoArchivo = new Shipcode_Model_NaveEquipoMantenimientoArchivo();
        
        $archivosNaves = $naveArchivo->getAll();
        $archivosCertificados = $certificadoArchivo->getAll();
        $archivosObservaciones = $observacionArchivo->getAll();
        $archivosCarenas = $carenaArchivo->getAll();
        $archivosSiniestros = $siniestroArchivo->getAll();
        $archivosEquipos = $equipoArchivo->getAll();
        $archivosMantenimientos = $mantenimientoArchivo->getAll();
        
        $path = Zend_Registry::get("PATH_SERVER");
        
        $noEncontrados = array(
            'naves' => NULL,
            'certificados' => NULL,
            'observaciones' => NULL,
            'carenas' => NULL,
            'siniestros' => NULL,
            'equipos' => NULL,
            'mantenimientos' => NULL
        );
        
        if(count($archivosNaves) > 0) {
            foreach($archivosNaves as $archivoNave){
                if(!file_exists($path . "files/naves/adjuntos/" . $archivoNave->archivo)){
                    $naveArchivo->setFileNotFound($archivoNave->id);
                    $noEncontrados['naves'][] = $archivoNave->toArray();
                }
            }
        } 
        
        if(count($archivosCertificados) > 0) {
            foreach($archivosCertificados as $archivoCertificado){
                if(!file_exists($path . "files/naves/certificados/" . $archivoCertificado->certificado_id . "/" . $archivoCertificado->archivo)){
                    $certificadoArchivo->setFileNotFound($archivoCertificado->id);
                    $noEncontrados['certificados'][] = $archivoCertificado->toArray();
                }
            }
        }
        
        if(count($archivosObservaciones) > 0) {
            foreach($archivosObservaciones as $archivoObservacion){
                if(!file_exists($path . "files/naves/observaciones/" . $archivoObservacion->observacion_id . "/" . $archivoObservacion->carpeta . "/" . $archivoObservacion->archivo)){
                    $observacionArchivo->setFileNotFound($archivoObservacion->id);
                    $noEncontrados['observaciones'][] = $archivoObservacion->toArray();
                }
            }
        } 
        
        if(count($archivosCarenas) > 0) {
            foreach($archivosCarenas as $archivoCarena){
                if(!file_exists($path . "files/naves/carenas/" . $archivoCarena->carena_id . "/" . $archivoCarena->archivo)){
                    $carenaArchivo->setFileNotFound($archivoCarena->id);
                    $noEncontrados['carenas'][] = $archivoCarena->toArray();
                }
            }
        }
        
        if(count($archivosSiniestros) > 0) {
            foreach($archivosSiniestros as $archivoSiniestro){
                if(!file_exists($path . "files/naves/siniestros/" . $archivoSiniestro->siniestro_id . "/" . $archivoSiniestro->archivo)){
                    $siniestroArchivo->setFileNotFound($archivoSiniestro->id);
                    $noEncontrados['siniestros'][] = $archivoSiniestro->toArray();
                }
            }
        }
        
        
        if(count($archivosEquipos) > 0) {
            foreach($archivosEquipos as $archivoEquipo){
                if(!file_exists($path . "files/equipos/adjuntos/" . $archivoEquipo->archivo)){
                    $equipoArchivo->setFileNotFound($archivoEquipo->id);
                    $noEncontrados['equipos'][] = $archivoEquipo->toArray();
                }
            }
        }
        
        if(count($archivosMantenimientos) > 0) {
            foreach($archivosMantenimientos as $archivoMantenimiento){
                if(!file_exists($path . "files/mantenimientos/" . $archivoMantenimiento->mantenimiento_id . "/" . $archivoMantenimiento->archivo)){
                    $mantenimientoArchivo->setFileNotFound($archivoMantenimiento->id);
                    $noEncontrados['mantenimientos'][] = $archivoMantenimiento->toArray();
                }
            }
        } 
        $this->view->noEncontrados = $noEncontrados;
    }
}