<?php
class UAdministradorController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        if(!$this->getRequest()->isXmlHttpRequest() && $this->usuario){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $empresa = new Shipcode_Model_Empresa();
        $this->view->pageTitle = "Sistema de Gestión de Mantenimiento";
        $nave = new Shipcode_Model_Nave();
        $this->view->carenas = $nave->getProximasCarenas(15);
        $this->view->data = $nave->getItemsPorVencer(); 
        $this->view->empresas = $empresa->getIndiceNaves();
    }
    
    /********************** OPERACIONES SOLICITUDES ***************************/
    public function solicitudesAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->view->pageTitle = "Gestión de solicitudes";
        
        try {
            $solicitud = new Shipcode_Model_Solicitud();
            $this->view->naves = Shipcode_Model_Nave::getPairsToSelect($this->empresa_id);
            
            if($this->getRequest()->isPost()) {
                $this->view->title = "Resultados búsqueda";
                $parametros = array(
                    'estado' => $this->_getParam('estado'),
                    'desde' => $this->_getParam('desde'),
                    'hasta' => $this->_getParam('hasta'),
                    'enviado_por' => $this->_getParam('enviado_por'),
                    'prioridad' => $this->_getParam('prioridad'),
                    'nave' => $this->_getParam('nave'),
                    'empresa' => $this->empresa_id
                );
                $this->view->parametros = $parametros;
                $this->view->solicitudes = $solicitud->filtrar($parametros, $this->empresa_id);
                $this->view->solicitudesConNuevosComentarios = $solicitud->getConNuevosComentarios($this->ultimaVisita);
                $this->view->numSolicitudesConNuevosComentarios = count(array_unique($this->view->solicitudesConNuevosComentarios));
                $this->view->fechaUltimaVisita = new Zend_Date($this->ultimaVisita['creacion']);
                
            } else {
                
                $this->view->title = "En trámite";
                $this->view->solicitudes = $solicitud->getEnTramite($this->empresa_id);
                $this->view->solicitudesConNuevosComentarios = $solicitud->getConNuevosComentarios($this->ultimaVisita);
                $this->view->numSolicitudesConNuevosComentarios = count(array_unique($this->view->solicitudesConNuevosComentarios));
                $this->view->fechaUltimaVisita = new Zend_Date($this->ultimaVisita['creacion']);
            }
            
        } catch(Exception $e){
            echo $e->getMessage();
        }
    }
}