<?php
class UbicacionVirtualController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->acl = new Shipcode_Acl();
        $this->view->usuario = $this->usuario = Zend_Auth::getInstance()->getIdentity();
        $this->view->autorizaciones = Zend_Json::decode($this->usuario->autorizaciones);
        $this->view->pagina = 15;
        if(!$this->getRequest()->isXmlHttpRequest()){
            $response = $this->getResponse();
            $response->insert('header' , $this->view->render($this->usuario->header));
        }
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $this->view->pageTitle = "Ubicaciones Virtuales";
        
        try {
            $ubicacion = new Shipcode_Model_UbicacionVirtual();
            $this->view->ubicaciones = $ubicacion->getAll();
            
        } catch(Exception $e){
            echo $e->getMessage();
        }
    }
    
    public function crearAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $request = $this->getRequest();
        $form = new Shipcode_Form_UbicacionVirtual();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {
                    
                    $ubicacion = new Shipcode_Model_UbicacionVirtual();
                    $ubicacion->crear($form->getValues(), $this->usuario->id);
                    $mSession->mensajes = array('La ubicación virtual fue creada de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/ubicacion-virtual');

                } catch (Exception $e) {
                    
                    $mSession->mensajes[] = 'Ocurrió un error al intentar crear ubicación virtual.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/ubicacion-virtual');
                }
            } else {
                $form->populate($request->getPost());
            }
        }
        $form->cancel->setAttrib('onclick', "javascript:goTo('/ubicacion-virtual');");
        $this->view->form = $form;
        $this->view->title = "Ubicaciones Virtuales : Crear";
        $this->view->pageTitle = "Ubicación Virtual";
        $this->renderScript('ubicacion-virtual/form.phtml');
    }
    
    public function editarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Shipcode_Form_UbicacionVirtual();
        $ubicacion = new Shipcode_Model_UbicacionVirtual();
        
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                try {

                    $ubicacion->editar($form->getValues(), $this->usuario->id, (int)$this->_getParam('id'));
                    
                    $mSession->mensajes = array('La ubicación virtual fue editado de forma exitosa.');
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/ubicacion-virtual');

                } catch (Exception $e) {

                    $mSession->mensajes = array('Ocurrió un error al intentar editar la ubicación virtual.');
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/ubicacion-virtual');
                }
            } else {
                $form->populate($request->getPost());
            }
        } 
        $id = (int)$this->_getParam('id');
        $ubicacion->setId($id);
        $form->populate($ubicacion->getRow()->toArray());
        $form->setAction('/ubicacion-virtual/editar/' . $id);
        $form->cancel->setAttrib('onclick', "javascript:goTo('/ubicacion-virtual');");
        $form->submit->setLabel('Guardar cambios');
        $this->view->form = $form;
        $this->view->title = "Ubicaciones Virtuales > Editar";
        $this->renderScript('ubicacion-virtual/form.phtml');
    }
    
    public function verAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        
        $id = (int)$this->_getParam('id');
        
        try {
            
            $ubicacionVirtual = new Shipcode_Model_UbicacionVirtual();
            $ubicacionVirtual->setId($id);
            $this->view->ubicacion = $ubicacionVirtual->getRow();
            $this->view->equipos = $ubicacionVirtual->getEquipos();
            $this->view->pageTitle = "Detalle Ubicación Virtual :: " . $this->view->ubicacion->nombre;
            
        } catch(Exception $e){
            
            $mSession->mensajes[] = "Ocurrió un problema al intentar visualizar la ubicación virtual.";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect($_SERVER['HTTP_REFERER']);
        }
    }
    
    public function equipoAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }
        $id = (int)$this->_getParam('id');
        
        if($this->_getParam('tab')){
            $this->view->tab = $this->_getParam('tab');
        }
        
        try {
            $modelEquipo = new Shipcode_Model_NaveEquipo();
            $modelEquipo->setId($id);
            $this->view->equipo = $modelEquipo->getRowFull();
            $this->view->partes = $modelEquipo->getPartes();
            $this->view->horometro = $modelEquipo->getUltimaLecturaHorometro();    
            $this->view->yearsMantenimientos = $modelEquipo->getHistorialMantenimiento();
            $this->view->plan = $modelEquipo->getPlanMantenimiento($this->view->equipo['planmant_id']);
            $this->view->pageTitle = "Detalle equipo";
            $this->view->archivos = $modelEquipo->getArchivos();
            
        } catch(Exception $e){
            
            $mSession->mensajes[] = "Ocurrió un problema al intentar visualizar el equipo.";
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = "error";
            $this->_redirect($_SERVER['HTTP_REFERER']);
            
        }
    }
    
    public function eliminarAction()
    {
        $mSession = new Zend_Session_Namespace('shipcode');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $id = (int)$this->_getParam('id');
        
        try {

            $ubicacion = new Shipcode_Model_UbicacionVirtual();
            $ubicacion->setId($id);
            $ubicacion->eliminar();
            
            $mSession->mensajes[] = 'La ubicación virtual fue eliminada de forma exitosa.';
            $mSession->claseMensaje = 'confirmacion';
            $this->_redirect('/ubicacion-virtual');

        } catch (Exception $e) {

            $mSession->mensajes[] = 'Ocurrió un error al intentar eliminar la ubicación virtual.';
            $mSession->mensajes[] = $e->getMessage();
            $mSession->claseMensaje = 'error';
            $this->_redirect('/ubicacion-virtual');
        }
    }
}