<?php
class Shipcode_Form_EmpresaOperaciones extends Zend_Form
{ 
    public function __construct($options = null, $usuariosOperacionesId = null)
    {
        parent::__construct($options);

        $optionsEmpresa = array('table' => 'empresas', 'field' => 'id');
        $validadorEmpresa = new Zend_Validate_Db_RecordExists($optionsEmpresa);
        
        $empresa_id = new Zend_Form_Element_Hidden('empresa_id');
        $empresa_id->addValidator('Int')
                   ->addFilter('StringTrim')
                   ->addFilter('StripTags')
                   ->addValidator($validadorEmpresa);

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Configurar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default') 
               ->setAttrib('onclick', 'javascript:history.back();');
        
        $campos = array($empresa_id, $submit, $cancel);
        $nombres = array();
        
        $modelUsuario = new Shipcode_Model_SistemaUsuario();
        $usuariosOperaciones = $modelUsuario->getUsuariosOperaciones();
        
        foreach($usuariosOperaciones as $usuarioOperaciones){
            $campoUsuarioOperaciones = new Zend_Form_Element_Checkbox($usuarioOperaciones['id']);
            $campoUsuarioOperaciones->setLabel($usuarioOperaciones['nombre']);
            
            if($usuariosOperacionesId != null && is_array($usuariosOperacionesId)){
                
                if(in_array($usuarioOperaciones['id'], $usuariosOperacionesId)){
                    $campoUsuarioOperaciones->setValue(1);
                }
            }
            
            $campos[] = $campoUsuarioOperaciones;
            $nombres[] = $usuarioOperaciones['id'];
        }
        
        $this->addElements($campos);
        $this->addDisplayGroup($nombres, 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel', 'empresa_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'form-actions clear'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $empresa_id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'empresa-operaciones',
            'action'    => '/empresa/configurar-usuarios-operaciones'
        ));
    } 
} 
