<?php
class Shipcode_Form_EmpresaSupervisor extends Zend_Form
{ 
    public function __construct($options = null, $supervisoresId = null)
    {
        parent::__construct($options);

        $optionsEmpresa = array('table' => 'empresas', 'field' => 'id');
        $validadorEmpresa = new Zend_Validate_Db_RecordExists($optionsEmpresa);
        
        $empresa_id = new Zend_Form_Element_Hidden('empresa_id');
        $empresa_id->addValidator('Int')
                   ->addFilter('StringTrim')
                   ->addFilter('StripTags')
                   ->addValidator($validadorEmpresa);

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Configurar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default') 
               ->setAttrib('onclick', 'javascript:history.back();');
        
        $campos = array($empresa_id, $submit, $cancel);
        $nombres = array();
        
        $modelUsuario = new Shipcode_Model_SistemaUsuario();
        $supervisores = $modelUsuario->getSupervisores();
        
        foreach($supervisores as $supervisor){
            $campoSupervisor = new Zend_Form_Element_Checkbox($supervisor['id']);
            $campoSupervisor->setLabel($supervisor['nombre']);
            
            if($supervisoresId != null && is_array($supervisoresId)){
                
                if(in_array($supervisor['id'], $supervisoresId)){
                    $campoSupervisor->setValue(1);
                }
            }
            
            $campos[] = $campoSupervisor;
            $nombres[] = $supervisor['id'];
        }
        
        $this->addElements($campos);
        $this->addDisplayGroup($nombres, 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel', 'empresa_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-12 form-actions clear'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $empresa_id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'empresa-supervisor',
            'action'    => '/empresa/configurar-supervisores'
        ));
    } 
} 
