<?php
class Shipcode_Form_ImagestionAccesoApi extends Zend_Form
{ 
    public function __construct($options = null)
    { 
        parent::__construct($options);

        $token= new Zend_Form_Element_Text('token');
        $token->setLabel('Token')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->setAttrib('class', 'input-xxlarge');
        
        $url = new Zend_Form_Element_Text('url');
        $url->setLabel('URL Base')
            ->setRequired(true)
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->setAttrib('class', 'input-xxlarge');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Guardar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;
        
        $this->addElements(array($token, $url, $submit, $cancel));
        $this->addDisplayGroup(array('token', 'url'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(array('FormElements', 'Fieldset'));

        $this->addDisplayGroup(array('submit', 'cancel'),'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-actions'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            array(array('data' => 'HtmlTag'),  array('tag' =>'div', 'class'=> 'controls')),
            array('Label', array('class' => 'control-label')),
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'control-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-horizontal',
            'name'      => 'imagestion-acceso-api',
            'action'    => '/imagestion/config-acceso'
        ));

    } 
} 
