<?php
class Shipcode_Form_ImagestionCentroCosto extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsCentro = array('table' => 'imagestion_centros_costo', 'field' => 'id');
        $validadorCentro = new Zend_Validate_Db_RecordExists($optionsCentro);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->addValidator($validadorCentro);
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre / Descripción')
               ->setRequired(true)
               ->addFilter('StripTags') 
               ->addFilter('StringTrim');
        
        $cod_centro = new Zend_Form_Element_Text('cod_centro');
        $cod_centro->setLabel('Código centro')
                   ->setRequired(true)
                   ->addFilter('StripTags') 
                   ->addFilter('StringTrim'); 
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;

        $this->addElements(array($id, $nombre, $cod_centro, $submit, $cancel));
        $this->addDisplayGroup(array('nombre', 'cod_centro'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-actions clear'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            array(array('data' => 'HtmlTag'),  array('tag' =>'div', 'class'=> 'controls')),
            array('Label', array('class' => 'control-label')),
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'control-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'imagestion-centro-costo',
            'action'    => '/imagestion/crear-centro-de-costo'
        ));
    } 
} 
