<?php
class Shipcode_Form_ImagestionPresupuesto extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsCodCentro = array('table' => 'naves', 'field' => 'cod_centro');
        $validadorCodCentro = new Zend_Validate_Db_RecordExists($optionsCodCentro);
       
        $cod_centro = new Zend_Form_Element_Select('cod_centro');
        $cod_centro->setLabel('Centro de Costo')
                   ->setRequired(true)
                   ->addFilter('StripTags') 
                   ->addFilter('StringTrim')
                   ->addValidator('Int')
                   ->addValidator($validadorCodCentro)
                   ->addMultiOption('', '-- Seleccionar --')
                   ->addMultiOptions(Shipcode_Model_Nave::getCentrosDeCostoToSelect());
        
        $year = new Zend_Form_Element_Text('year');
        $year->setLabel('Año')
             ->setRequired(true)
             ->addFilter('StripTags') 
             ->addFilter('StringTrim')
             ->setAttrib('class', 'help')
             ->setAttrib('title', 'Utilice 4 dígitos');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Importar')
               ->setAttrib('class','btn btn-primary');
        
        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;
        
        $this->addElements(array($cod_centro, $year, $submit, $cancel));
        $this->addDisplayGroup(array('cod_centro', 'year'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-actions clear'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            array(array('data' => 'HtmlTag'),  array('tag' =>'div', 'class'=> 'controls')),
            array('Label', array('class' => 'control-label')),
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'control-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-horizontal',
            'name'      => 'imagestion-presupuesto'
        ));
    } 
} 
