<?php
class Shipcode_Form_SistemaImportacionData extends Zend_Form
{
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int');
        
        $webservice_id = new Zend_Form_Element_Select('webservice_id');
        $webservice_id->setLabel('Webservice')
                      ->setRequired(true)
                      ->addFilter('StripTags')
                      ->setAttrib('class', 'form-control input-sm')
                      ->addFilter('StringTrim')
                      ->addMultiOption('', '-- Seleccionar --')
                      ->addMultiOptions(Shipcode_Model_SistemaWebservice::getPairsToSelect());

        $direccion = new Zend_Form_Element_Text('direccion');
        $direccion->setLabel('URL:Puerto')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->setAttrib('class', 'form-control input-sm')
              ->addFilter('StringTrim');
        
        $token = new Zend_Form_Element_Text('token');
        $token->setLabel('Token / Llave)')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->setAttrib('class', 'form-control input-sm')
              ->addFilter('StringTrim');

        
        $frecuencia = new Zend_Form_Element_Select('frecuencia');
        $frecuencia->setLabel('Frecuencia actualización')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->setAttrib('class', 'form-control input-sm')
              ->addFilter('StringTrim')
              ->addMultiOption('', '-- Seleccionar --')
              ->addMultiOption('MANUAL', 'MANUAL')
              ->addMultiOption('DIARIA', 'AUT. DIARIA')
              ->addMultiOption('SEMANAL', 'AUT. SEMANAL')
              ->addMultiOption('MENSUAL', 'AUT. MENSUAL');
        
      
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');
        
        $this->addElements(array($id, $webservice_id, $direccion, $token, $frecuencia, $submit, $cancel));
        $this->addDisplayGroup(array('webservice_id', 'direccion', 'token', 'frecuencia'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-4'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));
        
        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            'Description',    
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));

        $this->setAttribs(array(
            'name'      => 'sistema-importacion-data',
            'action'    => '/sistema-importacion-config/crear'
        ));

    } 
} 
