<?php
class Shipcode_Form_SistemaUsuarioPersonalizadoLectura extends Zend_Form
{
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int');

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->setAttrib('autocomplete', 'off')  
              ->setAttrib('class', 'form-control input-sm')
              ->addFilter('StringTrim');
        
        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Email')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->setAttrib('autocomplete', 'off')  
              ->setAttrib('class', 'form-control input-sm')
              ->addValidator('EmailAddress')
              ->setErrorMessages(array('Debe ingresar sólo letras y números. Sin espacios, ni signos.'));
        
        $empresa = new Zend_Form_Element_Text('empresa');
        $empresa->setLabel('Empresa')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->setAttrib('class', 'form-control input-sm')  
              ->addFilter('StringTrim');
        
        $valido_hasta = new Zend_Form_Element_Text('valido_hasta');
        $valido_hasta->setLabel('Válido Hasta el')
              ->setRequired(false)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator(new Zend_Validate_Date(array('format' => Zend_Registry::get('FORMAT_DATE'))))
              ->setAttrib('class', 'form-control input-sm show-calendar')
              ->setDescription('Si lo deja en blanco la validez es indefinida.')
              ->setErrorMessages(array('Debe ingresar sólo letras y números. Sin espacios, ni signos.'));
        
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');
        
        $this->addElements(
            array(
                $id, $nombre, $mail, $empresa, $valido_hasta, $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'nombre', 'empresa', 'mail', 'valido_hasta'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-4'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));
        
        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            'Description',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));

        $this->setAttribs(array(
            'name'      => 'usuario-personalizado',
            'action'    => '/sistema-usuario/crear-personalizado-lectura'
        ));

    } 
} 
