<?php
class Shipcode_Form_SistemaUsuarioSuperAdmin extends Zend_Form
{
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $descEmail = "Recuerde que esta casilla debe ser real, ya que ahí se le "
                   . "enviará al usuario su clave inicial y las instrucciones "
                   . " de acceso.";

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int');

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->setAttrib('class', 'form-control input-sm')
              ->addFilter('StringTrim');

        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Email')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('EmailAddress')
              ->setAttrib("class", "form-control input-sm help")
              ->setAttrib("title", $descEmail);

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default')
               ->setAttrib('onclick', 'javascript:history.back();');
        
        $this->addElements(
            array(
                $id, $nombre, $mail,
                $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'nombre', 'mail'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));
        
        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));

        $this->setAttribs(array(
            'name'      => 'usuario'
        ));

    } 
} 
