<?php
class Shipcode_Form_Acceso extends Zend_Form 
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);
        
        $usuario = new Zend_Form_Element_Text('usuario');
        $usuario->setRequired(true)
                ->setAttrib('placeholder', 'Usuario')
                ->addFilter('StripTags') 
                ->setAttrib('class', 'form-control')
                ->setErrorMessages(array('Por favor ingrese su nombre de usuario'))
                ->addFilter('StringTrim');
              
        $clave = new Zend_Form_Element_Password('clave');
        $clave->setRequired(true)
              ->setAttrib('placeholder', 'Contraseña')  
              ->setErrorMessages(array('Por favor ingrese su contraseña'))  
              ->setAttrib('class', 'form-control')
              ->addFilter('StripTags');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Ingresar')
               ->setAttrib('class', 'btn btn-primary btn-block btn-lg');
        
        $this->addElements(array($usuario, $clave, $submit));
        $this->addDisplayGroup(array('usuario', 'clave'),'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            )
        );

        $this->addDisplayGroup(array('submit'), 'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            array(array('data' => 'HtmlTag'),  array('tag' =>'div', 'class'=> 'controls')),
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));
        
        $submit->setDecorators(array('ViewHelper'));
        
        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'form-vertical', 
                'name'      => 'acceso',
                'action'    => '/acceso/index'
            ));

    } 
}