<?php
class Shipcode_Form_AsignacionPresupuestaria extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsAsignacion = array('table' => 'naves_presupuestos_asig', 'field' => 'id');
        $validadorAsignacion = new Zend_Validate_Db_RecordExists($optionsAsignacion);

        $id = new Zend_Form_Element_Hidden('id');
        $id->setLabel('ID')
           ->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int')
           ->addValidator($validadorAsignacion);
        
        $monto = new Zend_Form_Element_Text('monto');
        $monto->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('Int');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Guardar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default') 
               ->setAttrib('onclick', 'javascript:history.back();');

        $this->addElements(
            array(
                $id, $monto, $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'monto'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-actions clear'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            array(array('data' => 'HtmlTag'),  array('tag' =>'div', 'class'=> 'controls')),
            array('Label', array('class' => 'control-label')),
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'control-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'asignacion-presupuestaria'
        ));
    } 
} 
