<?php
class Shipcode_Form_AuditoriaInterna extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsNave = array('table' => 'naves', 'field' => 'id');
        $validadorNave = new Zend_Validate_Db_RecordExists($optionsNave);

        $id = new Zend_Form_Element_Hidden('id');
        $id->setLabel('ID')
           ->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $prioridad_id = new Zend_Form_Element_Select('prioridad_id');
        $prioridad_id->setlabel('Prioridad')
                     ->setRequired(true)
                     ->setAttrib('class', 'form-control input-sm')
                     ->addMultiOption('', '-- Seleccionar --')
                     ->addMultiOptions(Shipcode_Model_AuditoriaInternaPrioridad::getPairsToSelect());
        
        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->addValidator($validadorNave);
        
        $area_id = new Zend_Form_Element_Select('area_id');
        $area_id->setlabel('Área')
                       ->setRequired(true)
                       ->addFilter('StripTags') 
                       ->addFilter('StringTrim')
                       ->setAttrib('class', 'form-control input-sm')
                       ->addMultiOption('', '-- Seleccionar --');
        
        $responsable_id = new Zend_Form_Element_Select('responsable_id');
        $responsable_id->setlabel('Resposable')
                       ->setRequired(true)
                       ->addFilter('StripTags') 
                       ->addFilter('StringTrim')
                       ->setAttrib('class', 'form-control input-sm')
                       ->addMultiOption('', '-- Seleccionar --')
                       ->addMultiOptions(Shipcode_Model_SistemaUsuario::getPairsToSelect());
        
        $titulo = new Zend_Form_Element_Text('titulo');
        $titulo->setRequired(true)
               ->setLabel('Título')
               ->setAttrib('class', 'form-control input-sm')
               ->addFilter('StripTags') 
               ->addFilter('StringTrim');
        
        $descripcion = new Zend_Form_Element_Textarea('descripcion');
        $descripcion->setRequired(true)
                    ->setLabel('Descripión')
                    ->setAttrib('class', 'form-control input-sm')
                    ->addFilter('StripTags') 
                    ->addFilter('StringTrim')
                    ->setAttrib('rows', '5');
        
         
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Agregar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(
            array(
                $nave_id, $id, $prioridad_id, $area_id, $responsable_id, 
                $titulo, $descripcion, $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'nave_id', 'area_id', 'prioridad_id', 'responsable_id'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                'titulo', 'descripcion'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'nave_id', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $nave_id->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'auditoria-interna'
        ));
    } 
} 
