<?php
class Shipcode_Form_AuditoriaInternaCierre extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->setRequired(true)
           ->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        
        $cierre_informe = new Zend_Form_Element_Textarea('cierre_informe');
        $cierre_informe->setRequired(true)
                    ->setLabel('Informe / Comentarios / Observaciones')
                    ->setAttrib('class', 'form-control input-sm')
                    ->addFilter('StripTags') 
                    ->addFilter('StringTrim')
                    ->setAttrib('rows', '9');
        
        $solucionado = new Zend_Form_Element_Select('solucionado');
        $solucionado->setRequired(true)
                    ->setLabel('¿Problema solucionado?')
                    ->setAttrib('class', 'form-control input-sm')
                    ->addFilter('StripTags') 
                    ->addFilter('StringTrim')
                    ->setAttrib('style', 'width:150px;')
                    ->addMultiOption('', '-- Seleccionar --')
                    ->addMultiOption('SI', 'SI')
                    ->addMultiOption('NO', 'NO')
                    ->addMultiOption('SI CON REPAROS', 'SI CON REPAROS');
        
         
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Agregar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(
            array(
                $id, $cierre_informe, $solucionado, $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'solucionado', 'cierre_informe'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'nave_id', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'auditoria-interna-cierre'
        ));
    } 
} 
