<?php
class Shipcode_Form_AuditoriaInternaPrioridad extends Zend_Form
{ 
    public function __construct($options = null)
    { 
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int');

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->setAttrib('class', 'form-control input-sm')
               ->addFilter('StringTrim');
        
        $dias_aviso = new Zend_Form_Element_Text('dias_aviso');
        $dias_aviso->setLabel('Días para aviso')
                   ->setRequired(true)
                   ->addFilter('StripTags')
                   ->setAttrib('class', 'form-control input-sm')
                   ->addFilter('StringTrim')
                   ->addValidator('Int'); 
        
        $dias_vencimiento = new Zend_Form_Element_Text('dias_vencimiento');
        $dias_vencimiento->setLabel('Días para vencimiento')
                         ->setRequired(true)
                         ->addFilter('StripTags')
                         ->setAttrib('class', 'form-control input-sm')
                         ->addFilter('StringTrim')
                         ->addValidator('Int');
        
        $notificaciones_aviso = new Zend_Form_Element_Text('notificaciones_aviso');
        $notificaciones_aviso->setLabel('Enviar notificación de aviso a los correos')
                             ->setRequired(true)
                             ->addFilter('StripTags')
                             ->setAttrib('class', 'form-control input-sm')
                             ->addFilter('StringTrim')
                             ->setDescription('Para más de una casilla, sepárelas con coma (,)');
        
        $notificaciones_vencimiento = new Zend_Form_Element_Text('notificaciones_vencimiento');
        $notificaciones_vencimiento->setLabel('Enviar notificaciones de vencimiento a los correos')
                                   ->setRequired(true)
                                   ->addFilter('StripTags')
                                   ->setAttrib('class', 'form-control input-sm')
                                   ->addFilter('StringTrim')
                                   ->setDescription('Para más de una casilla, sepárelas con coma (,)');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');
        
        $this->addElements(array(
            $id, $nombre, $dias_aviso, $dias_vencimiento,
            $notificaciones_aviso, $notificaciones_vencimiento,
            $submit, $cancel));
        $this->addDisplayGroup(array(
            'nombre', 'dias_aviso', 'dias_vencimiento',
            'notificaciones_aviso', 'notificaciones_vencimiento'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );

        $this->addDisplayGroup(array('submit', 'cancel', 'id'),'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors',
            'Description'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'auditoria-interna-prioridad',
            'action'    => '/auditoria-interna-prioridad/crear'
        ));

    } 
} 
