<?php
class Shipcode_Form_BasePlanMant extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags') 
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm help')
               ->setAttrib("title", "El nombre le permitirá destinguir el plan de mantenimiento de otros del mismo tipo.");
        
        $tipo_id = new Zend_Form_Element_Select('tipo_id');
        $tipo_id->setLabel('Plan para')
                ->setRequired(true)
                ->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Shipcode_Model_TipoEquipo::getPairsToSelect());
        
        $observaciones = new Zend_Form_Element_Textarea('observaciones');
        $observaciones->setLabel('Observaciones')
                      ->setRequired(false)
                      ->addFilter('StripTags') 
                      ->addFilter('StringTrim')
                      ->setAttrib('rows', '5')
                      ->setAttrib('class', 'form-control input-sm help')
                      ->setAttrib('title', 'Puede ingresar las características especiales del plan o alguna nota');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(array($id, $tipo_id, $nombre, $observaciones, $submit, $cancel));
        $this->addDisplayGroup(
            array(
                'tipo_id', 'nombre' 
                
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                 'observaciones'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'plan-mantenimiento'
        ));
    } 
} 
