<?php
class Shipcode_Form_BoletaObservaciones extends Zend_Form
{ 
    public function __construct($options = null )
    { 
        parent::__construct($options);
        
        $opcionesNave = array('table' => 'naves', 'field' => 'id');
        $validadorNave = new Zend_Validate_Db_RecordExists($opcionesNave);
        
        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->setRequired(true)
           ->addValidator('Int')
           ->addFilter('StripTags')
           ->addFilter('StringTrim')
           ->setAttrib('class', 'form-control input-sm')
           ->addValidator($validadorNave);
        
        $archivo = new Zend_Form_Element_Text('archivo');
        $archivo->setLabel('Archivo')
                ->setRequired(true)
                ->addFilter('StripTags')
                ->setAttrib('class', 'form-control input-sm')
                ->addFilter('StringTrim');
        
        $numero = new Zend_Form_Element_Text('numero');
        $numero->setLabel('Nº de boleta')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->setAttrib('class', 'form-control input-sm')
               ->addFilter('StringTrim');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Subir')
               ->setAttrib('class','btn btn-primary');
        
        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(
            array(
                $nave_id, $numero, $archivo, $submit, $cancel
            )
        );
        
        $this->addDisplayGroup(
            array('numero', 'archivo'), 
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(array('submit', 'cancel', 'nave_id'),'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));
        
        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $nave_id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
        
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'boleta-observaciones'
        ));
    } 
} 
