<?php
class Shipcode_Form_CambiarClaveAcceso extends Zend_Form
{
    public function __construct($options = null)
    {
        parent::__construct($options);

        $clave = new Zend_Form_Element_Password('clave');
        $clave->setLabel('Clave actual')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setAttrib('class', 'form-control input-sm help')
              ->setAttrib("title", "Ingrese su clave actual")
              ->setValue('')
              ->setErrorMessages(array('Por favor ingrese la clave actual correctamente'));
        
        $clave1 = new Zend_Form_Element_Password('clave1');
        $clave1->setLabel('Nueva clave')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setAttrib('class', 'form-control input-sm help')
              ->setAttrib("title", "La nueva clave debe tener entre 6 y 10 caractéres alfanuméricos (sólo letras y números)")
              ->addValidator('StringLength', false, array(6,10))
              ->addValidator('Alnum')
              ->setValue('')
              ->setErrorMessages(array('Por favor ingrese una clave correcta'));
              
        $clave2 = new Zend_Form_Element_Password('clave2');
        $clave2->setLabel('Repetir nueva clave')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('Identical', false, array('token' => 'clave1'))
              ->setAttrib('class', 'form-control input-sm help')
              ->setAttrib("title", "Ingrese nuevamente su nueva clave")  
              ->setValue('')
              ->setErrorMessages(array('Debe introducir la misma clave que en el campo anterior'));
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Cambiar clave')
               ->setAttrib('class','btn btn-primary');
        

        $this->addElements(array($clave, $clave1, $clave2, $submit));
        $this->addDisplayGroup(array('clave', 'clave1', 'clave2'),'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(array('submit'), 'submitButtons');
        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-12 '))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
        
        $this->setAttribs(array(
                'name'      => 'cambio-clave',
                'action'    => '/config-personal/cambiar-clave-acceso'
            ));

    } 
} 
