<?php
class Shipcode_Form_CarenaProxima extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsNave = array('table' => 'naves', 'field' => 'id');
        $validadorNave = new Zend_Validate_Db_RecordExists($optionsNave);

        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->addValidator($validadorNave);
        
        $sig_carena_semestre = new Zend_Form_Element_Select('sig_carena_semestre');
        $sig_carena_semestre->setLabel('Semestre')
                            ->setRequired(true)
                            ->addFilter('StripTags') 
                            ->addFilter('StringTrim')
                            ->addMultiOption('', '-- Seleccionar --')
                            ->addMultiOption('1', '1º')
                            ->addMultiOption('2', '2º');
        
        $actual = date("Y");
        $sig_carena_year = new Zend_Form_Element_Select('sig_carena_year');
        $sig_carena_year->setLabel('Año')
                 ->setRequired(true)
                 ->addFilter('StripTags') 
                 ->addFilter('StringTrim')
                 ->addMultiOption('', '-- Seleccionar --')
                 ->addMultiOption($actual + 1, $actual + 1)
                 ->addMultiOption($actual + 2, $actual + 2)
                 ->addMultiOption($actual + 3, $actual + 3)
                 ->addMultiOption($actual + 4, $actual + 4);

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Guardar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default') 
               ->setAttrib('onclick', 'javascript:history.back();');

        $this->addElements(
            array(
                $nave_id, $sig_carena_semestre, 
                $sig_carena_year, $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'sig_carena_semestre', 'sig_carena_year'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'nave_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-actions clear'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            array(array('data' => 'HtmlTag'),  array('tag' =>'div', 'class'=> 'controls')),
            array('Label', array('class' => 'control-label')),
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'control-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $nave_id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'configurar-carena'
        ));
    } 
} 
