<?php
class Shipcode_Form_CarenaSmall extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsNave = array('table' => 'naves', 'field' => 'id');
        $validadorNave = new Zend_Validate_Db_RecordExists($optionsNave);

        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->addValidator($validadorNave);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->setLabel('ID')
           ->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $fecha = new Zend_Form_Element_Text('fecha');
        $fecha->setLabel('Fecha salida')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator(new Zend_Validate_Date(array('format' => Zend_Registry::get('FORMAT_DATE'))))
              ->setAttrib('class', 'show-calendar');
        
        $costo_total = new Zend_Form_Element_Text('costo_total');
        $costo_total->setLabel('Costo total')
                    ->setRequired(true)
                    ->addFilter('StripTags') 
                    ->addFilter('StringTrim')
                    ->setAttrib('class', 'help')
                    ->setAttrib('title', 'Ingrese sólo números enteros, sin puntos ni comas.')
                    ->addValidator('Int');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Ingresar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default') 
               ->setAttrib('onclick', 'javascript:history.back();');

        $this->addElements(
            array(
                $nave_id, $id, $fecha, $costo_total, 
                $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'fecha', 'costo_total'
            ),
            'infoInputs' 
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'nave_id', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-actions clear'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            array(array('data' => 'HtmlTag'),  array('tag' =>'div', 'class'=> 'controls')),
            array('Label', array('class' => 'control-label')),
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'control-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $nave_id->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'carena'
        ));
    } 
} 
