<?php
class Shipcode_Form_CentroCosto extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $vid = new Zend_Form_Element_Hidden('vid');
        $vid->addFilter('StripTags') 
            ->addFilter('StringTrim')
            ->addValidator('Int');
        
        $id = new Zend_Form_Element_Text('id');
        $id->setLabel('Código')
           ->setRequired(true) 
           ->addFilter('StripTags') 
           ->setAttrib('class', 'form-control input-sm') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim');

        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(array($vid, $id, $nombre, $submit, $cancel));
        $this->addDisplayGroup(array('id', 'nombre'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'vid'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $vid->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'centro-costo',
            'action'    => '/centro-costo/crear'
        ));
    } 
} 
