<?php
class Shipcode_Form_CodigoObservacion extends Zend_Form
{ 
    public function __construct($options = null)
    { 
        parent::__construct($options);
        
        $descripcionCodigo = "Sólo números";
        
        $descripcionPlazo = "Días de plazo para subsanar el problema. "
                          . "Cero (0) en caso de códigos que  hacen "
                          . "referencia a problemas subsanados de otras boletas.";

        $codigo = new Zend_Form_Element_Text('codigo');
        $codigo->setLabel('Código')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm help')
               ->setAttrib('title', $descripcionCodigo) 
               ->addValidator('Int');
        
        $plazo = new Zend_Form_Element_Text('plazo');
        $plazo->setLabel('Plazo')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm help')
               ->setAttrib('title', $descripcionPlazo)
               ->addValidator('Int');
        
        $comentarios = new Zend_Form_Element_Textarea('comentarios');
        $comentarios->setLabel('Comentarios')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->setAttrib('rows', '3')
                    ->setAttrib('class', 'form-control input-sm');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');
        
        $this->addElements(array($codigo, $plazo, $comentarios, $submit, $cancel));
        $this->addDisplayGroup(array('codigo', 'plazo', 'comentarios'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-4'))
            )
        );

        $this->addDisplayGroup(array('submit', 'cancel', 'id'),'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'codigo-observacion',
            'action'    => '/codigo-observacion/crear'
        ));

    } 
} 
