<?php
class Shipcode_Form_ConfigInicioOperaciones extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);

        $empresa_id = new Zend_Form_Element_Select('empresa_id');
        $empresa_id->setLabel('Empresa destino')
                   ->setRequired(false)
                   ->addValidator('Int')
                   ->addMultiOption('', '-- Seleccionar --')
                   ->addMultiOptions(Shipcode_Model_Empresa::getPairsToSelect())
                   ->setAttrib('class', 'form-control input-sm updateOther')
                   ->setAttrib('data-target', '#nave_id')
                   ->setAttrib('data-url', '/ajax/get-naves/');;
        
        $nave_id = new Zend_Form_Element_Select('nave_id');
        $nave_id->setLabel('Nave destino')
                ->setRequired(false)
                ->addValidator('Int')
                ->addMultiOption('', '-- Seleccionar --')
                ->setAttrib('class', 'form-control input-sm updateOther')
                ->setAttrib('data-target', '#sistema_id')
                ->setAttrib('data-url', '/ajax/get-sistemas/');;
        
        $sistema_id = new Zend_Form_Element_Select('sistema_id');
        $sistema_id->setLabel('Sistema destino')
                   ->addValidator('Int')
                   ->setAttrib('class', 'form-control input-sm')
                   ->addMultiOption('', '-- Seleccionar --');
        
        $fecha = new Zend_Form_Element_Text('fecha');
        $fecha->setLabel('Fecha inicio operaciones')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setAttrib('class', 'form-control input-sm show-calendar');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Asignar fecha')
               ->setAttrib('class','btn btn-primary');

        $this->addElements(
            array(
                $empresa_id, $nave_id, $sistema_id, $fecha, $submit
            ));

        $this->addDisplayGroup(
            array(
                  'empresa_id', 'nave_id', 'sistema_id', 'fecha'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'config-inicio-operaciones',
            'action'    => '/utilidades/config-inicio-operaciones'
        ));
    } 
} 
