<?php
class Shipcode_Form_CuentaGasto extends Zend_Form
{ 
    public function __construct($options = null)
    { 
        parent::__construct($options);
        
        $vid = new Zend_Form_Element_Hidden('vid');
        $vid->addFilter('StripTags') 
            ->addFilter('StringTrim')
            ->addValidator('Int');
        
        $id = new Zend_Form_Element_Text('id');
        $id->setLabel('Código')
           ->setRequired(true) 
           ->addFilter('StripTags') 
           ->setAttrib('class', 'form-control input-sm') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $cuenta_id = new Zend_Form_Element_Text('cuenta_id');
        $cuenta_id->setLabel('Cuenta madre')
                  ->setRequired(false) 
                  ->addFilter('StripTags') 
                  ->setAttrib('class', 'form-control input-sm') 
                  ->addFilter('StringTrim')
                  ->addValidator('Int');

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->setAttrib('class', 'form-control input-sm')
               ->addFilter('StripTags')
               ->addFilter('StringTrim');
        
        
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');
        
        $this->addElements(array($vid, $id, $nombre, $cuenta_id, $submit, $cancel));
        $this->addDisplayGroup(array('id', 'cuenta_id', 'nombre'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );

        $this->addDisplayGroup(array('submit', 'cancel', 'vid'),'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $vid->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'cuenta-gasto',
            'action'    => '/cuenta-gasto/crear'
        ));

    } 
} 
