<?php
class Shipcode_Form_Equipo extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $sistema_id = new Zend_Form_Element_Select('sistema_id');
        $sistema_id->setLabel('Sistema')
                   ->setRequired(true) 
                   ->addValidator('Int')
                   ->addFilter('StringTrim')
                   ->addFilter('StripTags')
                   ->setAttrib('class', 'form-control input-sm')
                   ->addMultiOption('', '-- Seleccionar --');
        
        $tipo_id = new Zend_Form_Element_Select('tipo_id');
        $tipo_id->setLabel('Tipo')
                ->setRequired(false)
                ->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Shipcode_Model_TipoEquipo::getPairsToSelect());
        
        $marca_id = new Zend_Form_Element_Select('marca_id');
        $marca_id->setLabel('Marca')
                 ->setRequired(false)
                ->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Shipcode_Model_EquipoMarca::getPairsToSelect());
        
        $modelo = new Zend_Form_Element_Text('modelo');
        $modelo->setLabel('Modelo')
               ->setRequired(false)
               ->addFilter('StripTags') 
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim');
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags') 
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim');
        
        $serie = new Zend_Form_Element_Text('serie');
        $serie->setLabel('Nº Serie')
                  ->addFilter('StripTags') 
                  ->setAttrib('class', 'form-control input-sm')
                  ->addFilter('StringTrim');
        
        $inicio_operaciones = new Zend_Form_Element_Text('inicio_operaciones');
        $inicio_operaciones->setLabel('Fecha de inicio de operaciones')
                           ->setRequired(true) 
                           ->addFilter('StripTags') 
                           ->addFilter('StringTrim')
                           ->setAttrib('class', 'form-control input-sm show-calendar');
        
        $datos_tecnicos = new Zend_Form_Element_Textarea('datos_tecnicos');
        $datos_tecnicos->setLabel('Información técnica')
                       ->addFilter('StripTags') 
                       ->addFilter('StringTrim')
                       ->setAttrib('rows', '8')
                       ->setAttrib('class', 'form-control input-sm help')
                       ->setAttrib('title', 'Recuerde ingresar un ítem por fila y separar los valores con : (dos puntos)');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(
            array(
                $sistema_id, $id, $tipo_id, $marca_id, $modelo,  
                $nombre, $serie, $datos_tecnicos, $inicio_operaciones,
                $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'sistema_id', 'tipo_id', 'marca_id',  
                'modelo', 'nombre'
                
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                 'serie', 'datos_tecnicos', 'inicio_operaciones'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-9'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'equipo'
        ));
    } 
} 
