<?php
class Shipcode_Form_EquipoAsignacionMantenimiento extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsMantenimiento = array('table' => 'naves_equipos_mantenimientos', 'field' => 'id');
        $validadorMantenimiento = new Zend_Validate_Db_RecordExists($optionsMantenimiento);

        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int')
           ->addValidator($validadorMantenimiento);
        
        $sistema = new Zend_Form_Element_Select('sistema');
        $sistema->setLabel('Sistema')
                ->setRequired(true)
                ->addMultiOption('', '-- Seleccionar --')
                ->setAttrib('class', 'form-control input-sm updateOther')
                ->setAttrib('data-target', "#equipo_id")
                ->setAttrib('data-url', '/ajax/get-equipos/');
        
        $equipo_id = new Zend_Form_Element_Select('equipo_id');
        $equipo_id->setRequired(true)
                  ->addMultiOption('', '-- Seleccionar --');
        
        $this->addElements(
            array(
                $id, $sistema, $equipo_id
            ));

        $this->addDisplayGroup(
            array(
                'sistema', 'equipo_id'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
            )
        );

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-horizontal well',
            'name'      => 'equipo-mantenimiento'
        ));
    } 
} 
