<?php
class Shipcode_Form_EquipoClonar extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);

        $oempresa_id = new Zend_Form_Element_Select('oempresa_id');
        $oempresa_id->setLabel('Empresa origen')
                   ->setRequired(false)
                   ->addValidator('Int')
                   ->addMultiOption('', '-- Seleccionar --')
                   ->addMultiOptions(Shipcode_Model_Empresa::getPairsToSelect())
                   ->setAttrib('class', 'form-control input-sm updateOther')
                   ->setAttrib('data-target', '#onave_id')
                   ->setAttrib('data-url', '/ajax/get-naves/');
        
        $onave_id = new Zend_Form_Element_Select('onave_id');
        $onave_id->setLabel('Nave origen')
                ->setRequired(false)
                ->addValidator('Int')
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Shipcode_Model_Nave::getPairsToSelect())
                ->setAttrib('class', 'form-control input-sm updateOther')
                ->setAttrib('data-target', '#osistema_id')
                ->setAttrib('data-url', '/ajax/get-sistemas/');
        
        $osistema_id = new Zend_Form_Element_Select('osistema_id');
        $osistema_id->setLabel('Sistema origen')
                ->setRequired(false)
                ->addValidator('Int')
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Shipcode_Model_Nave::getPairsToSelect())
                ->setAttrib('class', 'form-control input-sm updateOther')
                ->setAttrib('data-target', '#oequipo_id')
                ->setAttrib('data-url', '/ajax/get-equipos/');
        
        $oequipo_id = new Zend_Form_Element_Select('oequipo_id');
        $oequipo_id->setLabel('Equipo a clonar')
                ->setRequired(true)
                ->addValidator('Int')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Shipcode_Model_Nave::getPairsToSelect());
        
        $empresa_id = new Zend_Form_Element_Select('empresa_id');
        $empresa_id->setLabel('Empresa destino')
                   ->setRequired(false)
                   ->addValidator('Int')
                   ->addMultiOption('', '-- Seleccionar --')
                   ->addMultiOptions(Shipcode_Model_Empresa::getPairsToSelect())
                   ->setAttrib('class', 'form-control input-sm updateOther')
                   ->setAttrib('data-target', '#nave_id')
                   ->setAttrib('data-url', '/ajax/get-naves/');;
        
        $nave_id = new Zend_Form_Element_Select('nave_id');
        $nave_id->setLabel('Nave destino')
                ->setRequired(false)
                ->addValidator('Int')
                ->addMultiOption('', '-- Seleccionar --')
                ->setAttrib('class', 'form-control input-sm updateOther')
                ->setAttrib('data-target', '#sistema_id')
                ->setAttrib('data-url', '/ajax/get-sistemas/');;
        
        $sistema_id = new Zend_Form_Element_Select('sistema_id');
        $sistema_id->setLabel('Sistema destino')
                ->setRequired(true)
                ->addValidator('Int')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar --');
        
        $partes = new Zend_Form_Element_Select('partes');
        $partes->setLabel('¿Clonar partes y piezas?')
                ->setRequired(true)
                ->addMultiOption('', '-- Seleccionar --')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('0', 'No')
                ->addMultiOption('1', 'Sí');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Clonar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default') 
               ->setAttrib('onclick', 'javascript:history.back();');

        $this->addElements(
            array(
                $onave_id, $oempresa_id, $osistema_id, $oequipo_id,
                $empresa_id, $nave_id, $sistema_id, $partes,
                $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'oempresa_id', 'onave_id', 'osistema_id', 'oequipo_id'
                
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                  'empresa_id', 'nave_id', 'sistema_id', 'partes'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'equipo-clonar',
            'action'    => '/utilidades/clonar-equipo'
        ));
    } 
} 
