<?php
class Shipcode_Form_EquipoHorometro extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsEquipo = array('table' => 'naves_equipos', 'field' => 'id');
        $validadorEquipo = new Zend_Validate_Db_RecordExists($optionsEquipo);

        $equipo_id = new Zend_Form_Element_Hidden('equipo_id');
        $equipo_id->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->addValidator($validadorEquipo);
        
        $lectura = new Zend_Form_Element_Text('lectura');
        $lectura->setLabel('Horas lectura inicial')
                ->setRequired(true)
                ->addFilter('StripTags') 
                ->addFilter('StringTrim')
                ->addValidator('Int')
                ->setAttrib('autocomplete', 'off')
                ->setAttrib('class', 'form-control input-sm')
                ->setDescription('El valor debe corresponder al total histórico de horas del equipo. Ingrese un número entero, sin signos de ningún tipo.');

        $fecha = new Zend_Form_Element_Text('fecha');
        $fecha->setLabel('Fecha lectura inicial')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setAttrib('autocomplete', 'off')
              ->setAttrib('class', 'form-control input-sm show-calendar')
              ->setDescription('Fecha en que se tomó la lectura del valor inicial. Si el valor es cero, puede iniciar con la fecha de hoy.');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default') 
               ->setAttrib('onclick', 'javascript:history.back();');

        $this->addElements(
            array(
                $equipo_id, $lectura, $fecha, $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'lectura', 'fecha'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'equipo_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            'Description',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $equipo_id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'equipo-horometro'
        ));
    } 
} 
