<?php
class Shipcode_Form_EquipoMantenimiento extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsMantenimiento = array('table' => 'naves_equipos_mantenimientos', 'field' => 'id');
        $validadorMantenimiento = new Zend_Validate_Db_RecordExists($optionsMantenimiento);

        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int')
           ->addValidator($validadorMantenimiento);
        
        $fecha = new Zend_Form_Element_Text('fecha');
        $fecha->setLabel('Fecha')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator(new Zend_Validate_Date(array('format' => Zend_Registry::get('FORMAT_DATE'))))
              ->setAttrib('class', 'form-control input-sm show-calendar');
        
        $horometro = new Zend_Form_Element_Text('horometro');
        $horometro->setLabel('Horómetro')
                  ->setRequired(false)
                  ->addFilter('StripTags') 
                  ->addFilter('StringTrim')
                  ->addValidator('Int')
                  ->setAttrib('class', 'form-control input-sm');
        
        $detalles = new Zend_Form_Element_Textarea('detalles');
        $detalles->setRequired(false)
                 ->setLabel('Detalles')
                 ->setAttrib('rows', '2')
                 ->setAttrib('class', 'form-control input-sm')
                 ->setAttrib('disabled', 'disabled');
        
        $observaciones = new Zend_Form_Element_Textarea('observaciones');
        $observaciones->setRequired(false)
                      ->setLabel('Observaciones')
                      ->addFilter('StripTags') 
                      ->addFilter('StringTrim')
                      ->setAttrib('rows', '5')
                      ->setAttrib('class', 'form-control input-sm');

        $this->addElements(
            array(
                $id, $fecha, $detalles, 
                $horometro, $observaciones
            ));

        $this->addDisplayGroup(
            array(
                'detalles', 'fecha', 'horometro', 'observaciones', 'id'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            )
        );

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'ajax',
            'name'      => 'equipo-mantenimiento'
        ));
    } 
} 
