<?php
class Shipcode_Form_EquipoMantenimientoFull extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsMantenimiento = array('table' => 'naves_equipos_mantenimientos', 'field' => 'id');
        $validadorMantenimiento = new Zend_Validate_Db_RecordExists($optionsMantenimiento);

        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int')
           ->addValidator($validadorMantenimiento);
        
        $fecha = new Zend_Form_Element_Text('fecha');
        $fecha->setLabel('Fecha')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator(new Zend_Validate_Date(array('format' => Zend_Registry::get('FORMAT_DATE'))))
              ->setAttrib('class', 'form-control input-sm show-calendar');
        
        $horometro = new Zend_Form_Element_Text('horometro');
        $horometro->setLabel('Horómetro')
                  ->setRequired(false)
                  ->addFilter('StripTags') 
                  ->addFilter('StringTrim')
                  ->addValidator('Int')
                  ->setAttrib('class', 'form-control input-sm');
        
        $tipo_id = new Zend_Form_Element_Select('tipo_id');
        $tipo_id->setLabel('Tipo')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setAttrib('class', 'form-control input-sm');
        
        $detalles = new Zend_Form_Element_Textarea('detalles');
        $detalles->setRequired(false)
                 ->setLabel('Detalles')
                 ->setAttrib('rows', '4')
                 ->setAttrib('class', 'form-control input-sm')
                 ->setAttrib('disabled', 'disabled');
        
        $observaciones = new Zend_Form_Element_Textarea('observaciones');
        $observaciones->setRequired(false)
                      ->setLabel('Observaciones')
                      ->addFilter('StripTags') 
                      ->addFilter('StringTrim')
                      ->setAttrib('rows', '4')
                      ->setAttrib('class', 'form-control input-sm');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Ingresar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default') 
               ->setAttrib('onclick', 'javascript:history.back();');

        $this->addElements(
            array(
                $id, $fecha, $detalles, $submit, $cancel,
                $horometro, $tipo_id, $observaciones
            ));

        $this->addDisplayGroup(
            array(
                'detalles', 'fecha', 'horometro', 'tipo_id', 'observaciones'
            ),
            'infoInputs'
            
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $id->setDecorators(array('ViewHelper'));
        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'equipo-mantenimiento-full'
        ));
    } 
} 
