<?php
class Shipcode_Form_EquipoMover3 extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);

        $oubicacionv_id = new Zend_Form_Element_Select('oubicacionv_id');
        $oubicacionv_id->setLabel('Ubicación virtual de origen')
                   ->setRequired(true)
                   ->addValidator('Int')
                   ->addMultiOption('', '-- Seleccionar --')
                   ->addMultiOptions(Shipcode_Model_UbicacionVirtual::getPairsToSelect())
                   ->setAttrib('class', 'form-control input-sm updateOther')
                   ->setAttrib('data-target', '#oequipo_id')
                   ->setAttrib('data-url', '/ajax/get-equipos-uvirtual/');
        
        $oequipo_id = new Zend_Form_Element_Select('oequipo_id');
        $oequipo_id->setLabel('Equipo a mover')
                ->setRequired(true)
                ->addValidator('Int')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar --');
        
        $empresa_id = new Zend_Form_Element_Select('empresa_id');
        $empresa_id->setLabel('Empresa destino')
                   ->setRequired(false)
                   ->addValidator('Int')
                   ->addMultiOption('', '-- Seleccionar --')
                   ->addMultiOptions(Shipcode_Model_Empresa::getPairsToSelect())
                   ->setAttrib('class', 'form-control input-sm updateOther')
                   ->setAttrib('data-target', '#nave_id')
                   ->setAttrib('data-url', '/ajax/get-naves/');;
        
        $nave_id = new Zend_Form_Element_Select('nave_id');
        $nave_id->setLabel('Nave destino')
                ->setRequired(false)
                ->addValidator('Int')
                ->addMultiOption('', '-- Seleccionar --')
                ->setAttrib('class', 'form-control input-sm updateOther')
                ->setAttrib('data-target', '#sistema_id')
                ->setAttrib('data-url', '/ajax/get-sistemas/');;
        
        $sistema_id = new Zend_Form_Element_Select('sistema_id');
        $sistema_id->setLabel('Sistema destino')
                ->setRequired(true)
                ->addValidator('Int')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar --');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Mover')
               ->setAttrib('class','btn btn-primary');

        $this->addElements(
            array(
                $oubicacionv_id, $oequipo_id,
                $empresa_id, $nave_id, $sistema_id, $submit
            ));

        $this->addDisplayGroup(
            array(
                'oubicacionv_id', 'oequipo_id'
                
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                  'empresa_id', 'nave_id', 'sistema_id'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'equipo-mover-3',
            'action'    => '/utilidades/mover-equipo'
        ));
    } 
} 
