<?php
class Shipcode_Form_EquipoParte extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsEquipo = array('table' => 'naves_equipos', 'field' => 'id');
        $validadorEquipo = new Zend_Validate_Db_RecordExists($optionsEquipo);

        $equipo_id = new Zend_Form_Element_Hidden('equipo_id');
        $equipo_id->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->addValidator($validadorEquipo);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->setLabel('ID')
           ->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setAttrib('class', 'form-control input-sm');

        $num_parte = new Zend_Form_Element_Text('num_parte');
        $num_parte->setLabel('Nº de parte')
                  ->setRequired(true)
                  ->addFilter('StripTags') 
                  ->addFilter('StringTrim')
                  ->setAttrib('class', 'form-control input-sm');
        
        $detalles = new Zend_Form_Element_Textarea('detalles');
        $detalles->setRequired(false)
                 ->setLabel('Detalles')
                 ->addFilter('StripTags') 
                 ->addFilter('StringTrim')
                 ->setAttrib('rows', '4')
                 ->setAttrib('class', 'form-control input-sm');
        
        $cantidad = new Zend_Form_Element_Text('cantidad');
        $cantidad->setLabel('Cantidad')
                 ->setRequired(false)
                 ->addFilter('StripTags') 
                 ->addFilter('StringTrim')
                 ->addValidator('Int')
                 ->setAttrib('class', 'form-control input-sm');

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Guardar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(
            array(
                $equipo_id, $id, $nombre, $num_parte, 
                $detalles, $cantidad, $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'nombre', 'num_parte', 'cantidad', 'detalles'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'equipo_id', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $equipo_id->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'equipo-parte'
        ));
    } 
} 
