<?php
class Shipcode_Form_EtiquetaArchivo extends Zend_Form
{ 
    public function __construct($options = null)
    { 
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int');

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm');
        
        $naves = new Zend_Form_Element_Select('naves');
        $naves->setLabel('Usar en naves')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addMultiOption('SI', 'SI')
              ->addMultiOption('NO', 'NO')
              ->setAttrib('class', 'form-control input-sm');
        
        $equipos = new Zend_Form_Element_Select('equipos');
        $equipos->setLabel('Usar en equipos')
                ->setRequired(true)
                ->addFilter('StripTags')
                ->addFilter('StringTrim')
                ->addMultiOption('SI', 'SI')
                ->addMultiOption('NO', 'NO')
                ->setAttrib('class', 'form-control input-sm');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');
        
        $this->addElements(array($id, $nombre, $naves, $equipos, $submit, $cancel));
        $this->addDisplayGroup(array('nombre', 'naves', 'equipos'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            )
        );

        $this->addDisplayGroup(array('submit', 'cancel', 'id'),'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'etiqueta-archivo',
            'action'    => '/etiqueta-archivo/crear'
        ));

    } 
} 
