<?php
class Shipcode_Form_Gastos extends Zend_Form
{ 
    public function __construct($options = null )
    { 
        parent::__construct($options);
        
        $mes = new Zend_Form_Element_Select('mes');
        $mes->setLabel('Mes')
            ->setRequired(true)
            ->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addMultiOption("", "-- Seleccionar --")
            ->addMultiOption("1", "Enero")
            ->addMultiOption("2", "Febrero")
            ->addMultiOption("3", "Marzo")
            ->addMultiOption("4", "Abril")
            ->addMultiOption("5", "Mayo")
            ->addMultiOption("6", "Junio")
            ->addMultiOption("7", "Julio")
            ->addMultiOption("8", "Agosto")
            ->addMultiOption("9", "Septiembre")
            ->addMultiOption("10", "Octubre")
            ->addMultiOption("11", "Noviembre")
            ->addMultiOption("12", "Diciembre")
            ->setAttrib('class', 'form-control input-sm');
        
        $year = new Zend_Form_Element_Text('year');
        $year->setLabel('Año')
             ->setRequired(true)
             ->addFilter('StripTags')
             ->addFilter('StringTrim')
             ->setAttrib('class', 'form-control input-sm');
        
        $empresa = new Zend_Form_Element_Select('empresa');
        $empresa->setLabel('Empresa')
                ->setRequired(true)
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Shipcode_Model_Empresa::getPairsToSelect());
        
        $archivo = new Zend_Form_Element_Text('archivo');
        $archivo->setLabel('Archivo')
                ->setRequired(true)
                ->addFilter('StripTags')
                ->addFilter('StringTrim')
                ->setAttrib('class', 'form-control input-sm');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Subir')
               ->setAttrib('class','btn btn-primary');

        $this->addElements(array($mes, $year, $empresa, $archivo, $submit));
        $this->addDisplayGroup(array('mes', 'year', 'empresa', 'archivo'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(array('submit'),'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));
        
        $submit->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
        
        $this->setAttribs(array(
            'name'      => 'gastos'
        ));
    } 
} 
