<?php
class Shipcode_Form_InformeEnvio extends Zend_Form
{ 
    public function __construct($options = null)
    { 
        parent::__construct($options);

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre destinatario')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm');

        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Mail destinatario')
                   ->setRequired(true)
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim')
                   ->addValidator('EmailAddress')
                   ->setAttrib('class', 'form-control input-sm');
        
        $copia_a_mi = new Zend_Form_Element_Checkbox('copia_a_mi');
        $copia_a_mi->setLabel('Copia a mi')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->setAttrib('checked','checked');
        
        $copia_terceros = new Zend_Form_Element_Text('copia_terceros');
        $copia_terceros->setLabel('Copias a terceros')
                   ->setRequired(false)
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim')
                   ->setAttrib('class', 'form-control input-sm');

        $mensaje = new Zend_Form_Element_Textarea('mensaje');
        $mensaje->setLabel('Mensaje adicional')
                ->setRequired(false)
                ->addFilter('StripTags')
                ->addFilter('StringTrim')
                ->setAttrib('class', 'form-control input-sm')
                ->setAttrib('rows', '4');

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Enviar')
               ->setAttrib('class','btn btn-primary');
        
        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;
        
        $this->addElements(array(
            $nombre, $mail, $mensaje, $copia_a_mi, 
            $copia_terceros, $submit, $cancel
        ));

        $this->addDisplayGroup(
            array(
                'nombre', 'mail', 'copia_a_mi', 'copia_terceros', 'mensaje', 
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-11'))
            ));

        $this->addDisplayGroup(
            array('submit', 'cancel'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));
        
        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));
        
        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));

        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));   

        $this->setAttribs(array(
            'name'  => 'sistema-mensaje',
            'action' => '/informes/enviar'
        ));

    } 
} 
