<?php
class Shipcode_Form_InventarioArticulo extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $categoria_id = new Zend_Form_Element_Select('categoria_id');
        $categoria_id->setLabel('Categoría')
                   ->setRequired(true) 
                   ->addValidator('Int')
                   ->addFilter('StringTrim')
                   ->addFilter('StripTags')
                   ->setAttrib('class', 'form-control input-sm')
                   ->addMultiOption('', '-- Seleccionar --')
                   ->addMultiOptions(Shipcode_Model_InventarioCategoria::getGroupsToSelect());
        
        $marca_id = new Zend_Form_Element_Select('marca_id');
        $marca_id->setLabel('Marca')
                 ->setRequired(true)
                ->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Shipcode_Model_InventarioMarca::getPairsToSelect());
        
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags') 
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim');
        
        $stock_bajo = new Zend_Form_Element_Text('stock_bajo');
        $stock_bajo->setLabel('Stock bajo')
                   ->setRequired(true)
                   ->addFilter('StripTags') 
                   ->addValidator('Int')
                   ->setAttrib('class', 'form-control input-sm');
        
        $stock_minimo = new Zend_Form_Element_Text('stock_minimo');
        $stock_minimo->setLabel('Stock mínimo')
                     ->setRequired(true)
                     ->addFilter('StripTags') 
                     ->addValidator('Int')
                     ->setAttrib('class', 'form-control input-sm');
        
        $observaciones = new Zend_Form_Element_Textarea('observaciones');
        $observaciones->setLabel('Observaciones')
                       ->addFilter('StripTags') 
                       ->addFilter('StringTrim')
                       ->setAttrib('rows', '2')
                       ->setAttrib('class', 'form-control input-sm');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(
            array(
                $categoria_id, $id, $marca_id, $nombre,  
                $stock_bajo, $stock_minimo, $observaciones,
                $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'categoria_id', 'marca_id', 'nombre',  
                'stock_minimo', 'stock_bajo', 'observaciones'
                
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'inventario-articulo',
            'action'    => '/inventario-articulo/crear'
        ));
    } 
} 
