<?php
class Shipcode_Form_ListaVerificacionAsignacion extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $lista_id = new Zend_Form_Element_Select('lista_id');
        $lista_id->setLabel('Lista')
                 ->setRequired(true) 
                 ->addFilter('StripTags') 
                 ->addFilter('StringTrim')
                 ->addValidator('Int')
                 ->setAttrib('class', 'form-control input-sm')
                 ->addMultiOption('', '-- Seleccionar --')
                 ->addMultiOptions(Shipcode_Model_ListaVerificacion::getPairsToSelect());

        $usuario_id = new Zend_Form_Element_Select('usuario_id');
        $usuario_id->setLabel('Usuario')
                   ->setRequired(true)
                   ->addValidator('Int')
                   ->addFilter('StringTrim')
                   ->addFilter('StripTags')
                   ->setAttrib('class', 'form-control input-sm')
                   ->addMultiOption('', '-- Seleccionar --')
                   ->addMultiOptions(Shipcode_Model_SistemaUsuario::getPairsToSelect(5));
        
        $periodicidad = new Zend_Form_Element_Select('periodicidad');
        $periodicidad->setLabel('¿Cada cuantos días se debe verificar la lista?')
                     ->setRequired(true)
                     ->addFilter('StripTags')
                     ->setAttrib('class', 'form-control input-sm')
                     ->addFilter('StringTrim')
                     ->addValidator('Int')
                     ->addMultiOption('', '-- Seleccionar --')
                     ->addMultiOption('15', '15')
                     ->addMultiOption('30', '30')
                     ->addMultiOption('60', '60');
        
        $duracion = new Zend_Form_Element_Select('duracion');
        $duracion->setLabel('¿Cuantos días tiene para hacer la verificación?')
                 ->setRequired(true)
                 ->addFilter('StripTags')
                 ->setAttrib('class', 'form-control input-sm')
                 ->addFilter('StringTrim')
                 ->addValidator('Int')
                 ->addMultiOption('', '-- Seleccionar --')
                 ->addMultiOption('5', '5')
                 ->addMultiOption('10', '10')
                 ->addMultiOption('15', '15')
                 ->addMultiOption('20', '20')
                 ->addMultiOption('25', '25')
                 ->addMultiOption('30', '30');
        
        $fecha_inicio = new Zend_Form_Element_Text('fecha_inicio');
        $fecha_inicio->setLabel('Fecha de inicio')
                     ->setRequired(true)
                     ->addFilter('StringTrim')
                     ->addFilter('StripTags')
                     ->setAttrib('class', 'form-control input-sm show-calendar');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(array(
            $lista_id, $usuario_id, $fecha_inicio, $periodicidad, $duracion, $submit, $cancel
        ));
        
        $this->addDisplayGroup(
            array(
                'lista_id', 'usuario_id', 'periodicidad', 'duracion', 'fecha_inicio'
                
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'lista-asignacion'
        ));
    } 
} 
