<?php
class Shipcode_Form_ListaVerificacionItem extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsLista = array('table' => 'listas_verificacion', 'field' => 'id');
        $validadorLista = new Zend_Validate_Db_RecordExists($optionsLista);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $lista_id = new Zend_Form_Element_Hidden('lista_id');
        $lista_id->addFilter('StripTags') 
                 ->addFilter('StringTrim')
                 ->addValidator('Int')
                 ->addValidator($validadorLista);

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags') 
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm help');
        
        $descripcion = new Zend_Form_Element_Textarea('descripcion');
        $descripcion->setLabel('Descripción / Observaciones')
                    ->setRequired(false)
                    ->setAttrib('class', 'form-control input-sm')
                    ->addFilter('StripTags') 
                    ->addFilter('StringTrim')
                    ->setAttrib('style', 'height:120px;');
        
        $opcion_id = new Zend_Form_Element_Select('opcion_id');
        $opcion_id->setLabel('Set de respuestas')
                  ->setRequired(true)
                  ->addValidator('Int')
                  ->addFilter('StringTrim')
                  ->addFilter('StripTags')
                  ->setAttrib('class', 'form-control input-sm')
                  ->addMultiOption('', '-- Seleccionar --')
                  ->addMultiOptions(Shipcode_Model_ListaVerificacionOpcionesRespuesta::getPairsToSelect());
        
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(array(
            $id, $lista_id, $nombre, $descripcion, $opcion_id, $submit, $cancel
        ));
        
        $this->addDisplayGroup(
            array(
                'nombre', 'descripcion', 'opcion_id'
                
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id', 'lista_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        $lista_id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'lista-verificacion-item'
        ));
    } 
} 
