<?php
class Shipcode_Form_ListaVerificacionOpcionesRespuesta extends Zend_Form
{ 
    public function __construct($options = null)
    { 
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int');

        $respuestas = new Zend_Form_Element_Text('respuestas');
        $respuestas->setLabel('Set de respuestas')
                   ->setRequired(true)
                   ->addFilter('StripTags')
                   ->setAttrib('class', 'form-control input-sm')
                   ->setDescription('Separe las opciones con un punto y coma (;)')
                   ->addFilter('StringTrim');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');
        
        $this->addElements(array($id, $respuestas, $submit, $cancel));
        $this->addDisplayGroup(array('respuestas'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );

        $this->addDisplayGroup(array('submit', 'cancel', 'id'),'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Description',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'opciones-respuesta',
            'action'    => '/config-listas-verificacion/agregar-opciones-respuestas'
        ));

    } 
} 
