<?php
class Shipcode_Form_Nave extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsEmpresa = array('table' => 'empresas', 'field' => 'id');
        $validadorEmpresa = new Zend_Validate_Db_RecordExists($optionsEmpresa);

        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags');

        $empresa_id = new Zend_Form_Element_Hidden('empresa_id');
        $empresa_id->setRequired(true)
                   ->addValidator('Int')
                   ->addValidator($validadorEmpresa);
        
        $id = new Zend_Form_Element_Text('id');
        $id->setLabel('ID')
           ->setRequired(true)
           ->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int')
           ->setAttrib('class', 'form-control input-sm');
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags') 
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm');
        
        $matricula = new Zend_Form_Element_Text('matricula');
        $matricula->setLabel('Matrícula')
                  ->addFilter('StripTags') 
                  ->addFilter('StringTrim')
                  ->setAttrib('class', 'form-control input-sm');
        
        $cb = new Zend_Form_Element_Text('cb');
        $cb->setLabel('Señal de llamada')
           ->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->setAttrib('class', 'form-control input-sm'); 
         
        $puerto_matricula = new Zend_Form_Element_Text('puerto_matricula');
        $puerto_matricula->setLabel('Puerto de matrícula')
                         ->setRequired(true)
                         ->addFilter('StripTags') 
                         ->addFilter('StringTrim')
                         ->setAttrib('class', 'form-control input-sm');

        $ismm = new Zend_Form_Element_Text('ismm');
        $ismm->setLabel('ISMM')
             ->addFilter('StripTags') 
             ->addFilter('StringTrim')
             ->setAttrib('class', 'form-control input-sm'); 

        $tipo_nave = new Zend_Form_Element_Select('tipo_nave');
        $tipo_nave->setLabel('Tipo de nave')
                  ->setRequired(true)
                  ->addMultiOption('WELLBOAT', 'WELLBOAT')
                  ->addMultiOption('TRANSBORDADOR', 'TRANSBORDADOR')
                  ->addMultiOption('BARCAZA', 'BARCAZA')
                  ->addMultiOption('MOTONAVE', 'MOTONAVE')
                  ->addMultiOption('LANCHA MOTOR', 'LANCHA MOTOR')
                  ->addMultiOption('FERRY', 'FERRY')
                  ->setAttrib('class', 'form-control input-sm');
        
        $clasificacion = new Zend_Form_Element_Text('clasificacion');
        $clasificacion->setLabel('Clasificación')
                      ->addFilter('StripTags') 
                      ->addFilter('StringTrim')
                      ->setAttrib('class', 'col-lg-12');
        
        $construccion = new Zend_Form_Element_Text('construccion');
        $construccion->setLabel('Año de construcción')
                  ->setRequired(true)
                  ->addFilter('StripTags') 
                  ->addFilter('StringTrim')
                  ->setAttrib('class', 'form-control input-sm');

        $otras_modificaciones = new Zend_Form_Element_Textarea('otras_modificaciones');
        $otras_modificaciones->setLabel('Otras modificaciones')
                               ->addFilter('StripTags') 
                               ->addFilter('StringTrim')
                               ->setAttrib('class', 'help form-control input-sm')
                               ->setAttrib('title', '1 dato por fila. Año: Modificación')
                               ->setAttrib('rows', '6');
        
        $info_tecnica = new Zend_Form_Element_Textarea('info_tecnica');
        $info_tecnica->setLabel('Información técnica adicional')
                     ->addFilter('StripTags') 
                     ->addFilter('StringTrim')
                     ->setAttrib('class', 'help form-control input-sm')
                     ->setAttrib('title', '1 dato por fila. Nombre: Valor')
                     ->setAttrib('rows', '6');
        
        $dimensiones = new Zend_Form_Element_Textarea('dimensiones');
        $dimensiones->setLabel('Dimensiones')
                    ->addFilter('StripTags') 
                    ->addFilter('StringTrim')
                    ->setAttrib('class', 'help form-control input-sm')
                    ->setAttrib('title', '1 dato por fila. Nombre: Valor')
                    ->setAttrib('rows', '6');
        
        $capacidades = new Zend_Form_Element_Textarea('capacidades');
        $capacidades->setLabel('Capacidades')
                    ->addFilter('StripTags') 
                    ->addFilter('StringTrim')
                    ->setAttrib('class', 'help form-control input-sm')
                    ->setAttrib('title', '1 dato por fila. Nombre: Valor')
                    ->setAttrib('rows', '6');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;

        $this->addElements(
            array(
                $nave_id, $id, $empresa_id, $matricula, $nombre, 
                $puerto_matricula, $ismm, $tipo_nave, $cb, 
                $clasificacion, $construccion, $info_tecnica,
                $otras_modificaciones, $dimensiones, $capacidades,
                $submit, $cancel
            ));

        $this->addDisplayGroup(
            array('id', 'matricula', 'nombre',  'puerto_matricula', 'cb'),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-2'))
            )
        );
        
        $this->addDisplayGroup(
            array('construccion', 'tipo_nave', 'clasificacion', 'potencia_motor', 'ismm'),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-2'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                 'otras_modificaciones', 'info_tecnica'
            ),
            'infoInputs3'
        );

        $infoInputs3 = $this->getDisplayGroup('infoInputs3');
        $infoInputs3->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-4'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                 'dimensiones', 'capacidades'
            ),
            'infoInputs4'
        );

        $infoInputs4 = $this->getDisplayGroup('infoInputs4');
        $infoInputs4->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-4'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel', 'nave_id', 'empresa_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'col-lg-12 form-actions clear'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $nave_id->setDecorators(array('ViewHelper'));
        $empresa_id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'nave',
            'action'    => '/nave/crear'
        ));
    } 
} 
