<?php
class Shipcode_Form_NaveClonar extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $nave_id = new Zend_Form_Element_Select('nave_id');
        $nave_id->setLabel('Nave a clonar')
                ->setRequired(true)
                ->addValidator('Int')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar nave --')
                ->addMultiOptions(Shipcode_Model_Nave::getPairsToSelect());

        $empresa_id = new Zend_Form_Element_Select('empresa_id');
        $empresa_id->setLabel('Asociar la nueva nave a la empresa')
                   ->setRequired(true)
                   ->addValidator('Int')
                   ->setAttrib('class', 'form-control input-sm')
                   ->addMultiOption('', '-- Seleccionar nave --')
                   ->addMultiOptions(Shipcode_Model_Empresa::getPairsToSelect());
        
        $id = new Zend_Form_Element_Text('id');
        $id->setLabel('ID')
           ->setRequired(true)
           ->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->setAttrib('class', 'form-control input-sm')     
           ->addValidator('Int');
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags') 
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim');
        
        $matricula = new Zend_Form_Element_Text('matricula');
        $matricula->setLabel('Matrícula')
                  ->addFilter('StripTags') 
                  ->setAttrib('class', 'form-control input-sm')
                  ->addFilter('StringTrim');
        
        $cb = new Zend_Form_Element_Text('cb');
        $cb->setLabel('Señal de llamada')
           ->addFilter('StripTags') 
           ->setAttrib('class', 'form-control input-sm')
           ->addFilter('StringTrim'); 
         
        $puerto_matricula = new Zend_Form_Element_Text('puerto_matricula');
        $puerto_matricula->setLabel('Puerto de matrícula')
                         ->setRequired(true)
                         ->setAttrib('class', 'form-control input-sm')
                         ->addFilter('StripTags') 
                         ->addFilter('StringTrim');

        $ismm = new Zend_Form_Element_Text('ismm');
        $ismm->setLabel('ISMM')
             ->addFilter('StripTags') 
             ->setAttrib('class', 'form-control input-sm')
             ->addFilter('StringTrim'); 

        $clasificacion = new Zend_Form_Element_Text('clasificacion');
        $clasificacion->setLabel('Clasificación')
                      ->addFilter('StripTags') 
                      ->setAttrib('class', 'form-control input-sm')
                      ->addFilter('StringTrim');
        
        $construccion = new Zend_Form_Element_Text('construccion');
        $construccion->setLabel('Año de construcción')
                  ->setRequired(true)
                  ->addFilter('StripTags') 
                  ->setAttrib('class', 'form-control input-sm')
                  ->addFilter('StringTrim');

        $otras_modificaciones = new Zend_Form_Element_Textarea('otras_modificaciones');
        $otras_modificaciones->setLabel('Otras modificaciones')
                               ->addFilter('StripTags') 
                               ->addFilter('StringTrim')
                               ->setAttrib('class', 'help form-control input-sm')
                               ->setAttrib('title', '1 dato por fila. Año: Modificación')
                               ->setAttrib('rows', '4');
        
        $sistemas = new Zend_Form_Element_Select('sistemas');
        $sistemas->setLabel('¿Clonar sistemas?')
                ->setRequired(true)
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOption('0', 'No')
                ->addMultiOption('1', 'Sí (incluir equipos)')
                ->addMultiOption('2', 'Sí (sólo sistemas)');
        
        $certificados = new Zend_Form_Element_Select('certificados');
        $certificados->setLabel('¿Clonar certificados?')
                     ->setRequired(true)
                     ->setAttrib('class', 'form-control input-sm')
                     ->addMultiOption('', '-- Seleccionar --')
                     ->addMultiOption('1', 'Sí')
                     ->addMultiOption('0', 'No');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default')
               ->setAttrib('onclick', 'javascript:history.back();');

        $this->addElements(
            array(
                $nave_id, $id, $empresa_id, $matricula, $nombre, 
                $puerto_matricula, $ismm, $cb, $clasificacion, $construccion, 
                $otras_modificaciones, $sistemas, $certificados,
                $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'nave_id', 'empresa_id', 'id', 'nombre'
                
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                  'puerto_matricula', 'matricula', 'cb', 'construccion'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                  'ismm', 'clasificacion', 'otras_modificaciones'
            ),
            'infoInputs3'
        );

        $infoInputs3 = $this->getDisplayGroup('infoInputs3');
        $infoInputs3->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                  'sistemas', 'certificados'
            ),
            'infoInputs4'
        );

        $infoInputs4 = $this->getDisplayGroup('infoInputs4');
        $infoInputs4->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'nave-clonar',
            'action'    => '/utilidades/clonar-nave'
        ));
    } 
} 
