<?php
class Shipcode_Form_NaveEquipoArchivo extends Zend_Form
{ 
    public function __construct($options = null )
    { 
        parent::__construct($options);
        
        $opcionesEquipo = array('table' => 'naves_equipos', 'field' => 'id');
        $validadorEquipo = new Zend_Validate_Db_RecordExists($opcionesEquipo);
        
        $equipo_id = new Zend_Form_Element_Hidden('equipo_id');
        $equipo_id->setRequired(true)
                  ->addValidator('Int')
                  ->addFilter('StripTags')
                  ->addFilter('StringTrim')
                  ->addValidator($validadorEquipo);
        
        $archivo = new Zend_Form_Element_Text('archivo');
        $archivo->setLabel('Archivo')
                ->setRequired(true)
                ->addFilter('StripTags')
                ->addFilter('StringTrim')
                ->setAttrib('class', 'form-control input-sm');
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm');
        
        $etiqueta_id = new Zend_Form_Element_Select('etiqueta_id');
        $etiqueta_id->setLabel('Etiqueta')
                    ->setRequired(true)
                    ->addFilter('StripTags')
                    ->addFilter('StringTrim')
                    ->addMultiOption('', '-- Seleccionar --')
                    ->setAttrib('class', 'form-control input-sm')
                    ->addMultiOptions(Shipcode_Model_EtiquetaArchivo::getPairsToSelect('E'));
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Subir')
               ->setAttrib('class','btn btn-primary');
        
        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(
            array(
                $equipo_id, $nombre, $etiqueta_id, $archivo, 
                $submit, $cancel
            )
        );
        
        $this->addDisplayGroup(
            array('nombre', 'etiqueta_id', 'archivo'), 
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(array('submit', 'cancel', 'equipo_id'),'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));
        
        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $equipo_id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
        
        $this->setAttribs(array(
            'name'      => 'equipo-archivo'
        ));
    } 
} 
