<?php
class Shipcode_Form_NaveInforme extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);

        $optionsNave = array('table' => 'naves', 'field' => 'id');
        $validadorNave = new Zend_Validate_Db_RecordExists($optionsNave);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->setRequired(true)
                ->addValidator('Int')
                ->addValidator($validadorNave);

        $nave = new Zend_Form_Element_Text('nave');
        $nave->setRequired(false)
             ->setLabel('Nave')
             ->setAttrib('class', 'form-control input-sm')   
             ->setAttrib('disabled', 'disabled');
        
        $fecha_lectura = new Zend_Form_Element_Text('fecha_lectura');
        $fecha_lectura->setLabel('Fecha lectura de datos')
               ->setRequired(true)
               ->addFilter('StripTags') 
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm help show-calendar')
               ->setAttrib("title", "Indique por favor el día que se tomaron o tomarán los datos.");
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(array($id, $nave_id, $nave, $fecha_lectura, $submit, $cancel));
        $this->addDisplayGroup(
            array(
                'nave', 'fecha_lectura' 
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id', 'nave_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        $nave_id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'informe-nave'
        ));
    } 
} 
