<?php
class Shipcode_Form_NaveInformeSolicitud extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsInforme = array('table' => 'naves_informes', 'field' => 'id');
        $validadorInforme = new Zend_Validate_Db_RecordExists($optionsInforme);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $informe_id = new Zend_Form_Element_Hidden('informe_id');
        $informe_id->addFilter('StripTags') 
                   ->addFilter('StringTrim')
                   ->addValidator('Int')
                   ->setRequired(true) 
                   ->addValidator($validadorInforme);
      
        $detalles = new Zend_Form_Element_Textarea('detalles');
        $detalles->setRequired(true)
                 ->setAttrib('rows', '5')
                 ->setAttrib("class", "form-control input-sm")
                 ->setAttrib('placeholder', 'Detalles de la solicitud');
        
        $prioridad = new Zend_Form_Element_Select('prioridad');
        $prioridad->setLabel('Prioridad')
                  ->setRequired(true)
                  ->setAttrib("class", "form-control input-sm")  
                  ->addMultiOption("NORMAL", "NORMAL")
                  ->addMultiOption("URGENTE", "URGENTE");
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Guardar solicitud')
               ->setAttrib('class','btn btn-primary');

        $this->addElements(array($id, $informe_id, $prioridad, $detalles, $submit));

        $this->addDisplayGroup(
            array(
                'prioridad', 'detalles', 'id', 'informe_id', 'submit'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            )
        );

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $id->setDecorators(array('ViewHelper'));
        $informe_id->setDecorators(array('ViewHelper'));
        $submit->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'well',
            'name'      => 'informe-solicitud'
        ));
    } 
} 
