<?php
class Shipcode_Form_NaveSiniestroArchivo extends Zend_Form
{ 
    public function __construct($options = null )
    { 
        parent::__construct($options);
        
        $opcionesNave = array('table' => 'naves', 'field' => 'id');
        $validadorNave = new Zend_Validate_Db_RecordExists($opcionesNave);
        
        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->setRequired(true)
           ->addValidator('Int')
           ->addFilter('StripTags')
           ->addFilter('StringTrim')
           ->addValidator($validadorNave);
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm');
        
        $archivo = new Zend_Form_Element_Text('archivo');
        $archivo->setLabel('Archivo')
                ->setRequired(true)
                ->addFilter('StripTags')
                ->addFilter('StringTrim')
                ->setAttrib('class', 'form-control input-sm');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Subir')
               ->setAttrib('class','btn btn-primary');
     

        $this->addElements(array($nave_id, $nombre, $archivo, $submit) );
        $this->addDisplayGroup(array('nombre', 'archivo'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset'
            )
        );
        
        $this->addDisplayGroup(array('submit', 'nave_id'),'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));
        
        $submit->setDecorators(array('ViewHelper'));
        $nave_id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
        
        $this->setAttribs(array(
            'name'      => 'nave-siniestro-archivo'
        ));
    } 
} 
