<?php
class Shipcode_Form_NaveUsuario extends Zend_Form
{ 
    public function __construct($options = null, $motoristasId = null)
    {
        parent::__construct($options);

        $optionsNave = array('table' => 'naves', 'field' => 'id');
        $validadorNave = new Zend_Validate_Db_RecordExists($optionsNave);
        
        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->addValidator('Int')
                   ->addFilter('StringTrim')
                   ->addFilter('StripTags')
                   ->addValidator($validadorNave);

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Configurar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;
        
        $campos = array($nave_id, $submit, $cancel);
        $nombres = array();
        
        $modelUsuario = new Shipcode_Model_SistemaUsuario();
        $motoristas = $modelUsuario->getMotoristas();
        
        foreach($motoristas as $motorista){
            $campoMotorista = new Zend_Form_Element_Checkbox($motorista['id']);
            $campoMotorista->setLabel($motorista['nombre']);
            
            if($motoristasId != null && is_array($motoristasId)){
                
                if(in_array($motorista['id'], $motoristasId)){
                    $campoMotorista->setValue(1);
                }
            }
            
            $campos[] = $campoMotorista;
            $nombres[] = $motorista['id'];
        }
        
        $this->addElements($campos);
        $this->addDisplayGroup($nombres, 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cancel', 'nave_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $nave_id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'nave-usuario',
            'action'    => '/nave/configurar-usuarios'
        ));
    } 
} 
