<?php
class Shipcode_Form_Observacion extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsNave = array('table' => 'naves', 'field' => 'id');
        $validadorNave = new Zend_Validate_Db_RecordExists($optionsNave);

        $id = new Zend_Form_Element_Hidden('id');
        $id->setLabel('ID')
           ->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->addValidator($validadorNave);
        
        $boleta = new Zend_Form_Element_Text('boleta');
        $boleta->setLabel('Nº Boleta')
               ->setRequired(true)
               ->addFilter('StripTags') 
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm');
        
        $inspector_tc = new Zend_Form_Element_Text('inspector_tc');
        $inspector_tc->setLabel('Inspector TC')
                         ->setRequired(false)
                         ->addFilter('StripTags') 
                         ->addFilter('StringTrim')
                         ->setAttrib('class', 'form-control input-sm');
        
        $inspector_nv_man = new Zend_Form_Element_Text('inspector_nv_man');
        $inspector_nv_man->setLabel('Inspector NV/MAN')
                         ->setRequired(false)
                         ->addFilter('StripTags') 
                         ->addFilter('StringTrim')
                         ->setAttrib('class', 'form-control input-sm');
        
        $inspector_mq_cn = new Zend_Form_Element_Text('inspector_mq_cn');
        $inspector_mq_cn->setLabel('Inspector MQ/CN')
                         ->setRequired(false)
                         ->addFilter('StripTags') 
                         ->addFilter('StringTrim')
                         ->setAttrib('class', 'form-control input-sm');
        
        $fecha_emision = new Zend_Form_Element_Text('fecha_emision');
        $fecha_emision->setLabel('Fecha de emision')
                      ->setRequired(true)
                      ->addFilter('StripTags') 
                      ->addFilter('StringTrim')
                      ->addValidator(new Zend_Validate_Date(array('format' => Zend_Registry::get('FORMAT_DATE'))))
                      ->setAttrib('class', 'form-control input-sm show-calendar');

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Guardar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;

        $this->addElements(
            array(
                $nave_id, $id, $fecha_emision, $boleta, 
                $inspector_tc, $inspector_nv_man, $inspector_mq_cn,
                $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'boleta', 'fecha_emision', 'inspector_tc', 'inspector_nv_man', 'inspector_mq_cn' 
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'nave_id', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $nave_id->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'observacion'
        ));
    } 
} 
