<?php
class Shipcode_Form_ProgramacionMensual extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $nave_id = new Zend_Form_Element_Select('nave_id');
        $nave_id->setLabel('Nave')
                ->setRequired(true)
                ->addValidator('Int')
                ->addMultiOption('', '-- Seleccionar --')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOptions(Shipcode_Model_Nave::getAgrupadasPorEmpresaToSelect());
      
        
        $mes = new Zend_Form_Element_Select('year_mes');
        $mes->setLabel('Mes / Año')
            ->setRequired(true)
            ->addFilter('StripTags') 
            ->addFilter('StringTrim')
            ->setAttrib('class', 'form-control input-sm');
        
        
        $nMes = date("n"); // Mes inicio
        $meses = array(
            '1' => 'Enero',
            '2' => 'Febrero',
            '3' => 'Marzo',
            '4' => 'Abril',
            '5' => 'Mayo',
            '6' => 'Junio',
            '7' => 'Julio',
            '8' => 'Agosto',
            '9' => 'Septiembre',
            '10' => 'Octubre',
            '11' => 'Noviembre',
            '12' => 'Diciembre',
            '13' => 'Enero',
            '14' => 'Febrero'
        );
        
        $y = date("Y"); // Año actual
        $y2 = $y + 1; // Año siguiente
        
        $c = 0; // Contador de ítems impresos
        
        foreach($meses as $n => $nombre){
            if($n >= $nMes && $c < 1){
                if($n > 12) {
                    $mes->addMultiOption($y2 . '-' . ($n - 12), $nombre . ' ' . $y2);
                } else {
                    $mes->addMultiOption($y . '-' . $n, $nombre . ' ' . $y);
                }
                $c++;
            }
        }
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(array($id, $nave_id, $mes, $submit, $cancel));
        $this->addDisplayGroup(
            array(
                'nave_id', 'year_mes'
                
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'programacion-mensual'
        ));
    } 
} 
