<?php
class Shipcode_Form_Proveedor extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $validadorRut = new App_Validate_ValidRut();
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $rut = new Zend_Form_Element_Text('rut');
        $rut->setLabel('R.U.T.')
           ->setRequired(true) 
           ->addFilter('StripTags') 
           ->setAttrib('class', 'form-control input-sm') 
           ->addFilter('StringTrim')
           ->addValidator($validadorRut);
        
        $razon_social = new Zend_Form_Element_Text('razon_social');
        $razon_social->setLabel('Razón Social')
                     ->setRequired(true)
                     ->addFilter('StripTags')
                     ->setAttrib('class', 'form-control input-sm') 
                     ->addFilter('StringTrim');
        
        $nombre_fantasia = new Zend_Form_Element_Text('nombre_fantasia');
        $nombre_fantasia->setLabel('Nombre fantasía')
                        ->setRequired(true)
                        ->addFilter('StripTags')
                        ->setAttrib('class', 'form-control input-sm') 
                        ->addFilter('StringTrim');

        $telefono = new Zend_Form_Element_Text('telefono');
        $telefono->setLabel('Teléfono')
                 ->setRequired(false)
                 ->addFilter('StripTags')
                 ->setAttrib('class', 'form-control input-sm') 
                 ->addFilter('StringTrim');
        
        $direccion = new Zend_Form_Element_Text('direccion');
        $direccion->setLabel('Dirección')
                 ->setRequired(false)
                 ->addFilter('StripTags')
                 ->setAttrib('class', 'form-control input-sm') 
                 ->addFilter('StringTrim');
        
        $ciudad = new Zend_Form_Element_Text('ciudad');
        $ciudad->setLabel('Ciudad')
               ->setRequired(false)
               ->addFilter('StripTags')
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim');
        
        $contacto = new Zend_Form_Element_Text('contacto');
        $contacto->setLabel('Contacto')
               ->setRequired(false)
               ->addFilter('StripTags')
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim');
        
        $email = new Zend_Form_Element_Text('email');
        $email->setLabel('Email')
               ->setRequired(false)
               ->addFilter('StripTags')
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim')
               ->addValidator('EmailAddress');
        
        $giro = new Zend_Form_Element_Text('giro');
        $giro->setLabel('Giro')
               ->setRequired(false)
               ->addFilter('StripTags')
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');

        $this->addElements(array(
            $id, $rut, $razon_social, $nombre_fantasia, $telefono, $direccion, 
            $ciudad, $contacto, $giro, $email, $submit, $cancel));
        $this->addDisplayGroup(array('rut', 'razon_social', 'nombre_fantasia', 'telefono', 'direccion',), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(array('ciudad', 'contacto', 'email', 'giro'), 'infoInputs2');

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'form-vertical',
            'name'      => 'proveedor',
            'action'    => '/proveedor/crear'
        ));
    } 
} 
