<?php
class Shipcode_Form_ProyectoBuscar extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
   
        $centro_costo_id = new Zend_Form_Element_Select('centro_costo_id');
        $centro_costo_id->setLabel('Centro de Costo')
                        ->setRequired(true)
                        ->addValidator('Int')
                        ->addFilter('StringTrim')
                        ->addFilter('StripTags')
                        ->setAttrib('class', 'form-control input-sm')
                        ->addMultiOption('', '-- Seleccionar --')
                        ->addMultiOptions(Shipcode_Model_CentroCosto::getPairsToSelect());
        
        $concepto_imputacion_id = new Zend_Form_Element_Select('concepto_imputacion_id');
        $concepto_imputacion_id->setLabel('Concepto de Imputación')
                               ->setRequired(true) 
                               ->addFilter('StringTrim')
                               ->addFilter('StripTags')
                               ->setAttrib('class', 'form-control input-sm')
                               ->addMultiOption('', '-- Seleccionar --')
                               ->addMultiOptions(Shipcode_Model_ConceptoImputacion::getPairsToSelect());
        
        $tipo_id = new Zend_Form_Element_Select('tipo_id');
        $tipo_id->setLabel('Tipo de proyecto')
                ->setRequired(true)
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->setAttrib('class', 'form-control input-sm')
                ->addMultiOption('', '-- Seleccionar --')
                ->addMultiOptions(Shipcode_Model_TipoProyecto::getPairsToSelect());
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->setAttrib('class', 'form-control input-sm')  
              ->addFilter('StringTrim');
        
        
        $fecha_termino = new Zend_Form_Element_Text('fecha_termino');
        $fecha_termino->setLabel('Fecha de término proyecto')
                      ->setRequired(true)
                      ->addFilter('StripTags') 
                      ->addFilter('StringTrim')
                      ->addValidator(new Zend_Validate_Date(array('format' => Zend_Registry::get('FORMAT_DATE'))))
                      ->setAttrib('class', 'form-control input-sm show-calendar');
        
        $meses_prorrateo = new Zend_Form_Element_Text('meses_prorrateo');
        $meses_prorrateo->setLabel('Meses de prorrateo')
                        ->setRequired(true)
                        ->addFilter('StripTags') 
                        ->addFilter('StringTrim')
                        ->addValidator('Int')
                        ->setAttrib('class', 'form-control input-sm');
        
        $mes_inicio_prorrateo = new Zend_Form_Element_Select('mes_inicio_prorrateo');
        $mes_inicio_prorrateo->setLabel("Mes inicio prorrateo")
                        ->setRequired(true)
                        ->addFilter('StripTags') 
                        ->addFilter('StringTrim')
                        ->setAttrib('class', 'form-control input-sm')
                        ->addMultiOptions(array(
                            '01' => 'Enero',
                            '02' => 'Febrero',
                            '03' => 'Marzo',
                            '04' => 'Abril',
                            '05' => 'Mayo',
                            '06' => 'Junio',
                            '07' => 'Julio',
                            '08' => 'Agosto',
                            '09' => 'Septiembre',
                            '10' => 'Octubre',
                            '11' => 'Noviembre',
                            '12' => 'Diciembre',
                        ));
        
        $year_inicio_prorrateo = new Zend_Form_Element_Select('year_inicio_prorrateo');
        $year_inicio_prorrateo->setRequired(true)
                              ->setLabel("Año inicio prorrateo")
                              ->addFilter('StripTags') 
                              ->addFilter('StringTrim')
                              ->setAttrib('class', 'form-control input-sm')
                              ->addMultiOptions($years);

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Ingresar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;

        $this->addElements(
            array(
                $id, $centro_costo_id, $concepto_imputacion_id, $tipo_id, $nombre, 
                $observaciones, $costo_total, $fecha_termino, $meses_prorrateo,
                $mes_inicio_prorrateo, $year_inicio_prorrateo, $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'centro_costo_id', 'tipo_id', 'concepto_imputacion_id',  
                'nombre', 'fecha_termino'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                'costo_total', 'meses_prorrateo', 
                'mes_inicio_prorrateo', 'year_inicio_prorrateo'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                 'observaciones'
            ),
            'infoInputs3'
        );

        $infoInputs3 = $this->getDisplayGroup('infoInputs3');
        $infoInputs3->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div','class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'proyecto'
        ));
    } 
} 
