<?php
class Shipcode_Form_Siniestro extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsNave = array('table' => 'naves', 'field' => 'id');
        $validadorNave = new Zend_Validate_Db_RecordExists($optionsNave);

        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->setAttrib('class', 'form-control input-sm')
                ->addValidator($validadorNave);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->setLabel('ID')
           ->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->setAttrib('class', 'form-control input-sm')     
           ->addValidator('Int');
        
        $numero = new Zend_Form_Element_Text('numero');
        $numero->setLabel('Nº de siniestro')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->setAttrib('class', 'form-control input-sm')  
              ->addFilter('StringTrim');
        
        $fecha = new Zend_Form_Element_Text('fecha');
        $fecha->setLabel('Fecha')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator(new Zend_Validate_Date(array('format' => Zend_Registry::get('FORMAT_DATE'))))
              ->setAttrib('class', 'form-control input-sm show-calendar');
        
        $detalle = new Zend_Form_Element_Textarea('detalle');
        $detalle->setRequired(true)
                ->setLabel('Detalle')
                ->addFilter('StripTags') 
                ->addFilter('StringTrim')
                ->setAttrib('rows', '12')
                ->setAttrib('class', 'form-control input-sm');
        
        $valor = new Zend_Form_Element_Text('valor');
        $valor->setLabel('Monto reclamado')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->setAttrib('class', 'form-control input-sm')  
              ->addValidator('Int');
         
        $estado = new Zend_Form_Element_Select('estado');
        $estado->setLabel('Estado')
               ->setRequired(true)
               ->addMultiOption('', '-- Seleccionar --')
               ->addMultiOption('EN TRAMITE', 'EN TRÁMITE')
               ->addMultiOption('DESPACHADO', 'DESPACHADO')
               ->addMultiOption('LIQUIDADO', 'LIQUIDADO')
               ->addMultiOption('DESISTIDO', 'DESISTIDO')
               ->setAttrib('class', 'form-control input-sm');

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Ingresar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;

        $this->addElements(
            array(
                $nave_id, $id, $fecha, $detalle, $valor, 
                $numero, $estado, $submit, $cancel
            ));

        $this->addDisplayGroup(
            array(
                'numero', 'fecha', 'estado', 'valor'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array(
                'detalle'
            ),
            'infoInputs2'
        );

        $infoInputs2 = $this->getDisplayGroup('infoInputs2');
        $infoInputs2->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'nave_id', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $nave_id->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'siniestro'
        ));
    } 
} 
