<?php
class Shipcode_Form_SistemaInformeAutomatico extends Zend_Form
{
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int');
        
        $informe_id = new Zend_Form_Element_Select('informe_id');
        $informe_id->setLabel('Informe')
                   ->setRequired(true)
                   ->setAttrib('class', 'form-control input-sm')
                   ->addMultiOption('', '-- Seleccionar --')
                   ->addMultiOptions(Shipcode_Model_SistemaInformePreconfigurado::getPairsToSelect());
                
        $usuario_id = new Zend_Form_Element_Select('usuario_id');
        $usuario_id->setLabel('Enviar a')
                   ->setRequired(true)
                   ->setAttrib('class', 'form-control input-sm')
                   ->addMultiOption('', '-- Seleccionar --')
                   ->addMultiOptions(Shipcode_Model_SistemaUsuario::getPairsToSelect());
        
        $dia = new Zend_Form_Element_Select('dia');
        $dia->setLabel('Día del mes en que se enviará')
            ->setRequired(true)
            ->setAttrib('class', 'form-control input-sm')
            ->addMultiOption('', '-- Seleccionar --')
            ->addMultiOption('1', '1')
            ->addMultiOption('5', '5')
            ->addMultiOption('10', '10')
            ->addMultiOption('15', '15')
            ->addMultiOption('20', '20')
            ->addMultiOption('25', '25');
        
        $con_copia = new Zend_Form_Element_Textarea('con_copia');
        $con_copia->setLabel('Enviar copias a los siguientes correos')
                ->setAttrib('rows', '2')
                ->setAttrib('class', 'form-control input-sm')
                ->setRequired(false);
        
        $con_copia_oculta = new Zend_Form_Element_Textarea('con_copia_oculta');
        $con_copia_oculta->setLabel('Enviar copias ocultas a los siguientes correos')
                         ->setAttrib('rows', '2')
                         ->setAttrib('class', 'form-control input-sm')
                         ->setRequired(false);
        
        $mensaje = new Zend_Form_Element_Textarea('mensaje');
        $mensaje->setLabel('Mensaje por defecto')
                ->setAttrib('rows', '5')
                ->setAttrib('class', 'form-control input-sm')
                ->setRequired(false);

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;
        
        $this->addElements(array(
            $id, $informe_id, $usuario_id, $dia, $mensaje, 
            $con_copia_oculta, $con_copia, $submit, $cancel
        ));

        $this->addDisplayGroup(
            array(
                'informe_id', 
                'usuario_id', 
                'dia', 
                'con_copia', 
                'con_copia_oculta', 
                'mensaje'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-6'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));
        
        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));

        $this->setAttribs(array(
            'name'      => 'informe-automatico',
            'action'    => '/sistema-informe-automatico/crear'
        ));

    } 
} 
