<?php
class Shipcode_Form_SistemaInformePreconfigurado extends Zend_Form
{
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addValidator('Int')
           ->setRequired(true);
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel("Nombre / Referencia")
               ->setAttrib('class', 'form-control input-sm')
               ->setRequired(true);
        
        $tipo = new Zend_Form_Element_Text('tipo');
        $tipo->setLabel("Tipo")
             ->setAttrib('class', 'form-control input-sm')
              ->setRequired(false);

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Guardar')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;
        
        $this->addElements(array($id, $nombre, $tipo, $submit, $cancel));

        $this->addDisplayGroup(
            array(
                'nombre', 'tipo'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));
        
        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));

        $this->setAttribs(array(
            'name'      => 'informe-preconfigurado'
        ));

    } 
} 
