<?php
class Shipcode_Form_SistemaMensaje extends Zend_Form
{ 
    public function __construct($options = null)
    { 
        parent::__construct($options);

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Enviar a (nombre)')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim')
               ->setAttrib('class', 'form-control input-sm');

        $informe = new Zend_Form_Element_Select('informe');
        $informe->setLabel('Informe a enviar')
                   ->setRequired(true)
                   ->setAttrib('class', 'form-control input-sm')
                   ->addMultiOption('', '-- Seleccionar --')
                   ->addMultiOptions(Shipcode_Model_SistemaInformePreconfigurado::getPairsToSelect());

        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Mail')
                   ->setRequired(true)
                   ->addFilter('StripTags')
                   ->addFilter('StringTrim')
                   ->addValidator('EmailAddress')
                   ->setAttrib('class', 'form-control input-sm');

        $copia = new Zend_Form_Element_Checkbox('copia');
        $copia->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->setAttrib('checked','checked');

        $mensaje = new Zend_Form_Element_Textarea('mensaje');
        $mensaje->setLabel('Mensaje')
                ->setRequired(true)
                ->addFilter('StripTags')
                ->addFilter('StringTrim')
                ->setAttrib('class', 'form-control input-sm')
                ->setAttrib('rows', '4');

        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Enviar')
               ->setAttrib('class','btn btn-primary');
        
        $this->addElements(array($nombre, $mail, $mensaje, $submit,  $informe, $copia));

        $this->addDisplayGroup(
            array(
                'nombre', 'mail', 'informe', 'mensaje', 'copia'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class', 'col-lg-3'))
            ));

        $this->addDisplayGroup(
            array('submit', 'cancel'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));
        
        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));
        
        $submit->setDecorators(array('ViewHelper'));

        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));   

        $this->setAttribs(array(
            'name'  => 'sistema-mensaje',
            'action' => '/sistema-envio-mensaje/enviar'
        ));

    } 
} 
