<?php
class Shipcode_Form_Solicitud extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsNave = array('table' => 'naves', 'field' => 'id');
        $validadorNave = new Zend_Validate_Db_RecordExists($optionsNave);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->addFilter('StripTags') 
                ->addFilter('StringTrim')
                ->addValidator('Int')
                ->setRequired(true) 
                ->addValidator($validadorNave);
      
        $detalles = new Zend_Form_Element_Textarea('detalles');
        $detalles->setRequired(true)
                 ->setAttrib('style', 'height:160px;')
                 ->setAttrib("class", "form-control input-sm")
                 ->setAttrib('placeholder', 'Detalles de la solicitud');
        
        $prioridad = new Zend_Form_Element_Select('prioridad');
        $prioridad->setLabel('Prioridad')
                  ->setRequired(true)
                  ->setAttrib("class", "form-control input-sm")  
                  ->addMultiOption("NORMAL", "NORMAL")
                  ->addMultiOption("URGENTE", "URGENTE");
        
        $submit = new Zend_Form_Element_Button('submit');
        $submit->setLabel('Ingresar')
               ->setAttrib('type', 'submit')
               ->setAttrib('class','btn btn-primary');
        
        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Reset')
               ->setAttrib('type', 'reset')
               ->setAttrib('data-action-url', '/u-nave/solicitudes')
               ->setAttrib('data-submit-text', 'Ingresar')
               ->setAttrib('data-form-id', '#solicitud') 
               ->setAttrib('class','btn btn-default');

        $this->addElements(array(
            $id, $nave_id, $prioridad, $detalles, $submit, $cancel
        ));

        $this->addDisplayGroup(
            array(
                'prioridad', 'detalles', 'id', 'nave_id', 'submit', 'cancel'
            ),
            'infoInputs'
        );

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators( 
            array(
                'FormElements',
                'Fieldset'
            )
        );

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $id->setDecorators(array('ViewHelper'));
        $nave_id->setDecorators(array('ViewHelper'));
        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'class'     => 'well data-inline',
            'name'      => 'solicitud',
            'action'    => '/u-nave/solicitudes'
        ));
    } 
} 
