<?php
class Shipcode_Form_Subsistema extends Zend_Form
{ 
    public function __construct($options = null)
    {
        parent::__construct($options);
        
        $optionsNave = array('table' => 'naves', 'field' => 'id');
        $validadorNave = new Zend_Validate_Db_RecordExists($optionsNave);
        
        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags') 
           ->addFilter('StringTrim')
           ->addValidator('Int');
        
        $nave_id = new Zend_Form_Element_Hidden('nave_id');
        $nave_id->setRequired(true) 
                ->addValidator('Int')
                ->addFilter('StringTrim')
                ->addFilter('StripTags')
                ->addValidator($validadorNave); 
        
        $padre_id = new Zend_Form_Element_Select('padre_id');
        $padre_id->setLabel('Sistema padre')
                 ->setRequired(true) 
                 ->addValidator('Int')
                 ->addFilter('StringTrim')
                 ->addFilter('StripTags')
                 ->setAttrib('class', 'form-control input-sm')   
                 ->addMultiOption('', '-- Seleccionar --'); 
        
        $secundario_id = new Zend_Form_Element_Select('secundario_id');
        $secundario_id->setLabel('Nombre')
                      ->setRequired(true)
                      ->addValidator('Int')
                      ->addFilter('StringTrim')
                      ->addFilter('StripTags')
                      ->setAttrib('class', 'form-control input-sm')
                      ->addMultiOption('', '-- Seleccionar --')
                      ->addMultiOptions(Shipcode_Model_BaseSistema::getPairsSecundariosToSelect());
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Agregar')
               ->setAttrib('class','btn btn-primary');
        
        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');;

        $this->addElements(array($id, $nave_id, $padre_id, $secundario_id, $submit, $cancel));
        $this->addDisplayGroup(array('padre_id', 'secundario_id'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(array(
            'FormElements',
            'Fieldset',
            array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
        ));
        
        $this->addDisplayGroup(
            array('submit', 'cancel', 'id', 'nave_id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag',array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'subsistema'
        ));
    } 
} 
