<?php
class Shipcode_Form_TipoProyecto extends Zend_Form
{ 
    public function __construct($options = null)
    { 
        parent::__construct($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->addFilter('StripTags')
            ->addFilter('StringTrim')
            ->addValidator('Int');
      
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim');
        
        $detalle_mensual = new Zend_Form_Element_Select('detalle_mensual');
        $detalle_mensual->setLabel('Detalle mensual')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim')
               ->addMultiOption('NO', 'NO')
               ->addMultiOption('SI', 'SI');
        
        $requiere_presupuesto = new Zend_Form_Element_Select('requiere_presupuesto');
        $requiere_presupuesto->setLabel('¿Requiere presupuesto?')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->setAttrib('class', 'form-control input-sm') 
               ->addFilter('StringTrim')
               ->addMultiOption('NO', 'NO')
               ->addMultiOption('SI', 'SI');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Crear')
               ->setAttrib('class','btn btn-primary');

        $cancel = new Zend_Form_Element_Button('cancel');
        $cancel->setLabel('Cancelar')
               ->setAttrib('class', 'btn btn-default');
        
        $this->addElements(array($id, $nombre, $detalle_mensual, $requiere_presupuesto, $submit, $cancel));
        $this->addDisplayGroup(array('id', 'nombre', 'detalle_mensual', 'requiere_presupuesto'), 'infoInputs');

        $infoInputs = $this->getDisplayGroup('infoInputs');
        $infoInputs->setDecorators(
            array(
                'FormElements',
                'Fieldset',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-3'))
            )
        );

        $this->addDisplayGroup(array('submit', 'cancel'),'submitButtons');

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
            array(
                'FormElements',
                array('HtmlTag', array('tag' => 'div', 'class' => 'col-lg-12'))
            ));

        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array(array('row' => 'HtmlTag'), array('tag' => 'div', 'class' => 'form-group')),
            'Errors'
        ));

        $submit->setDecorators(array('ViewHelper'));
        $cancel->setDecorators(array('ViewHelper'));
        $id->setDecorators(array('ViewHelper'));
        
        $this->setDecorators(array(
            'FormElements',
            'Form'
        ));
     
        $this->setAttribs(array(
            'name'      => 'tipo-proyecto',
            'action'    => '/tipo-proyecto/crear'
        ));

    } 
} 
