<?php
class Shipcode_Model_Imagestion
{
    private $_meses = array(
        'enero', 
        'febrero', 
        'marzo', 
        'abril', 
        'mayo', 
        'junio',
        'julio', 
        'agosto', 
        'septiembre', 
        'octubre', 
        'noviembre', 
        'diciembre'
    );
    
    public function getDetallePresupuestoMensual($cod_centro, $mes, $year)
    {
        $data = array();
        $modelCuenta = new Shipcode_Model_CuentaGasto();
        $modelAsignacion = new Shipcode_Model_ImagestionPresupuestoAsignacion();
        $modelGasto = new Shipcode_Model_ImagestionGasto();
        $cuentas = $modelCuenta->getAll(false, true)->toArray();
        foreach($cuentas as $cuenta){
            $cuenta['presupuesto'] = $modelAsignacion->getTotalMensualCuenta($cod_centro, $cuenta['cod_cuenta'], $year, $mes);
            $cuenta['presupuesto_acumulado'] = $modelAsignacion->getTotalAcumuladoCuenta($cod_centro, $cuenta['cod_cuenta'], $year, $mes);
            $cuenta['gasto'] = $modelGasto->getTotalMensualCuenta($cod_centro, $cuenta['cod_cuenta'], $year, $mes);
            $cuenta['gasto_acumulado'] = $modelGasto->getTotalAcumuladoCuenta($cod_centro, $cuenta['cod_cuenta'], $year, $mes);;
            $cuenta['saldo'] = $cuenta['presupuesto'] - $cuenta['gasto'];
            $cuenta['saldo_acumulado'] = $cuenta['presupuesto_acumulado'] - $cuenta['gasto_acumulado'];
            $data[] = $cuenta;
        }
        return $data;
    }
    
    /*
    public function getYearsByEmpresa($empresa_id)
    {
        $presupuesto = new Shipcode_Model_ImagestionPresupuesto();
        $yearsPresupuestos = $presupuesto->getYears($empresa_id);
        
        $gasto = new Shipcode_Model_ImagestionGasto();
        $yearsGastos = $gasto->getYears();
        
        $years = array_unique(array_merge($yearsPresupuestos, $yearsGastos));
        
        $data = array();
        $i = 0;
        
        foreach($years as $year){
            
            $y = $year['year'];

            $presupuesto
            
            $data[$i]['year'] = $y;
        }    
        
    }
    */
    
    public function getPresupuestoMensual($cod_centro, $mes = NULL, $year = NULL)
    {
        if($mes == NULL || $year == NULL){
            $mes = date("m");
            $year = date("Y");
        }
        $presupuesto = new Shipcode_Model_ImagestionPresupuesto();
        return $presupuesto->getDetalleMensual($cod_centro, $mes, $year);
    }
    
    public function getDetallePresupuestoAcumulado($cod_centro, $mes = NULL, $year = NULL)
    {
        if($mes == NULL || $year == NULL){
            $mes = date("m");
            $year = date("Y");
        }
        $presupuesto = new Shipcode_Model_ImagestionPresupuesto();
        return $presupuesto->getDetalleAcumulado($cod_centro, $mes, $year);
    }
    
    public function getGastoMensual($cod_centro, $mes = NULL, $year = NULL)
    {
        if($mes == NULL || $year == NULL){
            $mes = date("m");
            $year = date("Y");
        }
        $gasto = new Shipcode_Model_ImagestionGasto();
        return $gasto->getDetalleMensual($cod_centro, $mes, $year);
    }
    
    public function getGastoAcumulado($cod_centro, $mes = NULL, $year = NULL)
    {
        if($mes == NULL || $year == NULL){
            $mes = date("m");
            $year = date("Y");
        }
        $gasto = new Shipcode_Model_ImagestionGasto();
        return $gasto->getDetalleAcumulado($cod_centro, $mes, $year);
    }
    
    public function cargarPresupuesto($cod_centro, $year)
    {
        $cuenta = new Shipcode_Model_CuentaGasto();
        $presupuesto = new Shipcode_Model_ImagestionPresupuesto();
        $cuentasGastos = $cuenta->getAll(false, true);
        $presupuestoId = $presupuesto->crear($cod_centro, $year);
                
        if(count($cuentasGastos) > 0) {

            $asignacion = new Shipcode_Model_ImagestionPresupuestoAsignacion();

            foreach($cuentasGastos as $cuentaGasto){

                $datos = array("anio" => $year, "cod_centro" => $cod_centro, "cod_cuenta" => $cuentaGasto->cod_cuenta); 
                $curl = curl_init(Zend_Registry::get("IMA_URL") . "presupuesto/presupuesto.php?token=". Zend_Registry::get("IMA_TOKEN"));
                curl_setopt($curl, CURLOPT_POST, 1);
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($curl, CURLOPT_POSTFIELDS, 'datos='. json_encode($datos).'&formato=json'."&get=detalle");
                $response = curl_exec($curl);

                if($response){
                    $data = Zend_Json::decode($response);
                    for($i = 0 ; $i < count($this->_meses) ; $i++){
                        $mes = $this->_meses[$i];
                        $asignacion->crear(array(
                            'presupuesto_id' => $presupuestoId,
                            'cod_cuenta'      => $cuentaGasto->cod_cuenta,
                            'mes'            => $i + 1,
                            'monto'          => (int)$data[0][$mes]
                        ));
                    }
                }
            }
        }
    }
    
    public function cargarOrdenesDeCompra($year, $mes)
    {
        
        $datos = array("ano_gasto" => $year, "mes_gasto" => $mes); 
        $curl = curl_init(Zend_Registry::get("IMA_URL") . "orden/orden.php?token=". Zend_Registry::get("IMA_TOKEN"));
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, 'datos='. json_encode($datos).'&formato=json'."&get=encabezado");
        $response = curl_exec($curl);
        $count = 0;
        if($response){
            $ordenes = Zend_Json::decode($response);
            if(count($ordenes) > 0){
                
                $cod_cuentas = Shipcode_Model_CuentaGasto::getCuentasOrdenes();
                $cod_centros = Shipcode_Model_Nave::getCentrosDeCosto();
                
                foreach($ordenes as $orden){
                    $items = $this->_getItems($orden['id_compra']);
                    if(count($items) > 0){
                        $gasto = new Shipcode_Model_ImagestionGasto();
                        foreach($items as $item){
                            if(in_array($item['cod_cuenta'], $cod_cuentas) && in_array($item['cod_centro'], $cod_centros)){
                                $gasto->crear($orden, $item);
                                $count++;
                            }
                        }
                    }
                }
            }
        }
        return $count;
    }
    
    public function cargarProductos()
    {
        $datos = array(); 
        $curl = curl_init(Zend_Registry::get("IMA_URL") . "producto/producto.php?token=". Zend_Registry::get("IMA_TOKEN"));
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, 'datos='. json_encode($datos).'&formato=json'."&get=detalle");
        $response = curl_exec($curl);
        $count = 0;
        if($response){
            $productos = Zend_Json::decode($response);
            if(count($productos) > 0){
                $modelProducto = new Shipcode_Model_ImagestionProducto();
                foreach($productos as $producto){
                    $modelProducto->crear($producto);
                    $count++;
                }
            }
        }
        return $count;
    }
    
    private function _getItems($id_compra)
    {
        $datos = array("id_compra" => $id_compra); 
        $curl = curl_init(Zend_Registry::get("IMA_URL") . "orden/orden.php?token=". Zend_Registry::get("IMA_TOKEN"));
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, 'datos='. json_encode($datos).'&formato=json'."&get=detalle");
        $response = curl_exec($curl);
        if($response){
            return Zend_Json::decode($response);
        }
        return $response;
    }
    
    public function getCentrosCosto()
    {
        $centroCosto = new Shipcode_Model_ImagestionCentroCosto();
        return $centroCosto->getAll();
    }
    
    public function crearCentroCosto($data, $user)
    {
        $centroCosto = new Shipcode_Model_ImagestionCentroCosto();
        return $centroCosto->crear($data, $user);
    }
    
    public function editarCentroCosto($data, $user)
    {
        $centroCosto = new Shipcode_Model_ImagestionCentroCosto();
        return $centroCosto->editar($data, $user);
    }
    
    public function getCentroCosto($id)
    {
        $centroCosto = new Shipcode_Model_ImagestionCentroCosto();
        $centroCosto->setId($id);
        return $centroCosto->getRow();
    }
    
    public function eliminarCentroCosto($id)
    {
        $centroCosto = new Shipcode_Model_ImagestionCentroCosto();
        $centroCosto->setId($id);
        return $centroCosto->eliminar();
    }
    
    
    public function getCuentasGasto()
    {
       $cuentaGasto = new Shipcode_Model_ImagestionCuentaGasto();
        return $cuentaGasto->getAll();
    }
    
    public function crearCuentaGasto($data, $user)
    {
        $cuentaGasto = new Shipcode_Model_ImagestionCuentaGasto();
        return $cuentaGasto->crear($data, $user);
    }
    
    public function editarCuentaGasto($data, $user)
    {
        $cuentaGasto = new Shipcode_Model_ImagestionCuentaGasto();
        return $cuentaGasto->editar($data, $user);
    }
    
    public function getCuentaGasto($id)
    {
        $cuentaGasto = new Shipcode_Model_ImagestionCuentaGasto();
        $cuentaGasto->setId($id);
        return $cuentaGasto->getRow();
    }
    
    public function eliminarCuentaGasto($id)
    {
        $cuentaGasto = new Shipcode_Model_ImagestionCuentaGasto();
        $cuentaGasto->setId($id);
        return $cuentaGasto->eliminar();
    }
}