<?php
class Shipcode_Model_ImagestionImporter
{
    private $_webservice_id = 1;
    
    public function getCuentasGasto()
    {
        $idExistentes = Shipcode_Model_CuentaGasto::getIdExistentes();
        $config = Shipcode_Model_SistemaImportacionData::getConfigService($this->_webservice_id);
        
        $curl = curl_init($config['direccion'] . "cuenta/cuenta.php?token=". $config['token']);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, 'tipo_cuenta=GASTO');
        $response = curl_exec($curl);
        $arrayCuentasCsv = explode(PHP_EOL, utf8_encode($response));
        unset($arrayCuentasCsv[0]);
        
        foreach($arrayCuentasCsv as $cuentaCsv) {
            if($cuentaCsv != '' && $cuentaCsv != NULL){
                $arrayCuenta = explode(",", $cuentaCsv);
                if($arrayCuenta[3] === 'GASTO'){
                    $rowCuenta['cod_cuenta'] = $arrayCuenta[0];
                    $rowCuenta['descripcion_cuenta'] = $arrayCuenta[1];
                    $rowCuenta['codigo_contable'] = $arrayCuenta[2];
                    $rowCuenta['tipo_cuenta'] = $arrayCuenta[3];
                    $rowCuenta['id_cuenta_madre'] = $arrayCuenta[5];
                    if(!in_array($rowCuenta['id'], $idExistentes)) {
                        $dataCuentas[] = $rowCuenta;
                    
                    }
                }
            }
        }
        
        return $dataCuentas;
    }
    
    public function getCentrosCosto()
    {
        $idExistentes = Shipcode_Model_CentroCosto::getIdExistentes();
        $config = Shipcode_Model_SistemaImportacionData::getConfigService($this->_webservice_id);
        
        $curl = curl_init($config['direccion'] . "centro/centro.php?token=". $config['token']);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, 'estado=Activo');
        $response = curl_exec($curl);
        $arrayCentrosCsv = explode(PHP_EOL, utf8_encode($response));
        unset($arrayCentrosCsv[0]);
        
        foreach($arrayCentrosCsv as $centroCsv) {
            if($centroCsv != '' && $centroCsv != NULL){
                $arrayCentro = explode(",", $centroCsv);
                if($arrayCentro[3] === "Activo"){
                    $rowCentro['cod_centro'] = $arrayCentro[0];
                    $rowCentro['descripcion_centro'] = $arrayCentro[1];
                    $rowCentro['area_general'] = $arrayCentro[2];
                    $rowCentro['codigo_contable'] = $arrayCentro[4];
                    if(!in_array($rowCentro['id'], $idExistentes)) {
                        $dataCentros[] = $rowCentro;
                    
                    }
                }
            }
        }
        
        return $dataCentros;
    }
    
    public function getProveedores()
    {
        $rutExistentes = Shipcode_Model_Proveedor::getRutExistentes();
        $config = Shipcode_Model_SistemaImportacionData::getConfigService($this->_webservice_id);
        
        $curl = curl_init($config['direccion'] . "proveedor/proveedor.php?token=". $config['token']);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, '');
        $response = curl_exec($curl);
        $arrayProveedoresCsv = explode(PHP_EOL, utf8_encode($response));
        unset($arrayProveedoresCsv[0]);
        foreach($arrayProveedoresCsv as $proveedorCsv) {
            if($proveedorCsv != '' && $proveedorCsv != NULL){
                $arrayProveedor = explode(",", $proveedorCsv);
                $rowProveedor['id_proveedor'] = $arrayProveedor[0];
                $rowProveedor['rut'] = App_Rut::cleanToDb($arrayProveedor[1]);
                $rowProveedor['empresa'] = $arrayProveedor[2];
                $rowProveedor['direccion'] = $arrayProveedor[3];
                $rowProveedor['telefono_1'] = $arrayProveedor[4];
                $rowProveedor['ciudad'] = $arrayProveedor[8];
                if(!in_array($rowProveedor['rut'], $rutExistentes)) {
                    $dataProveedores[] = $rowProveedor;
                    
                }
            }
        }
        
        return $dataProveedores;
    }
    
    public function getProductos()
    {
        $idExistentes = Shipcode_Model_Producto::getIdExistentes();
        $config = Shipcode_Model_SistemaImportacionData::getConfigService($this->_webservice_id);
        
        $curl = curl_init($config['direccion'] . "producto/producto.php?token=". $config['token']);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, '');
        $response = curl_exec($curl);
        $arrayProductosCsv = explode(PHP_EOL, utf8_encode($response));
        unset($arrayProductosCsv[0]);
        
        foreach($arrayProductosCsv as $productoCsv) {
            if($productoCsv != '' && $productoCsv != NULL){
                $arrayProducto = explode(",", $productoCsv);
                $rowProducto['producto_id'] = $arrayProducto[0];
                $rowProducto['nombre_producto'] = $arrayProducto[1];
                $rowProducto['tipo_producto'] = $arrayProducto[3];
                $rowProducto['estado'] = $arrayProducto[4];
                $rowProducto['cod_categoria'] = $arrayProducto[5];
                $dataProductos[] = $rowProducto;
                if(!in_array($rowProducto['id'], $idExistentes)) {
                    $dataProductos[] = $rowProducto;
                    
                }
            }
        }
        
        return $dataProductos;
    }
    
    public function getConceptosImputacion()
    {
        // falta implementar exclusión de ID existentes
        $config = Shipcode_Model_SistemaImportacionData::getConfigService($this->_webservice_id);
        $curl = curl_init($config['direccion'] . "concepto/concepto.php?token=". $config['token']);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, 'tipo_cuenta=GASTO');
        $response = curl_exec($curl);
        $arrayConceptosCsv = explode(PHP_EOL, utf8_encode($response));
        unset($arrayConceptosCsv[0]);
        
        foreach($arrayConceptosCsv as $conceptoCsv) {
            if($conceptoCsv != '' && $conceptoCsv != NULL){
                $arrayConcepto = explode(",", $conceptoCsv);
                $rowConcepto['cod_centro'] = $arrayConcepto[0];
                $rowConcepto['descripcion_centro'] = $arrayConcepto[1];
                $rowConcepto['area_general'] = $arrayConcepto[2];
                $rowConcepto['codigo_contable'] = $arrayConcepto[4];
                $dataConceptos[] = $rowConcepto;
            }
        }
        return $dataConceptos;
    }
}