<?php
class Shipcode_Model_ImagestionPresupuesto extends Zend_Db_Table_Abstract
{
    protected $_name = 'imagestion_presupuestos';
    protected $_primary = 'id';
    
    private $_id;
    
    public function getYears($empresa_id)
    {
        $adapter = $this->getAdapter();
        $sql = "SELECT DISTINCT(year) FROM imagestion_presupuestos AS p "
             . "JOIN naves AS n ON n.cod_centro=p.cod_centro "
             . "WHERE n.empresa_id='$empresa_id'";
        return $adapter->fetchAll($sql);
    }
    
    public function setId($id)
    {
        $this->_id = $id;
    }
    
    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getDetalleMensual($cod_centro, $mes, $year)
    {
        $where = "cod_centro = '$cod_centro' AND year='$year'";
        $presupuesto = $this->fetchRow($where)->toArray();
        $presupuesto['asignaciones'] = $this->_getAsignacionesMes($presupuesto['id'], $mes);
        return $presupuesto;
    }
    
    public function getDetalleAcumulado($cod_centro, $mes, $year)
    {
        $where = "cod_centro = '$cod_centro' AND year='$year'";
        $presupuesto = $this->fetchRow($where)->toArray();
        $presupuesto['asignaciones'] = $this->_getAsignacionesMeses($presupuesto['id'], $mes);
        return $presupuesto;
    }
    
    private function _getAsignacionesMeses($presupuesto_id, $mes)
    {
        $cuenta = new Shipcode_Model_CuentaGasto();
        $cuentas = $cuenta->getAll(false, true)->toArray();
        $asignaciones = array();
        $asignacion = new Shipcode_Model_ImagestionPresupuestoAsignacion();
        foreach($cuentas as $row){
            $data['cuenta'] = $row['nombre'];
            $data['montos'] = $asignacion->getMontosAsignados($presupuesto_id, $mes, $row['cod_cuenta']);
            $asignaciones[] = $data;
        }
        return $asignaciones;
    }
    
    private function _getAsignacionesMes($presupuesto_id, $mes)
    {
        $cuenta = new Shipcode_Model_CuentaGasto();
        $cuentas = $cuenta->getAll(false, true)->toArray();
        $asignaciones = array();
        $asignacion = new Shipcode_Model_ImagestionPresupuestoAsignacion();
        foreach($cuentas as $row){
            $data['cuenta'] = $row['nombre'];
            $data['monto'] = $asignacion->getMontoAsignado($presupuesto_id, $mes, $row['cod_cuenta']);
            $asignaciones[] = $data;
        }
        return $asignaciones;
    }
 
    public function crear($cod_centro, $year)
    {
        $data = array(
            'cod_centro' => $cod_centro,
            'year' => $year,
            'actualizacion_presupuesto' => date("Y-m-d")
        );
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
        return $row->id;
    }

    public function getAll()
    {
        $data = array();
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $sql = "SELECT DISTINCT year FROM imagestion_presupuestos";
        
        $years = $adapter->fetchAll($sql);
        
        $i = 0;
        
        foreach($years as $year){
            
            $y = $year['year'];
            
            $select = $adapter->select();
            $select->from(array('p' => 'imagestion_presupuestos'), array(
                            'id', 'creacion', 'cod_centro', 'year', 'actualizacion_presupuesto'))
                    ->join(array('n' => 'naves'), 'n.cod_centro=p.cod_centro', array('nave' => 'nombre'))
                    ->join(array('e' => 'empresas'), 'e.id=n.empresa_id', array('empresa' => 'nombre')) 
                    ->where("year=?", $y)
                    ->order("e.nombre");

            $presupuestos = $adapter->fetchAll($select); 
            $data[$i]['year'] = $y;
            $data[$i]['presupuestos'] = $presupuestos;
            $i++;
        }
        return  $data;
    }
    
    public function importarPresupuesto($data)
    {
        $imagestion = new Shipcode_Model_Imagestion();
        return $imagestion->cargarPresupuesto($data['cod_centro'], $data['year']);
    }
    
    public function checkPresupuesto($data)
    {
        $where = "year='". $data['year'] ."' AND cod_centro='". $data['cod_centro'] ."'";
        $row = $this->fetchRow($where);
        if($row){
            return TRUE;
        }
        return FALSE;
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - Eliminar Presupuesto");
        }
        
        $where = $this->getAdapter()->quoteInto("id=?", $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
}