<?php
class Shipcode_Model_ImagestionPresupuestoAsignacion extends Zend_Db_Table_Abstract
{
    protected $_name = 'imagestion_presupuestos_asig';
    protected $_primary = 'id';
    
    public function crear($data)
    {
        $row = $this->createRow($data);
        return $row->save();
    }
    
    public function getMontoAsignado($presupuesto_id, $mes, $cod_cuenta)
    {
        $adapter = $this->getAdapter();
        $sql = "SELECT monto FROM imagestion_presupuestos_asig "
             . "WHERE presupuesto_id='$presupuesto_id' AND mes='$mes' AND cod_cuenta='$cod_cuenta' "
             . "LIMIT 1";
        return $adapter->fetchOne($sql);
    }
    
    public function getMontosAsignados($presupuesto_id, $mes, $cod_cuenta)
    {
        $data = array();
        for($i = 1 ; $i <= $mes ; $i++){
            $adapter = $this->getAdapter();
            $sql = "SELECT monto FROM imagestion_presupuestos_asig "
                 . "WHERE presupuesto_id='$presupuesto_id' AND mes='$i' AND cod_cuenta='$cod_cuenta' "
                 . "LIMIT 1";
            $monto = $adapter->fetchOne($sql);
            $data[] = $monto;
        }
        return $data;
    }
    
    public function getTotalMensual($cod_centro, $year = NULL, $month = NULL)
    {
        if($year === NULL){
            $year = date("Y");
        }
        
        if($month === NULL){
            $month = date("m");
        }
        
        $sql = "SELECT SUM(pa.monto) AS total_presupuesto_mensual "
             . "FROM imagestion_presupuestos_asig AS pa "
             . "JOIN imagestion_presupuestos AS p ON p.id=pa.presupuesto_id "
             . "WHERE p.cod_centro='$cod_centro' AND p.year='$year' AND pa.mes='$month'";
        $adapter = $this->getAdapter();
        return $adapter->fetchOne($sql);
    }
    
    public function getTotalMensualCuenta($cod_centro, $cod_cuenta, $year, $month)
    {
        $sql = "SELECT SUM(pa.monto) AS total_presupuesto_mensual "
             . "FROM imagestion_presupuestos_asig AS pa "
             . "JOIN imagestion_presupuestos AS p ON p.id=pa.presupuesto_id "
             . "WHERE p.cod_centro='$cod_centro' AND pa.cod_cuenta='$cod_cuenta' "
             . "AND p.year='$year' AND pa.mes='$month'";
        $adapter = $this->getAdapter();
        return $adapter->fetchOne($sql);
    }
    
    public function getTotalAcumuladoCuenta($cod_centro, $cod_cuenta, $year, $month)
    {
        $sql = "SELECT SUM(pa.monto) AS total_presupuesto_mensual "
             . "FROM imagestion_presupuestos_asig AS pa "
             . "JOIN imagestion_presupuestos AS p ON p.id=pa.presupuesto_id "
             . "WHERE p.cod_centro='$cod_centro' AND pa.cod_cuenta='$cod_cuenta' "
             . "AND p.year='$year' AND pa.mes <= '$month'";
        $adapter = $this->getAdapter();
        return $adapter->fetchOne($sql);
    }
    
    public function getTotalAcumulado($cod_centro, $year = NULL, $month = NULL)
    {
        if($year === NULL){
            $year = date("Y");
        }
        
        if($month === NULL){
            $month = date("m");
        }
        
        $sql = "SELECT SUM(pa.monto) AS total_presupuesto_mensual "
             . "FROM imagestion_presupuestos_asig AS pa "
             . "JOIN imagestion_presupuestos AS p ON p.id=pa.presupuesto_id "
             . "WHERE p.cod_centro='$cod_centro' AND p.year='$year' AND pa.mes <= '$month'";
        $adapter = $this->getAdapter();
        return $adapter->fetchOne($sql);
    }
    
    public function getTotalAnual($cod_centro, $year = NULL)
    {
        if($year === NULL){
            $year = date("Y");
        }
        
        $sql = "SELECT SUM(pa.monto) AS total_presupuesto_anual "
             . "FROM imagestion_presupuestos_asig AS pa "
             . "JOIN imagestion_presupuestos AS p ON p.id=pa.presupuesto_id "
             . "WHERE p.cod_centro='$cod_centro' AND p.year='$year'";
        $adapter = $this->getAdapter();
        return $adapter->fetchOne($sql);
    }
}