<?php
class Shipcode_Model_NaveInformeSolicitudComentario extends Zend_Db_Table_Abstract
{
    protected $_name = 'naves_informes_solicitudes_comentarios';
    protected $_primary = 'id';
    
    public function getRowsBySolicitudId($solicitud_id)
    {
        $where = $this->getAdapter()->quoteInto("solicitud_id=?", $solicitud_id);
        $rows = $this->fetchAll($where);
        if($rows){
            return $rows->toArray();
        }
        return NULL;
    }
    
    public function getPosterioresUltimaVisita($ultimaVisita, $nave_id = NULL)
    {
        $adapter = $this->getAdapter();
        $sql = "SELECT solicitud_id FROM naves_informes_solicitudes_comentarios c ";
        
        if($nave_id != NULL) {
            $sql .= "JOIN naves_informes_solicitudes s ON s.id=c.solicitud_id "
                  . "JOIN naves_informes i ON i.id=s.informe_id ";
        }
             ;
        $sql .= "WHERE c.creacion > '". $ultimaVisita['creacion']. "' "
              . "AND c.creador != '". $ultimaVisita['usuario_id'] ."' ";
        
        if($nave_id != NULL) {
            $options = array('table' => 'naves', 'field' => 'id');
            $validador = new Zend_Validate_Db_RecordExists($options);
            if($validador->isValid($nave_id)){
                $sql .= "AND i.nave_id = '$nave_id'";
            }
        }
        return $adapter->fetchCol($sql);
    }
    
    public function crear($data)
    {
        $row = $this->createRow($data);
        $row->save();
        return $row;
    }
}