<?php
class Shipcode_Model_SistemaImportacionData extends Zend_Db_Table_Abstract
{
    protected $_name = 'sistema_importacion_data';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('sid' => 'sistema_importacion_data'), array('*'))
               ->join(array('sw' => 'sistema_webservices'), 'sw.id=sid.webservice_id', array('webservice' => 'nombre_servicio')) 
               ->order("sw.nombre_servicio");
        return $adapter->fetchAll($select);
    }
    
    public static function getConfigService($webservice_id)
    {
        $adapter = self::getDefaultAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $sql = "SELECT * FROM sistema_importacion_data WHERE webservice_id='$webservice_id'";
        return $adapter->fetchRow($sql);
    }
    
    public function crear($data)
    {
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data, $id)
    {
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - SistemaImportacionData::eliminar() ");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
}