<?php
class Shipcode_Model_AuditoriaInternaArchivo extends Zend_Db_Table_Abstract
{
    protected $_name = 'auditorias_internas_archivos';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = $id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        return $this->fetchAll();
    }
    
    public function getRowsByAuditoriaId($auditoria_id)
    {
        $where = $this->getAdapter()->quoteInto("auditoria_id=?", $auditoria_id);
        return $this->fetchAll($where);
    }

    public function crear($data, $user)
    {
        $result = Shipcode_Archivo::guardar($data['archivo'], 'auditorias-internas/');
        if($result !== FALSE){
            $data['creador'] = $user;
            $data['formato'] = $result;
            $row = $this->createRow();
            $row->setFromArray($data);
            return $row->save();
        } else {
            throw new Exception('No fue posible guardar el archivo en el directorio indicado. La operación fue cancelada.');
        }
    }    
    
    public function editar($data, $user)
    {
        $row = $this->find($data['id'])->current();
        $row->creador = $user;
        $row->nombre = $data['nombre'];
        return $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - AuditoriaInternaArchivo::eliminar()");
        }
        
        $where = $this->getAdapter()->quoteInto("id=?", $this->_id);
        $data = $this->getRow()->toArray();
        
        try {
            
            if(Shipcode_Archivo::borrar($data['archivo'], 'auditorias-internas/')){
                $this->delete($where);
                return $data['auditoria_id'];
            } else {
                return FALSE;
            }
            
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
}