<?php
class Shipcode_Model_AuditoriaInternaPrioridad extends Zend_Db_Table_Abstract
{
    protected $_name = 'auditorias_internas_prioridades';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('aip' => 'auditorias_internas_prioridades'), array('*'))
               ->join(array('su' => 'sistema_usuarios'), 'su.id=aip.creador', array('creada_por' => 'nombre'));
        $rows = $adapter->fetchAll($select);
        return $rows;
    }
    
    public function crear($data, $user)
    {
        $data['creador'] = $user;
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data, $user, $id)
    {
        $data['creador'] = $user;
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - AuditoriaInternaPrioridad::eliminar()");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public static function getPairsToSelect()
    {
        $adapter = self::getDefaultAdapter();
        $sql = 'SELECT id, nombre FROM auditorias_internas_prioridades ORDER BY nombre';
        return $adapter->fetchPairs($sql);
    }
}