<?php
class Shipcode_Model_AuxMes 
{
    public function setMes($mes = NULL)
    {
        $this->_mesActual = $this->_obtenerMesActual($mes);
    }
    
    public function getUltimoDia()
    {
        return $this->_mesActual->get(Zend_Date::MONTH_DAYS);
    }

    public function getFechasNavegacionMensual()
    {
        if(!$this->_mesActual){
            throw new Exception('No se han calculado las fechas de navegación semanal');
        }
        return $this->_obtenerFechasNavegacionMensual();
    }
    
    public function getDiasMes()
    {
        if(!$this->_mesActual){
            throw new Exception('No se han calculado las fechas de navegación semanal');
        }
        $totalDiasMes = $this->_mesActual->get(Zend_Date::MONTH_DAYS);
        
        $mes = clone($this->_mesActual);
        $diasMes = array();
        
        for($i = 1; $i <= $totalDiasMes; $i++) {
            if($i > 1 ) {
                $mes->add(1, Zend_Date::DAY);
            }
            $diaDeLaSemana = $mes->get(Zend_Date::WEEKDAY_8601);
            
            if($i < 10) { 
                $dia = array('fecha' => $mes->toString("YYYY-MM-dd"), 'numero' => '0' . $i);
            } else {
                $dia = array('fecha' => $mes->toString("YYYY-MM-dd"), 'numero' => $i);
            }
            
            if($diaDeLaSemana == 7 || $diaDeLaSemana == 6) {
                $dia['w'] = 1;
            } else {
                $dia['w'] = 0;
            }
            $diasMes[] = $dia;
        }
        return $diasMes;
    }
    
    private function _obtenerMesActual($mes)
    {
        if(!$mes){
            $fecha = new Zend_Date(date("Y-m-d"));
        } else {
            $fecha = new Zend_Date($mes);
        }
        
        $diaDelMes = $fecha->get(Zend_Date::DAY);
        return $fecha->sub($diaDelMes - 1, Zend_Date::DAY);
    }
    
    private function _obtenerFechasNavegacionMensual()
    {
        if(!$this->_mesActual){
            throw new Exception('No se ha configurado el mes actual');
        }
        $actual = clone($this->_mesActual);
        $meses= array(
            'mesVisualizado' => ucfirst($actual->toString("MMMM yyyy")),
            'mesAnterior' => $actual->sub(1,Zend_Date::MONTH)->toString("yyyy-MM-dd"),
            'mesSiguiente' =>$actual->add(2,Zend_Date::MONTH)->toString("yyyy-MM-dd")
            
        );
        return $meses;
    }
}