<?php
class Shipcode_Model_CentroCosto extends Zend_Db_Table_Abstract
{
    protected $_name = 'centros_costo';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('cc' => 'centros_costo'), array('id', 'nombre'));
        $rows = $adapter->fetchAll($select);
        return $rows;
    }
    
    public function crear($data)
    {
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data, $id)
    {
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - CentroCosto::eliminar()");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public static function getPairsToSelect()
    {
        $adapter = self::getDefaultAdapter();
        $sql = "SELECT id, nombre FROM centros_costo ORDER BY nombre";
        return $adapter->fetchPairs($sql);
    }
    
    public static function getIdExistentes()
    {
        $adapter = self::getDefaultAdapter();
        $sql = 'SELECT id FROM centros_costo';
        return $adapter->fetchCol($sql);
    }
}