<?php
class Shipcode_Model_CodigoObservacion extends Zend_Db_Table_Abstract
{
    protected $_name = 'codigos_observaciones';
    protected $_primary = 'codigo';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        return $this->fetchAll(null, 'codigo');
    }
    
    public function crear($data)
    {
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data, $id)
    {
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - Eliminar Código de Observación");
        }
        $where = $this->getAdapter()->quoteInto("codigo=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public static function getPlazo($codigo)
    {
        $adapter = self::getDefaultAdapter();
        $codigo = $adapter->quote((int)$codigo);
        $sql = "SELECT plazo FROM codigos_observaciones WHERE codigo=$codigo";
        return $adapter->fetchOne($sql);
    }
    
    public static function getPairsToSelect()
    {
        $adapter = self::getDefaultAdapter();
        $sql = 'SELECT codigo, codigo FROM codigos_observaciones ORDER BY codigo';
        return $adapter->fetchPairs($sql);
    }
}