<?php
class Shipcode_Model_ConceptoImputacion extends Zend_Db_Table_Abstract
{
    protected $_name = 'conceptos_imputacion';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('ci' => 'conceptos_imputacion'), array('id', 'nombre'));
        $rows = $adapter->fetchAll($select, 'nombre');
        return $rows;
    }
    
    public function crear($data)
    {
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data)
    {
        $row = $this->find($data['vid'])->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - ConceptoImputacion::eliminar()");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public static function getPairsToSelect()
    {
        $adapter = self::getDefaultAdapter();
        $sql = "SELECT id, nombre FROM conceptos_imputacion ORDER BY nombre";
        return $adapter->fetchPairs($sql);
    }
}