<?php
class Shipcode_Model_CuentaGasto extends Zend_Db_Table_Abstract
{
    protected $_name = 'cuentas_gastos';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('cg' => 'cuentas_gastos'), array('id', 'cuenta_id', 'nombre'))
               ->joinLeft(array('cm' => 'cuentas_gastos'), 'cm.id=cg.cuenta_id', array('madre' => 'nombre'))
               ->order('id');
        $rows = $adapter->fetchAll($select);
        return $rows;
    }
    
    public function crear($data)
    {
        if($data['cuenta_id'] == ''){
            $data['cuenta_id'] = NULL;
        }
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data, $id)
    {
        if($data['cuenta_id'] == ''){
            $data['cuenta_id'] = NULL;
        }
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - Eliminar Cuenta  de Gasto");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public static function getPairsToSelect()
    {
        $adapter = self::getDefaultAdapter();
        $sql = 'SELECT id, nombre FROM cuentas_gastos ORDER BY nombre';
        return $adapter->fetchPairs($sql);
    }
    
    public static function getIdExistentes()
    {
        $adapter = self::getDefaultAdapter();
        $sql = 'SELECT id FROM cuentas_gastos';
        return $adapter->fetchCol($sql);
    }
}