<?php
class Shipcode_Model_EquipoMarca extends Zend_Db_Table_Abstract
{
    protected $_name = 'equipos_marcas';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        return $this->fetchAll(null, 'nombre');
    }
    
    public function crear($data, $user)
    {
        $data['creador'] = $user;
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data, $user, $id)
    {
        $data['creador'] = $user;
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - Eliminar Tipo Equipo");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public static function getPairsToSelect()
    {
        $adapter = self::getDefaultAdapter();
        $sql = 'SELECT id, nombre FROM equipos_marcas ORDER BY nombre';
        return $adapter->fetchPairs($sql);
    }

    public function getRowsByTipoEquipoId($tipo_id = NULL)
    {
        if($tipo_id == NULL){
            throw new Exception("No se ha enviado un ID de tipo de equipos");
        }
        
        $adapter = $this->getAdapter();
        $sql = "SELECT DISTINCT(m.id), m.nombre FROM equipos_marcas AS m "
             . "JOIN naves_equipos AS e ON e.marca_id=m.id "
             . "WHERE e.tipo_id='$tipo_id'";
        return $adapter->fetchAll($sql);
    }
}