<?php
class Shipcode_Model_EtiquetaArchivo extends Zend_Db_Table_Abstract
{
    protected $_name = 'etiquetas_archivos';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        return $this->fetchAll()->toArray();
    }
    
    public function getParaNaves()
    {
        return $this->fetchAll("naves='SI'")->toArray();
    }
    
    public function getParaEquipos()
    {
        return $this->fetchAll("equipos='SI'")->toArray();
    }
    
    public function crear($data, $user)
    {
        $data['creador'] = $user;
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data, $user, $id)
    {
        $data['creador'] = $user;
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - EtiquetaArchivo::eliminar() ");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public static function getPairsToSelect($tipo = NULL)
    {
        $adapter = self::getDefaultAdapter();
        $sql = 'SELECT id, nombre FROM etiquetas_archivos';
        if($tipo === "E"){
            $sql .= " WHERE equipos='SI'";
        } elseif($tipo === "N") {
            $sql .= " WHERE naves='SI'";
        }
        $sql .= " ORDER BY nombre";
        return $adapter->fetchPairs($sql);
    }
}