<?php
class Shipcode_Model_Gasto extends Zend_Db_Table_Abstract
{
    protected $_name = 'gastos';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = $id;
    }
    
    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getRowsByEquipoId($equipo_id)
    {
        
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('g' => 'gastos'), array('num_ct', 'num_ot', 'fecha', 'detalles', 'total'))
               ->join(array('p' => 'proveedores'), 'p.rut=g.proveedor_id', array('proveedor' => 'razon_social')) 
               ->where("g.equipo_id=?", $equipo_id)
               ->order("g.id DESC");
        return $adapter->fetchAll($select);
    }
   
}