<?php
class Shipcode_Model_InventarioArticulo extends Zend_Db_Table_Abstract
{
    protected $_name = 'inventario_articulos';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getRowFull()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('ia' => 'inventario_articulos'), array('*'))
               ->join(array('uc' => 'sistema_usuarios'), 'uc.id=ia.creador_id', array('creador' => 'nombre')) 
               ->join(array('ic' => 'inventario_categorias'), 'ic.id=ia.categoria_id', array('categoria' => 'nombre')) 
               ->join(array('im' => 'inventario_marcas'), 'im.id=ia.marca_id', array('marca' => 'nombre'))
               ->where("ia.id=?", $this->_id);
        return $adapter->fetchRow($select);
    }
    
    public function crear($data, $creador_id)
    {
        $data['creador_id'] = $creador_id;
        if($data['observaciones'] == ''){ 
            $data['observaciones'] = NULL;
        }
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
        return $row->id;
    }
    
    public function editar($data, $creador_id, $id)
    {
        $data['creador_id'] = $creador_id;
        if($data['categoria_id'] == ''){ 
            $data['categoria_id'] = NULL;
        }
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
        return $row->id;
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('ia' => 'inventario_articulos'), array('*'))
               ->join(array('uc' => 'sistema_usuarios'), 'uc.id=ia.creador_id', array('creador' => 'nombre')) 
               ->join(array('ic' => 'inventario_categorias'), 'ic.id=ia.categoria_id', array('categoria' => 'nombre')) 
               ->join(array('im' => 'inventario_marcas'), 'im.id=ia.marca_id', array('marca' => 'nombre'))
               ->order("ia.id");
        return $adapter->fetchAll($select);
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - InventarioArticulo::eliminar()");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
}