<?php
class Shipcode_Model_InventarioCategoria extends Zend_Db_Table_Abstract
{
    protected $_name = 'inventario_categorias';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getRowFull()
    {
        return $this->getRow()->toArray();
    }
    
    public function crear($data)
    {
        if($data['categoria_id'] == ''){ 
            $data['categoria_id'] = NULL;
        }
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
        return $row->id;
    }
    
    public function editar($data, $id)
    {
        if($data['categoria_id'] == ''){ 
            $data['categoria_id'] = NULL;
        }
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
        return $row->id;
    }
    
    public function getAll()
    {
        $dataCategorias = array();
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        
        $sqlPadres = "SELECT * FROM inventario_categorias WHERE categoria_id IS NULL ORDER BY nombre";
        $padres = $adapter->fetchAll($sqlPadres);
        
        if(count($padres) > 0) {
            $i = 0;
            foreach($padres as $padre) {
                $dataCategorias[$i] = $padre;
                $dataCategorias[$i]['subcategorias'] = $this->_getSubcategorias($padre['id']);
                $i++;
            }
        }
        return $dataCategorias;
    }
    
    public static function getGroupsToSelect()
    {
        $dataCategorias = array();
        $principales = self::getPairsToSelect();
        foreach($principales as $id => $nombre){
            $dataCategorias[$nombre] =self::getPairsToSelect($id);
        }
        return $dataCategorias;
    }
    
    public static function getPairsToSelect($categoria_id = NULL)
    {
        $adapter = self::getDefaultAdapter();
        $sql = "SELECT id, nombre FROM inventario_categorias";
        if($categoria_id !== NULL) {
            $cat_id = (int)$categoria_id;
            $sql .= " WHERE categoria_id ='$cat_id'";
        } else {
            $sql .= " WHERE categoria_id IS NULL";
        }
        $sql .= " ORDER BY nombre";
        return $adapter->fetchPairs($sql);
    }
    
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - InventarioCategoria::eliminar()");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    private function _getSubCategorias($padre_id)
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $sqlHijas = "SELECT * FROM inventario_categorias WHERE categoria_id = '$padre_id' ORDER BY nombre";
        return $adapter->fetchAll($sqlHijas);
    }
}