<?php
class Shipcode_Model_ListaVerificacion extends Zend_Db_Table_Abstract
{
    protected $_name = 'listas_verificacion';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $sql = "SELECT * FROM $this->_name";
        return $adapter->fetchAll($sql);
    }
    
    public function getItems()
    {
        $item = new Shipcode_Model_ListaVerificacionItem();
        return $item->getRowsByListaId($this->_id);
    }
    
    public function crear($data)
    {
        if($data['observaciones'] == '') { $data['observaciones'] = NULL; }
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
        return $row->id;
    }
    
    public function editar($data)
    {
        if($data['observaciones'] == '') { $data['observaciones'] = NULL; }
        $row = $this->find($data['id'])->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - ListaVerificacion::eliminar()");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function habilitar()
    {
        $row = $this->getRow();
        $row->estado = 'HABILITADA';
        $row->save();
    }
    
    public function deshabilitar()
    {
        $row = $this->getRow();
        $row->estado = 'DESHABILITADA';
        $row->save();
    }
    
    public function clonar($user)
    {
        $original = $this->getRow()->toArray();
        $original['nombre']  = $original['nombre'] . ' - 2';
        unset($original['creador']);
        unset($original['id']);
        
        $nuevo_id = $this->crear($original, $user);
        $items = $this->getItems();
        if(count($items) > 0 ){
            $modelItem = new Shipcode_Model_BasePlanMantItem();
            foreach($items as $item){
                $dataNuevoItem['servicio_id'] = $item->servicio_id;
                $dataNuevoItem['plan_id'] = $nuevo_id;
                $dataNuevoItem['periodo_id'] = $item->periodo_id;
                $dataNuevoItem['cantidad_dias'] = $item->cantidad_dias;
                $dataNuevoItem['cantidad_horas'] = $item->cantidad_horas;
                $dataNuevoItem['dias_aviso'] = $item->dias_aviso;
                $modelItem->crear($dataNuevoItem, $user);        
            }
        }
        return $nuevo_id;
    }
    
    public static function getPairsToSelect()
    {
        $adapter = self::getDefaultAdapter();
        $sql = "SELECT id, nombre FROM listas_verificacion";
        return $adapter->fetchPairs($sql);
    }
}