<?php
class Shipcode_Model_ListaVerificacionAsignacion extends Zend_Db_Table_Abstract
{
    protected $_name = 'listas_verificacion_asignaciones';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_OBJ);
        $select = $adapter->select();
        $select->from(array('a' => $this->_name), array(
                    'id', 'lista_id', 'usuario_id','periodicidad', 
                    'duracion', 'fecha_inicio'))
               ->join(array('l' => 'listas_verificacion'), 'l.id=a.lista_id', array('lista' => 'nombre'))
               ->join(array('u' => 'sistema_usuarios'), 'u.id=a.usuario_id', array('usuario' => 'nombre'));
        return $adapter->fetchAll($select);
    }
    
    public function crear($data)
    {
        $row = $this->createRow();
        $row->setFromArray($data);
        return $row->save();
    }
    
    public function editar($data, $id)
    {
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        return $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - ListaVerificacionAsignacion::eliminar()");
        }
        try {
            $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
            $this->delete($where);
            
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
}