<?php
class Shipcode_Model_ListaVerificacionEmitida extends Zend_Db_Table_Abstract
{
    protected $_name = 'listas_verificacion_emitidas';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_OBJ);
        $select = $adapter->select();
        $select->from(array('l' => $this->_name), array(
                    'id', 'lista_id', 'usuario_id','fecha_inicio', 
                    'fecha_termino', 'estado'))
               ->join(array('l' => 'listas_verificacion'), 'l.id=a.lista_id', array('lista' => 'nombre'))
               ->join(array('u' => 'sistema_usuarios'), 'u.id=a.usuario_id', array('usuario' => 'nombre'));
        return $adapter->fetchAll($select);
    }
    
    public function buscar(array $data) {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('l' => $this->_name), array(
                    'id', 'lista_id', 'usuario_id','fecha_inicio', 
                    'fecha_termino', 'estado'))
               ->join(array('l' => 'listas_verificacion'), 'l.id=a.lista_id', array('lista' => 'nombre'))
               ->join(array('u' => 'sistema_usuarios'), 'u.id=a.usuario_id', array('usuario' => 'nombre'));

        if ($data['estado'] == 0) {
            $select->where("l.estado='ABIERTA'");
        } elseif ($data['estado'] == 1) {
            $select->where("pm.estado ='CERRADA'");
        }

        if ($data['empresa'] != 0) {
            $select->where("n.empresa_id=?", $data['empresa']);
        }

        if ($data['nave'] != 0) {
            $select->where("pm.nave_id=?", $data['nave']);
        }

        $select->order("pm.year DESC");
        $select->order("pm.mes DESC");

        return $adapter->fetchAll($select);
    }
    
    public function crear($data)
    {
        $row = $this->createRow();
        $row->setFromArray($data);
        return $row->save();
    }
    
    public function editar($data, $id)
    {
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        return $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - ListaVerificacionEmitida::eliminar()");
        }
        try {
            $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
            $this->delete($where);
            
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
}