<?php
class Shipcode_Model_NaveCarenaGasto extends Zend_Db_Table_Abstract
{
    protected $_name = 'naves_carenas_gastos';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = $id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }

    public function getDetalle($carena_id)
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(
                    array('ncg' => 'naves_carenas_gastos'), 
                    array(
                        'id', 'creacion', 'creador', 'carena_id', 
                        'cuenta_id', 'monto'
                    ))
               ->join(array('cc' => 'cuentas_carenas'), 'cc.id=ncg.cuenta_id', array('cuenta' => 'nombre')) 
               ->where("ncg.carena_id=?", $carena_id);
        return $adapter->fetchAll($select);
    }
    
    public function crear($data, $user)
    {
        $data['creador'] = $user;
        $row = $this->getGasto($data['carena_id'], $data['cuenta_id']);
        if(!$row) {
            $row = $this->createRow();
        }
        $row->setFromArray($data);
        return $row->save();
    }
    
    public function getGasto($carena_id, $cuenta_id)
    {
        $where = "carena_id='$carena_id' AND cuenta_id='$cuenta_id'";
        return $this->fetchRow($where);
    }
    
    public function editar($data, $user, $id)
    {
        unset($data['id']);
        $data['creador'] = $user;
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID");
        }
        $where = $this->getAdapter()->quoteInto("id=?", $this->_id);
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getDetalleToExport($carena_id)
    {
        $dataGastos = array();
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(
                    array('ncg' => 'naves_carenas_gastos'), 
                    array('cuenta_id', 'monto'))
               ->join(array('cc' => 'cuentas_carenas'), 'cc.id=ncg.cuenta_id', array('cuenta' => 'nombre')) 
               ->where("ncg.carena_id=?", $carena_id);
        $gastos = $adapter->fetchAll($select);
        if(count($gastos) > 0){
            $i = 0;
            foreach($gastos as $gasto){
                $dataGastos[$i]['monto'] = $gasto['monto'];
                $dataGastos[$i]['cuenta'] = array('id' => $gasto['cuenta_id'], 'nombre' => $gasto['cuenta']);
                $i++;
            }
        } 
        return $dataGastos;
    }
}