<?php
class Shipcode_Model_NaveCertificadoArchivo extends Zend_Db_Table_Abstract
{
    protected $_name = 'naves_certificados_archivos';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = $id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        return $this->fetchAll();
    }
    
    public function setFileNotFound($archivoId)
    {
        $row = $this->find($archivoId)->current();
        $row->nombre = $row->nombre . " (NO ENCONTRADO)";
        $row->save();
    }

    public function getRowsByCertificadoId($certificado_id)
    {
        $where = $this->getAdapter()->quoteInto("certificado_id=?", $certificado_id);
        return $this->fetchAll($where);
    }

    public function crear($data, $user)
    {
        if(Shipcode_Archivo::guardar($data['archivo'], 'certificados/')){
            $data['creador'] = $user;
            $row = $this->createRow();
            $row->setFromArray($data);
            return $row->save();
        } else {
            throw new Exception('No fue posible guardar el archivo en el directorio indicado. La operación fue cancelada.');
        }
    }    
    
    public function editar($data, $user)
    {
        $row = $this->find($data['id'])->current();
        $row->creador = $user;
        $row->nombre = $data['nombre'];
        return $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID");
        }
        
        $where = $this->getAdapter()->quoteInto("id=?", $this->_id);
        $data = $this->getRow()->toArray();
        
        try {
            
            if(Shipcode_Archivo::borrar($data['archivo'], 'certificados/')){
                $this->delete($where);
                return $data['certificado_id'];
            } else {
                return FALSE;
            }
            
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getRowsByCertificadoIdToExport($certificado_id)
    {
        $dataArchivos = array();
        $rows = $this->getRowsByCertificadoId($certificado_id);
        if(count($rows) > 0){
            foreach ($rows as $row){
                $dataArchivo['Nombre'] = $row->nombre;
                $dataArchivo['Archivo'] = $row->archivo;
                $dataArchivos[] = $dataArchivo;
            }
        }
        return $dataArchivos;
    }
}