<?php
class Shipcode_Model_NaveCertificadoEmision extends Zend_Db_Table_Abstract
{
    protected $_name = 'naves_certificados_emisiones';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = $id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }

    public function getUltimaEmisionByCertificadoId($certificado_id)
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('ce' => $this->_name), array('fecha_emision', 'fecha_vencimiento'))
               ->where("ce.certificado_id=?", $certificado_id)
               ->order("ce.id DESC")
               ->limit(1); 
        return $adapter->fetchRow($select);
    }
    
    public function crear($data, $user)
    {
        $data['creador'] = $user;
        if($data['fecha_emision']=='') { $data['fecha_emision'] = NULL; }
        if($data['fecha_vencimiento']=='') { $data['fecha_vencimiento'] = NULL; }
        $row = $this->createRow();
        $row->setFromArray($data);
        return $row->save();
    }
    
    public function editarUltimaByNaveId($data, $user)
    {
        $id = $this->_getIdUltimaEmision($data['id']);
        return $this->_editar($data, $user, $id); 
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID");
        }
        
        $where = $this->getAdapter()->quoteInto("id=?", $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    private function _editar($data, $user, $id)
    {
        unset($data['id']);
        $data['creador'] = $user;
        if($data['fecha_emision']=='') { $data['fecha_emision'] = NULL; }
        if($data['fecha_vencimiento']=='') { $data['fecha_vencimiento'] = NULL; }
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    private function _getIdUltimaEmision($certificado_id){
        $adapter = $this->getAdapter();
        $sql = "SELECT id FROM naves_certificados_emisiones "
             . "WHERE certificado_id='$certificado_id' "
             . "ORDER BY id DESC "
             . "LIMIT 1";
        return $adapter->fetchOne($sql);
    }
}