<?php
class Shipcode_Model_NaveEquipoArchivo extends Zend_Db_Table_Abstract
{
    protected $_name = 'naves_equipos_archivos';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = $id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        return $this->fetchAll();
    }
    
    public function setFileNotFound($archivoId)
    {
        $row = $this->find($archivoId)->current();
        $row->nombre = $row->nombre . " (NO ENCONTRADO)";
        $row->save();
    }
    
    public function getEquipoId()
    {
        return $this->getRow()->equipo_id;
    }
    
    public function getRowsByEquipoId($equipo_id)
    {
        $archivos = array();
        $etiqueta = new Shipcode_Model_EtiquetaArchivo();
        $etiquetasEquipo = $etiqueta->getParaEquipos();
        if($etiquetasEquipo > 0){
            foreach($etiquetasEquipo as $etiquetaEquipo){
                
                $rowEtiqueta['id'] = $etiquetaEquipo['id'];
                $rowEtiqueta['nombre'] = $etiquetaEquipo['nombre'];
                    
                $whereEtiqueta = $this->getAdapter()->quoteInto("equipo_id=? AND etiqueta_id='" .$etiquetaEquipo['id'] ."'", $equipo_id);
                $archivosEtiqueta = $this->fetchAll($whereEtiqueta)->toArray();
                
                if(count($archivosEtiqueta) > 0 ) {
                    $rowEtiqueta['archivos'] = $archivosEtiqueta;
                } else {
                    $rowEtiqueta['archivos'] = NULL;
                }
                $archivos[] = $rowEtiqueta;
            }
        } 
        
        $whereOtros = $this->getAdapter()->quoteInto("equipo_id=? AND etiqueta_id IS NULL", $equipo_id);
        
        $otros['id'] = 0;
        $otros['nombre'] = "Otros";
        $otros['archivos'] = $this->fetchAll($whereOtros)->toArray();
        
        $archivos[] = $otros;
        
        return  $archivos;
    }
    
    public function getRowsByEquipoIdToExport($equipo_id)
    {
        $archivos = array();
        $where = $this->getAdapter()->quoteInto("equipo_id=?", $equipo_id);
        $rows = $this->fetchAll($where);
        if(count($rows) > 0 ) {
            foreach($rows as $row){
                $archivo['Nombre'] = $row->nombre;
                $archivo['Archivo'] = $row->archivo;
                $archivos[] = $archivo;
            }
        } 
        return $archivos;
    }
    
    public function getEquipo()
    {
        $modelEquipo = new Shipcode_Model_NaveEquipo();
        $modelEquipo->setId($this->getRow()->equipo_id);
        return $modelEquipo->getRowFull();
    }
    
    public function crear($data, $user)
    {
        if(Shipcode_Archivo::guardar($data['archivo'], 'equipos/')){
            $data['creador'] = $user;
            $row = $this->createRow();
            $row->setFromArray($data);
            return $row->save();
        } else {
            throw new Exception('No fue posible guardar el archivo en el directorio indicado. La operación fue cancelada.');
        }
    }
    
    public function editar($data, $user, $id)
    {
        $data['creador'] = $user;
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID");
        }
        $where = $this->getAdapter()->quoteInto("id=?", $this->_id);
        try {
            if(Shipcode_Archivo::borrar($this->getRow()->archivo, 'equipos/')){
                $this->delete($where);
            }
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
}