<?php
class Shipcode_Model_NaveEquipoParte extends Zend_Db_Table_Abstract
{
    protected $_name = 'naves_equipos_partes';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = $id;
    }
    
    public function getEquipo()
    {
        $modelEquipo = new Shipcode_Model_NaveEquipo();
        $modelEquipo->setId($this->getEquipoId());
        return $modelEquipo->getRowFull();
    }
    
    public function getEquipoId()
    {
        return $this->getRow()->equipo_id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getRowsByEquipoId($equipo_id)
    {
        $where = $this->getAdapter()->quoteInto("equipo_id=?", $equipo_id);
        return $this->fetchAll($where);
    }

    public function crear($data, $user)
    {
        $data['creador'] = $user;
        if($data['num_parte']=='') { $data['num_parte'] = NULL; }
        if($data['detalles']=='') { $data['detalles'] = NULL; }
        if($data['cantidad']=='') { $data['cantidad'] = NULL; }
        $row = $this->createRow();
        $row->setFromArray($data);
        return $row->save();
    }
    
    public function editar($data, $user, $id)
    {
        unset($data['id']);
        $data['creador'] = $user;
        if($data['num_parte']=='') { $data['num_parte'] = NULL; }
        if($data['detalles']=='') { $data['detalles'] = NULL; }
        if($data['cantidad']=='') { $data['cantidad'] = NULL; }
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID");
        }
        
        $where = $this->getAdapter()->quoteInto("id=?", $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function eliminarPorEquipoId($equipo_id)
    {
        $where = $this->getAdapter()->quoteInto("equipo_id=?", $equipo_id);
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
}