<?php
class Shipcode_Model_NaveEquipoUbicacion extends Zend_Db_Table_Abstract
{
    protected $_name = 'naves_equipos_ubicaciones';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = $id;
    }
    
    public function getEquipoId()
    {
        return $this->getRow()->equipo_id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getNombre()
    {
        $nombre = '';
        $row = $this->getRow()->toArray();
        if($row['sistema_id'] != NULL && $row['sistema_id'] != ''){
            $sistema = new Shipcode_Model_NaveSistema();
            $sistema->setId($row['sistema_id']);
            $nombre = $sistema->getNombreToUbicacion();
        }
        
        if($row['ubicacionv_id'] != NULL && $row['ubicacionv_id'] != ''){
            $ubicacionVirtual = new Shipcode_Model_UbicacionVirtual();
            $ubicacionVirtual->setId($row['ubicacionv_id']);
            $nombre = $ubicacionVirtual->getRow()->nombre;;
        }
        
        return $nombre;
    }
    
    public function getRowsByEquipoId($equipo_id, $count = NULL)
    {
        $data = array();
        $where = $this->getAdapter()->quoteInto("equipo_id=?", $equipo_id);
        $order = "id DESC";

        if($count != NULL && is_int($count)){
            $rows = $this->fetchAll($where, $order, $count, 0);
        } else {
            $rows = $this->fetchAll($where, $order);
        }
        
        foreach($rows as $row){
            
            $ubicacion['fecha_entrada'] = $row->fecha_entrada;
            $ubicacion['fecha_salida'] = $row->fecha_salida;
            $ubicacion['observaciones'] = $row->observaciones;
            if($row->ubicacionv_id != NULL){
                $ubicacion['lugar'] = $this->_getNombreUbicacionVirtual($row->ubicacionv_id);
            } elseif($row->sistema_id != NULL){
                $ubicacion['lugar'] = $this->_getNombreSistema($row->sistema_id);
            }
            
            $data[] = $ubicacion;
            
        }
        return $data;
    }
    
    public function getLastByEquipoId($equipo_id)
    {
        $adapter = $this->getAdapter();
        $sql = "SELECT u.id FROM naves_equipos_ubicaciones AS u "
             . "WHERE u.equipo_id='$equipo_id' "
             . "AND fecha_salida IS NULL "
             . "ORDER BY id DESC";
        return $adapter->fetchOne($sql);
    }
    
    private function _getNombreSistema($id)
    {
        $sistema = new Shipcode_Model_NaveSistema();
        $sistema->setId($id);
        return $sistema->getNombreToUbicacion();
    }
    
    private function _getNombreUbicacionVirtual($id)
    {
        $ubicacionVirtual = new Shipcode_Model_UbicacionVirtual();
        $ubicacionVirtual->setId($id);
        return $ubicacionVirtual->getRow()->nombre;
    }

    public function crear($data, $user)
    {
        $data['creador'] = $user;
        if($data['ubicacionv_id'] == '' )   { $data['ubicacionv_id'] = NULL; }
        if($data['sistema_id'] == '' )      { $data['sistema_id'] = NULL; }
        if($data['observaciones'] == '' )   { $data['observaciones'] = NULL; }
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
        return $row->id;
    }
    
    public function cerrar()
    {
        $fechaSalida = new Zend_Date();
        $row = $this->getRow();
        $row->fecha_salida = $fechaSalida->toString("yyyy-MM-dd");
        $row->save();
    }
}