<?php
class Shipcode_Model_NaveParametroLectura extends Zend_Db_Table_Abstract
{
    protected $_name = 'naves_parametros_lecturas';
    protected $_primary = 'id';
    
    public function setId($id)
    {
        $this->_id = $id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getEquipoId()
    {
        return $this->getRow()->equipo_id;
    }
    
    public function guardar($data)
    {
        $row = $this->_checkExists($data);
        if($row === FALSE){
            $row = $this->createRow();
        } 
        $row->setFromArray($data);
        $row->save();
    }
    
    private function _checkExists($data)
    {   
        $where = "equipo_id ='" . $data['equipo_id'] . "' AND parametro_id = '" . $data['parametro_id'] . "' AND fecha='" . $data['fecha'] . "'";
        $row = $this->fetchRow($where);
        if($row){
            return $row;
        }
        return FALSE;
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - NaveParametroLectura::eliminar()");
        }
        
        $where = $this->getAdapter()->quoteInto("id=?", $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function eliminarHistorial($equipo_id = NULL)
    {
        if(NULL == $equipo_id) {
            throw new Exception("No se ha configurado el ID del equipo");
        }
        $where = $this->getAdapter()->quoteInto("equipo_id=?", $equipo_id);
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }

    public function getRequeridosByNaveId($nave_id)
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $sql = "SELECT ne.parametros FROM naves_equipos AS ne "
             . "JOIN naves_equipos_ubicaciones AS neu ON neu.id=ne.ubicacion_id "
             . "JOIN naves_sistemas AS ns ON ns.id=neu.sistema_id "
             . "WHERE ns.nave_id='$nave_id' AND ne.parametros IS NOT NULL";
        $dataParametros = $adapter->fetchCol($sql);
        $parametros = array();
        foreach($dataParametros as $dataParametro){
            $arrayParametros = explode(",", $dataParametro);
            foreach($arrayParametros as $valor){
                if(!in_array($valor, $parametros)){
                    $parametros[] = $valor; 
                }
            }
           
        }
        return $parametros;
    }
    
    public function getUltimaLecturaByEquipoIdAndParametroId($equipo_id, $parametro_id, $estado = 1)
    {
        $adapter = $this->getAdapter();
        $sql = "SELECT parametro_id, equipo_id, fecha, lectura, DATEDIFF(NOW(), fecha) AS dias_ultima_lectura "
             . "FROM $this->_name "
             . "WHERE equipo_id='$equipo_id' "
             . "AND parametro_id='$parametro_id' "; 
        /*
        if($estado === 1){
            $sql .= "AND estado='1' ";
        }
        */
        $sql .=  "ORDER BY fecha DESC LIMIT 1";
        return $adapter->fetchRow($sql, NULL, Zend_Db::FETCH_ASSOC);
    }
}