<?php
class Shipcode_Model_Proveedor extends Zend_Db_Table_Abstract
{
    protected $_name = 'proveedores';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }
    
    public static function getIdByRut($rut)
    {
        $adapter = self::getDefaultAdapter();
        $sql = "SELECT id FROM proveedores WHERE rut='$rut'";
        $result = $adapter->fetchOne($sql);
        if($result){
            return $result;
        }
        return FALSE;
    }
    
    public static function getRutById($id)
    {
        $adapter = self::getDefaultAdapter();
        $sql = "SELECT rut FROM proveedores WHERE id='$id'";
        $result = $adapter->fetchOne($sql);
        if($result){
            return $result;
        }
        return FALSE;
    }
    
    public static function getRazonSocialById($id)
    {
        $adapter = self::getDefaultAdapter();
        $sql = "SELECT razon_social FROM proveedores WHERE id='$id'";
        $result = $adapter->fetchOne($sql);
        if($result){
            return $result;
        }
        return FALSE;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getRowFull()
    {
        return $this->getRow()->toArray();
    }
    
    public function getAll()
    {
        return $this->fetchAll(null, 'razon_social')->toArray();
    }
    
    public function crear($data)
    {
        if($data['direccion'] == '') {$data['direccion'] = NULL;}
        if($data['telefono'] == '') {$data['telefono'] = NULL;}
        if($data['ciudad'] == '') {$data['ciudad'] = NULL;}
        if($data['contacto'] == '') {$data['contacto'] = NULL;}
        if($data['email'] == '') {$data['email'] = NULL;}
        if($data['giro'] == '') {$data['giro'] = NULL;}
        $data['rut'] = App_Rut::cleanToDb($data['rut']);
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
        return $row->id;
    }
    
    public function editar($data, $id)
    {
        if($data['direccion'] == '') {$data['direccion'] = NULL;}
        if($data['telefono'] == '') {$data['telefono'] = NULL;}
        if($data['ciudad'] == '') {$data['ciudad'] = NULL;}
        if($data['contacto'] == '') {$data['contacto'] = NULL;}
        if($data['email'] == '') {$data['email'] = NULL;}
        if($data['giro'] == '') {$data['giro'] = NULL;}
        $data['rut'] = App_Rut::cleanToDb($data['rut']);
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
        return $row->id;
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - Proveedor::eliminar()");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public static function getPairsToSelect()
    {
        $adapter = self::getDefaultAdapter();
        $sql = 'SELECT id, nombre_fantasia FROM proveedores ORDER BY nombre_fantasia';
        return $adapter->fetchPairs($sql);
    }
    
    public static function getRutExistentes()
    {
        $adapter = self::getDefaultAdapter();
        $sql = 'SELECT rut FROM proveedores';
        return $adapter->fetchCol($sql);
    }
}