<?php
class Shipcode_Model_SistemaInformeAutomatico extends Zend_Db_Table_Abstract
{
    protected $_name = 'sistema_mensajes_auto';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }
    
    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('sia' => 'sistema_mensajes_auto'), array('id', 'informe_id', 'usuario_id', 'dia', 'con_copia', 'con_copia_oculta', 'mensaje'))
               ->join(array('sip' => 'sistema_informes_preconfig'), 'sia.informe_id=sip.id', array('nombre', 'tipo', 'base', 'modelo', 'parametros')) 
               ->join(array('u' => 'sistema_usuarios'), 'sia.usuario_id=u.id', array('usuario' => 'nombre', 'mail'));
        return $adapter->fetchAll($select);
    }
    
    public function crear($data, $user)
    {
        $data['creador'] = $user;
        $data['con_copia'] = $this->_validarCorreos($data['con_copia']);
        $data['con_copia_oculta'] = $this->_validarCorreos($data['con_copia_oculta']);
        if($data['mensaje'] == '') { $data['mensaje'] = NULL; }
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data, $user, $id)
    {
        $data['creador'] = $user;
        $data['con_copia'] = $this->_validarCorreos($data['con_copia']);
        $data['con_copia_oculta'] = $this->_validarCorreos($data['con_copia_oculta']);
        if($data['mensaje'] == '') { $data['mensaje'] = NULL; }
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        if($this->delete($where)){
            return TRUE;
        }
        return FALSE;
    }
    
    private function _validarCorreos($correos)
    {
        $correosAprobados = array();
        if($correos !== '') {
            $data = explode(",", $correos);
            if(count($data) > 0) {
                $validadorEmail = new Zend_Validate_EmailAddress();
                for($i = 0; $i < count($data) ; $i++){
                    if($validadorEmail->isValid(trim($data[$i]))){
                        $correosAprobados[] = trim($data[$i]);
                    }
                }
                return implode(",", $correosAprobados);
            }
        }
        return NULL;
    }
}