<?php
class Shipcode_Model_SistemaInformePreconfigurado extends Zend_Db_Table_Abstract
{
    protected $_name = 'sistema_informes_preconfig';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }
    
    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        return $this->fetchAll("estado='1'");
    }
    
    public static function getToMenu()
    {
        $adapter = self::getDefaultAdapter();
        $sql = "SELECT * FROM sistema_informes_preconfig WHERE estado='1'";
        return $adapter->fetchAll($sql, array(), Zend_Db::FETCH_ASSOC);
    }
    
    public static function getPairsToSelect()
    {
        $adapter = self::getDefaultAdapter();
        $sql = "SELECT id, nombre FROM sistema_informes_preconfig WHERE estado='1'";
        return $adapter->fetchPairs($sql);
    }
    
    public function crear($parametros, $base, $tipo, $modelo)
    {
        $row = $this->createRow();
        $row->parametros = Zend_Json::encode($parametros);
        $row->base = $base;
        $row->nombre = $tipo;
        $row->tipo = $tipo;
        $row->modelo = $modelo;
        $row->save();
        return $row->id;
    }
    
    public function editar($data)
    {
        $row = $this->find($data['id'])->current();
        $row->nombre = $data['nombre'];
        $row->estado = 1;
        $row->save();
    }
    
    public function eliminar()
    {
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        if($this->delete($where)){
            return TRUE;
        }
        return FALSE;
    }
}