<?php
class Shipcode_Model_SistemaLogActividad extends Zend_Db_Table_Abstract
{
    protected $_name = 'sistema_log_actividades';
    protected $_primary = 'id';
    
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('sli' => 'sistema_log_ingresos'), array('id', 'creador', 'usuario_id', 'cierre'))
                ->join(array('su' => 'sistema_usuarios'), 'su.id=sli.usuario_id', array('usuario' => 'nombre')) 
                ->order("sli.id DESC");
        return $adapter->fetchAll($select);
    }
    
    public function getLastByUsuarioId($usuario_id)
    {
        $where = $this->getAdapter()->quoteInto("usuario_id=?", $usuario_id);
        $row = $this->fetchRow($where, "id DESC");
        if($row){
            return $row->creacion;
        }
        return NULL;
    }
    
    public static function getVisitaAnteriorByUsuarioId($usuario_id)
    {
        $adapter = self::getDefaultAdapter();
        $sql = "SELECT * FROM sistema_log_ingresos WHERE usuario_id='$usuario_id' ORDER BY id DESC LIMIT 1,1";
        $data = $adapter->fetchRow($sql, NULL, Zend_Db::FETCH_ASSOC);
        if($data){
            return $data;
        }
        return NULL;
    }
    
    public function getRowsByUsuarioId($usuario_id)
    {
        $where = $this->getAdapter()->quoteInto("usuario_id=?", $usuario_id);
        return $this->fetchAll($where, 'id DESC', 20);
    }
    
    public function registrar($session_id, $params, $ip_address = NULL)
    {
        $row = $this->createRow(array('session_id' => $session_id, 'params' => $params, 'ip' => $ip_address));
        $row->save();
    }
}