<?php
class Shipcode_Model_SistemaPreferencia extends Zend_Db_Table_Abstract
{
    protected $_name = 'sistema_preferencias';
    protected $_primary = 'id';

    private $_id = NULL;
    
    public function setId($id)
    {
        $id = (int)$id;
        $options = array('table' => $this->_name, 'field' => $this->_primary);
        $validador = new Zend_Validate_Db_RecordExists($options);
        
        if(!$validador->isValid($id)){
            throw new Exception("El ID configurado no existe");
        }
        
        $this->_id = $id;
    }
    
    public function getValidador()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID");
        }
        
        $row = $this->find($this->_id)->current();
        
        if($row->validador=='Float'){
            return new App_Validate_Float();
        }
        
        if($row->validador=='Int'){
            return new Zend_Validate_Int();
        }
    }
    
    public function getRow()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID");
        }
        $row = $this->find($this->_id)->current();
        return $row;
    }
    
    public function editar($valor, $id)
    {
        $row = $this->find($id)->current();
        $row->valor = $valor;
        $row->save();
    }
    
    public function getAll($tipo = NULL)
    {
        $order = "nombre";
        $where = NULL;
        if($tipo!=NULL){
            $where = $this->getAdapter()->quoteInto("tipo=?",$tipo);
        }
        
        return $this->fetchAll($where, $order);
    }        

    public static function getPref($name)
    {
        $adapter = self::getDefaultAdapter();
        $var = $adapter->quote($name);
        return $adapter->fetchOne("SELECT valor FROM sistema_preferencias WHERE nombre=$var LIMIT 1");
    }
}