<?php
class Shipcode_Model_SistemaUnidad extends Zend_Db_Table_Abstract
{
    protected $_name = 'sistema_unidades';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }
    
    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        return $this->fetchAll(null, 'nombre');
    }
    
    public static function getPairsToSelect()
    {
        $sql = "SELECT id,nombre FROM sistema_unidades ORDER BY nombre";
        $adapter = self::getDefaultAdapter();
        return $adapter->fetchPairs($sql);
    }
    
    public function crear($data)
    {
        if($data['simbolo'] == '') { $data['simbolo'] = NULL; }
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data, $id)
    {
        if($data['simbolo'] == '') { $data['simbolo'] = NULL; }
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        if($this->delete($where)){
            return TRUE;
        }
        return FALSE;
    }
}