<?php
class Shipcode_Model_TipoEquipo extends Zend_Db_Table_Abstract
{
    protected $_name = 'equipos_tipos';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_OBJ);
        $sql = "SELECT t.id, t.creacion, t.creador, t.nombre,  "
             . "(SELECT COUNT(*) FROM naves_equipos AS e WHERE e.tipo_id=t.id) AS num_equipos "
             . "FROM equipos_tipos AS t ORDER BY t.nombre";
        return $adapter->fetchAll($sql);
    }
    
    public function crear($data, $user)
    {
        $data['creador'] = $user;
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data, $user, $id)
    {
        $data['creador'] = $user;
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - Eliminar Tipo Equipo");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public static function getPairsToSelect()
    {
        $adapter = self::getDefaultAdapter();
        $sql = 'SELECT id, nombre FROM equipos_tipos ORDER BY nombre';
        return $adapter->fetchPairs($sql);
    }
    
    public function codificarDatos()
    {
        $i = 0;
        
        try {
            
            $rows = $this->fetchAll();
            foreach($rows as $row){

                $row->nombre = utf8_encode($row->nombre);
                $row->save();
                $i++;
               
            }
            return "Se actualizaron los datos de $i tipos de equipos";
            
        } catch(Exception $e){
            
            return $e->getMessage();
            
        }
    }
}