<?php
class Shipcode_Model_TipoMantenimiento extends Zend_Db_Table_Abstract
{
    protected $_name = 'mantenimientos_tipos';
    protected $_primary = 'id';
    
    private $_id;
    
    public function setId($id)
    {
        $this->_id = (int)$id;
    }

    public function getRow()
    {
        return $this->find($this->_id)->current();
    }
    
    public function getAll()
    {
        $adapter = $this->getAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_OBJ);
        $sql = "SELECT t.id, t.creacion, t.creador, t.nombre, t.grupo  "
             . "FROM mantenimientos_tipos AS t ORDER BY t.nombre";
        return $adapter->fetchAll($sql);
    }
    
    public function crear($data, $user)
    {
        $data['creador'] = $user;
        $row = $this->createRow();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function editar($data, $user, $id)
    {
        $data['creador'] = $user;
        $row = $this->find($id)->current();
        $row->setFromArray($data);
        $row->save();
    }
    
    public function eliminar()
    {
        if(NULL == $this->_id) {
            throw new Exception("No se ha configurado el ID - Eliminar Tipo Equipo");
        }
        $where = $this->getAdapter()->quoteInto("id=?",  $this->_id);
        
        try {
            $this->delete($where);
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public static function getPairsToSelect($grupo = NULL)
    {
        $adapter = self::getDefaultAdapter();
        $sql = "SELECT id, nombre FROM mantenimientos_tipos ";
        if($grupo !== NULL){
            $sql .= "WHERE grupo='$grupo' ";
        }
        $sql .= "ORDER BY nombre";
        return $adapter->fetchPairs($sql);
    }
    
    public static function getGrupoToSelect($tipo_id)
    {
        $adapter = self::getDefaultAdapter();
        
        $sqlGrupo = "SELECT grupo FROM mantenimientos_tipos WHERE id='$tipo_id'";
        $grupo = $adapter->fetchOne($sqlGrupo);
        
        $sqlPares = "SELECT id, nombre FROM mantenimientos_tipos WHERE grupo='$grupo' ORDER BY nombre";
        return $adapter->fetchPairs($sqlPares);
    }
}