<?php
class Shipcode_Model_VistaUsuarios extends Zend_Db_Table_Abstract
{
    protected $_name = 'vista_usuarios';
    protected $_primary = 'id';
 
    public static function getRowById($usuario_id)
    {
        $adapter = self::getDefaultAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('vu' => 'vista_usuarios'), array('*'))
               ->where('vu.id=?', $usuario_id);
        return $adapter->fetchRow($select);
    }
    
    public static function getAll($perfil_start = NULL, $perfil_end = NULL, $estado = 1)
    {
        $data = array();
        $adapter = self::getDefaultAdapter();
        $adapter->setFetchMode(Zend_Db::FETCH_ASSOC);
        $select = $adapter->select();
        $select->from(array('vu' => 'vista_usuarios'), array( '*'));
        
        if($estado !== NULL){
            $select->where("vu.estado = ?", $estado);
        }
        
        if($perfil_start !== NULL){
            $select->where("vu.perfil_id >= ?", $perfil_start);
        }
        
        if($perfil_end !== NULL){
            $select->where("vu.perfil_id <= ?", $perfil_end);
        }
        
        $usuarios = $adapter->fetchAll($select);
        foreach($usuarios as $usuario){
            $row = $usuario;
            $row['ultimo_acceso'] = Shipcode_Model_SistemaLogIngreso::getLastByUsuarioId($row['id']);
            $data[] = $row;
        }
        return $data;
    }
}