/******************** FUNCIONES EN PROCESO DE ELIMINACIÓN *********************/
var actualizarBotonReprogramacion = function (data)
{
    if(data.estado === '1'){
        $("#br" + data.id).removeClass('btn-warning');
        $("#br" + data.id).addClass('btn-success');
        $("#br" + data.id).text('Sí');
    } else if(data.estado === '0'){
        $("#br" + data.id).removeClass('btn-success');
        $("#br" + data.id).addClass('btn-warning');
        $("#br" + data.id).text('No');
    }
};
var getDataInforme = function()
{
    var inputs = $("input.input-valor-parametro");
    var data = [];
    
    for( i = 0 ; i < inputs.length ; i++ ){
        equipo[0] = '';
    }
    
    return data;
};
var checkCamposVacios = function()
{
    var inputs = $("table.table-informe input[type=text]");
    var camposVacios = 0;
    for(i=0; i< inputs.length; i++){
        if(inputs[i].value === ''){
            camposVacios++;
        }
    }
    return camposVacios;
};
var cargarCapturaHorometro = function(id)
{
    $("#popup-horometro div.modal-header h4").html($(id).attr('title'));
    $("#popup-horometro div.modal-body form#form-lectura-horometro").attr('action', $(id).attr('data-url'));
    $("#popup-horometro div.modal-body form#form-lectura-horometro input#back").attr('value', $(id).attr('data-back'));
};
/*******************************************************************************/ 

/*************************** FUNCTIONES AJAX 
 ******************************************************************************/
// LLAMADAS AJAX QUE DEVUELVEN JSON
var guardarArchivoMantenimiento = function(idForm, idTable)
{
    $.ajax({
        dataType: 'json',
        type: "POST",
        url: $(idForm).attr("action"),
        data : getInputsAjax(idForm),
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    agregarFilaTablaArchivosMantenimiento(requestData, idTable);
                    resetearForm(idForm);
                    $("#archivo, #submit").attr('disabled', 'disabled');
                    $(idForm).hide();
                    $("#selector-archivo-mantenimiento").show();

                    if(requestData.num > 0){
                        $("#m"+ requestData.mid +" span").attr('class', 'glyphicon glyphicon-folder-open');
                    }
                } 
            }
        }
    });
};

var filtrarOtrosEquipos = function()
{
    $.ajax({
        dataType: 'json',
        type: "POST",
        url: $("#filtrar-otros-servicios").attr('action'),
        data: getInputsAjax("#filtrar-otros-servicios"),
        beforeSend: function(){
            $("#listado-otros-servicios tbody").html('<td colspan="4">Filtrando servicios...</td>');
        },
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                $("#listado-otros-servicios tbody").html('');

                if(requestData !== null) {
                    for (var x = 0; x < requestData.length; x++) { 
                        var filaServicio = '<tr><td width="20" class="text-center">'
                                         + '<a href="/equipo-mantenimiento/agregar" data-servicio="' + requestData[x].id + '"'
                                         + 'class="btn btn-xs btn-info agregar-mantenimiento" '
                                         + 'title="Agregar al reporte"><span class="glyphicon glyphicon-arrow-left"></span></a></td>'
                                         + '<td>' + requestData[x].nombre + '</td>'
                                         + '</tr>';
                        $("#listado-otros-servicios tbody").append(filaServicio);
                    }
                } else {
                    var info = '<tr><td colspan="2"><span class="text-muted">No se encontraron coincidencias</span></td></tr>';
                    $("#listado-otros-servicios tbody").append(info);
                }
            }  
        },
        error : function(){
            alert('Ocurrió un error al intentar filtrar los servicios');
        }
    });
};

var guardarArchivoSiniestro = function(idForm, idTable)
{
    $.ajax({
        dataType: 'json',
        type: "POST",
        url: $(idForm).attr("action"),
        data : getInputsAjax(idForm),
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    agregarFilaTablaArchivosSiniestro(requestData, idTable);
                    resetearForm(idForm);
                    $("#archivo, #submit").attr('disabled', 'disabled');
                    $(idForm).hide();
                    $("#selector-archivo-siniestro").show();

                    if(requestData.num > 0){
                        $("#s"+ requestData.sid +" span").attr('class', 'glyphicon glyphicon-folder-open');
                    }
                }
            }     
        }
    });
};

var guardarArchivoCarena = function(idForm, idTable)
{
    $.ajax({
        dataType: 'json',
        type: "POST",
        url: $(idForm).attr("action"),
        data : getInputsAjax(idForm),
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    agregarFilaTablaArchivosCarena(requestData, idTable);
                    resetearForm(idForm);
                    $("#archivo, #submit").attr('disabled', 'disabled');
                    $(idForm).hide();
                    $("#selector-archivo-carena").show();

                    if(requestData.num > 0){
                        $("#c"+ requestData.cid +" span").attr('class', 'glyphicon glyphicon-folder-open');
                    }
                }
            }    
        }
    });
};

var cargarGraficaGastosEmpresa = function(empresaId, year)
{
    $.ajax({
        dataType: 'html',
        type: "POST",
        url: '/empresa/grafica-gastos/' + empresaId + '/' + year,
        success: function(requestData){
            if(requestData === '{"sessionError":true}'){
                terminarSesion();
            } else {
                $("#cont-grafica-gastos").append(requestData);
            }
        }
    });
};

var armarGraficaHorasOperacionMensual = function(dataHorasOperacion)
{
    var dataCategorias = [];
    var dataSeries = [];
    if(dataHorasOperacion.length > 0){
        for(i = 0; i < dataHorasOperacion.length ; i++){
            dataCategorias[i] = dataHorasOperacion[i]['nombre'];
            dataSeries[i] = dataHorasOperacion[i]['totalHoras'];
        }
    }
    chart = new Highcharts.Chart({
        chart: {
            renderTo: 'grafica-operacion',
            type: 'line'
        },
        title: {
            text: '',
            x: -20 //center
        },
        xAxis: {
            categories: dataCategorias
        },
        yAxis: {
            title: {
                text: 'Horas de operación'
            },
            plotLines: [{
                value: 0,
                width: 1,
                color: '#808080'
            }]
        },
        tooltip: {
            formatter: function() {
                    return '<b>'+ this.series.name +'</b><br/>'+
                    this.x +': '+ this.y +' Hrs';
            }
        },
        legend: {
            enabled: false
        },
        credits : {
            enabled: false
        },
        series: [{
            name: 'Horas de operación',
            data: dataSeries
        }]
    });
    return chart;
};

var actualizarContadorSeleccionados = function(valor)
{
    var nuevoValor = parseInt($("#numSeleccionados").html()) + valor;
    if(nuevoValor > 0) {
        $("#exportar-seleccion").removeAttr('disabled');
        $("#reset-equipos-seleccionados").removeAttr('disabled');
    } else {
        $("#exportar-seleccion").attr('disabled', 'disabled');
        $("#reset-equipos-seleccionados").attr('disabled', 'disabled');
    }
    $("#numSeleccionados").html(nuevoValor);
}; 

var agregarRegistroMantenimiento = function(data)
{
    var fila = '<tr id="m' + data.id + '">'
             + '<td>' + data.fecha + '</td>'
             + '<td>' + data.horometro + '</td>'
             + '<td>' + data.tipo + '</td>'
             + '<td>' + data.detalles + '</td>'
             + '<td>' + data.observaciones + '</td>'
             + '<td width="20" class="text-center">'
             + '<a data-url="/equipo-mantenimiento/editar/' + data.id + '" data-toggle="modal" href="#popup-mantenimiento" data-title="Editar mantenimiento" title="Editar ítem" class="cargar-popup">'
             + '<span class="glyphicon glyphicon-pencil"></span>'
             + '</a></td>'
             + '<td width="20" class="text-center">'
             + '<a href="/equipo-mantenimiento/eliminar/' + data.id + '" title="Eliminar ítem" class="eliminar-registro-mantenimiento">'
             + '<span class="glyphicon glyphicon-remove"></span>'
             + '</a></td>'
             + '</tr>';
      
    $("#registro-mantenimientos").append(fila);
};

var agregarFilaTablaArchivosMantenimiento = function(data, idTable)
{
    var content = '<tr id="f' + data.id + '" class="files">'
                + '<td width="20" class="text-center"><a href="/equipo-mantenimiento-archivo/descargar/' + data.id 
                + '" title="Descargar archivo"><span class="glyphicon glyphicon-download"></span></a></td>'
                + '<td>' + data.nombre + '</td>'
                + '<td width="20" class="text-center">'
                + '<a href="/equipo-mantenimiento-archivo/eliminar/' + data.id + '" title="Eliminar archivo" class="eliminar-archivo-mantenimiento" '
                + 'data-alert="¿Seguro que desea eliminar este archivo?. Esta operación no es reverible">'
                + '<span class="glyphicon glyphicon-remove"></span></a></td>'
                + '</tr>';
   var numRows = $(idTable + " tbody tr.files").length;
   if(numRows === 0) {
       $(idTable + " tbody").html('');
   }
   $(idTable).append(content);         
};

var agregarFilaTablaArchivosSiniestro = function(data, idTable)
{
    var content = '<tr id="r' + data.id + '" class="files">'
                + '<td width="20" class="text-center"><a href="/nave-siniestro-archivo/descargar/' + data.id 
                + '" title="Descargar archivo"><span class="glyphicon glyphicon-download"></span></a></td>'
                + '<td>' + data.nombre + '</td>'
                + '<td width="20" class="text-center">'
                + '<a href="/nave-siniestro-archivo/eliminar/' + data.id + '" title="Eliminar archivo" class="eliminar-archivo-siniestro" '
                + 'data-alert="¿Seguro que desea eliminar este archivo?. Esta operación no es reverible">'
                + '<span class="glyphicon glyphicon-remove"></span></a></td>'
                + '</tr>';
    var numRows = $(idTable + " tbody tr.files").length;
    if(numRows === 0) {
        $(idTable + " tbody").html('');
    }    
    $(idTable).append(content);         
};

var agregarFilaTablaArchivosCarena = function(data, idTable)
{
    var content = '<tr id="r' + data.id + '" class="files">'
                + '<td width="20" class="text-center"><a href="/nave-carena-archivo/descargar/' + data.id 
                + '" title="Descargar archivo"><span class="glyphicon glyphicon-download"></span></a></td>'
                + '<td>' + data.nombre + '</td>'
                + '<td width="20" class="text-center">'
                + '<a href="/nave-carena-archivo/eliminar/' + data.id + '" title="Eliminar archivo" class="eliminar-archivo-carena" '
                + 'data-alert="¿Seguro que desea eliminar este archivo?. Esta operación no es reverible">'
                + '<span class="glyphicon glyphicon-remove"></span></a></td>'
                + '</tr>';
    var numRows = $(idTable + " tbody tr.files").length;
    if(numRows === 0) {
        $(idTable + " tbody").html('');
    }      
   $(idTable).append(content);         
};

var cargarBoletaObservaciones = function(id)
{   
    $("#popup-boleta div.modal-header h4").html($(id).attr('title'));
    $("#popup-boleta img#imagen-boleta").attr('src', $(id).attr('data-src'));
    $("#popup-boleta a#eliminar-imagen-boleta").attr('href', $(id).attr('data-delete'));
    $("#popup-boleta a#descargar-imagen-boleta").attr('href', $(id).attr('data-download'));
};

var actualizarRegistroMantenimiento = function(data)
{
    var fila = '<td>' + data.fecha + '</td>'
             + '<td>' + data.horometro + '</td>'
             + '<td>' + data.tipo + '</td>'
             + '<td>' + data.detalles + '</td>'
             + '<td>' + data.observaciones + '</td>'
             + '<td width="20" class="text-center">'
             + '<a data-url="/equipo-mantenimiento/editar/' + data.id + '" data-toggle="modal" href="#popup-mantenimiento" data-title="Editar mantenimiento" title="Editar ítem" class="cargar-popup">'
             + '<span class="glyphicon glyphicon-pencil"></span>'
             + '</a></td>'
             + '<td width="20" class="text-center">'
             + '<a href="/equipo-mantenimiento/eliminar/' + data.id + '" title="Eliminar ítem" class="eliminar-registro-mantenimiento">'
             + '<span class="glyphicon glyphicon-remove"></span>'
             + '</a></td>';
    $("#m" + data.id).html(fila);
};

var eliminarRegistroMantenimiento = function(id)
{
    $("tr#m" + id).remove();
};

/****************************  CAPTURA DE EVENTOS *****************************/
$(document).ready(function() {
    
/***************************** ACCIONES GENÉRICAS *****************************/
    var url = document.location.toString();
    if (url.match('#')) {
        $('ul.nav a[href="#' + url.split('#')[1] + '"]').tab('show');
    } 

    // Change hash for page-reload
    $('ul.nav a').on('shown.bs.tab', function (e) {
        window.location.hash = e.target.hash;
    });
    $("input.uppercase").on('keyup', function(){
        $(this).val($(this).val().toUpperCase());
    });
    $("input.numeric").numeric();
    $(document).on('click', "a.put-values-in-form", function(e){
        e.preventDefault();
        var dataRow = $(this).data();
        var editAction = $(this).attr('href');
        if($(this).attr('data-form-id').length === 1){
            formId = $(this).attr('data-form-id');
        } else {
            formId = "form.data-inline";
        }
        if($(formId).length === 1){
            $(formId).attr('action', editAction);
            $(formId + " #submit").text('Guardar cambios');
            $.each(dataRow, function( index, value ) {
                var inputId = "#" + index;
                if($(inputId).length === 1 ) {
                    //if($(inputId + " [type=text]").length === 1){}
                    $(inputId).val(value);
                } else {
                    console.log(index + " : " + value);
                }
            });
        }
    });
    $(document).on('click', "form button[type=reset]", function(e){
        var formId = $(this).attr('data-form-id');
        var actionUrl = $(this).attr('data-action-url');
        var submitText = $(this).attr('data-submit-text');
        $(formId).attr('action', actionUrl);
        $("#submit").text(submitText);
    });
    $("tbody.sortable").sortable();
    $("tbody.sortable").bind( "sortupdate", function() {
        var data = getNuevoOrden();
        var controller = $(this).attr('data-controller');
        guardarNuevoOrden(controller, data);
    });
    $("tbody.sortable").disableSelection();
    $(document).on('click', 'input:text.show-calendar', function() {
        $(this).datepicker({
            showOn:'focus', 
            changeMonth: true, 
            changeYear:true,
            dateFormat: 'yy-mm-dd',
            firstDay : 1,
            monthNamesShort: [ "Ene", "Feb", "Mar", "Abr", "May", "Jun", "Jul", "Ago", "Sep", "Oct", "Nov", "Dic" ],
            dayNamesMin: [ "Do", "Lu", "Ma", "Mi", "Ju", "Vi", "Sa"]
        }).focus();
    });
    $("a[rel=popover]").on('click', function(e){
        e.preventDefault();
        $(this).popover('show');
    });
    $("a[rel=popover_simple]").popover();
    $(document).on('click', "a.show-alert", function(e){
        e.preventDefault();
        if(confirm($(this).attr('data-alert'))){
            location = $(this).attr('href');
        }
    });
    $(document).on('click', "a.show-message", function(e){
        e.preventDefault();
        alert($(this).attr('data-alert'));
    });
    $(document).on('click', "a.cargar-popup", function(e){
        e.preventDefault();
        cargarPopup($(this));
    });
    $(document).on('click', "a.cargar-info-menu", function(e){
        e.preventDefault();
        cargarInfoMenu($(this));
    });
    $(document).on('change', "select.updateOther", function(){
        actualizarSelect($(this).attr('data-target'), $(this).attr('data-url') + $(this).val());
    });
    $(document).on('mouseover', ".trigger-popover-ayuda", function(e){
        e.preventDefault();
        var contentHtml = $($(this).attr("data-target")).html();
        $(this).popover({
            placement: 'left', 
            html: true,
            container: '#popup',
            content: contentHtml
        });
    });
    $(document).on('click', "a.show-target", function(e){
        e.preventDefault();
        var target = $(this).attr('data-target');
        var clase = $(this).attr('data-clase');
        $(clase).addClass('hidden');
        $(target).removeClass('hidden');
        $("a.show-target").removeClass('disabled');
        $("a.show-target").parent().removeClass('active');
        $(this).addClass('disabled');
        $(this).parent().addClass('active');
    });
    $(document).on('change', 'select.go-to-with-value', function(){
        location = $(this).attr('data-url') + $(this).val();
    });
    
    $(document).on('click', "#nave-carena-archivo #submit", function(e){
        e.preventDefault();
        if($("#nombre").attr('value') === '' || $("#nombre").attr('value') === false || $("#nombre").attr('value') === null) {
             alert('Por favor ingrese el nombre del archivo');
        } else {
             $("#archivo").removeAttr('disabled');
            guardarArchivoCarena("#nave-carena-archivo", "#listado-archivos");
            
        }
    });
    
    $(document).on('click', "#nave-carena-archivo #cancel", function(e){
        e.preventDefault();
        resetearForm("#nave-carena-archivo");
        $("#nave-carena-archivo").hide();
        $("#selector-archivo-carena").show();
        $("#archivo, #submit").attr('disabled', 'disabled');
    });
    
    $(document).on('click', "a.eliminar-archivo-carena", function(e){
        e.preventDefault();
        if(confirm($(this).attr('data-alert'))){
            $.ajax({
                dataType: 'json',
                type: "POST",
                url: $(this).attr("href"),
                success: function(requestData){
                    if(requestData.error === false){
                        eliminarFila('#r' + requestData.id);
                        if(requestData.num === 0){
                            $("#c"+ requestData.cid +" span").attr('class', 'glyphicon glyphicon-upload');
                            $("#listado-archivos tbody").append('<tr><td colspan="3">No se han adjuntado archivos a esta carena.</td></tr>');
                        }                         
                    } 
                }
            });
        }
    });
    
    $(document).on('click', "a.eliminar-archivo-siniestro", function(e){
        e.preventDefault();
        if(confirm($(this).attr('data-alert'))){
            $.ajax({
                dataType: 'json',
                type: "POST",
                url: $(this).attr("href"),
                success: function(requestData){
                    if(requestData.error === false){
                        eliminarFila('#r' + requestData.id);
                        if(requestData.num === 0){
                            $("#s"+ requestData.sid +" span").attr('class', 'glyphicon glyphicon-upload');
                            $("#listado-archivos tbody").append('<tr><td colspan="3">No se han adjuntado archivos a este siniestro.</td></tr>');
                        }                         
                    } 
                }
            });
        }
    });
    
    $(document).on('click', "form#nave-siniestro-archivo #submit", function(e){
        e.preventDefault();
        if($("#nombre").attr('value') === '' || $("#nombre").attr('value') === false || $("#nombre").attr('value') === null) {
             alert('Por favor ingrese el nombre del archivo');
        } else {
             $("#archivo").removeAttr('disabled');
            guardarArchivoSiniestro("#nave-siniestro-archivo", "#listado-archivos");
        }
    });

    $(document).on('click', "form#nave-siniestro-archivo #cancel", function(e){
        e.preventDefault();
        resetearForm("#nave-siniestro-archivo");
        $("#nave-siniestro-archivo").hide();
        $("#selector-archivo-siniestro").show();
        uploaderSiniestro.fineUploader('reset');
        $("#archivo, #submit").attr('disabled', 'disabled');
    });
    
    $("#tipo_movimiento").on('change', function(){
        $.ajax({
            dataType: 'html',
            type: "POST",
            url: '/utilidades/get-form-mover-equipo/',
            data: 'tipo=' + $("#tipo_movimiento").val(),
            beforeSend: function(){
              $("#formulartio-mover").html('Cargando formulario...');  
            },
            success: function(requestData){
                $("#formulario-mover").html(requestData);
            }
        });
    });
    
    $(document).on('click', "input.item-mantenimiento", function(){
        $("input.item-mantenimiento").removeAttr('checked');
        $("#servicio_id").val($(this).attr('data-servicio'));
        $("#reparacion").val('');
        $("#reparacion").attr("disabled", "disabled");
        $("#horometroStatus").val($(this).attr('data-horometro'));
        $(this).prop("checked", true);
    }); 
    
    $(document).on('click', "input#otro-mantenimiento", function(){
        $("input.item-mantenimiento").removeAttr('checked');
        $(this).attr('checked', 'checked');
        $("#servicio_id").val($(this).attr('data-servicio'));
        $("#reparacion").removeAttr("disabled");
    });
    
    $(document).on('click', "#asignar-mantenimiento", function(){
        var mantenimiento_informe_id = $("#mantenimiento_informe_id").val();
        var equipo_id = $("#equipo_id").val();
        var fecha = $("#fecha").val();
        var servicio_id = $("#servicio_id").val();
        var horometro = $("#horometro").val();
        var reparacion = $("#reparacion").val();
        var horometroStatus = $("#horometroStatus").val();
    
        if(equipo_id !== '' && fecha !== ''){
            if(servicio_id === '' && reparacion === ''){
                alert("Debe seleccionar un servicio.");
            } else {
                if(horometroStatus === '1' && horometro === ''){
                    alert('Debe ingresar el horómetro del equipo');
                } else {
                    $.ajax({
                        dataType: 'json', type: "POST",
                        url: '/informe-semanal/guardar-mantenimiento-asignado/',
                        data : "equipo_id=" + equipo_id 
                                + "&fecha=" + fecha 
                                + "&servicio_id=" + servicio_id 
                                + "&horometro=" + horometro 
                                + "&detalles=" + reparacion 
                                + "&mantenimiento_informe_id=" + mantenimiento_informe_id,
                        success: function(requestData){
                            if(requestData.error === false){
                                goTo('/informe-semanal/mantenimientos');
                            } else {
                                alert(requestData.mensaje);
                            }
                        }
                    });
                }
            }
        } else {
            alert("No se ha agregado toda la información requerida para procesar la asignación");
        }
    });  
    
    $("a.form-carena").on('click', function(){
        $("form.sig_carena").toggle();
        $("div.info_carena").toggle();
    });
    
    $(document).on('click', "#equipo-mantenimiento-archivo #submit", function(e){
        e.preventDefault();
        if($("#nombre").attr('value') === '' || $("#nombre").attr('value') === false || $("#nombre").attr('value') === null) {
             alert('Por favor ingrese el nombre del archivo');
        } else {
             $("#archivo").removeAttr('disabled');
            guardarArchivoMantenimiento("#equipo-mantenimiento-archivo", "#listado-archivos");
        }
    });
    
    $("#equipo-mantenimiento-archivo #cancel").on('click', function(e){
        e.preventDefault();
        resetearForm("#equipo-mantenimiento-archivo");
        $("#equipo-mantenimiento-archivo").hide();
        $("#selector-archivo-mantenimiento").show();
        uploaderMant.fineUploader('reset');
        $("#archivo, #submit").attr('disabled', 'disabled');
    });
    
    $(document).on('click', "a.eliminar-archivo-mantenimiento", function(e){
        e.preventDefault();
        var enlace = $(this);
        if(confirm(enlace.attr('data-alert'))){
            $.ajax({
                dataType: 'json',
                type: "POST",
                url: enlace.attr("href"),
                success: function(requestData){
                    if(requestData.error === false){
                        eliminarFila('#f' + requestData.id);
                        if(requestData.num === 0){
                            $("#m"+ requestData.mid +" span").attr('class', 'glyphicon glyphicon-upload');
                            $("#listado-archivos tbody").append('<tr><td colspan="3">No se han adjuntado archivos a este registro de mantenimiento.</td></tr>');
                        }                         
                    } 
                }
            });
        }
    });
    
    $("#asignar-promedio").on('click', function(e){
        e.preventDefault();
        $("#boton-asignado").addClass('hidden');
        $("#form-asignado").removeClass('hidden');
    });
    
    $("#cancelar-asignar-promedio").on('click', function(e){
        e.preventDefault();
        $("#form-asignado").addClass('hidden');
        $("#boton-asignado").removeClass('hidden');
    });
    
    $("#form-buscar-equipos #empresa_id").on('change', function(){
        var empresaId = $("#empresa_id").val();
        if(empresaId === "0"){
            $("#form-buscar-equipos #ubicacionv_id").removeAttr('disabled');
        } else {
            $("#form-buscar-equipos #ubicacionv_id").attr('disabled', 'disabled');
        }
    });
    
    $("#form-buscar-equipos #ubicacionv_id").on('change', function(){
        var ubicacionvId = $("#ubicacion_id").val();
        if(ubicacionvId === "0"){
            $("#form-buscar-equipos #empresa_id, #form-buscar-equipos #nave_id, #form-buscar-equipos #sistema_id").removeAttr('disabled');
        } else {
            $("#form-buscar-equipos #empresa_id, #form-buscar-equipos #nave_id, #form-buscar-equipos #sistema_id").attr('disabled', 'disabled');
        }
    });
    
    $(document).on('click', 'a.mostrar-plan', function(e){
        e.preventDefault();
        $(this).next().removeClass('hidden');
    });
    
    $("a.mostrar-detalle-carena").on('click', function(e){
        e.preventDefault();
        cargarDatosPopup($(this));
    });
    
    $("a.mostrar-boleta-observaciones").on('click', function(e){
        e.preventDefault();
       cargarBoletaObservaciones($(this));
    });
    
    $("a.mostrar-planes-mantenimiento").on('click', function(e){
        e.preventDefault();
        cargarPopup($(this));
    });
    
    $("a.mostrar-gastos-mensuales").on('click', function(e){
        e.preventDefault();
        cargarPopup($(this));
    });
    
    $("a.mostrar-sistemas").on('click', function(e){
        e.preventDefault();
        $("ul.list-sistemas").hide();
        $("ul.list-horometros").hide();
        $("a.get-horometro").removeClass('horometro-seleccionado');
        $(this).next().show();
    });
    
    $(document).on('click', "a.agregar-mantenimiento-plan", function(e){
        e.preventDefault();
        if($("#fecha").val() === '' || $("#horometro").val() === ''){
            alert('Por favor ingrese la fecha y las horas del equipos cuando se realizó el mantenimiento');
            return;
        } else {
            $.ajax({
                dataType: 'json',
                type: "POST",
                url: $(this).attr("href"),
                data : getInputsAjax("#form-reporte-mantenimiento") + '&servicio_id=' + $(this).attr('data-servicio'),
                beforeSend: function(){
                    $("#registro-mantenimientos tbody").append('<tr><td colspan="8">Cargando datos...</td></td>');
                },
                success: function(requestData){
                    if(requestData.error === false){
                        $("#registro-mantenimientos tbody tr:last-child").remove();
                        agregarRegistroMantenimiento(requestData.fila);  
                    } else {
                        alert(requestData.mensaje);
                    }
                }
            });
        }
    });
    
    $(document).on('click', "a.agregar-mantenimiento", function(e){
        e.preventDefault();
        if($("#fecha").val() === ''){
            alert('Por favor ingrese la fecha cuando se realizó el mantenimiento');
            return;
        } else {
            $.ajax({
                dataType: 'json',
                type: "POST",
                url: $(this).attr("href"),
                data : getInputsAjax("#form-reporte-mantenimiento") + '&servicio_id=' + $(this).attr('data-servicio'),
                beforeSend: function(){
                    $("#registro-mantenimientos tbody").append('<tr><td colspan="8">Cargando datos...</td></td>');
                },
                success: function(requestData){
                    if(requestData.error === false){
                        $("#registro-mantenimientos tbody tr:last-child").remove();
                        agregarRegistroMantenimiento(requestData.fila);  
                    } else {
                        alert(requestData.mensaje);
                    }
                }
            });
        }
    });
    
    $(document).on('click', "a#agregar-reparacion", function(e){
        e.preventDefault();
        if($("#fecha").val() === '' || $("#reparacion").val() === ''){
            alert('Por favor ingrese la fecha y el detalle de la reparación que se realizó.');
            return;
        } else {
            $.ajax({
                dataType: 'json',
                type: "POST",
                url: $(this).attr("href"),
                data : getInputsAjax("#form-reporte-mantenimiento") + '&servicio_id=59' + '&detalles=' + $("#reparacion").val(),
                success: function(requestData){
                    if(requestData.error === false){
                        agregarRegistroMantenimiento(requestData.fila);  
                    } else {
                        alert(requestData.mensaje);
                    }
                }
            });
        }
    });
    
    $(document).on('click', "a#guardar-mantenimiento", function(e){
        e.preventDefault();
        $.ajax({
            dataType: 'json',
            type: "POST",
            url: $(this).attr("href"),
            data: getInputsAjax("#equipo-mantenimiento"),
            success: function(requestData){
                if(requestData.error === false){
                    actualizarRegistroMantenimiento(requestData.fila);  
                    $("#popup-mantenimiento").modal('hide');
                } else {
                    alert(requestData.mensaje);
                }
            }
        });
        
    });
    
    $(document).on('click', "a.eliminar-registro-mantenimiento", function(e){
        e.preventDefault();
        if(confirm('¿Seguro que desea eliminar este mantenimiento?')){
            $.ajax({
                dataType: 'json',
                type: "POST",
                url: $(this).attr('href'),
                success: function(requestData){
                    if(requestData.error === false){
                        eliminarRegistroMantenimiento(requestData.deleted);  
                    } else {
                        alert(requestData.mensaje);
                    }
                }
            });
        }
    });
    
    $(document).on('submit', "form#filtrar-otros-servicios", function(e){
        e.preventDefault();
        filtrarOtrosEquipos();
    });
    
    $(document).on('change', "#filtrar-servicios", function(){
        var tipoId = parseInt($(this).val());
        if(tipoId === 0){
            $("table tbody tr.detalle-servicio").removeClass('hidden');
        } else {
            $("table tbody tr.detalle-servicio").addClass('hidden');
            $("table tbody tr[data-tipo=" + tipoId +"]").removeClass('hidden');
        }
    });
    
    /******************* ACCIONES EN PROCESO DE ELIMINACIÓN *******************/
    $(document).on("click", "button#ir-al-reporte", function(e){
        e.preventDefault();
        var equipoId = $("#equipo_id").val();
        var mantenimientoInformeId = $("#mantenimiento_informe_id").val();
        goTo("/equipo-mantenimiento/reporte/" + equipoId + '/' + mantenimientoInformeId);
    });
    
    $("a.ver-asignacion").on('click', function(e){
        e.preventDefault();
        $(this).parent().next().toggle();
    });
    /**************************************************************************/
});