var getIdTodosEquiposEncontrados = function()
{
    var equipos = $("a.selequipo");
    var data = '';
    for( i = 0 ; i < equipos.length ; i++ ){
        if( i !== 0 ) {
            data = data + ',';
        }
        data = data + equipos[i].id;
    }
    return data;    
};
var getTipoIdTodosEquiposEncontrados = function()
{
    var equipos = $("a.selequipo");
    var data = '';
    for( i = 0 ; i < equipos.length ; i++ ){
        if( i !== 0 ) {
            data = data + ',';
        }
        data = data + $("#" + equipos[i].id).attr('data-tipo');
    }
    return data;    
}; 
var actualizarSeleccionEquipos = function()
{
    $.ajax({
        dataType: 'html',
        type: "POST",
        url: '/biblioteca-tecnica/equipos-seleccionados',
        beforeSend : function(){
            $("#equipos-seleccionados").html('Actualizando equipos seleccionados...');
        },
        success: function(requestData){
            $("#equipos-seleccionados").html('');
            $("#equipos-seleccionados").append(requestData);
        }
    });
};

var seleccionarEquipo = function(equipoId, tipoId)
{
    $.ajax({
        type: "POST",
        dataType: 'json',
        url: '/biblioteca-tecnica/seleccionar-equipo',
        data: 'equipo_id=' + equipoId + '&tipo_id=' + tipoId,
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    $("#" + equipoId).parent().parent().remove();
                    actualizarContadorSeleccionados(1);
                    actualizarSeleccionEquipos();
                } else {
                    alert(requestData.mensaje);
                }
            }
        },
        error: function(){
            alert('Ocurrió un error al intentar seleccionar el equipo');
        }
    });
};

var deseleccionarEquipo = function(equipoId)
{
    $.ajax({
        type: "POST",
        dataType: 'json',
        url: '/biblioteca-tecnica/deseleccionar-equipo',
        data: 'equipo_id=' + equipoId,
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    $("#" + equipoId).parent().parent().remove();
                    actualizarContadorSeleccionados(-1);
                } else {
                    alert(requestData.mensaje);
                }
            }                
        },
        error: function(){
            alert('Ocurrió un error al intentar deseleccionar el equipo');
        }
    });
};

var seleccionarTodosEquiposEncontrados = function()
{
    $.ajax({
        type: "POST",
        dataType: 'json',
        url: '/biblioteca-tecnica/seleccionar-todos',
        data: 'ids=' + getIdTodosEquiposEncontrados() + '&tipoIds=' + getTipoIdTodosEquiposEncontrados(),
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    actualizarContadorSeleccionados(requestData.cantidad);
                } else {
                    return false;
                }
            }    
        },
        error: function(){
            return false;
        }
    });
};

var deseleccionarTodosEquiposEncontrados = function()
{
    $.ajax({
        type: "POST",
        dataType: 'json',
        url: '/biblioteca-tecnica/deseleccionar-todos',
        data: 'ids=' + getIdTodosEquiposEncontrados(),
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    actualizarContadorSeleccionados(requestData.cantidad * -1);
                } else {
                    return false;
                }
            }    
        },
        error: function(){
            return false;
        }
    });
};

var actualizarListadoBiblioteca = function(dir)
{
    $.ajax({
        dataType: 'json',
        type: "POST",
        url: dir,
        data: getInputsAjax("#form-buscar-equipos"),
        beforeSend: function(){
            $("#equipos-encontrados table tbody").html('<td colspan="4">Buscando equipos...</td>');
        },
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                $("#equipos-encontrados").html('');
                $("#equipos-encontrados").append('<table class="table table-hover table-condensed"><tbody>');
                if(requestData !== null) {
                    for (var x = 0; x < requestData.length; x++) { 
                        var filaEquipo = '<tr><td width="75">' + requestData[x].ubicacion  + '</td>'
                                       + '<td><a href="#popup" data-url="/biblioteca-tecnica/equipo/' + requestData[x].id + '"'
                                       + 'class="cargar-popup" title="Detalles equipo" data-title="Detalles equipo" data-toggle="modal">' + requestData[x].nombre  + '</a></td>'
                                       + '<td width="30">'
                                       + '<a href="#" class="selequipo" data-tipo="' + requestData[x].tipo_id + '" id="' + requestData[x].id + '">'
                                       + '<span class="glyphicon glyphicon-check"></span>'
                                       + '</a></td>'
                                       + '</tr>';
                        $("#equipos-encontrados table tbody").append(filaEquipo);
                    }
                    $("#numEquipos").html(requestData.length);

                    if(requestData.length > 0){
                        $("#sel-resultados").removeAttr('disabled');
                        $("#reset-equipos-encontrados").removeAttr('disabled');
                    } else {
                        $("#sel-resultados").attr('disabled', 'disabled');
                        $("#reset-equipos-encontrados").attr('disabled', 'disabled');
                        $("#exportar-seleccion").attr('disabled', 'disabled');
                        $("#reset-equipos-seleccionados").attr('disabled', 'disabled');
                    }
                } else {
                    var info = '<tr><td colspan="2"><span class="text-muted">No se encontraron coincidencias</span></td></tr>';
                    $("#equipos-encontrados table tbody").append(info);
                    $("#numEquipos").html("(0)"); 
                }
                $("#equipos-encontrados").append('</tbody></table>');
            }                
        },
        error : function(){
            alert('Ocurrió un error al intentar cargar los equipos');
        }
    });
}; 
$(document).ready(function(){
    $(document).on('click', "button#asignar-promedio-masivo", function(e){
        e.preventDefault();
        if($("#promedio_asignado").val() === ''){
            alert('Por favor ingrese la cantidad de horas mensuales a asignar');
            return;
        } else {
            $.ajax({
                dataType: 'json',
                type: "POST",
                url: "/biblioteca-tecnica/asignar-promedio-masivamente",
                data : "promedio_asignado=" + $("#promedio_asignado").val(),
                beforeSend: function(){
                    $("button#asignar-promedio-masivo").text('Enviando datos...');
                    $("button#asignar-promedio-masivo").addClass('disabled');
                },
                success: function(requestData){
                    if(requestData.error === false){
                        $("#popup").modal('hide');
                        var notyPromedioMasivo = noty({text: "El promedio fue asignado de forma satisfactoria", type: "success", timeout: 2000});
                    } else {
                        alert(requestData.mensaje);
                        $("button#asignar-promedio-masivo").removeClass('disabled');
                        $("button#asignar-promedio-masivo").text('Asignar');
                    
                    }
                }
            });
        }
    });
    
    $(document).on('click', "a#buscar-equipos", function(e){
        e.preventDefault();
        actualizarListadoBiblioteca($("a#buscar-equipos").attr('href'));
    });
    
    $(document).on('click', "#menu-sel-equipos #sel-resultados", function(){
        var result = seleccionarTodosEquiposEncontrados();
        if(result !== false){
            $("#menu-sel-equipos #sel-resultados").attr('disabled', 'disabled');
            $("#menu-sel-equipos #reset-equipos-encontrados").attr('disabled', 'disabled');
            $("#equipos-encontrados").html('<p class="indicaciones-panel">Busque equipos por uno o más criterios.</p>');
            $("#numEquipos").html('0');
            $("#exportar-seleccion").removeAttr('disabled');
            $("#reset-equipos-seleccionados").removeAttr('disabled');
            actualizarSeleccionEquipos();
        } else {
            alert("Ocurrió un error al intentar seleccionar todos los equipos");
        }
    });
    
    $(document).on('click', "a.selequipo", function(e){
        e.preventDefault();
        var equipoId = $(this).attr("id");
        var tipoId = $(this).attr("data-tipo");
        seleccionarEquipo(equipoId, tipoId);
    });
    
    $(document).on('click', "a.deselequipo", function(e){
        e.preventDefault();
        var equipoId = $(this).attr("id");
        deseleccionarEquipo(equipoId);
    });
    $("#reset-equipos-seleccionados").on('click', function(){
        $.ajax({
            dataType: 'html',
            type: "POST",
            url: '/biblioteca-tecnica/resetear-equipos-seleccionados',
            success: function(requestData){
                $("#equipos-seleccionados").html('');
                $("#equipos-seleccionados").append(requestData);
                $("#numSeleccionados").html('0');
                $("input.selequipo").removeAttr('checked');
                $("#exportar-seleccion").attr('disabled', 'disabled');
                $("#reset-equipos-seleccionados").attr('disabled', 'disabled');
            }
        });
    });
    
    $("#reset-equipos-encontrados").on('click', function(){
        $("#equipos-encontrados").html('<p class="indicaciones-panel">Busque equipos por uno o más criterios.</p>');
        $("#numEquipos").html('0');
        $("#sel-resultados").attr('disabled', 'disabled');
        $("#reset-equipos-encontrados").attr('disabled', 'disabled');
    });
});