var actualizarInfoEvento = function(data)
{
    $("#e_tipo" + data.id).html(data.tipo);
    $("#e_tipo" + data.id).attr('title', data.title);
    $("#e_codigo" + data.id).html(data.codigo);
    $("#e_fecha" + data.id).html(data.fecha_formateada);
};
var getIdTodosEventosEncontrados = function()
{
    var eventos = $("input.selevento");
    var data = '';
    for( i = 0 ; i < eventos.length ; i++ ){
        if( i !== 0 ) {
            data = data + ',';
        }
        data = data + eventos[i].id;
    }
    return data;    
};
var getNaveIdTodosEventosEncontrados = function()
{
    var eventos = $("input.selevento");
    var data = '';
    for( i = 0 ; i < eventos.length ; i++ ){
        if( i !== 0 ) {
            data = data + ',';
        }
        data = data + $("#" + eventos[i].id).attr('data-nave');
    }
    return data;    
};
var seleccionarTodosEventosEncontrados = function()
{
    $.ajax({
        type: "POST",
        dataType: 'json',
        url: '/administrador-eventos/seleccionar-todos',
        data: 'ids=' + getIdTodosEventosEncontrados() + '&naveIds=' + getNaveIdTodosEventosEncontrados(),
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    actualizarContadorSeleccionados(requestData.cantidad);
                } else {
                    return false;
                }
            }    
        },
        error: function(){
            return false;
        }
    });
};

var deseleccionarTodosEventosEncontrados = function()
{
    $.ajax({
        type: "POST",
        dataType: 'json',
        url: '/administrador-eventos/deseleccionar-todos',
        data: 'ids=' + getIdTodosEventosEncontrados(),
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    actualizarContadorSeleccionados(requestData.cantidad * -1);
                } else {
                    return false;
                }
            }  
        },
        error: function(){
            return false;
        }
    });
};

var seleccionarEvento = function(eventoId, naveId)
{
    $.ajax({
        type: "POST",
        dataType: 'json',
        url: '/administrador-eventos/seleccionar-evento',
        data: 'evento_id=' + eventoId + '&nave_id=' + naveId,
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    $("#" + eventoId).parent().effect('highlight');
                    actualizarContadorSeleccionados(1);
                } else {
                    alert(requestData.mensaje);
                }
            }    
        },
        error: function(){
            alert('Ocurrió un error al intentar seleccionar el evento');
        }
    });
};

var deseleccionarEvento = function(eventoId)
{
    $.ajax({
        type: "POST",
        dataType: 'json',
        url: '/administrador-eventos/deseleccionar-evento',
        data: 'evento_id=' + eventoId,
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    $("#" + eventoId).parent().effect('highlight');
                    actualizarContadorSeleccionados(-1);
                } else {
                    alert(requestData.mensaje);
                }
            }    
        },
        error: function(){
            alert('Ocurrió un error al intentar deseleccionar el evento');
        }
    });
};

var actualizarListadoAdministradorEventos = function(dir)
{
    $.ajax({
        dataType: 'json',
        type: "POST",
        url: dir,
        data: getInputsAjax("#form-buscar-eventos"),
        beforeSend: function(){
            $("#eventos-encontrados table tbody").html('<td colspan="4">Buscando eventos...</td>');
        },
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                $("#eventos-encontrados").html('');
                $("#eventos-encontrados").append('<table class="table table-hover table-condensed"><tbody>');
                if(requestData !== null) {
                    for (var x = 0; x < requestData.length; x++) { 
                        var filaEvento = '<tr><td width="75">' + requestData[x].nave  + '</td>'
                                       + '<td>' + requestData[x].sistema  + '</td>' 
                                       + '<td>' + requestData[x].equipo  + '</td>' 
                                       + '<td>' + requestData[x].servicio  + '</td>'
                                       + '<td>' + requestData[x].fecha_editada  + '</td>'
                                       + '<td width="35"><input class="selevento" type="checkbox" data-nave="' + requestData[x].nave_id + '" id="' + requestData[x].id + '"></td>'
                                       + '</tr>';
                        $("#eventos-encontrados table tbody").append(filaEvento);
                    }
                    $("#numEventos").html(requestData.length);

                    if(requestData.length > 0){
                        $("#sel-resultados").removeClass('hidden');
                    } else {
                        $("#sel-resultados").addClass('hidden');
                    }
                    $("#des-resultados").addClass('hidden');

                } else {
                    var info = '<tr><td colspan="2"><span class="text-muted">No se encontraron coincidencias</span></td></tr>';
                    $("#eventos-encontrados table tbody").append(info);
                    $("#numEventos").html("(0)"); 
                }
                $("#eventos-encontrados").append('</tbody></table>');
            }
                
                
        },
        error : function(){
            alert('Ocurrió un error al intentar cargar los eventos');
        }
    });
}; 

$(document).ready(function(){
    
    $(document).on('click', "a#buscar-eventos", function(e){
        e.preventDefault();
        actualizarListadoAdministradorEventos($("a#buscar-eventos").attr('href'));
    });
    
    $(document).on('click', "button#asignar-fecha-masiva", function(e){
        e.preventDefault();
        if($("#fecha").val() === ''){
            alert('Por favor ingrese la fecha a asignar');
            return;
        } else {
            $.ajax({
                dataType: 'json',
                type: "POST",
                url: "/administrador-eventos/asignar-fecha-manual-masivamente",
                data : "fecha=" + $("#fecha").val(),
                beforeSend: function(){
                    $("button#asignar-fecha-masiva").text('Enviando datos...');
                    $("button#asignar-fecha-masiva").addClass('disabled');
                },
                success: function(requestData){
                    if(requestData.error === false){
                        $("#popup").modal('hide');
                        var notyFechaMasiva = noty({text: "La fecha fue asignada de forma satisfactoria a todos los eventos seleccionados", type: "success", timeout: 2000});
                    } else {
                        alert(requestData.mensaje);
                        $("button#asignar-fecha-masiva").removeClass('disabled');
                        $("button#asignar-fecha-masiva").text('Asignar');
                    }
                }
            });
        }
    });
    
    $(document).on('click', "#menu-sel-eventos #sel-resultados", function(){
        var result = seleccionarTodosEventosEncontrados();
        if(result !== false){
            $("#menu-sel-eventos #sel-resultados").addClass('hidden');
            $("#menu-sel-eventos #des-resultados").removeClass('hidden');
            $("input.selevento").parent().effect('highlight');
            $("input.selevento").attr('checked', 'checked');
        } else {
            alert("Ocurrió un error al intentar seleccionar todos los eventos");
        }
    });
    
    $(document).on('click', "#menu-sel-eventos #des-resultados", function(){
        var result = deseleccionarTodosEventosEncontrados();
        if(result !== false){
            $("#menu-sel-eventos #des-resultados").addClass('hidden');
            $("#menu-sel-eventos #sel-resultados").removeClass('hidden');
            $("input.selevento").parent().effect('highlight');
            $("input.selevento").removeAttr('checked');
        } else {
            alert("Ocurrió un error al intentar deseleccionar todos los eventos");
        }
    });
    
    $(document).on('click', "input.selevento", function(){
        var eventoId = $(this).attr("id");
        var naveId = $(this).attr("data-nave");
        var numCheck = $("#" + eventoId + ":checked").length;
        if(numCheck === 1){
            seleccionarEvento(eventoId, naveId);
        } else {
            deseleccionarEvento(eventoId);
        }
    });
    
    $(document).on('click', "#get-eventos-seleccionados", function(){
        $.ajax({
            dataType: 'html',
            type: "POST",
            url: '/administrador-eventos/eventos-seleccionados',
            beforeSend : function(){
                $("#eventos-seleccionados").html('Cargando eventos seleccionados...');
            },
            success: function(requestData){
                $("#eventos-seleccionados").html('');
                $("#eventos-seleccionados").append(requestData);
            }
        });
    });
    
    $(document).on('click', "#reset-eventos-seleccionados", function(){
        $.ajax({
            dataType: 'html',
            type: "POST",
            url: '/administrador-eventos/resetear-eventos-seleccionados',
            success: function(requestData){
                $("#eventos-seleccionados").html('');
                $("#eventos-seleccionados").append(requestData);
                $("#numSeleccionados").html('0');
                $("input.selevento").removeAttr('checked');
                $("#des-resultados").addClass('hidden');
                $("#sel-resultados").removeClass('hidden');
            }
        });
    });
    
    $(document).on('click', "#reset-eventos-encontrados", function(){
        $("#eventos-encontrados").html('<p class="indicaciones-panel">Busque eventos por uno o más criterios.</p>');
        $("#numEventos").html('0');
    });
    
    $(document).on('click', "a.asignar-fecha-manual", function(e){
        e.preventDefault();
        var formProgramacion = $(this).attr('data-form');
        var info = $(this).attr('data-info');
        $.ajax({
            dataType: 'json',
            type: "POST",
            url: $(this).attr('href'),
            data : "id=" + $(formProgramacion + " input.id").val() +"&fecha=" + $(formProgramacion + " input.fecha").val(),
            beforeSend : function(){
                $(formProgramacion).hide();
                $(formProgramacion + " > input.fecha").val('');
                
            },
            success: function(requestData){
                if(requestData.error === false){
                    actualizarInfoEvento(requestData.fila);
                    
                    $(info).show();
                    $(info).parent().effect('highlight', {duration: 2000});
                } else {
                    alert(requestData.mensaje);
                }
            }
        });
    });
    
    $("a.programar-actividad").on('click', function(e){
        e.preventDefault();
        var target = $(this).attr('data-target');
        $(this).addClass('hidden');
        $(target).removeClass('hidden');
    });
    
    $("button.cancelar-guardar-fecha").on('click', function(e){
        e.preventDefault();
        $(this).parent().addClass('hidden');
        $(this).parent().prev().removeClass('hidden');
        $("input.fecha").val('');
    });
    
});