var getIdItemsSeleccionados = function(clase){
    var itemsSeleccionados = $(clase);
    var data = '';
    for( i = 0 ; i < itemsSeleccionados.length ; i++ ){
        if( i !== 0 ) {
            data = data + ',';
        }
        data = data + itemsSeleccionados[i].id;
    }
    return data;    
}; 
var setTrabajoProgramacion = function(trabajoId){
    $.ajax({
        dataType: 'json',
        type: "POST",
        url: '/programacion-mensual/set-trabajo/',
        data: "trabajo_id=" + trabajoId,
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    $("#td-" + trabajoId).parent().effect('highlight');
                } else {
                    alert(requestData.mensaje);
                }
            }
        }
    });
};
var actualizarSumarioTrabajosMes = function(sumario){
    $.each(sumario, function( index, value ) {
        var idCount = "#num-" + index;
        if($(idCount).length === 1 ) {
            $(idCount).text(value);
        } 
    });
};
var armarFormularioRechazoTrabajo = function(data){
    console.log(data.comentarios);
    var formulario = '<form class="ajax form-inline form-small" id="form-rechazar-trabajo" style="width:250px;">'
                   + '<input type="hidden" name="trabajo_id" id="trabajo_id" value="' + data.id + '">'
                   + '<p style="font-size:.85em;color:red;">Recuerde que sólo puede rechazar un trabajo si éste no corresponde al equipo.</p>'
                   + '<textarea id="comentarios" name="comentarios" class="form-control input-sm" placeholder="Comentarios rechazo" style="width:245px;margin:5px 0;height:60px;">' + data.comentarios + '</textarea>'
                   + '<button id="btn-rechazar-trabajo" type="submit" class="btn btn-xs btn-primary" style="margin-right:5px;">Guardar</button>'
                   + '<button id="btn-cancelar-rechazo-trabajo" class="btn btn-xs btn-default" type="reset">Cancelar</button>'
                   + '</form>';
    return formulario;
};
var armarFormularioPostergacionTrabajo = function(data){
    var formulario = '<form class="ajax form-inline form-small" id="form-postergacion-trabajo" style="width:250px;">'
                   + '<input type="hidden" name="trabajo_id" id="trabajo_id" value="' + data.id + '">'
                   + '<select name="motivo" id="motivo" class="form-control input-sm">'
                   + '<option value="0">-- Postergar por --</option>';
    if(data.motivo === 1){
        formulario += '<option value="1" selected>No disponibilidad comercial</option>';
    } else {
        formulario += '<option value="1">No disponibilidad comercial</option>';
    }
    if(data.motivo === 2){
        formulario += '<option value="2" selected>No disponibilidad proveedor</option>';
    } else {
        formulario += '<option value="2">No disponibilidad proveedor</option>';
    }
    if(data.motivo === 3){
        formulario += '<option value="3" selected>No disponibilidad de presupuesto</option>';
    } else {
        formulario += '<option value="3">No disponibilidad de presupuesto</option>';
    }
    formulario += '</select>'
                + '<textarea id="comentarios" name="comentarios" class="form-control input-sm" placeholder="Comentarios postergación" style="width:245px;margin:5px 0;height:60px;">' + data.comentarios + '</textarea>'
                + '<button id="btn-postergar-trabajo" type="submit" class="btn btn-xs btn-primary" style="margin-right:5px;">Guardar</button>'
                + '<button id="btn-cancelar-postergacion-trabajo" class="btn btn-xs btn-default" type="reset">Cancelar</button>'
                + '</form>';
    return formulario;
};
var armarFormularioCierreTrabajo = function(data){
    var formulario = '<form class="ajax form-inline form-small" id="form-cierre-trabajo" style="width:250px;">'
                   + '<input type="hidden" name="trabajo_id" id="trabajo_id" value="' + data.trabajo_id + '">'
                   + '<input type="hidden" name="horometro" id="horometro" value="' + data.horometro + '">'
                   + '<input type="hidden" name="numero" id="numero" value="' + data.numero + '">'
                   + '<input type="text" class="form-control input-sm" name="fecha" value="' + data.fecha + '" id="fecha" disabled="disabled" style="width:120px;margin-right:5px;">'
                   + '<input type="text" class="form-control input-sm" name="horas" value="' + data.horas + '" placeholder="Horómetro" id="horas" style="width:120px;"';
    
    if(parseInt(data.horometro) === 1) {
        formulario += '>';
    } else {
        formulario += ' disabled="disabled">';
    }    
        
    formulario +='<textarea id="comentarios" name="comentarios" class="form-control input-sm" placeholder="Comentarios" style="width:245px;margin:5px 0;height:60px;">' + data.comentarios + '</textarea>'
               + '<button id="btn-cerrar-trabajo" type="submit" class="btn btn-xs btn-primary" style="margin-right:5px;">Guardar</button>'
               + '<button class="btn btn-xs btn-default btn-cancelar-cierre-trabajo" type="reset">Cancelar</button>'
               + '</form>';
    return formulario;
};
var actualizarFilaTrabajo = function(data){
    var check = "#check-" + data.trabajo_id;
    var fila = "#t" + data.trabajo_id;
    var tr = fila + " td";
    var estado = data.estado;
    var enlaces = $("a.calendario-cerrar-trabajo[data-trabajo_id=" + data.trabajo_id + "]");
    var enlacePostergacion = $("a.calendario-postergar-trabajo[data-trabajo_id=" + data.trabajo_id + "]");
    var enlaceRechazo = $("a.calendario-rechazar-trabajo[data-trabajo_id=" + data.trabajo_id + "]");
    $(fila).addClass(estado.toLowerCase());
    $(tr).removeClass('fecha-realizacion');
    if(data.estado === "TERMINADO") {
        $(check).html('<span class="glyphicon glyphicon-ok text-success"></span>');
        enlaces.attr("data-comentarios", data.comentarios);
        enlaces.attr("data-horas", data.horas_realizacion);
        enlacePostergacion.attr("data-comentarios", "");
        enlacePostergacion.attr("data-motivo", "");
        enlaceRechazo.attr("data-comentarios", "");
        if(data.numero !== false){
            var td = "#s" + data.trabajo_id + "-" + data.numero;
            $(td).addClass('fecha-realizacion');
            $(td).effect('highlight');
        }
    } 
    if(data.estado === "POSTERGADO"){
        $(check).html('');
        enlaces.attr("data-comentarios", "");
        enlaces.attr("data-horas", "");
        enlacePostergacion.attr("data-comentarios", data.postergacion_comentarios);
        enlacePostergacion.attr("data-motivo", data.postergacion_motivos);
        enlaceRechazo.attr("data-comentarios", "");
    }
    if(data.estado === "RECHAZADO"){
        $(check).html('');
        enlaces.attr("data-comentarios", "");
        enlaces.attr("data-horas", "");
        enlacePostergacion.attr("data-comentarios", "");
        enlacePostergacion.attr("data-motivo", "");
        enlaceRechazo.attr("data-comentarios", data.rechazo_comentarios);
    }
};
$(document).ready(function(){
    $(document).on('click focus', 'a.calendario-cerrar-trabajo, a.calendario-rechazar-trabajo, a.calendario-postergar-trabajo', function(e){
        e.preventDefault();
    });
    $("input.trabajo").on('click', function(){
        var trabajoId = $(this).attr('data-id');
        setTrabajoProgramacion(trabajoId);
    });
    $(document).on('click', "a.asignar-responsable-trabajo", function(e){
        e.preventDefault();
        var id = $(this).attr('data-id');
        var responsable = $(this).attr('data-responsable');
        var dir = $(this).attr('href');
        $.ajax({
            dataType: 'json',
            type: "POST",
            url: dir,
            data : "responsable=" + responsable,
            beforeSend: function(){
                $("#cont-btn-" + id).hide();
                $("#cont-msg-" + id).html('<span class="status-activity-inline">Guardando...</span>');
            },
            success: function(requestData){
                if(requestData.error === false){
                    if(responsable === 'NAVE'){
                        $("#cont-btn-" + id + " a.btn-externo").attr('class', 'btn btn-xs btn-default asignar-responsable-trabajo');
                        $("#cont-btn-" + id + " a.btn-nave").attr('class', 'btn btn-xs btn-success asignar-responsable-trabajo');
                    } else if(responsable === 'EXTERNO'){
                        $("#cont-btn-" + id + " a.btn-externo").attr('class', 'btn btn-xs btn-warning asignar-responsable-trabajo');
                        $("#cont-btn-" + id + " a.btn-nave").attr('class', 'btn btn-xs btn-default asignar-responsable-trabajo');
                    }
                    $("#cont-msg-" + id).html('');
                    $("#cont-btn-" + id).show();
                    $("#cont-btn-" + id).parent().effect('highlight');
                } else {
                    $("#cont-btn-" + id).show();
                    alert(requestData.mensaje);
                }
            },
            error: function(){
                $(contenedor).parent().html('<span class="status-error-inline">Guardando...</span>');
                $(contenedor).show();
                alert('Ocurrió un error al intentar asignar el trabajo.');
            }
        });
    });
    $(document).on('click', "a.calendario-editar-fecha", function(e){
        e.preventDefault();
        var id = $(this).attr('data-id');
        var fecha = $(this).attr('data-fecha');
        var numero = $(this).attr('data-numero');
        var dir = $(this).attr('href');
        $.ajax({
            dataType: 'json',
            type: "POST",
            url: dir,
            data : "id=" + id + "&fecha=" + fecha +  "&numero=" + numero,
            success: function(requestData){
                if(requestData.error === false){
                    var td = "#s" + requestData.id + "-" + requestData.numero;
                    $("#t" + requestData.id + " td").removeClass('fecha-realizacion');
                    if(requestData.estado === "TERMINADO") {
                        $(td).addClass('fecha-realizacion');
                    }
                    $(td).effect('highlight');
                } else {
                    alert(requestData.mensaje);
                }
            },
            error: function(){
                alert('Ocurrió un error al intentar la operación.');
            }
        });
    });
    $("#enviar-programacion").on('click', function(e){
        e.preventDefault();
        var numTrabajosSeleccionados = $("input.trabajo:checked").length;
        if(numTrabajosSeleccionados > 0) {
             if(confirm("Recuerde que una vez enviada no podrá agregar o eliminar trabajos")){
                 location = $("#enviar-programacion").attr('href');
             }
        } else {
            alert('Debe seleccionar a lo menos un trabajo para enviar la programación mensual');
        }
    }); 
    
    $(document).on('focus', 'a.calendario-cerrar-trabajo', function(){
        var data = [];
        data.trabajo_id = $(this).attr('data-trabajo_id');
        data.horas = $(this).attr('data-horas');
        data.numero = $(this).attr('data-numero');
        data.comentarios = $(this).attr('data-comentarios');
        data.servicio = $(this).attr('data-servicio');
        data.equipo = $(this).attr('data-equipo');
        data.fecha = $(this).attr('data-fecha');
        data.horometro = $(this).attr('data-horometro');

        $("a.calendario-cerrar-trabajo").popover('destroy');
        $(this).popover({
            html: true,
            placement: 'top',
            title: function(){
                var titulo = $(this).data('servicio') + "<br><span style='font-size:.85em;color:#888;'>" + $(this).data('equipo') + "</span>";
                return titulo;
            },
            content: function(){
                return armarFormularioCierreTrabajo(data);
            }
        });
    });
    $(document).on('mouseover', 'a.calendario-rechazar-trabajo', function(){
        $(".popover").popover('hide');
        $(this).popover({
            html: true,
            placement: 'top',
            title: function(){
                var titulo = $(this).data('servicio') + "<br><span style='font-size:.85em;color:#888;'>" + $(this).data('equipo') + "</span>";
                return titulo;
            },
            content: function(){
                var data = $(this).data();
                return armarFormularioRechazoTrabajo(data);
            }
        });
    });
    $(document).on('mouseover', 'a.calendario-postergar-trabajo', function(){
        $(".popover").popover('hide');
        $(this).popover({
            html: true,
            placement: 'top',
            title: function(){
                var titulo = $(this).data('servicio') + "<br><span style='font-size:.85em;color:#888;'>" + $(this).data('equipo') + "</span>";
                return titulo;
            },
            content: function(){
                var data = $(this).data();
                return armarFormularioPostergacionTrabajo(data);
            }
        });
    }); 
    $(document).on("submit", "#form-cierre-trabajo", function(e){
        e.preventDefault();
        var horometro = $("#horometro").val();
        var horas = $("#horas").val();
        if(horometro === "1" && (isNaN(horas) || horas ==='')) {
            alert("Ingrese las horas del equipo cuando se hizo el mantenimiento.");
        } else {
            $.ajax({
                dataType: 'json',
                type: "POST",
                url: '/programacion-mensual/terminar-trabajo/',
                data : getInputsAjax("#form-cierre-trabajo"),
                success: function(requestData){
                    if(requestData.error === false){
                        $(".popover").popover('destroy');
                        actualizarSumarioTrabajosMes(requestData.sumario);
                        actualizarFilaTrabajo(requestData);
                    } else {
                        alert(requestData.mensaje);
                    }
                },
                error: function(){
                    alert('Ocurrió un error al intentar la operación.');
                }
            });
        }
    });
    $(document).on("submit", "#form-postergacion-trabajo", function(e){
        e.preventDefault();
        var motivo = $("#motivo").val();
        if(motivo === "0") {
            alert("Seleccione el motivo de la postergación del trabajo.");
        } else {
            $.ajax({
                dataType: 'json',
                type: "POST",
                url: '/programacion-mensual/postergar-trabajo/',
                data : getInputsAjax("#form-postergacion-trabajo"),
                success: function(requestData){
                    if(requestData.error === false){
                        actualizarFilaTrabajo(requestData);
                        actualizarSumarioTrabajosMes(requestData.sumario);
                        $(".popover").popover('destroy');
                    } else {
                        alert(requestData.mensaje);
                    }
                },
                error: function(){
                    alert('Ocurrió un error al intentar la operación.');
                }
            });
        }
    });
    $(document).on("submit", "#form-rechazar-trabajo", function(e){
        e.preventDefault();
        $.ajax({
            dataType: 'json',
            type: "POST",
            url: '/programacion-mensual/rechazar-trabajo/',
            data : getInputsAjax("#form-rechazar-trabajo"),
            success: function(requestData){
                if(requestData.error === false){
                    actualizarFilaTrabajo(requestData);
                    actualizarSumarioTrabajosMes(requestData.sumario);
                    $(".popover").popover('destroy');
                } else {
                    alert(requestData.mensaje);
                }
            },
            error: function(){
                alert('Ocurrió un error al intentar la operación.');
            }
        });
    });
    $(document).on('click', '#btn-cancelar-rechazo-trabajo, #btn-cancelar-postergacion-trabajo', function(){
       $(".popover").popover('destroy');
    });
    $(document).on('click', 'button.btn-cancelar-cierre-trabajo', function(){
       $('a.calendario-cerrar-trabajo').popover('destroy');
    });
});