// LLAMADAS AJAX QUE DEVUELVEN HTML
var setCuenta = function(tipoId, cuentaId)
{
    $.ajax({
        dataType: 'json',
        type: "POST",
        url: '/tipo-proyecto/set-cuenta/',
        data: "tipo_id=" + tipoId + "&cuenta_id=" + cuentaId,
        success: function(requestData){
            if(requestData.sessionError === true){
                terminarSesion();
            } else {
                if(requestData.error === false){
                    $("#c" + cuentaId).parent().effect('highlight');
                } else {
                    alert(requestData.mensaje);
                }
            }
        }
    });
};
var getDataProrrateo = function(direccion, idMensaje)
{
    $.ajax({
        type: "POST",
        dataType: 'html',
        url: direccion,
        data : getInputsAjax("#conf-visualizador-prorrateo"),
        beforeSend : function(){
            if(idMensaje === "#get-prorrateo"){
                $("#get-prorrateo").text('Consultando datos...').addClass('disabled');
            } else {
                $("#calendario-prorrateo").html('Consultando datos...');
            }
        },
        success: function(requestData){
            if(requestData === '{"sessionError":true}'){
                terminarSesion();
            } else {
                $("#get-prorrateo").text('Consultar estado prorrateo').removeClass('disabled');
                $("#calendario-prorrateo").html(requestData);
            }
           
        },
        error: function(){
            $("#get-prorrateo").text('Consultar estado prorrateo').removeClass('disabled');
            alert('Ocurrió un error al intentar enviar obtener la información del prorrateo.');
        }
    });
}; 

$(document).ready(function(){
    
    $("#conf-visualizador-prorrateo").on('submit', function(e){
        e.preventDefault();
        var numCentrosCosto = $("input.centro_costo:checked").length;
        var numConceptosImputacion = $("input.concepto_imputacion:checked").length;
        var numTiposProyecto = $("input.tipo_proyecto:checked").length;

        if(numCentrosCosto === 0 || numConceptosImputacion === 0 || numTiposProyecto === 0){
            alert('Por favor seleccione al menos un ítem en cada categoría para realizar la búsqueda de información.');
            return;
        } else {
            getDataProrrateo('/gestion-proyectos/get-data-prorrateo', "#get-prorrateo");
        }
    });
    
    $(document).on('click', "#getDataProrrateoNextYear", function(e){
        e.preventDefault();
        getDataProrrateo('/gestion-proyectos/get-data-prorrateo-next-year', false);
    });
    
    $(document).on('click', "#getDataProrrateoPrevYear", function(e){
        e.preventDefault();
        getDataProrrateo('/gestion-proyectos/get-data-prorrateo-prev-year', false);
    });
    
    $("input.config-cuenta").on('click', function(){
        var tipoId = $(this).attr('data-tipo');
        var cuentaId = $(this).attr('data-cuenta');
        setCuenta(tipoId, cuentaId);
    });
    
    $("#sel-all-centros").on('click', function(){
        if($("#sel-all-centros:checked").length === 1){
            $("input.centro_costo").attr("checked", "checked");
        } else {
            $("input.centro_costo").removeAttr("checked");
        }
    });
    
    $("#sel-all-conceptos").on('click', function(){
        if($("#sel-all-conceptos:checked").length === 1){
            $("input.concepto_imputacion").attr("checked", "checked");
        } else {
            $("input.concepto_imputacion").removeAttr("checked");
        }
    });
    
    $("#sel-all-tipos").on('click', function(){
        if($("#sel-all-tipos:checked").length === 1){
            $("input.tipo_proyecto").attr("checked", "checked");
        } else {
            $("input.tipo_proyecto").removeAttr("checked");
        }
    });
    
    $("input.centro_costo").on('click', function(){
        if($("input.centro_costo").length !== $("input.centro_costo:checked").length){
            $("#sel-all-centros").removeAttr('checked');
        } else {
            $("#sel-all-centros").attr('checked', 'checked');
        }
    });
    
    $("input.concepto_imputacion").on('click', function(){
        if($("input.concepto_imputacion").length !== $("input.concepto_imputacion:checked").length){
            $("#sel-all-conceptos").removeAttr('checked');
        } else {
            $("#sel-all-conceptos").attr('checked', 'checked');
        }
    });
    
    $("input.tipo_proyecto").on('click', function(){
        if($("input.tipo_proyecto").length !== $("input.tipo_proyecto:checked").length){
            $("#sel-all-tipos").removeAttr('checked');
        } else {
            $("#sel-all-tipos").attr('checked', 'checked');
        }
    });
    
});