$(document).ready(function(){
    
    $(document).on('click', "a.enviar-comentario", function(e){
        e.preventDefault();
        var c = $(this).prev().val();
        var solicitudId = $(this).attr('data-id');
        var tipo = $(this).attr('data-tipo');
        if(c === ''){
            var mensajeAdvertencia = noty({text: "Debe ingresar un comentario", type: 'warning', timeout: '3000'});
        } else {
            $.ajax({
                dataType: 'json', type: "POST",
                url: $(this).attr('href'),
                data : "c=" + c + "&t=" + tipo,
                success: function(requestData){
                    if(requestData.error === false){
                        var comentario = '<p class="respuesta ' + tipo + '"> <span class="glyphicon glyphicon-share-alt"></span> <span class="fecha_comentarios">' 
                                       + requestData.fecha + '</span> <span class="label ';
                        if(tipo === 'supervisor') {
                            comentario += 'label-info">S';
                        } else if (tipo === 'motorista') {
                            comentario += 'label-warning">M';
                        } else if(tipo === 'administrador') {
                            comentario += 'label-success">A';
                        }      
                        comentario += '</span> ' + requestData.comentario + '</p>';
                        $("#comentarios" + solicitudId).append(comentario);
                        $("#com" + solicitudId).val('');
                    } else {
                        var mensajeError = noty({text: requestData.mensaje, type: 'error', timeout: '4000'});
                    }    
                }
            });
        }
    });
    $(document).on('click', "a.ver-comentarios", function(e){
        e.preventDefault();
        $(this).parent().next().toggle();
    });
    $("#show-nuevos").on('click', function(){
        $("#show-nuevos").parent().addClass('active');
        $("#show-all").parent().removeClass('active');
        $("table#listado-solicitudes tbody tr.no-nuevo").hide();
    });
    $("#show-all").on('click', function(){
        $("#show-all").parent().addClass('active');
        $("#show-nuevos").parent().removeClass('active');
        $("table#listado-solicitudes tbody tr.no-nuevo").show();
    });
    
    $(document).on('click', "a.aceptar-solicitud",function(e){
        e.preventDefault();
        var id = $(this).attr('data-id');
        var label = "#l" + id;
        var boton1 = "#b1" + id;
        var boton2 = "#b2" + id;
        var solicitud = "#s" + id;
        var contentBoton1 = '<a class="btn btn-xs btn-success terminar-solicitud" href="/u-supervisor/terminar-solicitud/' 
                          + id + '" data-id="' + id + '" title="Dar por terminada de forma satisfactoria">'
                          + '<span class="glyphicon glyphicon-thumbs-up"></span></a>';
        var contentBoton2 = '<a class="btn btn-xs btn-danger rechazar-solicitud" href="/u-supervisor/rechazar-solicitud/' 
                         + id + '" data-id="' + id + '" title="Dar por terminada de forma insatisfactoria">'
                         + '<span class="glyphicon glyphicon-thumbs-down"></span></a>';
        var contentSolicitud = '<span class="pull-right"><a class="ver-comentarios" href="#" title="Ver comentarios / Comentar">'
                             + '<span class="glyphicon glyphicon-comment"></span></a></span>'
                             + '<div class="respuestas_solicitudes" style="display: none;">'
                             + '<div id="comentarios' + id + '"></div>'
                             + '<div class="control-group" style="margin:10px 0;">'
                             + '<input type="text" class="col-lg-9 comentario" name="comentario" id="com' + id + '" style="margin:0;padding:2px 5px;font-size:12px;"> '
                             + '<a style="margin:0;" href="/u-supervisor/guardar-comentario/' + id + '" data-id="' + id 
                             + '" class="enviar-comentario btn btn-xs btn-primary">'
                             + '<span class="glyphicon glyphicon-comment"></span></a></div></div>';
        $.ajax({
            dataType: 'json', type: "POST",
            url: $(this).attr('href'),
            beforeSend: function(){
                $(this).addClass('disabled');
            },    
            success: function(requestData){
                if(requestData.error === false){
                    
                    $(label).html('<span class="label label-info">EN CURSO</span>');
                    $(boton1).html(contentBoton1);
                    $(boton2).html(contentBoton2);
                    $(solicitud).append(contentSolicitud);
                    
                } else {
                    var mensajeError = noty({text: requestData.mensaje, type: 'error', timeout: '4000'});
                }    
            }
        });
    });
    
    $(document).on('click', "a.reaceptar-solicitud", function(e){
        e.preventDefault();
        var id = $(this).attr('data-id');
        var label = "#l" + id;
        var boton1 = "#b1" + id;
        var boton2 = "#b2" + id;
        var contentBoton1 = '<a class="btn btn-xs btn-success terminar-solicitud" href="/u-supervisor/terminar-solicitud/' 
                          + id + '" data-id="' + id + '" title="Dar por terminada de forma satisfactoria">'
                          + '<span class="glyphicon glyphicon-thumbs-up"></span></a>';
        var contentBoton2 = '<a class="btn btn-xs btn-danger rechazar-solicitud" href="/u-supervisor/rechazar-solicitud/' 
                         + id + '" data-id="' + id + '" title="Dar por terminada de forma insatisfactoria">'
                         + '<span class="glyphicon glyphicon-thumbs-down"></span></a>';
        $.ajax({
            dataType: 'json', type: "POST",
            url: $(this).attr('href'),
            beforeSend: function(){
                $(this).addClass('disabled');
            },    
            success: function(requestData){
                if(requestData.error === false){
                    
                    $(label).html('<span class="label label-info">EN CURSO</span>');
                    $(boton1).html(contentBoton1);
                    $(boton2).html(contentBoton2);
                    
                } else {
                    var mensajeError = noty({text: requestData.mensaje, type: 'error', timeout: '4000'});
                }    
            }
        });
    });
    
    $(document).on('click', "a.terminar-solicitud", function(e){
        e.preventDefault();
        var id = $(this).attr('data-id');
        var label = "#l" + id;
        var boton1 = "#b1" + id;
        var boton2 = "#b2" + id;
        var contentBoton1 = '<a class="btn btn-xs btn-info reaceptar-solicitud" '
                          + 'href="/u-supervisor/aceptar-solicitud/227" '
                          + 'data-id="' + id + '" title="Reabrir la solicitud"> '
                          + '<span class="glyphicon glyphicon-retweet"></span></a>';
        
        $.ajax({
            dataType: 'json', type: "POST",
            url: $(this).attr('href'),
            beforeSend: function(){
                $(this).addClass('disabled');
            },    
            success: function(requestData){
                if(requestData.error === false){
                    $(label).html('<span class="label label-success">TERMINADA OK</span>');
                    $(boton1).html(contentBoton1);
                    $(boton2).html('');
                } else {
                    var mensajeError = noty({text: requestData.mensaje, type: 'error', timeout: '4000'});
                }    
            }
        });
    });
    
    $(document).on('click', "a.rechazar-solicitud", function(e){
        e.preventDefault();
        var id = $(this).attr('data-id');
        var label = "#l" + id;
        var boton1 = "#b1" + id;
        var boton2 = "#b2" + id;
        
        $.ajax({
            dataType: 'json', type: "POST",
            url: $(this).attr('href'),
            beforeSend: function(){
                $(this).addClass('disabled');
            },    
            success: function(requestData){
                if(requestData.error === false){
                    $(label).html('<span class="label label-danger">RECHAZADA</span>');
                    $(boton1).html('');
                    $(boton2).html('');
                } else {
                    var mensajeError = noty({text: requestData.mensaje, type: 'error', timeout: '4000'});
                }    
            }
        });
    });
});